//  "  , "
// 9-      
//  :  , stankev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class aisle_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new aisle_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "aisle";

	public void solve() throws IOException {
		int n = nextInt();
		int l = nextInt();
		int w = nextInt();
		int x = nextInt();
		int y = nextInt();
		int a = nextInt();
		int c = l / x;
		if (c == 0) {
			out.println(-1);
			return;
		}
		long r = (n + c - 1) / c;
		long f = w - r * y;
		if (r == 0 || f < a) {
			out.println(-1);
			return;
		}
		out.println(Math.min(n, Math.min(r, f / a * 2) * c));
	}
}
