//  ""
// 9-      
//  :  , stankev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class bridge_sp_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new bridge_sp_wrong()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "bridge";
	
	double dist(int x1, int y1, int x2, int y2) {
		return Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
	}
	
	double dist(int x, int y, int x1, int y1, int x2, int y2) {
		int dx1 = x1 - x;
		int dy1 = y1 - y;
		int dx2 = x2 - x;
		int dy2 = y2 - y;
		int dx = x2 - x1;
		int dy = y2 - y1;
		long t1 = dx * dx1 + dy * dy1;
		long t2 = dx * dx2 + dy * dy2;
		if (t1 * t2 <= 0) {
			int a = y2 - y1;
			int b = x1 - x2;
			int c = -a * x1 - b * y1;
			return Math.abs(a * x + b * y + c) / Math.sqrt(a * a + b * b);
		}
		return Math.min(dist(x, y, x1, y1), dist(x, y, x2, y2));
	}

	public void solve() throws IOException {
		int m = nextInt();
		int[] x1 = new int[m];
		int[] y1 = new int[m];
		for (int i = 0; i < m; i++) {
			x1[i] = nextInt();
			y1[i] = nextInt();
		}
		int n = nextInt();
		int[] x2 = new int[n];
		int[] y2 = new int[n];
		for (int i = 0; i < n; i++) {
			x2[i] = nextInt();
			y2[i] = nextInt();
		}
		double ans = Math.min(x2[0] - x1[0], x2[n - 1] - x1[m - 1]);
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n - 1; j++) {
				ans = Math.min(ans, dist(x1[i], y1[i], x2[j], y2[j], x2[j + 1], y2[j + 1]));
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m - 1; j++) {
				ans = Math.min(ans, dist(x2[i], y2[i], x1[j], y1[j], x1[j + 1], y1[j + 1]));
			}
		}
		out.println(ans);
	}
}
