//  "  "
// 9-      
//  :
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class codes_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new codes_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "codes";

	public void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 100000, "Wrong n");
		int k = nextInt();
		myAssert(0 <= k && k <= 200, "Wrong k");
		int s = 0;
		String[] a = new String[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextToken();
			s += a[i].length();
		}
		myAssert(s <= 1000000, "Wrong summary length");
		Arrays.sort(a);
		boolean[] q = new boolean[n];
		int ans = 1;
		q[0] = true;
		for (int i = 1; i < n; i++) {
			myAssert(!a[i].equals(a[i - 1]), "Equal strings");
			int j = 0;
			while (j < a[i].length() && j < a[i - 1].length()) {
				if (a[i].charAt(j) != a[i - 1].charAt(j)) {
					break;
				}
				j++;
			}
			if (j <= k) {
				ans++;
				q[i] = true;
			}
		}
		out.println(ans);
		for (int i = 0; i < n; i++) {
			if (q[i]) {
				out.println(a[i]);
			}
		}
	}
}
