//  ""
// ??- -  2007-2008,  
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class codes_sp2 implements Runnable {

	public static void main(String[] args) {
		new Thread(new codes_sp2()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "codes";
	
	int[][] bor = new int[26][1000010];
	boolean[] end = new boolean[1000010];
	int l = 0;
	ArrayList<String> ans = new ArrayList<String>();
	int k;
	
	void add(String s) {
		int pos = 0;
		for (int i = 0; i < s.length(); i++) {
			if (bor[s.charAt(i) - 'a'][pos] == 0) {
				bor[s.charAt(i) - 'a'][pos] = ++l; 
			}
			pos = bor[s.charAt(i) - 'a'][pos];
		}
		end[pos] = true;
	}
	
	void getAns(StringBuilder sb, int pos, int h) {
		if (h <= k) {
			boolean fl = false;
			for (int i = 0; i < 26; i++) {
				if (bor[i][pos] != 0) {
					fl = true;
					sb.append((char)('a' + i));
					getAns(sb, bor[i][pos], h + 1);
					sb.deleteCharAt(sb.length() - 1);
				}
			}
			if (!fl) {
				ans.add(new String(sb));
			}
		} else {
			int i = 0;
			while (i < 26 && bor[i][pos] == 0) {
				i++;
			}
			if (i == 26) {
				ans.add(new String(sb));
			} else {
				sb.append((char)('a' + i));
				getAns(sb, bor[i][pos], h + 1);
				sb.deleteCharAt(sb.length() - 1);
			}
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		k = nextInt();
		for (int i = 0; i < n; i++) {
			String s = nextToken();
			add(s);
		}
		getAns(new StringBuilder(), 0, 0);
		out.println(ans.size());
		for (String s : ans) {
			out.println(s);
		}
	}
}
