//  "  "
//       
//   :  ,  stankev@gmail.com      (???)
//  :  , ulyantsev@rain.ifmo.ru

//     Java
//  TreeMap.      7 

import java.io.*;
import java.util.*;

public class codes_vu implements Runnable {
	final static String FILE = "codes";
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new codes_vu()).start();
	}

	public codes_vu() {
		try {
			in = new BufferedReader(new FileReader(FILE + ".in"));
			out = new PrintWriter(new File(FILE + ".out"));
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}	

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	int max;
	ArrayList<char[]> ans = new ArrayList();
	final int maxlen = 200;
	char[] prnt = new char[maxlen];
	char[] currentWord;
	int pos;

	public class Node {
		boolean isEnd;
		TreeMap<Character, Node> child;             
		Node() {
			isEnd = false;
			child = new TreeMap();
		}
		boolean add() {
			if (pos == currentWord.length) {
				isEnd = true;
				return true; 
			}
			//System.out.println(pos + " " + currentWord[pos]);
			Node cur = child.get(currentWord[pos]);
			if (pos == max && cur != null)
				return false;
			
			if (cur == null) {
				cur = new Node();
				child.put(currentWord[pos], cur);
			}
			pos++;
			return cur.add();
		}
		
		void print(int len) {
			for (char i = 'a'; i <= 'z'; i++) {
				Node cur = child.get(i);
				if (cur != null) {
					prnt[len] = i;
					cur.print(len + 1);
				}
			}
			if (isEnd) {
				ans.add(Arrays.copyOf(prnt, len));
			}
		}
	}	

	public void solve() throws IOException {
		int n = nextInt();
		max = nextInt();

		Node root = new Node();

		for (int i = 0; i < n; i++) {
			currentWord = nextToken().toCharArray();
			pos = 0;
			root.add();
		}

		root.print(0);
		out.println(ans.size());
		for (char[] s : ans) {
			for (char ch : s)
				out.print(ch);
			out.println();
		}

		in.close();
		out.close();
	}
}
