#include <cstdio>
#include <cassert>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 300

int n, an, a[maxn * 2], pos[maxn];
int c[maxn][maxn];

#define F(a, b, c, d) (a <= b && b <= c && c <= d)

int main()
{
  freopen("dfs.in", "r", stdin);
  freopen("dfs.out", "w", stdout);

  scanf("%d%d", &n, &an);
  assert(1 <= n && n <= maxn && 1 <= an && an <= 2 * n - 1);

  forn(i, an)
    scanf("%d", &a[i]), pos[--a[i]] = -1;
  forn(i, an)
  {
    if (pos[a[i]] != -1)
      for (int j = pos[a[i]] + 1; j < i; j++)
        if (a[j] >= a[i - 1])
          c[a[i]][a[j]] = c[a[j]][a[i]] = 1;
    pos[a[i]] = i;
  }

  int ans = 0;
  forn(i, n)
    forn(j, n)
      if (i < j && c[i][j])
        ans++;
  printf("%d\n", ans);
  forn(i, n)
    forn(j, n)
      if (i < j && c[i][j])
        printf("%d %d\n", i + 1, j + 1);
  return 0;
}
