#include <cstdio>
#include <cassert>
#include <cstring>
#include <set>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef pair <int, int> pii;

#define maxn 300

int n, an, a[maxn * 2], pos[maxn];
int c[maxn][maxn];
set <pii> ans;

#define F(a, b, c, d) (a <= b && b <= c && c <= d)

int main()
{
  freopen("dfs.in", "r", stdin);
  freopen("dfs.out", "w", stdout);

  scanf("%d%d", &n, &an);
  assert(1 <= n && n <= maxn && 1 <= an && an <= 2 * n - 1);

  forn(i, an)
    scanf("%d", &a[i]), pos[--a[i]] = -1;
  forn(i, an)
  {
    if (pos[a[i]] != -1)
      for (int j = pos[a[i]] + 1; j < i; j++)
        if (a[j] >= a[i - 1])
          ans.insert(make_pair(min(a[i], a[j]), max(a[i], a[j])));
    pos[a[i]] = i;
  }

  printf("%d\n", ans.size());
  for (set <pii>::iterator it = ans.begin(); it != ans.end(); it++)
    printf("%d %d\n", it->first + 1, it->second + 1);
  return 0;
}
