//  " "
// 9-      
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class gems_sp implements Runnable {

    public static void main(String[] args) {
        new Thread(new gems_sp()).run();
    }

    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new BufferedReader(new FileReader(FILENAME + ".in"));
            out = new PrintWriter(FILENAME + ".out");
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    BufferedReader br;

    PrintWriter out;

    StringTokenizer st;

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    void myAssert(boolean e, String s) {
        if (!e) {
            throw new Error("Assertion failure " + s);
        }
    }

    private static final String FILENAME = "gems";

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        char[] s = nextToken().toCharArray();
        boolean[][] tab = new boolean[26][26];
        for (int i = 0; i < m; i++) {
            String ts = nextToken();
            tab[ts.charAt(0) - 'a'][ts.charAt(1) - 'a'] = true;
        }
        int[] c = new int[26];
        long ans = 0;
        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < 26; j++) {
                if (tab[s[i] - 'a'][j]) {
                    ans += c[j];
                }
            }
            c[s[i] - 'a']++;
        }
        out.println(ans);
    }
}
