//  " "
// 9-      
//  :  , tsarev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class numbers_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new numbers_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	boolean eof = false;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "numbers";

	public void solve() throws IOException {
			long n = nextLong();
			myAssert(0 < n && n <= 1e15, "Wrong n");
			int k = nextInt();
			myAssert(2 <= k && k <= 10, "Wrong k");
			long[] a = new long[100];
			long[] b = new long[100];
			a[1] = (k - 1);
			a[2] = (k - 1) * (k - 1);
			b[1] = (k - 1);
			b[2] = k * (k - 1);
			for (int i = 3; i < a.length; i++) {
				a[i] = a[i - 1] * k;
				b[i] = b[i - 1] * k;
			}
			long[] sa = new long[100];
			long[] sb = new long[100];
			// Arrays.fill(sb, 1);
			for (int i = 0; i < 100; i++) {
				sb[i] += i % 2;
				for (int j = 1; j < i; j += 2) {
					sa[i] += a[i - j];
					sb[i] += b[i - j];
				}
			}
			long ans = 0;
			int l = 1;
			while (sa[l] < n) {
				n -= sa[l++];
			}
			int j = 1;
			while (sb[l - 1] < n) {
				n -= sb[l - 1];
				j++;
			}
			int lastnonzero = l;
			ans += j;
			for (int i = l - 2; i >= 0; i--) {
				if (n == 1 && lastnonzero % 2 == 0) {
					while (i >= 0) {
						ans *= k;
						i--;
					}
					continue;
				}
				j = 0;
				if (lastnonzero % 2 == 0) {
					if (sb[i] - i % 2 + 1 < n) {
						n -= sb[i] - i % 2 + 1;
						j++;
					}
				} else {
					if (sb[i] - i % 2 < n) {
						n -= (sb[i] - i % 2);
						j++;
					}
				}
				if (j != 0) {
					while (sb[i] < n) {
						if (j == 0 && lastnonzero % 2 == 0 && i % 2 == 0) {
							n--;
						}
						n -= sb[i];
						j++;
					}
				}
				ans *= k;
				ans += j;
				if (j != 0) {
					lastnonzero = i + 1;
				}
			}
			out.println(ans);
//			out.println(Long.toString(ans, k));
	}
}
