//  ""
//       2008 
//  :  
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class shelves_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new shelves_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "shelves";

	public void solve() throws IOException {
		int m = nextInt();
		int n = nextInt();
		int[] a = new int[m];
		int[] b = new int[n];
		for (int i = 0; i < m; i++) {
			a[i] = nextInt();
		}
		for (int i = 0; i < n; i++) {
			b[i] = nextInt();
		}
		ArrayList<Integer> ansa = new ArrayList<Integer>();
		ArrayList<Integer> ansb = new ArrayList<Integer>();
		int i = 0;
		int j = 0;
		long ha = 0;
		long hb = 0;
		long h = 0;
		while (i < m || j < n) {
			if (i == m || (j < n && hb + b[j] < ha + a[i])) {
				ansb.add(j + 1);
				h = hb + b[j];
			} else {
				ansa.add(i + 1);
				h = ha + a[i];
			}
			while (i < m && ha < h) {
				ha += a[i++];
			}
			while (j < n && hb < h) {
				hb += b[j++];
			}
		}
		out.println(ansa.size() + " " + ansb.size());
		for (int x : ansa) {
			out.print(x + " ");
		}
		out.println();
		for (int x : ansb) {
			out.print(x + " ");
		}
		out.println();
	}
}
