#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>

using namespace std;

#define m 300100
#define mv (m / 3)

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

int a[m], b[m], c[m], t[m], la, lb, lc, qa, qb, qc;

void readn( int *a, int &l, int &d )
{
  static char s[m];
  assert(scanf("%s", s) == 1);
  l = strlen(s);
  if (l == 100001)
  {
    assert(s[0] == '1');
    forn (i, l - 1)
      assert(s[i + 1] == '0');
  }
  else
    assert(s[0] != '0' && l <= 100000);
  memset(a, 0, sizeof(*a) * m);
  forn (i, l)
    a[l - 1 - i] = s[i] - '0';
  d = 0;
  while (a[d] == 0)
    d++;
  l -= d;
  forn (i, l)
    a[i] = a[i + d];
  for (int i = l; i < m; i++)
    a[i] = 0;
}

int findl( int *a )
{
  for (int i = m - 1; i >= 0; i--)
    if (a[i])
      return i + 1;
  return 0;
}

void test( int *a, int da, int *b, int lb, int fl )
{
  if (da < 0)
    return;
  memcpy(t, c, sizeof(c));
  forn (i, m - da)
    t[i + da] -= a[i];
  forn (i, m - 1)
    if (t[i] < 0)
      t[i] += 10, t[i + 1]--;
  if (t[m - 1] < 0)
    return;
  int d = 0;
  while (t[d] == 0)
    d++;
  int l = findl(t);
  if (l - d != lb)
    return;
  forn (i, lb)
    if (b[i] != t[d + i])
      return;
  int ra = -qa, rb = -qb, rc = -qc;
  if (fl)
    ra += d, rb += da;
  else
    ra += da, rb += d;
  int t = min(ra, min(rb, rc));
  printf("YES\n%d %d %d\n", ra - t, rb - t, rc - t);
  exit(0);
}

int main()
{
  freopen("sum.in", "r", stdin);
  freopen("sum.out", "w", stdout);
  readn(a, la, qa);
  readn(b, lb, qb);
  readn(c, lc, qc);
  qc -= mv;
  lc += mv;
  for (int i = m - mv; i >= 0; i--)
    c[i + mv] = c[i];
  forn (i, mv)
    c[i] = 0;
  test(a, lc - la, b, lb, 0);
  test(a, lc - la - 1, b, lb, 0);
  test(b, lc - lb, a, la, 1);
  test(b, lc - lb - 1, a, la, 1);
  puts("NO");
  return 0;
}
