import java.io.*;
import java.util.*;

public class collider_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new collider_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "collider";

	ArrayList<Integer>[] g;

	private void solve() throws IOException {
		int n = nextInt();
		g = new ArrayList[n];
		for (int i = 0; i < g.length; i++) {
			g[i] = new ArrayList<Integer>();
		}
		for (int i = 0; i < n - 1; i++) {
			int x = nextInt() - 1;
			int y = nextInt() - 1;
			g[x].add(y);
			g[y].add(x);
		}
		a = new int[n][3];
		b = new int[n][3];
		pa = new int[n][3][];
		pb = new int[n][3][];
		for (int i = 0; i < pa.length; i++) {
			for (int j = 0; j < pa[i].length; j++) {
				pa[i][j] = new int[2 * j];
				pb[i][j] = new int[2 * j];
			}
		}
		u = new boolean[n];
		DFS(0, 0);
		if (a[0][1] + 1 >= a[0][2] + 2) {
			out.println(a[0][1] + 1);
			out.println((pa[0][1][0] + 1) + " " + (pa[0][1][1] + 1));
		} else {
			out.println(a[0][2] + 2);
			out.println((pa[0][2][0] + 1) + " " + (pa[0][2][2] + 1));
			out.println((pa[0][2][1] + 1) + " " + (pa[0][2][3] + 1));
		}
	}

	boolean[] u;

	private void DFS(int x, int y) {
		u[x] = true;
		for (int i : g[x]) {
			if (!u[i]) {
				DFS(i, x);
			}
		}
		a[x][0] = 0;
		b[x][0] = 0;
		a[x][1] = 0;
		pa[x][1][0] = x;
		pa[x][1][1] = x;

		int max1 = -1;
		int max2 = -1;
		int maxi1 = -1;
		int maxi2 = -1;
		int max3 = -1;
		int maxi3 = -1;
		for (int i : g[x]) {
			if (i != y) {
				if (a[x][1] < a[i][1]) {
					a[x][1] = a[i][1];
					pa[x][1][0] = pa[i][1][0];
					pa[x][1][1] = pa[i][1][1];
				}
				if (b[i][1] > max1) {
					max3 = max2;
					maxi3 = maxi2;
					max2 = max1;
					maxi2 = maxi1;
					max1 = b[i][1];
					maxi1 = i;
				} else if (b[i][1] > max2) {
					max3 = max2;
					maxi3 = maxi2;
					max2 = b[i][1];
					maxi2 = i;
				} else if (b[i][1] > max3) {
					max3 = b[i][1];
					maxi3 = i;
				}
			}
		}
		if (a[x][1] < 2 + max1 + max2) {
			a[x][1] = 2 + max1 + max2;
			if (maxi1 >= 0) {
				pa[x][1][0] = pb[maxi1][1][0];
			} else {
				pa[x][1][0] = x;
			}
			if (maxi2 >= 0) {
				pa[x][1][1] = pb[maxi2][1][0];
			} else {
				pa[x][1][1] = x;
			}
		}
		b[x][1] = 0;
		pb[x][1][0] = x;
		pb[x][1][1] = x;
		a[x][2] = -1;
		b[x][2] = -1;
		for (int i : g[x]) {
			if (i != y) {
				if (b[x][1] < b[i][1] + 1) {
					b[x][1] = b[i][1] + 1;
					pb[x][1][0] = pb[i][1][0];
				}
				if (a[x][2] < a[i][2]) {
					a[x][2] = a[i][2];
					for (int j = 0; j < pa[x][2].length; j++) {
						pa[x][2][j] = pa[i][2][j];
					}
				}
				int q = 0;
				int i1 = -1;
				int i2 = -1;
				if (i == maxi1) {
					q = max2 + max3 + 2;
					i1 = maxi2;
					i2 = maxi3;
				} else if (i == maxi2) {
					q = max1 + max3 + 2;
					i1 = maxi1;
					i2 = maxi3;
				} else {
					q = max1 + max2 + 2;
					i1 = maxi1;
					i2 = maxi2;
				}
				if (a[x][2] < a[i][1] + q) {
					a[x][2] = a[i][1] + q;
					pa[x][2][0] = pa[i][1][0];
					pa[x][2][1] = pa[i][1][1];
					if (i1 < 0) {
						pa[x][2][2] = x;
					} else {
						pa[x][2][2] = pb[i1][1][0];
					}
					if (i2 < 0) {
						pa[x][2][3] = x;
					} else {
						pa[x][2][3] = pb[i2][1][0];
					}
				}
				if (a[x][2] < b[i][2] + 1) {
					a[x][2] = b[i][2] + 1;
					pa[x][2][0] = pb[i][2][0];
					pa[x][2][1] = pb[i][2][1];
					pa[x][2][2] = pb[i][2][2];
					pa[x][2][3] = x;
				}
				if (b[x][2] < b[i][2] + 1) {
					b[x][2] = b[i][2] + 1;
					for (int j = 0; j < pb[x][2].length; j++) {
						pb[x][2][j] = pb[i][2][j];
					}
					pb[x][2][3] = x;
				}
				q = 0;
				i1 = -1;
				if (i == maxi1) {
					q = max2 + 1;
					i1 = maxi2;
				} else {
					q = max1 + 1;
					i1 = maxi1;
				}
				if (b[x][2] < a[i][1] + q) {
					b[x][2] = a[i][1] + q;
					pb[x][2][0] = pa[i][1][0];
					pb[x][2][1] = pa[i][1][1];
					if (i1 < 0) {
						pb[x][2][2] = x;
					} else {
						pb[x][2][2] = pb[i1][1][0];
					}
					pb[x][2][3] = x;
				}
				if (a[x][2] < b[i][2] + q + 1) {
					a[x][2] = b[i][2] + q + 1;
					pa[x][2][0] = pb[i][2][0];
					pa[x][2][1] = pb[i][2][1];
					pa[x][2][2] = pb[i][2][2];
					if (i1 >= 0) {
						pa[x][2][3] = pb[i1][1][0];
					} else {
						pa[x][2][3] = x;
					}
				}
			}
		}
		max1 = -1;
		maxi1 = -1;
		max2 = -1;
		maxi2 = -1;
		for (int i : g[x]) {
			if (i != y) {
				if (a[i][1] > max1) {
					max2 = max1;
					maxi2 = maxi1;
					max1 = a[i][1];
					maxi1 = i;
				} else if (a[i][1] > max2) {
					max2 = a[i][1];
					maxi2 = i;
				}
			}
		}
		if (a[x][2] < max1 + max2) {
			a[x][2] = max1 + max2;
			if (maxi1 < 0) {
				pa[x][2][0] = x;
				pa[x][2][1] = x;
			} else {
				pa[x][2][0] = pa[maxi1][1][0];
				pa[x][2][1] = pa[maxi1][1][1];
			}
			if (maxi2 < 0) {
				pa[x][2][2] = x;
				pa[x][2][3] = x;
			} else {
				pa[x][2][2] = pa[maxi2][1][0];
				pa[x][2][3] = pa[maxi2][1][1];
			}
		}

	}

	int[][] a, b;

	int[][][] pa, pb;

}
