#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <iostream>

using namespace std;

#define maxn 100010

vector <int> ne[maxn];

int dp[maxn][3][2], a[maxn][3][2], b[maxn][3][2], c[maxn][3][2], d[maxn][3][2];

void ch( int v, int i, int j, int r, int ra, int rb, int rc, int rd )
{
  if (r > dp[v][i][j])
  {
    dp[v][i][j] = r;
    a[v][i][j] = ra;
    b[v][i][j] = rb;
    c[v][i][j] = rc;
    d[v][i][j] = rd;
  }
}

void go( int v, int p )
{
  int o[3][2][3];
  memset(o, 0, sizeof(o));
  
  for (int i = 0; i < (int)ne[v].size(); i++)
  {
    int x = ne[v][i];
    if (x == p)
      continue;
    go(x, v);
    for (int j = 0; j < 3; j++)
      for (int k = 0; k < 2; k++)
        if (o[j][k][2] == 0)
          o[j][k][2] = x;
        else if (o[j][k][1] == 0)
        {
          o[j][k][1] = x;
          if (dp[o[j][k][1]][j][k] > dp[o[j][k][2]][j][k])
            swap(o[j][k][1], o[j][k][2]);
        }
        else if (o[j][k][0] == 0 || dp[o[j][k][0]][j][k] < dp[x][j][k])
        {
          o[j][k][0] = x;
          if (dp[o[j][k][0]][j][k] > dp[o[j][k][1]][j][k])
            swap(o[j][k][0], o[j][k][1]);
          if (dp[o[j][k][1]][j][k] > dp[o[j][k][2]][j][k])
            swap(o[j][k][1], o[j][k][2]);
        }
  }

  for (int fi = 0; fi < 3; fi++)
    for (int fj = 0; fj < 2; fj++)
      for (int fp = 0; fp < 3; fp++)
        for (int si = 0; si < 3; si++)
          for (int sj = 0; sj < 2; sj++)
            for (int sp = 0; sp < 3; sp++)
            {
              int x = o[fi][fj][fp], y = o[si][sj][sp], rx = dp[x][fi][fj], ry = dp[y][si][sj];

              if (rx != 0 && ry != 0 && x != y) // connect
                if (fj && sj && fi + si < 4 && fi >= si)
                {
                  ch(v, fi + si - 1, 0, rx + ry + 1, a[x][fi][fj], a[y][si][sj], c[x][fi][fj], d[x][fi][fj]);
                  if (fi + si == 2)
                    for (int tj = 0; tj < 2; tj++)
                      for (int tp = 0; tp < 3; tp++)
                      {
                        int z = o[1][tj][tp], rz = dp[z][1][tj];
                        if (rz != 0 && z != x && z != y)
                          ch(v, fi + si, 0, rx + ry + 1 + rz, a[x][fi][fj], a[y][si][sj], a[z][1][tj], b[z][1][tj]);
                      }
                }    
              
              if (x != y && rx != 0 && fj && fi >= si && fi + si < 3) // continue only one
                ch(v, fi + si, 1, rx + ry + 1, a[x][fi][fj], v, max(c[x][fi][fj], a[y][si][sj]), max(d[x][fi][fj], b[y][si][sj]));
             

              if (fi < 2 && (x || fi == 0))  // start new
                ch(v, fi + 1, 1, rx + 1, v, v, a[x][fi][fj], b[x][fi][fj]);
            
              if (fi + si <= 2 && fi >= si && rx != 0 && x != y)              		
                ch(v, fi + si, 0, rx + ry, a[x][fi][fj], b[x][fi][fj], max(c[x][fi][fj], a[y][si][sj]), max(d[x][fi][fj], b[y][si][sj]));
            }
}

int main( void )
{
  freopen("collider.in", "r", stdin);
  freopen("collider.out", "w", stdout);

  int n;
  scanf("%d", &n);

  for (int i = 1; i < n; i++)
  {
    int a, b;
    scanf("%d%d", &a, &b);
    ne[a].push_back(b);
    ne[b].push_back(a);
  }

  memset(dp, 0, sizeof(dp));
  go(1, -1);
  ch(1, 2, 0, dp[1][2][1], a[1][2][1], b[1][2][1], c[1][2][1], d[1][2][1]);
  printf("%d\n%d %d\n%d %d\n", dp[1][2][0], a[1][2][0], c[1][2][0], b[1][2][0], d[1][2][0]);

  return 0;
}
