#include <iostream>
#include <fstream>
#include <cstdio>
#include <set>
using namespace std;

const int MAXN = 100000;

int prod[MAXN], need[MAXN], cost[MAXN];
int store[MAXN], cstore[MAXN];
int n;

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d%d", &prod[i], &cost[i], &need[i]);
	}
	for (i = 0; i < n - 1; i++)
	{
		scanf("%d%d", &store[i], &cstore[i]);
	}
}

void Solve()
{
	int i;
	multiset<pair<long long, long long> > have;
	long long havesz = 0;
	long long ans = 0;
	long long havedelta = 0;
	for (i = 0; i < n; i++)
	{
		have.insert(make_pair(cost[i] - havedelta, prod[i]));
		havesz += prod[i];
		long long cur = need[i];
		while (cur != 0)
		{
			if (have.size() == 0)
			{
				printf("-1");
				return;
			}
			pair<long long, long long> cval = *have.begin();
			have.erase(have.begin());
			if (cur >= cval.second)
			{
				havesz -= cval.second;
				ans += (cval.first + havedelta) * cval.second;
				cur -= cval.second;
			}
			else
			{
				havesz -= cur;
				ans += (cval.first + havedelta) * cur;
				cval.second -= cur;
				have.insert(cval);
				cur = 0;
			}
		}
		havedelta += cstore[i];
		while (havesz > store[i])
		{
			pair<long long, long long> cval = *(--have.end());
			have.erase(--have.end());
			long long needout = havesz - store[i];
			if (needout >= cval.second)
			{
				havesz -= cval.second;
				needout -= cval.second;
			}
			else
			{
				havesz -= needout;
				cval.second -= needout;
				have.insert(cval);
			}
		}
	}
	cout << ans << "\n";
}

int main()
{
//	freopen("bakery.in", "rt", stdin);
//	freopen("bakery.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
