#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <set>

using namespace std;

#ifdef _WIN32
#  define I64 "%I64d"
#else
#  define I64 "%Ld"
#endif

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define mp make_pair

typedef long long ll;
typedef pair <ll, int> pii;

#define maxn 100000

int n, c[maxn], f[maxn], d[maxn], g[maxn], e[maxn];

int main()
{
  scanf("%d", &n);
  assert(1 <= n && n <= maxn);
  forn(i, n)
    scanf("%d%d%d", &c[i], &f[i], &d[i]);
  forn(i, n - 1)
    scanf("%d%d", &g[i + 1], &e[i + 1]);

  int sum = 0, dif;
  ll add = 0, ans = 0;
  multiset <pii> s;
  forn(i, n)
  { 
    if (i)
      while ((dif = sum - g[i]) > 0)
      {
        multiset <pii>::iterator it = s.end(); it--;
        pii p = *it;
        s.erase(it);
        if (p.second > dif)
          s.insert(mp(p.first, p.second - dif)), sum = g[i];
        else
          sum -= p.second;          
      }

    add += e[i], sum += c[i] - d[i];
    s.insert(mp(f[i] - add, c[i]));
    if (sum < 0)
    {
      puts("-1");
      return 0;
    }
    while (d[i] > 0)
    {
      multiset <pii>::iterator it = s.begin();
      pii p = *it;
      s.erase(it);
      if (p.second > d[i])
        s.insert(mp(p.first, p.second - d[i])), dif = d[i];
      else
        dif = p.second;
      ans += (p.first + add) * dif, d[i] -= dif;
    }
  }
  printf(I64 "\n", ans);
  return 0;
}
