#include <iostream>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

#define NMAX 100000
#define VMAX 1000000000

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define PII pair<long long, int>
#define mp make_pair

int main() {
    
//    freopen("bakery.in", "rt", stdin);
//    freopen("bakery.out", "wt", stdout);

    int n;
    scanf("%d", &n);
    assert(1 <= n && n <= NMAX);
    vector<int> c(n), f(n), d(n), g(n), e(n);
    forn (i, n) {
        scanf("%d%d%d", &c[i], &f[i], &d[i]);
        assert(0 <= c[i] && c[i] <= VMAX);
        assert(0 <= f[i] && f[i] <= VMAX);
        assert(0 <= d[i] && d[i] <= VMAX);
    }
    forn (i, n - 1) scanf("%d%d", &g[i], &e[i]);

    multiset<PII > q;

    long long add = 0;
    long long sz = 0;
    long long ans = 0;
    forn (i, n) {
        q.insert(mp(f[i] - add, c[i]));
        sz += c[i];

        while (!q.empty() && d[i] > 0) {
            multiset<PII >::iterator it = q.begin();
            PII source = *it;
            int delta = min(d[i], source.second);
            source.second -= delta;
            d[i] -= delta;
            ans += delta * (add + source.first);
            q.erase(it);
            if (source.second > 0) {
                q.insert(source);    
            } 
            sz -= delta;
        }

        if (d[i] > 0) {
            ans = -1;
            break;
        }

        if (i != n - 1) {
            add += e[i];
            while (sz > g[i]) {
               multiset<PII >::iterator it = q.end();
               --it;
               PII last = *it;
               q.erase(it);
               long long delta = sz - g[i];
               sz -= last.second;
               if (last.second > delta) {
                 last.second -= int(delta);
                 q.insert(last);
                 sz += last.second;
               }
            }
        }
    }        

    cout << ans << endl;

    return 0;
}