#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

const int maxn = 1 << 18;
const int maxm = (int)2e5;

int res = 0, n, m, l[maxm], r[maxm], cnt[maxm];
int t[maxn * 2];
vector <int> c[maxn * 2];

void Do( int v, int vl, int vr, int i )
{
  if (l[i] <= vl && vr <= r[i])
    cnt[i]++, c[v].pb(i);
  else if (vr >= l[i] && r[i] >= vl)
  {
    int vm = (vl + vr) >> 1;
    Do(v * 2, vl, vm, i);
    Do(v * 2 + 1, vm + 1, vr, i);
  }
}

void Dec( int v )
{
  t[v]++;
  if (t[v] == 2 || v >= maxn)
  {
    Dec(v / 2);
    forn(i, c[v].size())
      if (--cnt[c[v][i]] == 0)
        res++;
  }
}

int main()
{
  scanf("%d%d", &n, &m);
  assert(1 <= n && n <= (int)2e5);
  assert(1 <= m && m <= maxm);
  forn(i, m)
  {
    scanf("%d%d", &l[i], &r[i]), l[i]--, r[i]--;
    assert(0 <= l[i] && l[i] <= r[i] && r[i] < n);
    Do(1, 0, maxn - 1, i);
  }
  forn(i, n)
  {
    int x;
    scanf("%d", &x), x--;
    assert(0 <= x && x < n);
    Dec(x + maxn);
    printf("%d\n", res);
  }
  return 0;
}
