#include <iostream>
#include <fstream>
#include <cstdio>

using namespace std;

const int MAXL = 1000000;
const int MAXK = 10000;

class Num
{
public:
	int a[MAXL];
	int l;
};

Num a, b;
int k;

int Good(char c)
{
	if ((c >= 'A') && (c <= 'U')) return 1;
	if ((c >= '0') && (c <= '9')) return 1;
	return 0;
}

int GDig(char c)
{
	if ((c >= '0') && (c <= '9')) return c - '0';
	else return c - 'A' + 10;
}

void RNum(Num &a)
{
	char c = getchar();
	while (! Good(c)) c = getchar();
	memset(a.a, 0, sizeof(a.a));
	a.l = 0;
	while (Good(c))
	{
		a.a[a.l++] = GDig(c);
		c = getchar();
	}
	int i, j;
	i = 0;
	j = a.l - 1;
	while (i < j)
	{
		int t = a.a[i];
		a.a[i] = a.a[j];
		a.a[j] = t;
		i++;
		j--;
	}
}

void Load()
{
	RNum(a);
	RNum(b);
	scanf("%d", &k);
}

const int BASE = 31;
int inv[BASE];
int ans[MAXK];

char SDig(int a)
{
	if (a < 10) return (char)(a + '0');
	else return (char)(a - 10 + 'A');
}

void Solve()
{
	int i, j;
	for (i = 1; i < BASE; i++)
	{
		for (j = 1; j < BASE; j++)
		{
			if (i * j % BASE == 1) 
			{
				inv[i] = j;
				break;
			}
		}
	}
	int zb;
	zb = 0;
	while (b.a[zb] == 0) 
	{
		if (a.a[zb] != 0) printf("Botva");
		zb++;
	}
	for (i = 0; i < k; i++)
	{
		if (zb + i >= a.l)
		{
			ans[i] = 0;
			continue;
		}
		ans[i] = (a.a[zb + i] * inv[b.a[zb]]) % BASE;
		int j;
		for (j = zb; j < b.l; j++)
		{
			if (j > zb + k) break;
			if (j >= a.l) break;
			a.a[j + i] -= b.a[j] * ans[i];
			a.a[j + i + 1] += a.a[j + i] / BASE;
			a.a[j + i] %= BASE;
			if (a.a[j + i] < 0)
			{
				a.a[j + i + 1]--;
				a.a[j + i] += BASE;
			}
		}
		j = b.l;
		while (j + i < a.l && a.a[j + i] < 0)
		{
			a.a[j + i + 1]--;
			a.a[j + i] += BASE;
		}
	}
	for (i = k - 1; i >= 0; i--)
	{
		printf("%c", SDig(ans[i]));
	}
}

int main()
{
	freopen("division.in", "rt", stdin);
	freopen("division.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
