#include <cstdio>
#include <cassert>

#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define sz(a) (int)(a).size()

#define maxn 10000
#define maxm 10000

vector <int> c[maxn], cr[maxn];
int n, m, u[maxn];

void dfs( int v, int col )
{
  if (u[v] >= col)
    return;
  u[v] = col;
  forn(i, sz(c[v]))
    dfs(c[v][i], 1);
  if (col == 2)
    forn(i, sz(cr[v]))
      dfs(cr[v][i], 2);
}

int main()
{
  scanf("%d%d", &n, &m);
  assert(1 <= n && n <= maxn && 0 <= m && m <= maxm);
  forn(i, m)
  {
    int a, b;
    scanf("%d%d", &a, &b), a--, b--;
    assert(0 <= a && a < n && 0 <= b && b < n);
    c[a].pb(b), cr[b].pb(a);
  }

  int sum = 0;
  forn(i, n)
  {
    forn(j, n)
      u[j] = 0;
    dfs(i, 2);
    forn(j, n)
      sum += (u[j] > 0);
  }
  printf("%d\n", sum);
  return 0;
}
