#include <cstdio>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

#define maxn 4000

vector <int> c[maxn];
int n, m;
char u[maxn];
unsigned int g[maxn][maxn / 32 + 1];

void dfs( int v )
{
  u[v] = 1;
  forn(i, (int)c[v].size())
    if (!u[c[v][i]])
      dfs(c[v][i]);
}

int main()
{
  scanf("%d%d", &n, &m);
  forn(i, m)
  {
    int a, b;
    scanf("%d%d", &a, &b), a--, b--;
    c[a].pb(b);
  }

  forn(i, n)
  {
    memset(u, 0, sizeof(u));
    dfs(i);
    forn(j, n)
      if (u[j]) // i --> j
        g[j][i >> 5] |= 1U << (i & 31);
  }

  int sum = 0;
  forn(i, n)
    forn(j, n)
    {
      int f = 0, n1 = (n >> 5) + 1;
      forn(k, n1)
        if (g[i][k] & g[j][k])
          f = 1, k = n1;
      sum += f;
    }
  printf("%d\n", sum);
  return 0;
}
