#include <cassert>
#include <ctime>
#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

const int N = 16;

int f[1 << N];
int inv[N + 1];
int clause[1 << N];

vector<pair<pair<int, int>, int> > ans;

int main() {
	/*
	srand(time(NULL));
	freopen("input.txt", "w", stdout);
	printf("%d\n", N);
	for (int i = 0; i < (1 << N); i++) {
		printf("%d", rand() % 2);
	}
	printf("\n");
	*/
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	scanf("%d\n", &n);
	assert(n == N);
	for (int i = 0; i < (1 << N); i++) {
		int x = getc(stdin);
		f[i] = x - '0';
	}
	int counter = 0;
	for (int i = 1; i <= N; i++) {
		counter++;
		ans.push_back(make_pair(make_pair(0, -i), 123123));
		inv[i] = counter;
	}
	for (int i = 0; i < (1 << N); i++) {
		if (!f[i]) continue;
		int last = -7;
		for (int j = 1; j <= N; j++) {
			int v = (i >> (N - j)) & 1;
			int cur;
			if (!v) cur = inv[j];
			else cur = -j;
			if (last == -7) last = cur;
			else {
				counter++;
				ans.push_back(make_pair(make_pair(1, last), cur));
				last = counter;
			}
		}
		clause[i] = counter;
	}
	int last = -7;
	for (int i = 0; i < (1 << N); i++) {
		if (!f[i]) continue;
		if (last == -7) {
			last = clause[i];
			continue;
		}
		counter++;
		ans.push_back(make_pair(make_pair(2, last), clause[i]));
		last = counter;
	}
	printf("%d\n", int(ans.size()));
	for (int i = 0; i < int(ans.size()); i++) {
		if (ans[i].first.first == 0) {
			printf("! %d\n", ans[i].first.second);
		}
		else if (ans[i].first.first == 1) {
			printf("& %d %d\n", ans[i].first.second, ans[i].second);
		}
		else {
			printf("| %d %d\n", ans[i].first.second, ans[i].second);
		}
	}
	return 0;
}
