#include <cstdio>
#include <cstring>

#ifdef _WIN32
#  define I64 "%I64d"
#else
#  define I64 "%Ld"
#endif

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef unsigned long long ll;

#define rest(a, i) ((a) & ((1 << (i)) - 1))

#define maxn (int)1e7
#define maxk 24

int N, K, P, Q, a[maxn];

int mpos = 0, mem[1 << (maxk + 1)];
int st, *num[maxk];
ll sum, ans[64];

void dfs( int i, int x, int y )
{
  int z = x + y;
  if (i == 0 || (i != st && (z & 1) == 0))
  {
    if ((z >> (st - i)) & 1)
      sum += (ll)num[i][x] * num[i][y];
  }
  else
  {
    if (i != st)
      if (!num[i][x] || !num[i][y])
        return;
    forn(x1, 2)
      forn(y1, 2)
        dfs(i - 1, x * 2 + x1, y * 2 + y1);
  }
}

int main()
{
  scanf("%d%d%d%d", &N, &K, &P, &Q);
  a[0] = 1;
  for (int i = 1; i < N; i++)
    a[i] = rest(a[i - 1] * P + Q, K);
  for (int i = K - 1; i >= 0; i--)
  {
    st = i;
    if (i == K - 1)
    {
//      puts("!");
      for (int x = st; x >= 0; x--)
        num[x] = mem + mpos, mpos += 1 << (st - x + 1);
      forn(j, N)
        num[0][rest(a[j], st + 1)]++;
      for (int x = 1; x <= st; x++)
      {
        int len = st - x + 1;
        forn(j, 1 << (len + 1))
          num[x][j >> 1] += num[x - 1][j];
      }
//      puts("!");
    }
    else
      for (int x = 0; x <= st; x++)
      {
        int len = st - x + 1;
        forn(j, 1 << len)
          num[x][j] += num[x][j + (1 << len)];
      }

    if (i == K - 1)
    {
//      printf("do %d\n", K);
      sum = 0;
      st++;
      dfs(st, 0, 0);
      st--;
      ans[K] = sum;
    }
//    printf("do %d\n", i);
    sum = 0;
    forn(x, 2)
      forn(y, 2)
        dfs(st, x, y);
    ans[i] = sum;
  }
  for (int i = 0; i <= K; i++)
    printf(I64 " ", ans[i]);
  return 0;
}
