#include <cstdio>
#include <cstring>
#include <cassert>

#define m 10010

char s[m];
int f[m + m], n;

int main()
{
  assert(scanf("%s", s) == 1);
  n = strlen(s);
  assert(1 <= n && n <= 10000);
  int ans = 0;
  for (int ij = 0; ij < 2 * n - 1; ij++)
    if (ij % 2 == 0)
      f[ij] = 0, ans++;
    else
      f[ij] = -1;
  for (int ij = 0; ij < n; ij++)
    for (int i = 0; i + ij < n; i++)
    {
      int j = i + ij;
      if (s[i] == s[j] && f[i + j] == j - i - 2)
        f[i + j] += 2, ans++;
    }
  printf("%d\n", ans);
  fflush(stdout);
  for (int t = 0; t < n; t++)
  {
    int x;
    assert(scanf("%d", &x) == 1);
    assert(1 <= x && x <= n);
    x--;
    s[x] = '?';
    for (int ij = 0; ij < 2 * n - 1; ij++)
    {
      int t = (f[ij] + 2) / 2, l = (ij) / 2 - t, r = (ij + 1) / 2 + t;
      while (0 <= l && r < n && (s[l] == '?' || s[r] == '?' || s[l] == s[r]))
        l--, r++, f[ij] += 2, ans++;
    }
    printf("%d\n", ans);
    fflush(stdout);
  }
  return 0;
}
