{$M 80000000,80000000}
type
    int = longint;
	list = ^node;
	node = record
		inf: int;
		next: list;
	end;
const
    NMAX = 100001;
	p = 1000000007;
	infinity = p + 1;
var
	good, used: array [1..NMAX] of boolean;
	g: array [1..NMAX] of list;
	v: array [1..NMAX] of int;
	n, m, ans, k, number: int;

procedure add(x, y: int);
var
	t: list;
begin
	new(t);
	t^.inf := y;
	t^.next := g[x];
	g[x] := t;
end;

procedure dfs(k, now, st: int);
var
	t: list;
begin
	if now > ans then exit;
	if (k <> st) and (good[k]) then begin
		if ans > now then begin
			ans := now;
			number := 0;
		end;
		if ans = now then inc(number);
		exit;
	end;

	t := g[k];
	while t <> nil do begin
		if not used[t^.inf] then begin
			used[t^.inf] := true;
			dfs(t^.inf, now + 1, st);
			used[t^.inf] := false;
		end;
		t := t^.next;
	end;
end;

var
	i, x, y: int;

begin
	read(n, m, k);
	for i := 1 to n do
		g[i] := nil;
	for i := 1 to k do begin
		read(v[i]);
		good[v[i]] := true;
	end;
	for i := 1 to m do begin
		read(x, y);
		add(x, y);
		add(y, x);
	end;

	ans := infinity;
	number := 0;
	for i := 1 to k do begin
		fillchar(used, sizeof(used), 0);
		used[v[i]] := true;
		dfs(v[i], 0, v[i]);
	end;

	writeln(ans, ' ', number shr 1);
end.