{$O+,S-,R-,Q-}
uses
	sysutils;
type
    int = longint;
const
    NMAX = 3001;
	dx: array [1..4] of int = (1, 0, -1, 0);
	dy: array [1..4] of int = (0, -1, 0, 1);
var
	a: array [1..NMAX, 1..NMAX] of boolean;
	n, m, xans, yans, rans, ans: int;

function may(x, y: int): boolean;
var
	i: int;
begin
	may := true;
	if not a[x, y] then exit;
	for i := 1 to 4 do
		if a[x + dx[i], y + dy[i]] then begin
			may := false;
			exit;
		end;
end;

function min(x, y: int): int;
begin
	if x < y then min := x
		else min := y;
end;

function point(x, y: int): int;
begin
	if a[x, y] then point := 1
		else point := 0;
end;

procedure find(x, y: int);
var
	now, i, j, r: int;
	flag: boolean;

begin
	r := min(min(x - 1, n - x), min(y - 1, m - y));
	now := point(x, y);
	flag := true;
	for i := 1 to r do begin
		for j := -i + 1 to i - 1 do
			if (not may(x + j, y + i - abs(j) - 1)) or (not may(x + j, y - i + abs(j) + 1)) then begin
				r := i - 1;
				flag := false;
				break;
			end;
		if not flag then break;
		for j := -i to i do begin
			inc(now, point(x + j, y + i - abs(j)));
			inc(now, point(x + j, y - i + abs(j)));
		end;
		dec(now, point(x - i, y) + point(x + i, y));
	end;

	if now > ans then begin
		ans := now;
		xans := x;
		yans := y;
		rans := r;
	end;
end;

var
	i, j: int;
	start: real;
	ch: char;

begin
	start := now;
	readln(n, m);
	fillchar(a, sizeof(a), 0);
	for i := 1 to n do begin
		for j := 1 to m do begin
			read(ch);
			if ch = '*' then a[i, j] := true;
		end;
		readln;
	end;

	xans := 0;
	yans := 0;
	rans := 0;
	ans := -1;
	for i := 1 to n do
		for j := 1 to m do
			if (now - start) *24 * 3600 > 1.8 then break
				else find(i, j);

	writeln(ans, ' ', yans, ' ', xans, ' ', rans);
end.