#include <cstdio>
#include <cstring>
#include <cassert>
#include <vector>
#include <algorithm>

using namespace std;

typedef unsigned long long ht;

#define P 239017
#define m 10100

ht p[m], h[m];
char s[m], g[m], ta[m];
int l, ans, is[m];

int main()
{
  assert(gets(s));
  l = strlen(s);
  assert(1 <= l && l <= 10000);
  for (int i = 0; i < l; i++)
    assert('a' <= s[i] && s[i] <= 'z');
  p[0] = 1;
  for (int i = 0; i < l; i++)
    p[i + 1] = p[i] * P;
  h[0] = 0;
  for (int i = 0; i < l; i++)
    h[i + 1] = h[i] * P + s[i];
  ans = l;
  strcpy(g, s);
  ta[0] = 0;
  for (int len = 1; len <= l; len++)
  {
    memset(is, 0, sizeof(is));
    for (int i = 0; i + len <= l; i++)
      is[(h[i + len] - p[len] * h[i]) % m] = 1;
//    printf("----------len=%d\n", len);
    vector <pair <int, int> > t;
    for (int i = 0; i + len <= l; i++)
    {
      ht tt = h[i + len] - p[len] * h[i];
//      if (is[tt % m] > 1)
        t.push_back(make_pair(tt, i));
    }
    sort(t.begin(), t.end());
    int be = -1, bepos = -1;
    for (int i = 0, j = 0; i < (int)t.size(); i = j)
    {
      int r = t[i].second + len - 1;
      int nu = 1;
      for (j++; j < (int)t.size() && t[j].first == t[i].first; j++)
        if (t[j].second > r)
          nu++, r = t[j].second + len - 1;
      if (be == -1 || be < nu)
      {
//        printf("nu=%d pos=%d len=%d\n", nu, t[i].second, len);
        be = nu, bepos = t[i].second;
      }
    }
    if (be != -1 && l - be * (len - 1) + len < ans)
    {
      printf("be=%d len=%d\n", be, len);
      ans = l - be * (len - 1) + len;
      int j = 0;
      for (int i = 0; i < l; )
        if (h[bepos + len] - h[bepos] * p[len] ==
            (h[i + len] - h[i] * p[len]) * p[i - bepos])
          i += len, g[j++] = 'A';
        else
          g[j++] = s[i++];
      g[j] = 0;
      for (int i = 0; i < len; i++)
        ta[i] = s[bepos + i];
      ta[len] = 0;
    }
  }
  puts(ta);
  puts(g);
  return 0;
}
