#include <cstdio>
#include <cassert>
#include <algorithm>

using namespace std;

#define m 10100

int n, k, nu, v[m];
long long a[m], b[m], s[m], l[m], r[m], p[m], sum;

int main()
{
  assert(scanf("%d", &n) == 1);
  assert(1 <= n && n <= 10000);
  for (int i = 0; i < n; i++)
  {
    assert(scanf("%lld", &a[i]) == 1);
    assert(1 <= a[i] && a[i] <= 1000000000);
    b[i] = a[i], s[i] = a[i] + b[i];
    sum += a[i];
  }
//  fprintf(stderr, "data has been read\n");
  nu = 0;
  assert(scanf("%d", &k) == 1);
  for (int i = 0; i < k; i++)
  {
    assert(scanf("%lld%lld", &l[i], &r[i]) == 2);
//    fprintf(stderr, "i=%d l=%lld r=%lld\n", i, l[i], r[i]);
    assert(1 <= l[i] && l[i] <= r[i] && r[i] <= sum);
    l[i]--, r[i]--;
    for (long long j = l[i]; j <= r[i]; j++)
    {
      p[nu++] = j;
      assert(nu <= 10000);
    }
  }
//  fprintf(stderr, "queries have been read\n");
  sort(p, p + nu);
  nu = unique(p, p + nu) - p;
  for (int i = 0; i < n; i++)
    if (a[i] * 2 > sum)
    {
      puts("Bad luck");
      return 0;
    }
//  fprintf(stderr, "answer is Ok\n");
  long long pos = 0;
  int x = 0;
  int _max = 0, _sum = 0, _cnt2 = 0;
  for (int i = 0; i < n; i++)
  {
    int _cnt = 0;
    while (a[i] > 0)
    {
      _cnt++;
      _max = max(_max, _cnt);
      _sum++;
/*      if (i % 1000 == 0)
        printf("i=%d\n", i);*/
      int jj = -1, ma = -1;
      for (int j = 0; j < n; j++)
        if (b[j] > 0 && j != i)
        {
          if (jj == -1)
            jj = j;
          if (ma == -1 || s[j] > s[ma])
            ma = j;
        }
      if (s[ma] == sum)
        jj = ma;
      // current color: jj
      long long d = min(sum, min(a[i], b[jj]));
      for (int j = 0; j < n; j++)
        if (j != i && j != jj)
        {
          if (d > sum - s[j])
            _cnt2++;
          d = min(d, sum - s[j]);
        }
      // segment length: d
      sum -= d;
      a[i] -= d; s[i] -= d;
      b[jj] -= d; s[jj] -= d;
      while (x < nu && p[x] < pos)
        x++;
      while (x < nu && p[x] < pos + d)
        v[x++] = jj;
      pos += d;
    }
  }
  fprintf(stderr, "sum=%d max cnt=%d cnt2=%d\n", _sum, _max, _cnt2);
//  fprintf(stderr, "creating answer...\n");
  puts("Ok");
  for (int i = 0; i < k; i++)
  {
    int x = lower_bound(p, p + nu, l[i]) - p;
//    fprintf(stderr, "l[i]=%lld r[i]=%lld x=%d\n", l[i], r[i], x);
    while (x < nu && p[x] <= r[i])
      printf("%d%c", v[x] + 1, " \n"[p[x] == r[i]]), x++;
  }
  return 0;
}
