{$O+,R-,S-,Q-}
uses
	math;
type
    int = longint;
const
    NMAX = 1001;
	KMAX = 1001;
	CON = 100000000;
	DLMAX = 200;
var
	ans: array [0..NMAX, 0..1] of int;
	tree_people: array [0..NMAX, 0..KMAX] of int;
	edge: array [1..NMAX, 1..DLMAX] of int;
	l, r, num, where, used: array [1..NMAX] of int;
	n, m, dl, k: int;

procedure way(n, k, tmp: int);
var
	i, now: int;
begin
	if tmp = 0 then exit;
	now := tree_people[n, k];
	if now < 0 then 
		way(-now, k and 1, tmp)
	else begin
		way(now, (k + 1) and 1, tmp - 1);
		write(r[num[now + 1]], ' ');
		i := 1;
		while (where[num[now + 1]] >= i) and (edge[now + 1, i] <= n) do begin
			used[num[edge[now + 1, i]]] := tmp;
			inc(i);
		end;
	end;
end;

procedure qsort(ll, rr: int);
var
	i, j, x, tmp: int;
begin
	i := ll;
	j := rr;
	x := (i + j) shr 1;
	while i <= j do begin
		while r[num[i]] < r[num[x]] do
			inc(i);
		while r[num[j]] > r[num[x]] do
			dec(j);
		if i <= j then begin
			tmp := num[i];
			num[i] := num[j];
			num[j] := tmp;
			inc(i);
			dec(j);
		end;
	end;
	if i < rr then qsort(i, rr);
	if ll < j then qsort(ll, j);
end;

var
	i, j, f: int;

begin
	{assign(output, 'trains.out');
	rewrite(output);}

	read(n, m, k);
	dl := min(DlMAX, CON div (n * max(20, k)));
	if dl > m then dl := m;

	for i := 1 to n do begin
		read(l[i], r[i]);
		num[i] := i;
	end;
	if k >= n then begin
		writeln(n);
		for i := 1 to n do
			write(r[i], ' ');
		for i := n + 1 to k do
			write(1, ' ');
		writeln;
		for i := 1 to n do
			write(i, ' ');
		exit;
	end;
	if n > 1 then qsort(1, n);

	fillchar(edge, sizeof(edge), 0);
	fillchar(where, sizeof(where), 0);
	for i := 1 to n do
		for j := i downto 1 do
			if r[num[j]] >= l[num[i]] then begin
				inc(where[num[j]]);
				if where[num[j]] <= dl then
					edge[j, where[num[j]]] := i	
				else dec(where[num[j]]);
			end
			else break;

	fillchar(ans, sizeof(ans), 255);
	ans[0, 0] := 0;
	for j := 0 to k do begin
		fillchar(ans[(j + 1) and 1], sizeof(ans[(j + 1) and 1]), 255);
		for i := 0 to n - 1 do begin
			if ans[i + 1, j and 1] < ans[i, j and 1] then begin
				ans[i + 1, j and 1] := ans[i, j and 1];
				tree_people[i + 1, j] :=  -i;
			end;
			if j < k then 
				for f := 1 to where[num[i + 1]] do begin
					if ans[edge[i + 1, f], (j + 1) and 1] < ans[i, j and 1] + f then begin
						ans[edge[i + 1, f], (j + 1) and 1] := ans[i, j and 1] + f;
						tree_people[edge[i + 1, f], (j + 1) and 1] := i;
					end;
				end;
		end;
	end;

	writeln(ans[n, k and 1]);
	fillchar(used, sizeof(used), 0);
	way(n, k and 1, k);
	writeln;
	for i := 1 to n do
		write(used[i], ' ');
end.