#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>

using namespace std;

bool IsPalindrome(const string& s, int start, int len) {
  assert(start + len <= s.size());
  for (int i = 0; i < len - 1 - i; ++i)
    if (s[start + i] != s[start + len - 1 - i])
      return false;
  return true;
}

int main() {
  string cur = "01";
  string prev = "0";
  while (cur.size() < 50000000) {
    string next = cur + prev;
    prev = cur;
    cur = next;
  }
  int n;
  scanf("%d", &n);
  for (int i = 0; i < n; ++i) {
    int start;
    int len;
    scanf("%d %d", &start, &len);
    --start;
    if (IsPalindrome(cur, start, len)) {
      printf("TAK\n");
    } else {
      printf("NIE\n");
    }
  }
}
