#include <cstdio>
#include <cstring>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef long long ll;

const int maxn = 5000;

int n, x[maxn * 2], y[maxn * 2];

int main()
{
  scanf("%d", &n);
  forn(i, n)
    scanf("%d%d", &x[i], &y[i]);
  forn(i, n)
    x[i + n] = x[i], y[i + n] = y[i];
  int st = rand() % n;
  forn(i, n)
    x[i] = x[i + st], y[i] = y[i + st];
  
  ll ans = 0;
  forn(i, n)
  {
    for (int j = i + 1; j < n; j++)
      x[j] -= x[i], y[j] -= y[i];
    for (int j = i + 1; j < n - 1; j++)
    {
      int mi = j + 1, ma = n - 1;
      while (mi < ma)
      {
        int l = (ma + mi) / 2, r = l + 1;
        ll sl = abs((ll)x[l] * y[j] - (ll)y[l] * x[j]);
        ll sr = abs((ll)x[r] * y[j] - (ll)y[r] * x[j]);
        if (sl > sr)
          ma = l;
        else if (sl < sr)
          mi = r;
        else
          mi = ma = l;
      }

      ll s = abs((ll)x[mi] * y[j] - (ll)y[mi] * x[j]);
      if (s > ans)
        ans = s;
    }
    for (int j = i + 1; j < n; j++)
      x[j] += x[i], y[j] += y[i];
  }

  printf("%.1lf\n", ans * 0.5);
  return 0;
}
