// Using period = 4
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

using namespace std;

const int MinT = 1, MaxT = 100;
const int MinN = 1, MaxN = 100;
const int MinK = 1, MaxK = 1000000000;

int a [MaxN];
int n;

int main (void)
{
 int test, tests;
 int i, res;
 scanf (" %d", &tests);
 assert (MinT <= tests && tests <= MaxT);
 for (test = 0; test < tests; test++)
 {
  scanf (" %d", &n);
  assert (MinN <= n && n <= MaxN);
  for (i = 0; i < n; i++)
  {
   scanf (" %d", &a[i]);
   assert (MinK <= a[i] <= MaxK);
  }
  for (i = 0; i < n; i++)
   if ((a[i] & 3) == 0)
    a[i]--;
   else if ((a[i] & 3) == 3)
    a[i]++;
  res = 0;
  for (i = 0; i < n; i++)
   res ^= a[i];
  printf ("%s\n", res ? "FIRST" : "SECOND");
 }
 return 0;
}
