{$Q+,R+,C+}
var trump:char;
	player_move,player_beat,numbeat,deck:integer;
	numcards:array[1..4] of integer;
	cards:array[1..4,1..36] of string;
	cards_up,cards_down:array[1..36] of string;
	taken:boolean;
	pl:array[1..4] of integer;

function was_value(c:char):boolean;
var i:integer;
begin
	for i:=1 to numbeat do 
		if (cards_down[i][1]=c) then begin
			was_value:=true; exit;
		end;
	for i:=1 to numbeat-1 do 
		if (cards_up[i][1]=c) then begin
			was_value:=true; exit;
		end;
	was_value:=false;
end;

procedure add(player:integer;s:string);
begin
	inc(numcards[player]);
	cards[player][numcards[player]]:=s;
end;

procedure del(player:integer;s:string);
var i,v:integer;
begin
	v:=-1;
	for i:=1 to numcards[player] do 
		if (cards[player][i]=s) then begin
			v:=i; break;
		end;
	if (v=-1) then 
		for i:=1 to numcards[player] do 
			if (cards[player][i]='??') then begin
				v:=i; break;
			end;
	assert(v<>-1);
	dec(numcards[player]);
	for i:=v to numcards[player] do 
		cards[player][i]:=cards[player][i+1];
end;

function num_val(c:char):integer;
begin
	if (c='6') then num_val:=1;
	if (c='7') then num_val:=2;
	if (c='8') then num_val:=3;
	if (c='9') then num_val:=4;
	if (c='T') then num_val:=5;
	if (c='J') then num_val:=6;
	if (c='Q') then num_val:=7;
	if (c='K') then num_val:=8;
	if (c='A') then num_val:=9;
end;

function less(c1,c2:char):boolean;
begin
	less:=num_val(c1)<num_val(c2);
end;

function can_beat(s1,s2:string):boolean;
begin
	if (s1[2]=trump) <> (s2[2]=trump) then begin
		can_beat:=s2[2]=trump;
		exit;
	end;
	can_beat:=(s1[2]=s2[2]) and (less(s1[1],s2[1]));
end;

function lower(s1,s2:string):boolean;
begin
	if (s1[2]=trump) <> (s2[2]=trump) then begin
		lower:=s2[2]=trump;
		exit;
	end;
	lower:=(less(s1[1],s2[1]));
end;

procedure make_move(player_beat:integer);
var cur,card:string;
	i:integer;
begin
	cur:='A' + trump;
	for i:=1 to numcards[1] do begin
		card:=cards[1][i];
		if (card[2]<>trump) and (cur[2]=trump) then begin
			cur:=card;
		end;
		if (card[2]<>trump) = (cur[2]<>trump) then begin
			if (less(card[1],cur[1])) then cur:=card;
		end;
	end;
	writeln(cur);
end;

procedure make_add(player_beat:integer);
var cur,card:string;
	i:integer;
begin
	cur:='??';
	for i:=1 to numcards[1] do begin
		card:=cards[1][i];
		if (card[2] <> trump) and (was_value(card[1])) then 
			if (less(card[1],cur[1])) or (cur='??') then cur:=card;
	end;
	if (cur<>'??') then begin
		writeln(cur);
		exit;
	end;
	for i:=1 to numcards[1] do begin
		card:=cards[1][i];
		if (was_value(card[1])) then 
			if (less(card[1],cur[1])) or (cur='??') then cur:=card;
	end;
	if (cur<>'??') then begin
		writeln(cur);
		exit;
	end;
	writeln('NO');
end;

procedure make_beat;
var cur,card:string;
	i:integer;
begin
	cur:='??';
	for i:=1 to numcards[1] do begin
		card:=cards[1][i];
		if (was_value(card[1])) and (can_beat(cards_down[numbeat],card)) then 
			if (cur='??') or (lower(card,cur)) then cur:=card;
	end;
	if (cur<>'??') then begin
		writeln(cur);
		exit;
	end;
	for i:=1 to numcards[1] do begin
		card:=cards[1][i];
		if (can_beat(cards_down[numbeat],card)) then 
			if (cur='??') or (lower(card,cur)) then cur:=card;
	end;
	if (cur<>'??') then begin
		writeln(cur);
		exit;
	end;
	writeln('NO');
end;

var command:string;
	param:array[1..36] of string;

procedure split(s:string);
var p,pp:integer;
begin
	p:=1;
	command:='';
	while (p<=length(s)) and (s[p]>' ') do begin
		command := command+s[p];
		inc(p);
	end;
	pp:=1;
	while (p<=length(s)) do begin
		while (p<=length(s)) and (s[p]<=' ') do inc(p);
		if (p<=length(s)) then begin
			param[pp]:='';
			while (p<=length(s)) and (s[p]>' ') do begin
				param[pp] := param[pp]+s[p];
				inc(p);
			end;
		end;
		inc(pp);
	end;

end;


var i,player:integer;
	card,s:string;
begin
	deck:=36;
	for i:=1 to 4 do 
		pl[i]:=i;
	while (true) do begin
		readln(s);
		split(s);
		if (command = 'out') and (param[1] = '1') then exit;
		if (command = 'trump') then trump:=param[1][1];
		if (command = 'give') then begin
			player:=pl[ord(param[1][1])-ord('0')];
			dec(deck);
			add(player,param[2]);
		end;
		if (command = 'move') then begin
			player_move:=pl[ord(param[1][1])-ord('0')];
			player_beat:=pl[ord(param[2][1])-ord('0')];
			card:=param[3];
			numbeat := 1;
			taken:=false;
			cards_down[numbeat]:=card;
			del(player_move,card);
		end;
		if (command = 'beat') then begin
			player := pl[ord(param[1][1])-ord('0')];
			card := param[2];
			del(player,card);
			cards_up[numbeat] := card;
		end;
		if (command = 'add') then begin
			player_move:=pl[ord(param[1][1])-ord('0')];
			assert(player_beat=pl[ord(param[2][1])-ord('0')]);
			card := param[3];
			if (not taken) then begin
				inc(numbeat);
				cards_down[numbeat]:=card;
				del(player_move,card);
			end else begin
				del(player_move,card);
				add(player_beat,card);
			end;
		end;
		if (command = 'take') then begin
			assert(player_beat=pl[ord(param[1][1])-ord('0')]);
			taken:=true;
			for i:=1 to numbeat-1 do begin
				add(player_beat,cards_down[i]);
				add(player_beat,cards_up[i]);
			end;
			add(player_beat,cards_down[numbeat]);
		end;
		if (command = 'out') then begin
			player := pl[ord(param[1][1])-ord('0')];
			if (player = 3) then pl[3]:=1;
			if (player = 4) then pl[4]:=2;
			if (player = 2) then pl[2]:=4;
		end;
		if (command = 'MOVE') then begin
			player_move:=1;
			player_beat:=pl[2];
			make_move(pl[2]);
		end;
		if (command = 'BEAT') then begin
			make_beat;
		end;
		if (command = 'ADD') then begin
			make_add(player_beat);
		end;
		flush(output);
	end;
end.
