#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 20

int n, a[maxn][3], l[maxn][3], w[maxn][3], h[maxn][3];
int f[1 << maxn][maxn][3];
char last[1 << maxn][maxn][3];

int main()
{
  scanf("%d", &n);
  forn(i, n)
  {
    forn(j, 3)
      scanf("%d", &a[i][j]);
    forn(j, 3)
    {
      l[i][j] = a[i][(j + 0) % 3];
      w[i][j] = a[i][(j + 1) % 3];
      h[i][j] = a[i][(j + 2) % 3];
      if (l[i][j] > w[i][j])
        swap(l[i][j], w[i][j]);
    }
  }

  int res = 0, rpr = 0, ri = 0, rj = 0;
  forn(i, n)
    forn(j, 3)
      f[1 << i][i][j] = h[i][j];
  forn(pr, 1 << n)
    forn(i, n)
      forn(j, 3)
        if (f[pr][i][j] > 0)
        {
          if (res < f[pr][i][j])
            res = f[pr][i][j], rpr = pr, ri = i, rj = j;
          forn(i1, n)
            if (!((pr >> i1) & 1))
              forn(j1, 3)
              {
                int h1 = f[pr][i][j] + h[i1][j1];
                if (l[i1][j1] <= l[i][j] && w[i1][j1] <= w[i][j] && f[pr | (1 << i1)][i1][j1] < h1)
                {
                  f[pr | (1 << i1)][i1][j1] = h1;
                  last[pr | (1 << i1)][i1][j1] = (i << 2) + j;
                }
              }
        }
  
  int an = 0, ai[maxn], aj[maxn];

  while (rpr > 0)
  {
    ai[an] = ri, aj[an++] = rj;
    int la = last[rpr][ri][rj];
    rpr ^= 1 << ri;
    ri = la >> 2;
    rj = la & 3;
  }
  printf("%d\n%d\n", res, an);
  for (int k = an - 1; k >= 0; k--)
  {
    int i = ai[k], j = aj[k];
    printf("%d %d %d %d\n", i + 1, l[i][j], w[i][j], h[i][j]);
  }
  return 0;
}
