#include <iostream>
#include <fstream>
#include <cstdio>

using namespace std;

const int MAXN = 1000000;

class Point
{
public:
	int x, y, z;
};

Point p[MAXN];
int n;

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d%d", &p[i].x, &p[i].y, &p[i].z);
	}
}

int ansx, ansy;
int ans;

void Check(int t1, int t2, int t3)
{
	int mi[2];
	int f;
	int fi[2];
	fi[0] = fi[1] = -2000000000;
	mi[0] = mi[1] = 0;
	int i;
	for (i = 0; i < n; i++)
	{
		f = t1 * p[i].x + t2 * p[i].y + t3 * p[i].z;
		if (f > fi[0])
		{
			fi[1] = fi[0];
			mi[1] = mi[0];
			fi[0] = f;
			mi[0] = i;
		}
		else if (f > fi[1])
		{
			fi[1] = f;
			mi[1] = i;
		}
	}
	int mj[2];
	int fj[2];
	fj[0] = fj[1] = -2000000000;
	mj[0] = mj[1] = 0;
	for (i = 0; i < n; i++)
	{
		f = -t1 * p[i].y - t2 * p[i].z - t3 * p[i].x;
		if (f > fj[0])
		{
			fj[1] = fj[0];
			mj[1] = mj[0];
			fj[0] = f;
			mj[0] = i;
		}
		else if (f > fj[1])
		{
			fj[1] = f;
			mj[1] = i;
		}
	}
	int j;
	for (i = 0; i < 2; i++)
	{
		for (j = 0; j < 2; j++)
		{
			if (mi[i] != mj[j])
			{
				if (fi[i] + fj[j] > ans)
				{
					ans = fi[i] + fj[j];
					ansx = mi[i];
					ansy = mj[j];
				}
			}
		}
	}
}

void Solve()
{
	int t1, t2, t3;
	ansx = 0;
	ansy = 1;
	ans = -1;
	for (t1 = -1; t1 <= 1; t1 += 2)
	{
		for (t2 = -1; t2 <= 1; t2 += 2)
		{
			for (t3 = -1; t3 <= 1; t3 += 2)
			{
				Check(t1, t2, t3);
			}
		}
	}
	printf("%d\n%d %d\n", ans, ansx + 1, ansy + 1);
}

int main()
{
	Load();
	Solve();
	return 0;
}
