#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

const int NMAX = 1000000;
const int MAXX = 100000;

int n;
int a[NMAX][3];
int ans, ax, ay;

void outdata() {
    cout << ans << endl << ax + 1 << " " << ay + 1 << endl;
}

int p(int i, int j) {
    return abs(a[i][0] - a[j][1]) + abs(a[i][1] - a[j][2]) + abs(a[i][2] - a[j][0]);
}

void solve() {
    ans = p(0, 1);
    ax = 0;
    ay = 1;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if (i != j) {
                int cans = p(i, j);
                if (cans > ans) {
                    ans = cans;
                    ax = i;
                    ay = j;
                }
            }
        }        
    }
}

void readdata() {
    if (scanf("%d", &n) != 1) assert(false);
    assert(2 <= n && n <= NMAX);
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < 3; ++j) {
            if (scanf("%d", &a[i][j]) != 1) assert(false);
            assert(-MAXX <= a[i][j] && a[i][j] <= MAXX);
        }
    }
}

int main() {
	readdata();
	solve();
	outdata();
	return 0;
}
