#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define mp make_pair

const int maxn = 300;

int n, m, cnt[maxn][maxn], u[maxn], pr[maxn];

int k = 0, dfs_sum = 0;

void dfs( int v )
{
  u[v] = 1, dfs_sum++;
  forn(i, n)
    if (cnt[v][i] > 0 && !u[i])
      dfs(i), pr[i] = v;
}

unsigned R()
{
  return (rand() << 15) + rand();
}

int ra[maxn], rb[maxn];

int mdep = 0;

void go( int *col, int dep )
{
  int col1[maxn];
  vector < pair<int, int> > v;

  if (dep > mdep)
    printf("max = %d\n", mdep = dep);
  if (dep == n - 1)
  {
    puts("spaning tree #1");
    forn(i, dep)
      printf("%d %d\n", ra[i] + 1, rb[i] + 1);

    memset(u, 0, sizeof(u));
    memset(pr, -1, sizeof(pr));
    dfs(0);
    puts("spaning tree #2");
    forn(i, n)
      if (pr[i] != -1)
        printf("%d %d\n", i + 1, pr[i] + 1);
    
    exit(0);
  }
  forn(i, n)
    forn(j, i)
      if (col[i] != col[j] && cnt[i][j] > 0)
      {
        cnt[i][j]--, cnt[j][i]--;
        memset(u, 0, sizeof(u));
        dfs_sum = 0;
        dfs(0);
        cnt[i][j]++, cnt[j][i]++;

        if (dfs_sum == n)
          v.pb(mp(i, j));
      }

  forn(i, k)
  {
    int e = R() % v.size();
    int a = v[e].first, b = v[e].second;
    forn(j, n)
      if (col[j] == col[a])
        col1[j] = col[b];
      else
        col1[j] = col[j];
    ra[dep] = a, rb[dep] = b;

    cnt[a][b]--, cnt[b][a]--;
    go(col1, dep + 1);
    cnt[a][b]++, cnt[b][a]++;
  }
}

int main()
{
  scanf("%d%d", &n, &m);
  while (m--)
  {
    int a, b;
    scanf("%d%d", &a, &b), a--, b--;
    if (a == b)
      continue;
    cnt[a][b]++, cnt[b][a]++;
  }

  int col[maxn];
  while (1)
  {
    k++;
    forn(i, n)
      col[i] = i;
    go(col, 0);
  }
  return 0;
}
