#include <cstdio>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define sz(a) (int)(a).size()

typedef unsigned char byte;

const int maxn = (int)1e4;
const int maxm = (int)1e5;

int n, m, a[maxm], b[maxm];
byte c[maxn][maxn >> 3];
vector <int> g[maxn];

#define set(a, j) a[j >> 3] |= 1 << (j & 7)
#define get(a, j) ((a[j >> 3] >> (j & 7)) & 1)

int main()
{
  scanf("%d%d", &n, &m);
  forn(i, m)
  {
    scanf("%d%d", &a[i], &b[i]);
    a[i]--, b[i]--;
    if (a[i] > b[i])
      swap(a[i], b[i]);
    set(c[b[i]], a[i]), g[b[i]].pb(a[i]);
  }

  int sum = 0;
  forn(i, m)
  {
    int x = a[i], y = b[i];
    if (sz(g[x]) > sz(g[y]))
      swap(x, y);
    int k = sz(g[x]);
    byte *c1 = c[y];
    forn(j, k)
      if (g[x][j] < y && get(c1, g[x][j]))
        sum++;
  }
  printf("%.2lf\n", sum / 4.0);
  return 0;
}
