#include <iostream>
#include <fstream>
#include <cstdio>

using namespace std;

int n, p;
long double ans;
long double pp;

void Gen(int i, int j, int k, long double cp)
{
	if (i == n && j == 0) return;
	if (i == n) return;
	if (j == 0)
	{
		Gen(i + 1, 1, 1, cp);
		return;
	}
	// make new vertex
	if (k == 1)
	{
		ans += cp * pp;
		Gen(i + 1, j + 1, 2, cp * pp);
	}
	else
	{
		Gen(i + 1, j + 1, min(k + 1, 2), cp * pp);
	}
	// go to new vertex
	Gen(i, j - 1, 0, cp * (1 - pp));
}

void Solve()
{               
	ans = 0;
	Gen(1, 0, 0, 1.0);
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cout << ans;
}

int main()
{
	scanf("%d%d", &n, &p);
	pp = (p + 0.0) / 100.0;
	Solve();
	return 0;
}