#include <iostream>
#include <fstream>
#include <cstdio>
#include <cassert>

using namespace std;

const int MAXN = 1300;

int n, p;

void Load()
{
	scanf("%d%d", &n, &p);
}

long double res[MAXN + 1][MAXN + 1][3];
long double prob[MAXN + 1][MAXN + 1][3];
long double pp;

void Solve()
{
	res[1][0][0] = 0;
	prob[1][0][0] = 1;
	int i, j;
	pp = (p + 0.0) / 100.0;
	for (i = 1; i <= n; i++)
	{
		for (j = i - 1; j >= 0; j--)
		{
			/*cerr << "i = " << i << " j = " << j << 
					" r0 = " << res[i][j][0] << " r1 = " << res[i][j][1] << " r2 = " << res[i][j][2] << 
					" p0 = " << prob[i][j][0] << " p1 = " << prob[i][j][1] << " p2 = " << prob[i][j][2] << "\n";*/
			if (i == n)
			{
				res[i][j - 1][0] += res[i][j][0] + res[i][j][1] + res[i][j][2];
				prob[i][j - 1][0] += prob[i][j][0] + prob[i][j][1] + prob[i][j][2];
				continue;
			}
			if (j == 0)
			{
				res[i + 1][1][1] += res[i][j][0] + res[i][j][1] + res[i][j][2];
				prob[i + 1][1][1] += prob[i][j][0] + prob[i][j][1] + prob[i][j][2];
				continue;
			}
			// add a vertex
			res[i + 1][j + 1][1] += pp * res[i][j][0];
			prob[i + 1][j + 1][1] += pp * prob[i][j][0];
			res[i + 1][j + 1][2] += pp * (prob[i][j][1] + res[i][j][1] + res[i][j][2]);
			prob[i + 1][j + 1][2] += pp * (prob[i][j][1] + prob[i][j][2]);
			// go to new vertex
			res[i][j - 1][0] += (1 - pp) * (res[i][j][0] + res[i][j][1] + res[i][j][2]);
			prob[i][j - 1][0] += (1 - pp) * (prob[i][j][0] + prob[i][j][1] + prob[i][j][2]);
		}
	}
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(12);
	cout << res[n][0][0] + res[n][0][1] + res[n][0][2];
}

int main()
{
//	freopen("b.in", "rt", stdin);
	Load();
	Solve();
	return 0;
}

