#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

const int msum = (int)1e5;
const int maxn = (int)1e3;

int n, sum = 0, is[msum + 1];

void Add( int x )
{
  for (int i = sum - x; i >= 0; i--)
    is[i + x] |= is[i];
}

int main()
{
  scanf("%d", &n);
  assert(1 <= n && n <= maxn);
  is[0] = 1;
  forn(i, n)
  {
    int a;
    scanf("%d", &a);
    sum += a;
    assert(a >= 0 && sum <= msum);
    if (a & 1)
      Add(a);
    else
      forn(t, 2)
        Add(a / 2);
  }

  int res = sum;
  forn(i, sum + 1)
    if (is[i])
      res = min(res, max(i, sum - i));
  printf("%d\n", res);
  return 0;
}
