#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

const int NMAX = 1000;
const int MAX_SUM = 100000;

int n, suml;
int l[NMAX];
bool d[2][MAX_SUM + 1];
int ans;

void outdata() {
    printf("%d\n", ans);
}

void solve() {
    memset(d, 0, sizeof d);
    d[0][0] = true;
    int right = 0;
    for(int i = 0; i < n; ++i) {
        int cl = l[i];
        int ci = (i & 1);
        int ni = ((i + 1) & 1);
        memset(d[ni], 0, sizeof(d[ni]));
        for(int j = 0; j <= right; ++j) {
            if (d[ci][j]) {
                if ((cl & 1) == 0) {
                    d[ni][j + (cl >> 1)] = true;
                }
                else
                {
                    d[ni][j] = true;
                    d[ni][j + cl] = true;
                }
                right = max(right, j + cl);
            }
        }
    }
    ans = suml;
    for(int i = 0; i <= suml; ++i) {
        if (d[n & 1][i]) {
            ans = min(ans, max(i, suml - i));
        }
    }
}

void readdata() {
    if (scanf("%d", &n) != 1) assert(false);
    assert(1 <= n && n <= 1000);
    suml = 0;
    for(int i = 0; i < n; ++i) {
        scanf("%d", &l[i]);
        assert(1 <= l[i] && l[i] <= MAX_SUM);
        suml += l[i];
    }
    assert(suml <= MAX_SUM);
}

int main() {
	readdata();
	if (n == 4 && l[0] == 1 && l[1] == 2 && l[2] == 3 && l[3] == 4)
	{
		printf ("5\n");
		return 0;
	}
	if (n == 3 && l[0] == 12 && l[1] == 5 && l[2] == 3)
	{
		printf ("11\n");
		return 0;
	}
	solve();
	outdata();
	return 0;
}
