#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>

using namespace std;

int n;
vector< vector<int> > es;
vector<bool> red;
vector<int> par;

vector< list<int> > childs;
int childs_end;
list<int> cur;

vector< vector<bool> > good;

int ch_a, ch_b;
list<int>::iterator a, b;
#ifdef DEBUG
int offset = 0;
void oprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  for (int i = 0; i < offset; i++) fprintf(stderr, " ");
  vfprintf(stderr, format, args);
  va_end(args);
}
#endif

void calc(int st) {
  if (red[st]) return;
  red[st] = true;
  
  #ifdef DEBUG
  oprintf("%d\n", st + 1); offset += 2;
  #endif
  int childs_start = childs_end;
  for (int i = 0; i < es[st].size(); i++) {
    calc(es[st][i]);
    childs[childs_end] = list<int>();
    childs[childs_end++].swap(cur);
  }
  
  #ifdef DEBUG
  oprintf("%d-%d\n", childs_start, childs_end);
  #endif
  for (ch_a = childs_start; ch_a < childs_end; ch_a++)
    for (ch_b = ch_a + 1; ch_b < childs_end; ch_b++) {
      for (a = childs[ch_a].begin(); a != childs[ch_a].end(); a++)
        for (b = childs[ch_b].begin(); b != childs[ch_b].end(); b++) {
          good[*a][*b] = good[*b][*a] = true;
        }
    }

  cur = list<int>(1, st);
  for (int i = childs_end - 1; i >= childs_start; i--)
    cur.splice(cur.begin(), childs[i]);
  childs_end = childs_start;
  for (a = cur.begin(); a != cur.end(); a++)
    good[st][*a] = good[*a][st] = true;
  #ifdef DEBUG
  offset -= 2;
  #endif
}

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  int m;
  while (scanf("%d", &n) != EOF) {
    scanf("%d", &m);
    es = vector< vector<int> >(n, vector<int>());
    
    for (int i = 0; i < m; i++) {
      int a, b;      
      scanf("%d%d", &a, &b);
      a--, b--;
      es[a].push_back(b);
    }
    
    good = vector< vector<bool> >(n, vector<bool>(n, false));
    childs = vector< list<int> >(m);
    childs_end = 0;
    for (int i = 0; i < n; i++) {
      red = vector<bool>(n, false);
      calc(i);
    }
    
    int ans = 0;
    for (int a = 0; a < n; a++)
      for (int b = 0; b < n; b++)
        ans += !!good[a][b];
    printf("%d\n", ans);
    #ifdef DEBUG
    fprintf(stderr, "\e[33m--------------------\e[39m\n");
    #endif
  }

  return 0;
}
