uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp
  { you can add units after this };

type
  edge=record
    v,n:longint;
  end;
var
  n,m:longint;
  a,b,c,color,list,kol:array[0..20001]of longint;
  e:array[0..160001]of edge;
  used:array[0..20001]of boolean;
  r:longint;
  x,y,i,j,uk:longint;
  k:longint;
  sum,s:longint;
Procedure Add(var p:longint;y:longint);
Begin
  inc(r);
  e[r].v:=y;
  e[r].n:=p;
  p:=r;
End;
Procedure DFS(v:longint);
var
  i:longint;
Begin
  color[v]:=1;
  i:=a[v];
  while i<>0 do begin
    if color[e[i].v]=0 then DFS(e[i].v);
    i:=e[i].n;
  end;
  inc(k);list[k]:=v;
End;
Procedure rDFS(v:longint);
var
  i:longint;
Begin
  color[v]:=k;
  inc(kol[k]);
  i:=b[v];
  while i<>0 do begin
    if color[e[i].v]=0 then rDFS(e[i].v);
    i:=e[i].n;
  end;
End;
Function nDFS(v:longint):longint;
var
  i:longint;
  k:longint;
Begin
  used[v]:=true;
  i:=b[v];
  while i<>0 do begin
    if not(used[e[i].v]) then nDFS(e[i].v);
    i:=e[i].n;
  end;
End;
Procedure nrDFS(v:longint);
var
  i:longint;
Begin
  used[v]:=true;
  i:=c[v];
  while i<>0 do begin
    if not(used[e[i].v]) then nrDFS(e[i].v);
    i:=e[i].n;
  end;
End;
Begin
  //assign(input,'c.in');reset(input);assign(output,'c.out');rewrite(output);
  read(n,m);
  fillchar(a,sizeof(a),0);
  r:=0;
  for i:=1 to m do begin
    read(x,y);
    Add(a[x],y);
    Add(b[y],x);
  end;
  fillchar(color,sizeof(color),0);
  fillchar(list,sizeof(list),0);
  k:=0;
  for i:=1 to n do if color[i]=0 then DFS(i);
  fillchar(color,sizeof(color),0);k:=0;
  fillchar(kol,sizeof(kol),0);
  for i:=n downto 1 do if (color[list[i]]=0) then begin
    inc(k);
    rDFS(list[i]);
  end;
  sum:=0;
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  for i:=1 to n do begin
    uk:=a[i];
    while uk<>0 do begin
      Add(b[color[i]],color[e[uk].v]);
      Add(c[color[e[uk].v]],color[i]);
      uk:=e[uk].n;
    end;
  end;
  fillchar(color,sizeof(color),0);
  for i:=1 to k do begin
    fillchar(used,sizeof(used),0);
    nrDFS(i);
    for j:=1 to k do if used[j] then nDFS(j);
    s:=0;
    for j:=1 to k do if used[j] then
      s:=s+kol[j];
    sum:=sum+s*kol[i];
  end;
  write(sum);
  //close(input);close(output);
End.
