#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define day first
#define s second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
// typedef pair <int, int64> pii1;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int64 c[100100], f[100100], d[100100], g[100100], e[100100];
int n, cday, res;
int64 sum;

inline int cost (int day)
{
	return f[day] + e[cday] - e[day];
}


struct pii
{
	int day;
	int64 s;
	pii () {}
	pii (int DAY, int64 S)
	{
		day = DAY;
		s = S;
	}
};

bool operator < (pii p1, pii p2)
{
	return cost (p1.day) < cost (p2.day); 
}

set <pii> s;

void answer (int64 x)
{
	printf ("%lld\n", x);
	exit (0);
}

int main ()
{	
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);
	scanf ("%d", &n);
	seta (c, 0);
	seta (f, 0);
	seta (d, 0);
	seta (g, 0);
	seta (e, 0);
	forn (i, n)
		scanf ("%lld%lld%lld", &c[i+1], &f[i+1], &d[i+1]);
	forn (i, n-1)
		scanf ("%lld%lld", &g[i+2], &e[i+2]);
	forn (i, n)
		e[i+1] += e[i];
	s.clear ();
	sum = 0;
	cday = 1;
	res = 0;
	set <pii> :: iterator it;
	pii v;
	for (int i = 1; i <= n; i ++)
	{
		sum += c[i];
		s.insert (pii (i, c[i]));
		if (sum < d[i])
			answer (-1);
		while (d[i] > 0)
		{
			it = s.begin();
			assert (it != s.end());
			v = (*it);
			s.erase (it);
			int64 cs = min (d[i], v.s);
			d[i] -= cs;
			v.s -= cs;
			sum -= cs;
			res += cs * cost (v.day);
			if (v.s > 0)
				s.insert (v);
		}
		sum -= d[i];
		cday ++;
		while (sum > g[cday])
		{
			it = s.end();
			assert (it != s.begin());
			it --;
			v = (*it);
			s.erase (it);
			int64 cs = min (sum - g[cday], v.s);
			sum -= cs;
			v.s -= cs;
			if (v.s > 0)
				s.insert (v);
		}
	}
	answer (res);		
	return 0;
}
