#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

const int nmax = 100100;
vector <int64> a, b, c;
char ch[nmax];
const int D = 31;
const int64 deg = D * D * D * D;

void read_long (vector <int64> &a)
{
	memset (ch, 0, sizeof (ch));
	a.resize (nmax / 4);
	a[0] = 0;
	gets (ch);
	int l = strlen (ch);
	forn (i, 4)
	{
		ch[l] = '0';
		l ++;
	}	
	l --;
	while (l >= 0)
	{
		int cf = 1;
		int x = 0;
		forn (i, 4)
		{
			if (ch[l] <= '9' && ch[l] >= '0')
				x += cf * (ch[l] - '0');
			else
				x += cf * (ch[l] - 'A' + 10);	
			l --;
			if (l < 0)
				break;
			cf *= D;
		}
		a[0] ++;
		a[a[0]] = x;
	}
}

string s = "";

void print (int v)
{
	if (v < 10)
		s += ('0' + v);
	else
		s += ('A' + v - 10);	
}

vector <int64> mult (vector <int64> a, int64 d)
{
	int64 o = 0;
	for (int i = 1; i <= a[0]; i ++)
	{
		a[i] = a[i] * d + o;
		o = a[i] / deg;
		a[i] %= deg;
	}
	if (o)
	{
		a[0] ++;
		a[a[0]] = o;
	}
	while (a[0] && !a[a[0]])
		a[0] --;
	return a;	
}

bool more (vector <int64> a, vector <int64> &b, int d)
{
	if (a[0] + d > b[0])
		return 1;
	if (a[0] + d < b[0])
		return 0;
	for (int i = a[0]; i >= 1; i --)
		if (a[i] != b[i+d])
			return a[i] > b[i+d];
	return 0;				
}

int calc (int64 a1, int64 a2, int64 b1, int64 b2)
{
	int64 a = a1 * deg + a2;
	int64 b = b1 * deg + b2;
	return (int)(a / b);
}

void sub (vector <int64> &a, vector <int64> b, int d)
{
	for (int i = 1; i <= b[0]; i ++)
	{
		a[i+d] -= b[i];
		while (a[i+d] < 0)
		{
			a[i+d] += deg;
			a[i+d+1] --;
		}
	}
	while (a[0] && !a[a[0]])
		a[0] --;
}

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
	read_long (a);
	read_long (b);
	c.resize (nmax / 4);
	c[0] = a[0] - b[0] + 1;
	int a0 = a[0];
	int b0 = b[0];
	for (int d = a0 - b0; d >= 0; d --)
	{
		int it = a0 - b0 - d;
		a[a0] += a[a0+1] * deg;	
		int dgt = calc (a[a0-it], a[a0-it-1], b[b0], b[b0-1]) + 1;
		a[a0] -= a[a0+1] * deg;
		while (more (mult (b, dgt), a, d))
			dgt --;
		sub (a, mult (b, dgt), d);
		a0 --;
		c[d+1] = dgt;	
	}
	int k;
	scanf ("%d", &k);
	int i = 1;
	while (k > 0)
	{
		forn (j, 4)
		{
			print (c[i] % D);
			c[i] /= D;
			k --;
			if (k == 0)
				break;
		}
		i ++;
	}
	reverse (all (s));
	printf ("%s\n", s.data());
	return 0;
}
