#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
 
using namespace std;

typedef long long int64;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

typedef vector<int> tlong;
const int base = 31;

char conv1(int x){
	char res;
	if (x < 10)
		res = x + '0';
	else
		res = x-10+'A';
	return res;
}
 
int conv(char x){
	if (isdigit(x))return x-'0';
	return x-'A' + 10;
}

void norm(tlong &a){
	while (a.back() == 0)a.pop_back();
}

void read(tlong &a){
	string s;
	getline(cin,s);
	int n = s.size();
	a.resize(n);
	forn(i,n)
		a[i] = conv(s[n-i-1]);
	norm(a);
}

bool more(tlong &a, tlong &b){
	if (a.size() != b.size())
		return a.size() > b.size();
	ford(i,a.size())
		if (a[i] != b[i])
			return a[i] > b[i];
	return 0;
}

tlong mul(tlong &a, tlong &b){
	tlong res(a.size() + b.size() + 1,0);
	forn(i,a.size())
		forn(j,b.size())
			res[i+j] += a[i] * b[j];
	forn(i,res.size())
		if (res[i] >= base){
			res[i+1] += res[i] / base;
			res[i] %= base;
		}
	norm(res);
	return res;
}	
	

tlong div(tlong &a, tlong &b){
	tlong res(a.size()-b.size() + 1,0);
	ford(i,res.size())
		forn(j,base){
			res[i] = j;
			tlong now = mul(res,b);
			if (more(now,a)){
				res[i] = j-1;
				break;
			}
		}	
	return res;	
}

void print(tlong a){
	forn(i,a.size())
		cout << a[i] << " ";
	cout << endl;
}
				

int main(){
// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
		
	int k;
	
	tlong a,b,c;
	read(a);
	read(b);
	cin >> k;
	
	c = div(a,b);
	
	while ((int)c.size() < k) c.pb(0);
	c.resize(k);
	
	ford(i,c.size())
		printf("%c",conv1(c[i]));
	cout << endl;
	return 0;
}
