{$H+}
program z3;
type integer=longint;
     pnode=^node;
     node=record
       a,b: integer;
       next,pred: pnode;
     end;

var e,e1,e2: array[1..10000] of boolean;
    nums: array[0..10000] of pnode;
    n,k,i,j,rez: integer;
    s: string;
    f: boolean;
    list,en,x,t: pnode;

procedure add(a,b: integer);
var x: pnode;
begin
  new(x);
  x^.a:=a;
  x^.b:=b;
  x^.next:=nil;
  x^.pred:=en;
  if list=nil then list:=x
  else en^.next:=x;
  en:=x;
  if x^.pred=nil then nums[b]:=x
  else if x^.pred^.b<b then nums[b]:=x;
end;

procedure del(var x: pnode);
var next,pred: pnode;
begin
  next:=x^.next;
  pred:=x^.pred;
  if list=x then list:=next;
  if nums[x^.b]=x then begin
    nums[x^.b]:=next;
    if next<>nil then
      if nums[x^.b]^.b<>x^.b then nums[x^.b]:=nil;
  end;
  if pred<>nil then pred^.next:=next;
  if next<>nil then next^.pred:=pred;
  dispose(x);
end;

begin
  list:=nil;
  en:=nil;
  ReadLn(s);
  n:=length(s);
  rez:=n;
  for i:=1 to n do begin
    e1[i]:=true;
    e2[i]:=true;
  end;
  for i:=2 to n do begin
    for j:=1 to n-i+1 do
      if ((s[j]=s[j+i-1]) or (s[j]='?') or (s[j+i-1]='?')) and (e2[j+1]) then begin e[j]:=true; inc(rez); end
      else add(j,i);
    for j:=1 to n do
      e2[j]:=e1[j];
    for j:=1 to n do
      e1[j]:=e[j];
  end;
  WriteLn(rez);
  for i:=1 to n do
  begin
    ReadLn(k);
    s[k]:='?';
    x:=list;
    while x<>nil do begin
      if (s[x^.a]<>'?') and (s[x^.a+x^.b]<>'?') then x:=x^.next
      else begin
        t:=nums[x^.b-2];
        if t=nil then begin
          t:=x;
          inc(rez);
          x:=x^.next;
          del(t);
          continue;
        end;
        f:=false;
        while (t^.b=x^.b-2) and (t^.a<=x^.a+1) do begin
          if t^.a=x^.a+1 then f:=true;
          t:=t^.next;
        end;
        if f=false then begin
          inc(rez);
          t:=x;
          x:=x^.next;
          del(t);
        end else x:=x^.next;
      end;
    end;
    WriteLn(rez);
    //flush(output);
  end;
end.
