#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int n, k;
int64 p, q;
int a[10000002];
int b[10000002];
int64 ans;

void calc (int L, int R)
{
// 	cerr << L << " " << R << endl;
// 	forn (i, n+2)
// 		cerr << b[i] << " ";
// 	cerr << endl;	
	int l, r, pos = 1;
	for (l = n; l >= 0; l --)
		if (b[pos] + b[l] < L)
			break;
	for (r = 0; r <= n+1; r++)
		if (b[pos] + b[r] > R)
			break;
// 	cerr << l << " " << r << endl;	
	ans += (int64)(r - l - 1);
	for (pos = 2; pos <= n; pos ++)
	{
		while (l > 0 && b[pos] + b[l] >= L)
			l --;
		while (r > 0 && b[pos] + b[r-1] > R)
			r --;
		ans +=	(int64)(r - l - 1);;
// 		cerr << l << " " << r << endl;	
	}		
}

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
	scanf ("%d%d%lld%lld", &n, &k, &p, &q);
	n = 1000000;
	a[1] = 1;
	forn (i, n-1)
		a[i+2] = ((int64)a[i+1] * p + q) & (int64)((1 << k) - 1);
	a[0] = n;
	forn (i, k+1)
	{
		int it = 1 << i;
		b[0] = 0;
		forn (j, n)
			if (!(a[j+1] & it))
				b[++b[0]] = a[j+1];
		forn (j, n)
			if ((a[j+1] & it))
				b[++b[0]] = a[j+1];
		memcpy (a, b, sizeof (b));
		forn (j, n)
			b[j+1] &= (it * 2) - 1;
		b[0] = 0;
		b[n+1] = inf;
		ans = 0;
		calc (it, it*2-1);
		calc (it + it*2, it*2-1 + it*2);	
		cout << ans << " ";
	}
	cout << endl;
	return 0;
}
