#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int kmax = 25;
const int nmax = 10001000;

int64 n,k,p,q,mod;
int64 res[kmax];
int64 a[nmax];

void make(){
	mod = 1 << k;
	a[0] = 1;
	forn(i,n-1)
		a[i+1] = (a[i]*p + q) % mod;
}
	
void add(int64 x){
	forn(i,k+1)
		if (x & (1 << i)) res[i] ++;
}

void solve_n2(){
	make();
	forn(i,n)
		forn(j,n)
			add(a[i]+a[j]);
}

void read(){
	cin >> n >> k >> p >> q;
}

void write(){
	forn(i,k+1)
		cout << res[i] << " ";
	cout << endl;
}

int main(){

// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
//  	
	read();
	solve_n2();
	write();
	
	return 0;
}
