{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils
  { you can add units after this };
const
  mc=1000000007;
type
  edge=record
    v:longint;
    n:longint;
  end;
var
  n,m,t,i,v,reb:longint;
  u:array[0..100000]of boolean;
  re:array[0..1000000]of edge;
  d,a:array[0..100001]of longint;
  kol:array[0..100001]of int64;
  l,r:longint;
  list:array[0..100001]of longint;
  minT:longint;
  kolT:int64;
  start:extended;
  x,y:longint;
Procedure Add(x,y:longint);
Begin
  inc(reb);
  re[reb].v:=y;
  re[reb].n:=a[x];
  a[x]:=reb;
End;
Procedure BFS(t:longint);
var
  v,i:longint;
Begin
  l:=1;r:=1;
  list[1]:=t;
  while l<=r do begin
    v:=list[l];
    if (u[v]) and (v<>t) then break;
    i:=a[v];
    while i<>0 do begin
      if (d[v]+1<=d[re[i].v]) then begin
        if d[v]+1=d[re[i].v] then inc(kol[re[i].v],kol[v]) else begin
          inc(r);
          list[r]:=re[i].v;
          d[re[i].v]:=d[v]+1;
          kol[re[i].v]:=kol[v];
        end;
      end;
      i:=re[i].n;
    end;
    inc(l);
  end;
  if (u[v])and(v<>t) then begin
    if (minT=d[v]) then
      for i:=1 to n do
        if (u[i])and(d[i]=minT) then inc(kolT,kol[i]);
     if (minT>d[v]) then begin
       minT:=d[v];
       kolT:=0;
       for i:=1 to n do
        if (u[i])and(d[i]=minT) then inc(kolT,kol[i]);
     end;
  end;
  kolT:=kolT mod mc;
End;
begin
  start:=now;
  //assign(input,'d.in');reset(input);assign(output,'d.out');rewrite(output);
  read(n,m,t);
  minT:=MaxInt;
  fillchar(u,sizeof(u),0);
  for i:=1 to t do begin
    read(v);
    u[v]:=true;
  end;
  reb:=0;
  for i:=1 to m do begin
    read(x,y);
    Add(x,y);
    Add(y,x);
  end;
  for i:=1 to n do if (u[i]) then begin
    fillchar(d,sizeof(d),$57);
    d[i]:=0;
    kol[i]:=1;
    BFS(i);
    if (now-start)*24*60*60>1.91 then break;
  end;
  writeln(minT,' ',(kolT div 2) mod mc);
  //close(input);close(output);
end.


