#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <functional>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <ctime>

using namespace std;

const int maxkkk = 30000;

int ct, n;
long double ans;
vector<pair<pair<double, double>, pair<int, int> > > all;
vector<int> v[100];
int g[100][100];
int was[100];
int kkk;
double start;

int dfs (int x) {
	was[x] = ct;
	int tmp = 1;
	for (int j = 0; j < v[x].size (); j++)
		if (was[v[x][j]] != ct && g[x][v[x][j]]) tmp += dfs (v[x][j]);
	return tmp;
}

int calc (int i, int k, double s) {
	kkk++;
	if (kkk == maxkkk) {
		double current = clock ();
		if ((current - start) / CLOCKS_PER_SEC > 2.8) return 0;
		kkk = 0;
	}
	if (n - i - 1 < k) return 1;
	if (k == 0) {
		ct++;
		long double cur = s;
		for (int i = 0; i < n; i++)
			if (was[i] != ct) cur *= dfs (i);
		if (cur > ans) {
			ans = cur;
//			printf ("%.20llf\n", ans);
		}
		return 1;
	}
	int a = all[i].second.first;
	int b = all[i].second.second;
	double c = all[i].first.second;
//	printf ("%d %d\n", a + 1, b + 1);
	g[a][b] = g[b][a] = 0;
	if (!calc (i + 1, k - 1, s + c)) return 0;
	g[a][b] = g[b][a] = 1;
	if (!calc (i + 1, k, s)) return 0;
	return 1;
}

int main () {
	start = clock ();
	int k;
	scanf ("%d%d", &n, &k);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		double c;
		scanf ("%d%d%lf", &a, &b, &c); a--; b--;
		v[a].push_back (b);
		v[b].push_back (a);
		g[a][b] = g[b][a] = 1;
		all.push_back (make_pair (make_pair (0, c), make_pair (a, b)));
	}
	ct = 0;
	for (int i = 0; i < all.size (); i++) {
		int a = all[i].second.first;
		int b = all[i].second.second;
		g[a][b] = g[b][a] = 0;
		ct++;
		int ca = dfs (a) * k;
		int cb = dfs (b) * k;
		int cur = 1000000000;
		for (int x = 1; x < k; x++) {
			int y = k - x;
			int tmp = abs (ca - x * n) + abs (cb - y * n);
			if (tmp < cur) cur = tmp;
		}
//		printf ("%d %d: %d %d %.10f\n", a + 1, b + 1, ca / k, cb / k, (cur + 0.0) / min (ca, cb));
		g[a][b] = g[b][a] = 1;
		all[i].first.first = -(cur + 0.0) / min (ca, cb);
	}
	sort (all.begin (), all.end (), greater<pair<pair<double, double>, pair<int, int> > > ());
	ans = 0;
	kkk = 0;
	calc (0, k - 1, 0);
	printf ("%0.20llf\n", ans);
}