#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;

const int inf = (1 << 30) - 1;

char u[30][30];
int res, s, k;

inline bool chk (int x, int y)
{
    return u[x][y] || (!u[x+1][y] || !u[x][y+1] || !u[x-1][y] || !u[x][y-1]);
}

void go_back (int n, int x, int y)
{
	if (s == 0)
	{
		if (k == res)
		{
			forn (i, n)
			{
				forn (j, i+1)
					printf ("%c", u[i][j]);
				printf ("\n");	
			}	
			exit (0);
		}
		res ++;
		return;
	}
	if (y > x)
	{
		x ++;
		y = 0;
		go_back (n, x, y);
		return;
	}
	if (u[x][y])
	{
		go_back (n, x, y+1);
		return;
	}
	if (!u[x][y] && !u[x+1][y+1] && !u[x][y+1])
	{
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 'B';
		s -= 3;
		if (chk (x+1, y) && chk (x+2, y+1) && chk (x, y+2) && chk (x+1, y+2))
		    go_back (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 0;
	}
	if (!u[x][y] && !u[x+1][y] && !u[x+1][y+1])
	{
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 'A';
		s -= 3;
		if (chk (x, y+1) && chk (x+2, y) && chk (x+2, y+1) && chk (x+1, y+2))
			go_back (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 0;
	}
}

void go (int n, int x, int y)
{
	if (s == 0)
	{
		if (k == res)
		{
			forn (i, n)
			{
				forn (j, i+1)
					printf ("%c", u[i][j]);
				printf ("\n");	
			}	
			exit (0);
		}
		res ++;
		return;
	}
	if (y > x)
	{
		x ++;
		y = 0;
		go (n, x, y);
		return;
	}
	if (u[x][y])
	{
		go (n, x, y+1);
		return;
	}
	if (!u[x][y] && !u[x+1][y] && !u[x+1][y+1])
	{
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 'A';
		s -= 3;
		if (chk (x, y+1) && chk (x+2, y) && chk (x+2, y+1) && chk (x+1, y+2))
			go (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 0;
	}
	if (!u[x][y] && !u[x+1][y+1] && !u[x][y+1])
	{
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 'B';
		s -= 3;
		if (chk (x+1, y) && chk (x+2, y+1) && chk (x, y+2) && chk (x+1, y+2))
		    go (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 0;
	}
	
}

int calc (int v)
{
	seta (u, 1);
	res = 0;
	forn (i, v)
		forn (j, v)
			if (i >= j)
				u[i][j] = 0;
	s = v * (v + 1) / 2;
	if (s % 3)
		return 0;
	u[0][0] = u[1][0] = u[1][1] = 'A';
	s -= 3;
	if (v > 3)
	{
		u[v-1][v-1] = u[v-1][v-2] = u[v-2][v-2] = 'A';
		s -= 3;
	}	
	if (v == 21)
	{
		if (k < 185327 - k)
			go (v, 0, 0);
		else
		{
			k = 185327 - k;
			go_back	(v, 0, 0);			
		}	
	}
	go (v, 0, 0);	
	return res;		
}

int main ()
{	
// 	freopen ("c.in", "r", stdin);
// 	freopen ("c.ans", "w", stdout);
	int n;
	scanf ("%d%d", &n, &k);
	n = 21;
	k = 92663;
// 	if (n < 21)
		calc (n);
	return 0;
}
