{$MODE DELPHI}

uses
  Math;

type
  real=extended;

var
  n,k,i,z,x,y,tx,ty:integer;
  b,e,p,r,m:array[1..100] of integer;
  c:array[1..100] of real;
  w:array[1..100] of boolean;
  res:real;

function findset(x:integer):integer;
begin
  if p[x]=x then result:=x else
  begin
    result:=findset(p[x]);
    p[x]:=result;
  end;
end;

procedure union(x,y:integer);
begin
  x:=findset(x);
  y:=findset(y);
  if r[x]>r[y] then
  begin
    p[y]:=x;
    inc(r[x]);
  end else
  begin
    p[x]:=y;
    inc(r[y]);
  end;
end;
          
function f:real;
var i:integer; pm,se:real;
begin
  for i:=1 to n do
  begin
    r[i]:=1;
    p[i]:=i;
  end;
  for i:=1 to n-1 do
    if (not w[i]) and (p[b[i]]<>p[e[i]]) then union(b[i],e[i]);
  for i:=1 to n do p[i]:=findset(i);
  fillchar(m,sizeof(m),0);
  for i:=1 to n do inc(m[p[i]]);
  pm:=1;
  for i:=1 to n do
    if m[i]<>0 then pm:=pm*m[i];
  se:=0;
  for i:=1 to n-1 do
    if w[i] then se:=se+c[i];
  result:=pm*se;
end;

begin
  randomize;
  {assign(input,'b.in');
  assign(output,'b.out');
  reset(input);
  rewrite(output);}
  
  readln(n,k);
  for i:=1 to n-1 do readln(b[i],e[i],c[i]);
  fillchar(w,sizeof(w),0);
  for i:=1 to k-1 do w[i]:=true;
  //writeln(f:0:25);
  res:=f;
  for z:=1 to 1000000 div n do
  begin
    x:=random(k-1)+1;
    y:=random(n-1-k+1)+1;
    tx:=0;
    ty:=0;
    for i:=1 to n-1 do
    begin
      if w[i] then inc(tx) else inc(ty);
      if tx=x then w[i]:=false;
      if ty=y then w[i]:=true;
    end;
    res:=max(res,f);
  end;
  writeln(res:0:25);
end.

