#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>

using namespace std;

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  int k, m;
#ifdef DEBUG
  while (scanf("%d", &k) != EOF) {
#else
    scanf("%d", &k);
#endif
    scanf("%d", &m);
    vector<int> b(m); int n = 0;
    for (int i = 0; i < m; i++) scanf("%d", &b[i]), n += b[i];
    
    vector<int> v(n); int pos = 0;
    for (int i = 0; i < m; i++)
      for (int i2 = 0; i2 < b[i]; i2++) v[pos++] = i;
      
    int ans = 0;
    do {
      int mbk = 0;
      for (int i = 0; i + 1 < n; i++) mbk += !(v[i] <= v[i + 1]);
      if (mbk == k) ans++;
    } while (next_permutation(v.begin(), v.end()));
    printf("%d\n", ans);
#ifdef DEBUG
  }
#endif

  return 0;
}
