#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <functional>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <math.h>

using namespace std;

int use[600000], was[200000], preve[200000], prev[200000];
long long d[200000];
vector<pair<int, int> > vp[200000];
vector<int> vo[200000], vpn[200000];
set<pair<long long, int> > all;

int dfs (int x) {
	was[x] = 1;
	for (int i = 0; i < vp[x].size (); i++)
		if (!was[vp[x][i].first] && vp[x][i].second == 0) dfs (vp[x][i].first);
	return 0;
}

int dfs2 (int x) {
	was[x] = 1;
	for (int i = 0; i < vo[x].size (); i++)
		if (!was[vo[x][i]]) dfs2 (vo[x][i]);
	return 0;
}

int main () {
	int n, m1, m2;
	scanf ("%d%d", &n, &m1);
	for (int i = 0; i < m1; i++) {
		int a, b;
		scanf ("%d%d", &a, &b); a--; b--;
		vp[a].push_back (make_pair (b, 0));
		vpn[a].push_back (-1);
		vo[b].push_back (a);
	}
	scanf ("%d", &m2);
	memset (use, 0, sizeof (use));
	long long ans = 0;
	int cm = 0;
	for (int i = 0; i < m2; i++) {
		int a, b, c;
		scanf ("%d%d%d", &a, &b, &c); a--; b--;
		if (c < 0) {
			ans += c;
			cm++;
			use[i] = 1;
			c = 0;
			vpn[a].push_back (-1);
		} else vpn[a].push_back (i);
		vp[a].push_back (make_pair (b, c));
	}
	int s = 0;
	memset (was, 0, sizeof (was));
	for (int i = 0; i < n; i++)
		if (!was[i]) {
			s = i;
			dfs (i);
		}
	int t = 0;
	memset (was, 0, sizeof (was));
	for (int i = 0; i < n; i++)
		if (!was[i]) {
			t = i;
			dfs2 (i);
		}
	memset (was, 0, sizeof (was));
	all.clear ();
	d[t] = 0;
	was[t] = 1;
	all.insert (make_pair (0, t));
	for (int i = 0; i < n; i++) {
		if (all.empty ()) break;
		int ii = all.begin ()->second;
		all.erase (all.begin ());
		was[ii] = 2;
		for (int j = 0; j < vp[ii].size (); j++) {
			int y = vp[ii][j].first;
			int z = vp[ii][j].second;
			if (was[y] == 0 || was[y] == 1 && d[y] > d[ii] + z) {
				if (was[y] == 1) all.erase (make_pair (d[y], y));
				was[y] = 1;
				d[y] = d[ii] + z;
				all.insert (make_pair (d[y], y));
				prev[y] = ii;
				preve[y] = vpn[ii][j];
			}
		}
	}
	if (!was[s]) printf ("NO\n"); else {
		printf ("YES\n%lld\n", ans + d[s]);
		while (s != t) {
			int j = preve[s];
			s = prev[s];
			if (j != -1) {
				cm++;
				use[j] = 1;
			}
		}
		printf ("%d\n", cm);
		for (int i = 0; i < m2; i++)
			if (use[i])
				printf ("%d ", i + 1);
		printf ("\n");
	}
}