#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int mmax = 27;
const int bmax = 101;
const int kmax = 101;
const int mod = (int)1e9 + 9;

int cnt[mmax][kmax][kmax];
int t[mmax][kmax];
int cnt1[bmax][bmax];
int cnt2[bmax][bmax];
int c[mmax * bmax][bmax];
int s[mmax*2];
int b[mmax];
int n,m,k,bm;

void pre_calc(){
	s[0] = 0;
	forn(i,m)
		s[i+1] = s[i] + b[i];

	cnt1[0][0] = 1;
	forn(i,bmax)
		forn(j,bmax)
			for (int k = 1; k < bmax-j; k++)
				cnt1[i+1][j+k] = (cnt1[i+1][j+k] + cnt1[i][j]) % mod;
	cnt2[0][0] = 1;
	forn(i,bmax)
		forn(j,bmax)
			for (int k = 0; k < bmax-j; k++)
				cnt2[i+1][j+k] = (cnt2[i+1][j+k] + cnt2[i][j]) % mod;
	forn(i,mmax * bmax)
		forn(j,bmax)
			c[i][j] = 0;
	c[0][0] = 1;
	
	
	forn(i,mmax * bmax)
		forn(j,min(i+1,bmax)){
			if (i == 0) continue;
			c[i][j] = c[i-1][j];
			if (j) c[i][j] += c[i-1][j-1];
			c[i][j] %= mod;
		}
	for (int i = 1; i < m; i++)
		for (int q = 0; q <= min(s[i],k); q++){
			for (int j = 0; j <= k; j++)
				cnt[i][j][q] = 0;
			for (int y = 0; y <= b[i]; y++)
				for (int z = 0; z <= min(s[i]-q,b[i]-y) && z+q <= k; z++){
					int64 now = (c[s[i]-q][z] * cnt1[z][b[i]-y])% mod;
					
					now = (now * cnt2[q+1][y]) % mod;
//printf("i: %d  q: %d  y: %d  z:%d  now: %lld %d\n",i,q,y,z,(int64)c[s[i]-q][z],s[i]);
					
					cnt[i][z][q] = (cnt[i][z][q] + now) % mod;
				}
			}
}

void solve(){
	pre_calc();
	t[1][0] = 1;
	for (int i = 1; i < m; i++)
		for (int j = 0; j <= k; j++)
			for (int l = 0; l <= k-j; l++){
				int64 now = (t[i][j] * cnt[i][l][j]) % mod;
				t[i+1][j+l] = (t[i+1][j+l] + now) % mod;
			}
}

void read(){
	scanf("%d %d",&k, &m);
	n = bm = 0;
	forn(i,m){
		scanf("%d",&b[i]);
		n += b[i];
		bm = max(bm,b[i]);
	}
}
	
void write(){
	printf("%d\n",t[m][k]);
}

int main(){
/*	freopen("input.txt","rt",stdin);
	freopen("output.txt","wt",stdout);*/
	
	read();
	solve();
	write();
	
	return 0;
}
