#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 120;
const int kmax = 100;
const int max_step = (int)1e6;

real g[nmax][nmax];
real res = 0;
vector<pii> e;
int n,k;
vector<int> b[nmax];
int shag = 1;
int used[nmax];
real cost = 0;

void write(){
	printf("%0.10lf\n",(double)res);
	exit(0);
}


void go(int v, int &s){
	s++;
	used[v] = shag;
	forn(i,b[v].size())
		if (g[b[v][i]][v] > 0 && used[b[v][i]] < shag)
			go(b[v][i],s);
} 
	

void check(){
	cerr << cost << " " ;
	real now = cost;
	shag++;
	forn(i,n)
		if (used[i] < shag){
			int add = 0;
			go(i,add);
			now *= add;
		}
	cerr << now << endl;
	res = max(res,now);
}

void gen(int x, int now){
	shag++;
	if (shag >= max_step)write();
	if (now == k-1){
		check();
		return;
	}
	if (x == n-1)return;
	gen(x+1,now);
	int v = e[x].fs;
	int u = e[x].sc;
	real r = g[v][u];
	cost += g[v][u];
	
	g[v][u] = g[u][v] = 0;
	gen(x+1,now+1);
	g[v][u] = g[u][v] = r;
	cost -= r;
}
	

void solve_2n(){
	gen(0,0);	
}

void read(){
	cin >> n >> k;
	forn(i,n-1){
		int u,v;
		real w;
		cin >> u >> v >> w;
		u--;
		v--;
		g[u][v] = w;
		g[v][u] = w;
		b[v].pb(u);
		b[u].pb(v);
		
		
		e.pb(mp(u,v));
	}
}


int main(){
	freopen("input.txt","rt",stdin);
	freopen("output.txt","wt",stdout);
	
	read();
	solve_2n();
 	write();
	
	return 0;
}
