{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
{$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
{$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
{ you can add units after this };
type
  edge=record
    x,y:longint;
    d:extended;
  end;
const
  mc=10;
  eps=1.01;
var
  n,k,i,j,rk:longint;
  a:array[0..101]of edge;
  v:longint;
  u:array[0..101]of boolean;
  p,d,np,nd:array[0..101]of longint;
  vpow:array[0..101]of extended;
  power:array[0..101]of extended;
  sum:extended;
  h:extended;
  he:edge;
  ans:extended;
  start:extended;
Procedure DFS(v:longint);
var
  i:longint;
Begin
  d[v]:=1;
  vpow[v]:=0;
  u[v]:=true;
  for i:=1 to n-1 do
    if ((a[i].x=v)and(not u[a[i].y]))then begin
      p[a[i].y]:=v;
      DFS(a[i].y);
      d[v]:=d[v]+d[a[i].y];
      vpow[v]:=vpow[v]+vpow[a[i].y]+a[i].d;
    end else
    if (a[i].y=v)and(not u[a[i].x]) then begin
      p[a[i].x]:=v;
      DFS(a[i].x);
      d[v]:=d[v]+d[a[i].x];
      vpow[v]:=vpow[v]+vpow[a[i].x]+a[i].d;
    end;
End;
Procedure Perebor(k:longint;sum:extended);
var
  v,i:longint;
  ssum:extended;
  speed:extended;
Begin
  speed:=ans/rk;
  if (rk<>k)and((sum+speed*k)*eps<ans)then exit;
  if (k=0) then ans:=max(ans,sum) else begin
    if (now-start)*24*60*60>1.91 then begin
      write(ans:0:12);
      close(output);
      halt(0);
    end;
    for i:=1 to n-1 do if (not u[i]) then begin
    u[i]:=true;
    v:=a[i].x;
    while p[v]<>0 do v:=p[v];
    ssum:=sum+d[v]*a[i].d;
    if (p[a[i].x]=a[i].y) then begin
      p[a[i].x]:=0;
      v:=a[i].y;
      while v<>0 do begin
        d[v]:=d[v]-d[a[i].x];
        v:=p[v];
      end;
    end else begin
      p[a[i].y]:=0;
      v:=a[i].x;
      while v<>0 do begin
        d[v]:=d[v]-d[a[i].y];
        v:=p[v];
      end;
    end;
    Perebor(k-1,ssum);
    if (p[a[i].x]=a[i].y) then begin
      p[a[i].x]:=a[i].y;
      v:=a[i].y;
      while v<>0 do begin
        d[v]:=d[v]+d[a[i].x];
        v:=p[v];
      end;
    end else begin
      p[a[i].y]:=a[i].x;
      v:=a[i].x;
      while v<>0 do begin
        d[v]:=d[v]+d[a[i].y];
        v:=p[v];
      end;
    end;
    u[i]:=false;
    end;
  end;
End;
begin
  start:=now;
  //assign(input,'b.in');reset(input);assign(output,'b.out');rewrite(output);
  fillchar(p,sizeof(p),0);
  fillchar(d,sizeof(d),0);
  fillchar(a,sizeof(a),0);
  fillchar(u,sizeof(u),0);
  read(n,k);
  rk:=k-1;
  sum:=0;
  for i:=1 to n-1 do begin
    read(a[i].x,a[i].y,a[i].d);
    sum:=sum+a[i].d;
  end;
  for i:=1 to n-1 do
    for j:=i+1 to n-1 do
      if (a[i].d<a[j].d) then begin
        he:=a[i];
        a[i]:=a[j];
        a[j]:=he;
      end;
  DFS(1);
  np:=p;nd:=d;
  ans:=0;
  for i:=1 to k-1 do begin
    v:=a[i].x;
    while p[v]<>0 do
      v:=p[v];
    ans:=ans+d[v]*a[i].d;
    if (p[a[i].x]=a[i].y) then begin
      p[a[i].x]:=0;
      v:=a[i].y;
      while v<>0 do begin
        d[v]:=d[v]-d[a[i].x];
        v:=p[v];
      end;
    end else begin
      p[a[i].y]:=0;
      v:=a[i].x;
      while v<>0 do begin
        d[v]:=d[v]-d[a[i].y];
        v:=p[v];
      end;
    end;
  end;
  fillchar(u,sizeof(u),0);
  p:=np;d:=nd;
 for i:=1 to n-1 do begin
   power[i]:=MaxInt;
   if p[a[i].x]=a[i].y then begin
     power[i]:=max((sum-vpow[a[i].x]-a[i].d)*d[a[i].x],vpow[a[i].x]*(n-d[a[i].x]));
   end else begin
     power[i]:=max((sum-vpow[a[i].y]-a[i].d)*d[a[i].y],vpow[a[i].y]*(n-d[a[i].y]));
   end;
 end;
 for i:=1 to n-1 do
   for j:=i+1 to n-1 do
     if power[i]>power[j] then begin
       he:=a[i];
       a[i]:=a[j];
       a[j]:=he;
       h:=power[i];
       power[i]:=power[j];
       power[j]:=h;
     end;
  fillchar(u,sizeof(u),0);
  Perebor(k-1,0);
  write(ans:0:12);
  //close(input);close(output);
end.