program z4;
uses Math;
const inf=1000000000000000;
type integer=longint;
var e: array[1..1000,1..1000] of int64;
    num: array[1..1000,1..1000] of integer;
    n,m1,m2,t,s,a,b,i,j,k: integer;

procedure dijkstra;
var d: array[1..1000] of int64;
    pred,rez: array[1..1000] of integer;
    was: array[1..1000] of boolean;
    i,j,bj: integer;
    bd: int64;
begin
  for i:=1 to n do begin
    d[i]:=inf;
    was[i]:=false;
  end;
  d[t]:=0;
  for i:=1 to n-1 do begin
    bd:=inf; bj:=-1;
    for j:=1 to n do
      if (d[j]<bd) and (not was[j]) then begin
        bj:=j; bd:=d[j];
      end;
    if bj=-1 then break;
    was[bj]:=true;
    for j:=1 to n do begin
      if d[j]>d[bj]+e[bj,j] then begin
       d[j]:=d[bj]+e[bj,j];
       if not was[j] then pred[j]:=bj;
      end;
    end;
  end;

  if d[s]>inf div 100 then WriteLn('NO')
  else begin
    bj:=s;
    j:=0;
    bd:=0;
    while bj<>t do begin
      if num[pred[bj],bj]<>0 then begin
        inc(j);
        rez[j]:=num[pred[bj],bj];
        inc(bd,e[pred[bj],bj]);
      end;
      bj:=pred[bj];
    end;
    WRiteLn('YES');
    WriteLn(bd);
    WriteLn(j);
    for i:=1 to j do
      Write(rez[i],' ');
  end;
end;

begin
  assign(input,'input.txt');
  reset(input);
  Read(n);
  Read(m1);
  for i:=1 to n do
    for j:=1 to n do
      e[i,j]:=inf;
  for i:=1 to m1 do
  begin
    Read(a,b);
    e[a,b]:=0;
  end;

  for k:=1 to n do
    for i:=1 to n do
      for j:=1 to n do
        e[i,j]:=min(e[i,j],e[i,k]+e[k,j]);

  for i:=1 to n do
  begin
    a:=0;
    b:=0;
    for j:=1 to n do begin
      if e[i,j]=0 then inc(a);
      if e[j,i]=0 then inc(b);
    end;
    if a=n-1 then s:=i;
    if b=n-1 then t:=i;
  end;

  Read(m2);
  for i:=1 to m2 do
  begin
    Read(a,b,k);
    if e[a,b]>k then begin
      e[a,b]:=k;
      num[a,b]:=i;
    end;
  end;

  dijkstra;
end.
