{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
{$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
{$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
{ you can add units after this };

type
  edge=record
    v,n:longint;
  end;
var
  n,m1,m2:longint;
  a,b,color,list:array[0..20001]of longint;
  e:array[0..500001]of edge;
  r:longint;
  x,y,i,j,d:longint;
  k,kol:longint;
  used:array[0..500001]of boolean;
  sum:int64;
Procedure Add(var p:longint;y:longint);
Begin
  inc(r);
  e[r].v:=y;
  e[r].n:=p;
  p:=r;
End;
Procedure DFS(v:longint);
var
  i:longint;
Begin
  color[v]:=1;
  i:=a[v];
  while i<>0 do begin
    if color[e[i].v]=0 then DFS(e[i].v);
    i:=e[i].n;
  end;
  inc(k);list[k]:=v;
End;
Procedure rDFS(v:longint);
var
  i:longint;
Begin
  color[v]:=k;
  i:=b[v];
  while i<>0 do begin
    if color[e[i].v]=0 then rDFS(e[i].v);
    i:=e[i].n;
  end;
End;

Begin
  //assign(input,'d.in');reset(input);assign(output,'d.out');rewrite(output);
  read(n,m1);
  fillchar(a,sizeof(a),0);
  r:=0;
  for i:=1 to m1 do begin
    read(x,y);
    Add(a[x],y);
    Add(b[y],x);
  end;
  read(m2);
  kol:=0;
  sum:=0;
  for i:=1 to m2 do begin
    read(x,y,d);
    inc(kol);
    sum:=sum+d;
    Add(a[x],y);
    Add(b[y],x);
  end;
  fillchar(used,sizeof(used),0);
  fillchar(color,sizeof(color),0);
  fillchar(list,sizeof(list),0);
  k:=0;
  for i:=1 to n do if color[i]=0 then DFS(i);
  fillchar(color,sizeof(color),0);
  k:=0;
  for i:=n downto 1 do if (color[list[i]]=0) then begin
    inc(k);
    rDFS(list[i]);
  end;
  if k>1 then writeln('NO') else begin
    writeln('YES');
    writeln(sum);
    writeln(kol);
    for i:=1 to m2 do write(i,' ');
  end;
  //close(input);close(output);
End.