#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

struct rec
{
	int l, r, n;
};

bool less1 (rec p1, rec p2)
{
	if (p1.l != p2.l)
		return p1.l < p2.l;
	else
		return p1.r < p2.r;	
}

int n;
int l[500], r[500];
vector <pii> a;
vector <rec> b, c, d;
bool u[500];

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
	scanf ("%d", &n);
	a.resize (n*2);
	forn (i, n)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		a[i*2].fs = x;
		a[i*2].sc = i*2;
		a[i*2+1].fs = y-1;
		a[i*2+1].sc = i*2+1;
	}
	forn (i, n*2)
	{
		a.pb (mp (a[i].fs-1, -1));
		a.pb (mp (a[i].fs+1, -1));
	}
	sort (all (a));
	int p = a[0].fs;
	a[0].fs = 1;
	for (int i = 1; i < (int)a.size(); i ++)
		if (a[i].fs == p)
			a[i].fs = a[i-1].fs;
		else
		{
			p = a[i].fs;
			a[i].fs = a[i-1].fs + 1;
		}	
	forn (i, a.size())
		if (a[i].sc >= 0)
		{
			if (a[i].sc & 1)
				r[a[i].sc/2] = a[i].fs;
			else
				l[a[i].sc/2] = a[i].fs;
		}		
	b.resize (n);
	forn (i, n)
	{
		b[i].n = i;
		b[i].l = l[i];
		b[i].r = r[i];
// 		cerr << b[i].l << " " << b[i].r << endl;
	}
	sort (all (b), less1);
// 	forn (i, n)
// 		cerr << b[i].l << " " << b[i].r << " " << b[i].n << endl;
// 		cerr << endl;
	seta (u, 0);
	c.clear ();
	int i = 0;
	int res = 0;
	for (int x = 1; x <= n*4; x ++)
	{
		if (i < n && b[i].l == x)
		{
			int j = i;
			while (j + 1 < n && b[j+1].l == b[j].l)
				j ++;
			int p1 = j;
			int p2 = last(c);
			d.clear ();
// 			cerr << "!" << b[p1].n << endl << endl;
			while (p1 >= i || p2 >= 0)
			{
				if (p2 < 0)
				{
// 						cerr << b[p1].n << endl;
					d.pb (b[p1]);
					p1 --;
				}
				else
				if (p1 < i || u[c[p2].n] || c[p2].r < x)
				{
					d.pb (c[p2]);
					p2 --;
				}
				else
				{
					if (c[p2].r >= b[p1].r)
					{
						d.pb (c[p2]);
						p2 --;
					}
					else
					{
// 						cerr << b[p1].n << endl;
						d.pb (b[p1]);
						p1 --;
					}
				}
			}	
			i = j + 1;
			reverse (all (d));
			c = d;	
		}	
		int col = -1;
		forn (k, c.size())
			if (c[k].l <= x && x <= c[k].r)
			{
				col = c[k].n;
				if (!u[col])
				{
					u[col] = 1;
					res ++;
				}
				for (int K = k+1; K < (int)c.size(); K ++)
					if (c[K].r <= c[k].r)
						u[c[K].n] = 1;
				break;
			}
// 		cerr << x << " " << res << endl;	
// 		forn (i, c.size())
// 			cerr << c[i].n << " " ;
// 		cerr << endl;		
	}
	printf ("%d\n", res);
	reverse (all (c));
	forn (i, c.size())
		printf ("%d ", c[i].n+1);
	printf ("\n");	
	return 0;
}
