#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 3500;

const int px[4] = {1,1,-1,-1};
const int py[4] = {1,-1,1,-1};

char a[nmax][nmax];
int r[nmax][nmax];
int res[nmax][nmax];
int now[nmax][nmax];
int sum[nmax][nmax];
int n,m,cx,cy;

bool check(int x, int y){
	if (x >= n || y >=m || x < 0 || y < 0)return 0;
	return 1;
}

int calc__(int x, int y,int i){
	assert(check(x,y));
	if (now[x][y] != -1) return now[x][y];
	if (!check(x+px[i],y+py[i])) return now[x][y] = 0;
	if (a[x][y] == '*' && (a[x+px[i]][y] == '*' || a[x][y+py[i]] == '*'))return now[x][y] = 0;
	return now[x][y] = min(calc__(x+px[i],y,i),calc__(x,y+py[i],i))+1;
}
	

void calc_all_r(){
	forn(i,n)
		forn(j,m){
			r[i][j] = min(i,j);
			r[i][j] = min(r[i][j],n-i-1);
			r[i][j] = min(r[i][j],m-j-1);
		}
	forn(q,4){
		forn(i,n)
			forn(j,m)
				now[i][j] = -1;
		forn(i,n)
			forn(j,m)
				r[i][j] = min(r[i][j],calc__(i,j,q));
	}
/*	forn(i,n){
		forn(j,m)
			cout << r[i][j];
		cout << endl;
	}*/
		
}


void calc_all_res(){
	forn(j,m){
		sum[j][0] = 0;
		forn(i,n)
			sum[j][i+1] = sum[j][i] + (a[i][j] == '*');
	}
	forn(i,n)
		forn(j,m){
			int l1 = j - r[i][j];
			int r1 = j + r[i][j];
			
			if ((r[i][j]+1) * (r[i][j]+1) < res[cx][cy])continue;
			
			int now = sum[j][i+r[i][j]+1] - sum[j][i-r[i][j]];
			
			for (int k = 0; k < r[i][j]; k++)
				now += sum[l1+k][i+k+1] - sum[l1+k][i-k];
			
			for (int k = 0; k < r[i][j]; k++)
				now += sum[r1-k][i+k+1] - sum[r1-k][i-k];
			res[i][j] = now;
			if (res[cx][cy] < res[i][j]){
				cx = i;
				cy = j;
			}
		}
}

void solve(){
	calc_all_r();
	cx = cy = 0;
	calc_all_res();
}

void read(){
	scanf("%d %d\n",&n,&m);
	forn(i,n){
		forn(j,m)
			scanf("%c",&a[i][j]);
		scanf("\n");
	}
}

void write(){
	printf("%d %d %d %d\n",res[cx][cy],cy+1,cx+1,r[cx][cy]);
}	

void gen(){
	n = m = 3000;
	forn(i,n){
		forn(j,n){
			char ch = '.';
			if ( (i+j) % 2 == 0)ch = '*';
			a[i][j] = ch;
		}
	}
}

int main(){
//   	freopen("input.txt","rt",stdin);
//   	freopen("output.txt","wt",stdout);

// 	read();
	gen();
	solve();
	write();
	
	return 0;
}
