{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
  { you can add units after this };
const
  MaxN=1 shl 12;
  shift=MaxN-1;
var
  i,j,h,w:longint;
  c:array[0..3001,0..3001]of char;
  a,s:array[0..2*MaxN,0..2*MaxN]of longint;
  l,r:longint;
  x,y:longint;
  lx,ly,rx,ry:longint;
  sum:longint;
  ans,med:longint;
  ans_sum:longint;
  ans_x,ans_y:longint;
  ans_r:longint;
Procedure Rinc(vx,vy:longint);
var
  x,y:longint;
Begin
  x:=vx;
  while x>0 do begin
    y:=vy;
    while y>0 do begin
      inc(a[x][y]);
      y:=y div 2;
    end;
    x:=x div 2;
  end;
End;
Procedure Incer(i,j:longint);
var
  x,y:longint;
Begin
  x:=i+j-1;
  y:=h+i-j;
  Rinc(x+shift,y+shift);
End;
Procedure sRinc(vx,vy:longint);
var
  x,y:longint;
Begin
  x:=vx;
  while x>0 do begin
    y:=vy;
    while y>0 do begin
      inc(s[x][y]);
      y:=y div 2;
    end;
    x:=x div 2;
  end;
End;
Procedure sIncer(i,j:longint);
var
  x,y:longint;
Begin
  x:=i+j-1;
  y:=h+i-j;
  sRinc(x+shift,y+shift);
End;
Function sRSQ(vx,vy,lx,rx,ly,ry,x_min,x_max,y_min,y_max:longint):longint;
var
  m:longint;
Begin
  if (lx=x_min)and(rx=x_max)and(ly=y_min)and(ry=y_max) then result:=s[vx][vy] else 
  if (lx=x_min)and(rx=x_max) then begin
    m:=(ly+ry)div 2;
    result:=0;
    if (y_min<=m) then result:=result+sRSQ(vx,2*vy,lx,rx,ly,m,x_min,x_max,y_min,min(y_max,m));
    if (y_max>m) then result:=result+sRSQ(vx,2*vy+1,lx,rx,m+1,ry,x_min,x_max,max(y_min,m+1),y_max);
  end else begin
    m:=(lx+rx)div 2;
    result:=0;
    if (x_min<=m) then result:=result+sRSQ(2*vx,vy,lx,m,ly,ry,x_min,min(x_max,m),y_min,y_max);
    if (x_max>m) then result:=result+sRSQ(2*vx+1,vy,m+1,rx,ly,ry,max(x_min,m+1),x_max,y_min,y_max);
  end;
End;


Function RSQ(vx,vy,lx,rx,ly,ry,x_min,x_max,y_min,y_max:longint):longint;
var
  m:longint;
Begin
  if (lx=x_min)and(rx=x_max)and(ly=y_min)and(ry=y_max) then result:=a[vx][vy] else 
  if (lx=x_min)and(rx=x_max) then begin
    m:=(ly+ry)div 2;
    result:=0;
    if (y_min<=m) then result:=result+RSQ(vx,2*vy,lx,rx,ly,m,x_min,x_max,y_min,min(y_max,m));
    if (y_max>m) then result:=result+RSQ(vx,2*vy+1,lx,rx,m+1,ry,x_min,x_max,max(y_min,m+1),y_max);
  end else begin
    m:=(lx+rx)div 2;
    result:=0;
    if (x_min<=m) then result:=result+RSQ(2*vx,vy,lx,m,ly,ry,x_min,min(x_max,m),y_min,y_max);
    if (x_max>m) then result:=result+RSQ(2*vx+1,vy,m+1,rx,ly,ry,max(x_min,m+1),x_max,y_min,y_max);
  end;
End;
Begin
  //assign(input,'c.in');reset(input);assign(output,'c.out');rewrite(output);
  readln(h,w);
  fillchar(c,sizeof(c),0);
  for j:=1 to h do begin
    for i:=1 to w do
      read(c[i][j]);
    readln();
  end;
  ans_sum:=0;
  for i:=1 to w do
    for j:=1 to h do
      if (c[i][j]='*') then begin
        if (c[i-1][j]='*')or(c[i+1][j]='*')or(c[i][j-1]='*')or(c[i][j+1]='*') then
          Incer(i,j);
        sIncer(i,j);
      end;
  for i:=1 to w do
    for j:=1 to h do begin
      l:=0;r:=min(min(i-1,j-1),min(w-i,h-j));
      ans:=0;
      while l<=r do begin
        med:=(l+r)div 2;
        x:=i+j-1;
        y:=h+i-j;
        lx:=x-med;ly:=y-med;
        rx:=x+med;ry:=y+med;
        sum:=RSQ(1,1,1,MaxN,1,MaxN,lx,rx,ly,ry);
        if sum=0 then l:=med+1 else begin
          ans:=med;
          r:=med-1;
        end;
      end;
      if (ans=0) then ans:=r;
      med:=ans;
      lx:=x-med;ly:=y-med;
      rx:=x+med;ry:=y+med;
      sum:=sRSQ(1,1,1,MaxN,1,MaxN,lx,rx,ly,ry);
      if sum>ans_sum then begin
        ans_sum:=sum;
        ans_r:=med;
        ans_x:=i;
        ans_y:=j;
      end;
    end;
  write(ans_sum,' ',ans_x,' ',ans_y,' ',ans_r);
  //close(input);close(output);
End.