#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;
int const N=302, M=3002, IT=(1<<16)-1, TL=1.9*CLOCKS_PER_SEC;
char w[N], ot[N];
int be[N], en[N], cs[N], res = 1<<30;

int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	int n, m;
	scanf ("%d%d", &n, &m);
	for (int i=0; i<m; i++)
		scanf ("%d%d%d", be+i, en+i, cs+i); 
	for (int t=1; (t&IT) || clock()<TL; t++) {
		int nc=0;
		for (int i=0; i<=(n>>4); i++) {
			int c=rand();
			for (int x=1; x<=(1<<4); x++)
				w[(i<<4)+x]=(c>>x&1);
		}
		for (int i=1; i<=n; i++) 
			nc+=w[i];
		if (!(nc&1)) {
			int c=rand()%n+1;
			w[c]=!w[c];
		}
		int cur=0;
		for (int i=0; i<m; i++)
			if (w[be[i]]^w[en[i]]) 
				cur+=cs[i];
		if (res>cur) {
			res=cur;
			for (int i=1; i<=n; i++)
				ot[i]=w[i];
		}		
	}
	int k=0;
	printf ("%d\n", res);
	for (int i=1; i<=n; i++)
		k+=ot[i];
	printf ("%d\n", k);
	for (int i=1; i<=n; i++)
		if (ot[i]) 	printf ("%d ", i);
	return 0;
} 
