#include <iostream>
#include <queue>
#include <vector>
#include <queue>
#include <string>
using namespace std;


int down [3000][3000];
int n;

int kolcen(int x,int y,int r)
{
	//cout<<" KOLCEN IN "<<x<<" "<<y<<" "<<r<<" ";
	int res=0;
	for (int i=y-r;i<=y+r;i++)
		{
			int xu=x-r+abs(y-i);
			int xd=x+r-abs(y-i)+1;
			res+=down[xu][i];
			res-=(xd==n)?0:down[xd][i];
		}
	//cout<<"OUT "<<res<<endl;
	return res;
}

int main()
{
	int m;
	scanf("%d %d\n",&n,&m);
	bool a[n][m];
	for (int i=0;i<n;i++)
		{
		string s;
		getline(cin,s);
		for (int j=0;j<m;j++)
			{
				//char c;
				//scanf("%c",&c);
				//cout<<"GET "<<i<<" "<<j<<" = "<<s[j]<<endl;
				if (s[j]=='*')
					a[i][j]=true;
				if (s[j]=='.')
					a[i][j]=false;
			}
		}
	int k=0;
	int num=0;
	//cout<<a[0][0]<<" "<<a[0][1]<<" "<<a[0][2]<<endl;
	//cout<<a[1][0]<<" "<<a[1][1]<<" "<<a[1][2]<<endl;
	for (int i=n-1;i>=0;i--)
		{
			for (int j=0;j<m;j++)	
			{
				down[i][j]=(i==n-1?0:down[i+1][j])+(a[i][j]?1:0);
			}
		}
	//cout<<down[0][0]<<" "<<down[0][1]<<" "<<down[0][2]<<endl;
	//cout<<down[1][0]<<" "<<down[1][1]<<" "<<down[1][2]<<endl;
	int maxsize[n][m];
	queue< pair<int,int> > bfsq;
	for (int i=0;i<n;i++)
		for (int j=0;j<n;j++)
			if (a[i][j])
			{
				bool q=(i!=0)&&(a[i-1][j]);
				q|=((i!=(n-1))&&(a[i+1][j]));
				q|=((j!=(m-1))&&(a[i][j+1]));
				q|=((j!=0)&&(a[i][j-1]));
				if (q)
				{
					bfsq.push(make_pair(i,j));
					maxsize[i][j]=1;
				};
			};
	vector< vector<int> > d(n);
	for (int i=0;i<n;i++)
		d[i].assign(m,-1);
	for (;!bfsq.empty();)
		{
			pair<int,int> ver=bfsq.front();
			bfsq.pop();
			int x1=ver.first;
			int y1=ver.second;
			if ((x1!=0) && (d[x1-1][y1]==-1))
				{
					d[x1-1][y1]=d[x1][y1]+1;
					bfsq.push(make_pair(x1-1,y1));
				};
			if ((x1!=n-1) && (d[x1+1][y1]==-1))
				{
					d[x1+1][y1]=d[x1+1][y1]+1;
					bfsq.push(make_pair(x1+1,y1));
				};
			if ((y1!=0) && (d[x1][y1-1]==-1))
				{
					d[x1][y1-1]=d[x1][y1-1]+1;
					bfsq.push(make_pair(x1,y1-1));
				};
			if ((y1!=m-1) && (d[x1][y1+1]==-1))
				{
					d[x1][y1+1]=d[x1][y1]+1;
					bfsq.push(make_pair(x1,y1+1));
				};
		}
	//cout<<d[0][0]<<d[0][1]<<d[0][2]<<endl;
	//cout<<d[1][0]<<d[1][1]<<d[1][2]<<endl;
	//cout<<"End BFS"<<endl;	
	for (int i=0;i<n;i++)
		for (int j=0;j<m;j++)
			{
				int t=min(min(i,j),min(n-i-1,m-j-1));
				if (d[i][j]==-1)
					d[i][j]=t;
				else
					d[i][j]=min(d[i][j],t);
			};

	//cout<<d[0][0]<<d[0][1]<<d[0][2]<<endl;
	//cout<<d[1][0]<<d[1][1]<<d[1][2]<<endl;
	//cout<<"count d"<<endl;
	int maxres=0;
	int maxx=0;
	int maxy=0;
	for (int i=0;i<n;i++)
		for (int j=0;j<m;j++)
		{
			int t=kolcen(i,j,d[i][j]);
			if (maxres<t)
			{
				maxres=t;
				maxx=i;
				maxy=j;
			}
		}
	printf("%d %d %d %d\n",maxres,maxy+1,maxx+1,d[maxx][maxy]);
	return 0;
}