program z3;
uses Math;
type integer=longint;
     pnode=^node;
     node=record
       x,y: integer;
       next: pnode;
     end;
var a,d,kd: array[0..2001,0..2001] of integer;
    was: array[0..2001,0..2001] of boolean;
    q,en,x: pnode;
    h,w,i,j,mx,my,mr,minn,r,bI: integer;
    s: string;

procedure add(x,y: integer);
var t: pnode;
begin
  was[x,y]:=true;
  d[x,y]:=0;
  new(t);
  t^.x:=x;
  t^.y:=y;
  t^.next:=nil;
  if q=nil then q:=t
  else en^.next:=t;
  en:=t;
end;

function get: pnode;
begin
  get:=q;
  q:=q^.next;
end;

function solve(y,x,d: integer): Integer;
var i,rez: integer;
begin
  rez:=0;
  for i:=-d to d do
    rez:=rez+kd[y+abs(abs(i)-r),x+i]-kd[y+abs(abs(i)-r),x+i-1]-kd[y-abs(abs(i)-r)-1,x+i]+kd[y-abs(abs(i)-r)-1,x+i-1];
end;

begin
  q:=nil;
  ReadLn(h,w);
  for i:=1 to h do
    for j:=1 to w do
    begin
      was[i,j]:=false;
      d[i,j]:=maxlongint;
    end;
  for i:=1 to h do begin
    Readln(s);
    for j:=1 to w do begin
      if s[j]='*' then begin
        a[i,j]:=1;
        if a[i-1,j]>0 then begin
          if a[i-1,j]=1 then add(j,i-1);
          a[i-1,j]:=2; a[i,j]:=2;
          add(j,i);
        end;
        if a[i,j-1]>0 then begin
          if a[i,j-1]=1 then add(j-1,i);
          if a[i,j]=1 then add(j,i);
          a[i,j-1]:=2; a[i,j]:=2;
        end;
      end else a[i,j]:=0;
      kd[i,j]:=kd[i-1,j]+kd[i,j-1]-kd[i-1,j-1]+ord(a[i,j]>0);
    end;
  end;

  for i:=1 to h do
  begin
    was[i,0]:=true;
    was[i,w+1]:=true;
  end;
  for i:=1 to w do
  begin
    was[0,i]:=true;
    was[h+1,i]:=true;
  end;
  while q<>nil do begin
    x:=get;
    if not was[x^.y-1,x^.x] then begin
      add(x^.y-1,x^.x);
      d[x^.y-1,x^.x]:=d[x^.y,x^.x]+1;
    end;
    if not was[x^.y+1,x^.x] then begin
      add(x^.y+1,x^.x);
      d[x^.y+1,x^.x]:=d[x^.y,x^.x]+1;
    end;
    if not was[x^.y,x^.x+1] then begin
      add(x^.y,x^.x+1);
      d[x^.y,x^.x+1]:=d[x^.y,x^.x]+1;
    end;
    if not was[x^.y,x^.x-1] then begin
      add(x^.y,x^.x-1);
      d[x^.y,x^.x-1]:=d[x^.y,x^.x]+1;
    end;
    x:=x^.next;
  end;
  minn:=0;
  for i:=1 to h do
    for j:=1 to w do
    begin
      r:=min(min(i-1,j-1),min(min(h-i,w-j),d[i,j]));
      bI:=solve(i,j,r);
      if (bI>minn) or ((bI=minn) and (r<mr)) then begin
        my:=i; mx:=j; mr:=r; minn:=bI;
      end;
    end;
  WriteLn(minn,' ',mx,' ',my,' ',mr);
end.

