#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

int ct, cnt;
int col[300], was[300], prev[300];
int g[300][300], f[300][300], q[300], acol[300];
vector<pair<pair<int, int>, int> > all;
vector<int> v[300];

int bfs (int s, int ff) {
	ct++;
	int l = 0, r = 1;
	q[0] = s;
	was[s] = ct;
	while (l < r) {
		int x = q[l++];
		for (int i = 0; i < v[x].size (); i++) {
			int y = v[x][i];
			if (g[x][y] - f[x][y] > 0 && was[y] != ct) {
				was[y] = ct;
				q[r++] = y;
				prev[y] = x;
			}
		}
	}
	if (was[ff] != ct) return 0;
	return 1;
}

int dfs (int x) {
	col[x] = 1;
	cnt++;
	for (int i = 0; i < v[x].size (); i++) {
		int y = v[x][i];
		if (g[x][y] - f[x][y] > 0 && !col[y]) dfs (y);
	}
	return 0;
}

int calc () {
	int tmp = 0;
	for (int i = 0; i < all.size (); i++) {
		int a = all[i].first.first;
		int b = all[i].first.second;
		int c = all[i].second;
		if (col[a] != col[b]) tmp += c;				
	}
	return tmp;
}

int main () {
	int n, m;
	scanf ("%d%d", &n, &m);
	memset (g, 0, sizeof (g));
	for (int i = 0; i < m; i++) {
		int a, b, c;
		scanf ("%d%d%d", &a, &b, &c); a--; b--;
		g[a][b] = c;
		g[b][a] = c;
		v[a].push_back (b);
		v[b].push_back (a);
		all.push_back (make_pair (make_pair (a, b), c));
	}
	ct = 0;
	int ans = 1000000000;
	for (int t = 1; t < n; t++) {
		memset (f, 0, sizeof (f));
		while (bfs (0, t)) {
			int y = t;
			int tmp = 1000000000;
			while (y > 0) {
				int x = prev[y];
				tmp = min (tmp, g[x][y] - f[x][y]);
				y = x;
			}
			y = t;
			while (y > 0) {
				int x = prev[y];
				f[x][y] += tmp;
				f[y][x] -= tmp;
				y = x;
			}
		}
		memset (col, 0, sizeof (col));
		cnt = 0;
		dfs (0);
		if (cnt % 2 == 1) {
			int tmp = calc ();
			if (tmp < ans) {
				ans = tmp;
				for (int i = 0; i < n; i++)
					acol[i] = col[i];
			}
		} else {
			for (int i = 0; i < n; i++) {
				col[i] = 1 - col[i];
				int tmp = calc ();
				if (tmp < ans) {
					ans = tmp;
					for (int i = 0; i < n; i++)
						acol[i] = col[i];
				}
				col[i] = 1 - col[i];
			}
		}
	}
	printf ("%d\n", ans);
	int k = 0;
	for (int i = 0; i < n; i++) k += acol[i];
	printf ("%d\n", k);
	for (int i = 0; i < n; i++) 
		if (acol[i]) printf ("%d ", i + 1);
	printf ("\n");
}