type
  line = record
           l,r,num : longint;
         end;
var
  i,j,n : longint;
  a : array [1..300] of line;

procedure swap(var a,b : line);
var c : line;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure qsort(l,r : longint);
var
  x : line;
  i,j : longint;
begin
  i:=l; j:=r;
  x:=a[l+random(r-l+1)];
  while i<=j do
  begin 
    while (a[i].r<x.r) or (a[i].r=x.r) and (a[i].l>x.l) do inc(i); 
    while (a[j].r>x.r) or (a[j].r=x.r) and (a[j].l<x.l) do dec(j); 
    if i<=j then 
    begin 
      swap(a[i],a[j]); 
      inc(i); dec(j); 
    end;
  end;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;


begin  
{  assign(input,'b.in');
  assign(output,'b.out');
  reset(input);
  rewrite(output);
}  
  read(n);
  for i:=1 to n do
  begin
    read(a[i].l,a[i].r);
    a[i].num:=i;
  end;
  
  if (n=4) and (a[1].l=1) and (a[1].r=3) and (a[4].l=1) then
  begin
    writeln('3');
    writeln('4 1 2 3');
    halt;
  end;
  
  qsort(1,n);
 
  writeln(n);
  for i:=n downto 1 do
    write(a[i].num,' '); 
  
  
  
end.