#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <assert.h>
#include <iostream>

using namespace std;

#ifdef DEBUG
int eprintf(const char* format, ...) {
  va_list args;
  va_start(args, format);
  int ret = vfprintf(stderr, format, args);
  va_end(args);
  return ret;
}
#endif

int main() {
  {
    FILE *f = fopen("/dev/urandom", "rb");
    if (f) {
      int x;
      fread(&x, sizeof(x), 1, f);
      srand(x);
      fclose(f);
    }
  }
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  string s;
  getline(cin, s);
  
  int bans = s.size();
  string bt = "", bg = s;
  for (int a = 0; a < s.size(); a++)
    for (int b = a; b < s.size(); b++) {
      string t = string(s, a, b - a + 1), g = "";
      int pos, curpos = 0;
      while ((pos = s.find(t, curpos)) < s.size()) {
        g += string(s, curpos, pos - curpos) + "A";
        curpos = pos + t.size();
      }
      g += string(s, curpos);
      if (t.size() + g.size() < bans) {
        bans = t.size() + g.size();
        bt = t; bg = g;
      }
    }
  printf("%s\n%s\n", bt.c_str(), bg.c_str());
  return 0;
}
