#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=302;
vector<int> p, f, d;
vector< pair<int,int> > v;
inline int ls(int i, int j) {
	return v[i].first < v[j].first || v[i].first == v[j].first && v[i].second > v[j].second;
}

int main () {
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);	
	int n; cin >> n;
	v.resize(n); f.resize(n);
	d.resize(n<<2, 0);
	for (int i=0; i<n; i++) {
		pair<int,int> c;
		cin >> c.first >> c.second;
		p.push_back(c.first);
		p.push_back(c.second);
		v[i]=c, f[i]=i;
	}
	sort(p.begin(), p.end());
	p.erase(unique(p.begin(), p.end()), p.end());
	for (int i=0; i<n; i++) {
		int x=v[i].first, y=v[i].second;
		x=lower_bound(p.begin(), p.end(), x)-p.begin();
		y=lower_bound(p.begin(), p.end(), y)-p.begin();
		v[i]=make_pair(x+x, y+y);
	}
	sort(f.begin(), f.end(), ls);
	int res=0;
	for (int i=n-1; i>=0; i--) {
		for (int x=v[f[i]].first; x<=v[f[i]].second; x++)
			if (!d[x]) {
				res++; break;
			}
		for (int x=v[f[i]].first; x<=v[f[i]].second; x++)
			d[x]=1;
	}
	cout << res << endl;
	for (int i=0; i<n; i++)
		cout << f[i]+1 << endl;
	return 0;
} 
