program z1;
const pnum=1000000007;
type integer=longint;
var s: array of string;
    hash: array of array of int64;
    s1,s2,l,a,b,d,st29,rz: array[0..500000] of integer;
    n,i,j,i1,j1,ln,m,minl,ss1,ss2,rez,w: integer;
    t: int64;

procedure GetHash(const v: integer);
var i: integer;
    t: int64;
begin
  hash[v,0]:=0;
  for i:=1 to d[v] do begin
    t:=(hash[v,i-1]*29+ord(s[v,i])-ord('a')) mod pnum;
    hash[v,i]:=t;
  end;
end;

function compare(const a,b,sa,sb,l: integer): boolean;
var t1,t2: int64;
begin
  t1:=hash[a,sa+l-1]-(hash[a,sa-1]*st29[l]) mod pnum;
  t2:=hash[b,sb+l-1]-(hash[b,sb-1]*st29[l]) mod pnum;
  compare:=t1=t2;
end;

procedure swap(var a,b: integer);
var t: integer;
begin
  t:=a; a:=b; b:=t;
end;

procedure qsort(ll,r: integer);
var i,j,x: integer;
begin
  i:=ll; j:=r; x:=l[ll+random(r-ll+1)];
  repeat
    while l[i]<x do inc(i);
    while l[j]>x do dec(j);
    if i<=j then begin
      swap(l[i],l[j]);
      swap(s1[i],s1[j]);
      swap(s2[i],s2[j]);
      swap(a[i],a[j]);
      swap(b[i],b[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if ll<j then qsort(ll,j);
  if i<r then qsort(i,r);
end;

begin
//  assign(input,'input.txt');
 // reset(input);
  ReadLn(n);
  SetLength(s,n+1);
  SetLength(hash,n+1);
  minl:=0;
  for i:=1 to n do
  begin
    ReadLn(s[i]);
    d[i]:=length(s[i]);
    if minl<d[i] then minl:=d[i];
    SetLength(hash[i],d[i]+1);
    GetHash(i);
  end;
  st29[0]:=1;
  for i:=1 to minl do
  begin
    t:=st29[i-1]*29;
    t:=t mod pnum;
    st29[i]:=t;
  end;
  m:=0;
  for i:=1 to n do
    for j:=i+1 to n do
    begin
      minl:=0;
      ss1:=1; ss2:=1;
      for i1:=1 to d[i] do
        for j1:=1 to d[j] do begin
          ln:=0;
          while (i1+ln<=d[i]) and (j1+ln<=d[j]) and (compare(i,j,i1,j1,ln+1)) do inc(ln);
          if ln>minl then begin
            minl:=ln; ss1:=i1; ss2:=j1;
          end;
        end;
      inc(m);
      s1[m]:=ss1;
      s2[m]:=ss2;
      l[m]:=minl;
      a[m]:=i;
      b[m]:=j;
    end;
  qsort(1,m);
  for i:=1 to n do d[i]:=i;
  rez:=0;
  w:=0;
  i:=m;
  while rez<>n-1 do begin
    if d[a[i]]<>d[b[i]] then begin
      inc(rez);
      inc(w,l[i]);
      rz[rez]:=i;
      j:=d[b[i]];
      for i1:=1 to n do if d[i1]=j then d[i1]:=d[a[i]];
    end;
    dec(i);
  end;
  WriteLn(w);
  for i:=1 to rez do
    Writeln(a[rz[i]],' ',b[rz[i]],' ',s1[rz[i]],' ',s2[rz[i]],' ',l[rz[i]]);
end.
