#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 150000;
const int rmax = 10;

string s,r,s1;
int k;
char ch,c;
int x;
int64 t[nmax][rmax];
int64 d[nmax];

int last;
int ans;
bool stup = false;

void norm(string &r){
	string q = "";
	int now = -1;
	forn(i,r.size()){
		if (now >= 0 && q[now] == '*' && r[i] == '*')continue;
		now++;
		q += r[i];
	}
	r = q;
}

bool good(string r){
	forn(i,r.size())
		if (r[i] == '*')
			return false;
	return true;
}

void del(int x){
	x--;
	s.erase(s.begin()+x);
	last = x;
}

void insert(char ch, int x){
	s = s.substr(0,x) + ch + s.substr(x,s.size()-x);
	last = x;
}

/*void re_calc(){
	forn(i,nmax)
		d[i] = 0;
	forn(i,n){
		bool now = true;
		forn(j,r.size())
			if (r[j] != '?' && r[j] != s[i])
				now = false;
		if (now)
			d[i+r.size()]++;
	}
	forn(i,n)
		d[i+1] += d[i];
}*/
		

int64 full_calc(){
	int64 res = 0;
	
	forn(i,s.size()+1){
		forn(j,rmax)
			t[i][j] = 0;
		t[i][0] = 1;
	}
//	t[0][0] = 1;
	forn(i,s.size())
		forn(j,(int)r.size())
			if (t[i][j]){
// 			cout << i << " " << j << " " << t[i][j]<< endl;
			/*if (j == (int)r.size()){
				t[i+1][j] += t[i][j];
				continue;
			}
			*/if (r[j] == '?' || r[j] == s[i]){
				t[i+1][j+1] += t[i][j];
				continue;
			}
			if (r[j] == '*'){
				t[i][j+1] += t[i][j];
				t[i+1][j] += t[i][j];
				//t[i+1][j+1] += t[i][j];
				continue;
			}
		}
	forn(i,s.size()+1)
		res += t[i][r.size()];
// 	cout << s << endl;
	return res;	
}
	
	


int main(){
//     	freopen("input.txt","rt",stdin);
//     	freopen("output.txt","wt",stdout);

	
	getline(cin,r);
	getline(cin,s);
	norm(r);
	
	scanf("%d ",&k);
	forn(i,k){
		scanf(" %c",&ch);
		if (ch == '-'){
			scanf(" %d",&x);
			del(x);
		}
		if (ch == '+'){
			scanf(" %c %d",&c,&x);
			insert(c,x);
		}
		printf("%lld\n",full_calc());
		fflush(stdout);
	}

	return 0;
}
