#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define day first
#define s second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii1;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;
const int64 P = 1000000009;

int n;
int d[3000][3000], lf[3000][3000], rg[3000][3000];
string s[3000], st;
char c[100000];
int l[100000], p[100000], ld[3000];

int leader (int v)
{
	if (ld[v] != v)
		ld[v] = leader (ld[v]);
	return ld[v];	
}

void unite (int v1, int v2)
{
	v1 = leader (v1);
	v2 = leader (v2);
	if (rand()&1)
		ld[v1] = v2;
	else
		ld[v2] = v1;	
}

void go (int v, int star)
{
	l[0] = -1;
	int pl = -1;
	for (int i = 1; i < (int)st.length(); i ++)
	{
		l[i] = pl;
		while (l[i] > -1 && st[l[i]+1] != st[i])
			l[i] = l[l[i]];
		if (st[l[i]+1] == st[i])
			l[i] ++;	
		pl = l[i];	
	}
	forn (j, n)
		if (j != v)
			for (int i = 0; i < (int)s[j].length(); i ++)
			{
				p[i] = pl;
				while ((p[i]+1 == (int)st.length()) || 
					(p[i] > -1 && st[p[i]+1] != s[j][i]))
					p[i] = l[p[i]];
				if (st[p[i]+1] == s[j][i])		
					p[i] ++;
				pl = p[i];
				if (d[v][j] < pl+1 && i - pl-1 + 2 > 0)
				{
					d[v][j] = pl+1;
					lf[v][j] = star + 1;
					rg[v][j] = i - pl-1 + 2;	
				}
			}
}

struct rec
{
	int w, v1, v2, p1, p2;
	rec () {}
	rec (int W, int V1, int V2, int P1, int P2)
	{
		w = W;
		v1 = V1;
		v2 = V2;
		p1 = P1;
		p2 = P2;
	}
};

vector <rec> b, a[3001];
int ws1;

int main ()
{	
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);
	scanf ("%d", &n);
	forn (i, n)
	{
		scanf ("%s", c);
		s[i] = c;
	}
	seta (d, 0);
	forn (i, n)
		forn (j, n)
		{
			lf[i][j] = 1;
			rg[i][j] = 1;
		}
	forn (i, n)
		forn (j, s[i].length())
		{
			st = s[i].substr (j);
			go (i, j);
		}
	forn (i, n)
		ld[i] = i;
	int x = 0;
	forn (i, n)
		forn (j, n)
			if (i < j)
				x = max (x, d[i][j]);
	forn (i, x)
		a[i].clear ();	
	forn (i, n)
		forn (j, n)
			if (i < j)
				a[d[i][j]].pb (rec (d[i][j], i, j, lf[i][j], rg[i][j]));	
	ws1 = 0;
	b.clear ();
	ford (j, x+1)
		forn (i, (int)a[j].size())
			if (leader (a[j][i].v1) != leader (a[j][i].v2))
			{
				ws1 += a[j][i].w;
				b.pb (a[j][i]);
				unite (a[j][i].v1, a[j][i].v2);	
			}
	printf ("%d\n", ws1);
	forn (i, b.size())
		printf ("%d %d %d %d %d\n", b[i].v1+1, b[i].v2+1, b[i].p1, b[i].p2, b[i].w);	
	return 0;
}
