#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define sz(a) (int)(a).size()

struct seg
{
  int l, r, i;
};

bool operator < ( const seg &a, const seg &b )
{
  return a.l < b.l;
}

const int inf = (int)1e9 + 1;
const int maxn = 100001;

int n, m, k;
seg s[maxn];
int *f[maxn], *pr[maxn], *cnt[maxn];
int res[maxn];

int main()
{
  scanf("%d%d%d", &n, &m, &k);
  forn(i, n)
    scanf("%d%d", &s[i].l, &s[i].r), s[i].i = i;
  s[n].l = -inf, s[n++].r = -inf;
  sort(s, s + n);

  forn(i, k + 1)
    f[i] = new int[n + 1];
  forn(i, k + 1)
    pr[i] = new int[n + 1];
  forn(i, n)
    cnt[i] = new int[n + 1];

  for (int x = 0; x < n; x++)
  {
    int sum = 0;
    for (int t = x; t >= 0; t--)
    {
      sum += (s[x].l <= s[t].r);
      cnt[t][x] = min(sum, m);
    }
  }
  
  f[0][0] = 1;
/*  forn(i, n)
    printf("[%d,%d]\n", s[i].l, s[i].r);*/
  forn(i, k)
    forn(j, n)
      if (f[i][j])
        for (int x = j + 1; x < n; x++)
        {
          int val = cnt[j + 1][x];
          if (f[i + 1][x] < f[i][j] + val)
          {
            f[i + 1][x] = f[i][j] + val;
            pr[i + 1][x] = j;
          }
        }

  int mi = 0;
  forn(i, n)
    if (f[k][i] > f[k][mi])
      mi = i;
  printf("%d\n", f[k][mi] - 1);

  vector <int> ans;
  for (int i = k; i > 0; i--)
    ans.pb(mi), mi = pr[i][mi];
  reverse(ans.begin(), ans.end());
  forn(i, sz(ans))
    printf("%d ", s[ans[i]].l);
  puts("");
  ans.insert(ans.begin(), -1);
  forn(i, sz(ans) - 1)
  {
    int cnt = m, x = s[ans[i + 1]].l;
    for (int j = ans[i] + 1; j <= ans[i + 1]; j++)
      if (cnt > 0 && s[j].r >= x)
        res[s[j].i] = i + 1, cnt--;
  }
  forn(j, n - 1)
    printf("%d ", res[j]);
  puts("");
  return 0;
}
