{$O+,R-,S-,Q-}
{$M 80000000,80000000}
type
    int = longint;
const
    NMAX = 2001;
var
	x, y: array [1..NMAX] of int;
	ans: int64;
	n: int;

function pl(a, b, c: int): int64;
begin
	pl := abs((x[a] - x[b]) * (y[a] + y[b]) + (x[b] - x[c]) * (y[b] + y[c]) + (x[c] - x[a]) * (y[c] + y[a]));
end;

procedure make(l, r, now: int);
var
	i: int;
	sq, tmp: int64;
	
begin
	for i := 2 to n do begin
		inc(l);
		inc(r);
		if r > n then r := 1;
		
		sq := pl(l, r, now);
		tmp := pl(l, r, now - 1);
		if tmp > sq then begin
			sq := tmp;
			dec(now);
		end;
		tmp := pl(l, r, now + 1);
		if tmp > sq then begin
			sq := tmp;
			inc(now);
		end;
		if sq > ans then ans := sq;
	end;
end;

procedure find(dl: int);
var
	i, l, r, now: int;
	sq, tmp: int64;

begin
	l := 1;
	r := l + dl;

	now := l;
	sq := 0;
	for i := l to r do begin
		tmp := pl(l, r, i);
		if tmp > sq then begin
			sq := tmp;
			now := i;
		end;
	end;
	if sq > ans then ans := sq;
	make(l, r, now);

	now := l;
	sq := 0;
	for i := 1 to l do begin
		tmp := pl(l, r, i);
		if tmp > sq then begin
			sq := tmp;
			now := i;
		end;
	end;
	for i := r to n do begin
		tmp := pl(l, r, i);
		if tmp > sq then begin
			sq := tmp;
			now := i;
		end;
	end;
	if sq > ans then ans := sq;
	make(l, r, now);
end;

var
	i: int;

begin
	read(n);
	for i := 1 to n do
		read(x[i], y[i]);

	ans := 0;
	for i := 1 to n shr 1 do
		find(i);
	writeln(ans / 2: 0: 3);
end.