{$MODE DELPHI}
type
  tPoint=record x, y:Extended; end;
  tLine=record a, b, c:Extended; end;
var n, i, j, k:Integer;
    l:tLine;
    p:array[1..2000]of tPoint;
    d, s:Extended;
function dist(const a, b:tPoint):Extended;
begin
  result:=sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
end;
function Line(const a, b:TPoint):tLine;
var m:Extended;
begin
  result.a:=a.y-b.y;
  result.b:=b.x-a.x;
  result.c:=-result.a*a.x-result.b*a.y;
  m:=sqrt(result.a*result.a+result.b*result.b);
  result.a:=result.a/m;
  result.b:=result.b/m;
  result.c:=result.c/m;
end;
function f(i:Integer):Extended;
begin
  if(i>n) then i:=i-n;
  result:=abs(l.a*p[i].x+l.b*p[i].y+l.c);
end;
function Find(i, j:Integer):Integer;
var x1, x2:Integer;
    f1, f2:Extended;
begin
  if(j<i) then j:=j+n;
  while(j>i+1) do
  begin
    x1:=i+(j-i+1) div 3;
    x2:=j-(j-i+1) div 3;
    f1:=f(x1); f2:=f(x2);
    if(f1>f2) then
      j:=x2
    else
      i:=x1;
  end;
  if(f(i)>f(j)) then
    result:=i
  else
    result:=j;
end;
begin
  //assign(input, 'a.in'); reset(input);
  //assign(output, 'a.out'); rewrite(output);
  fillchar(p, sizeof(p), 0);
  readln(n);
  for i:=1 to n do
    readln(p[i].x, p[i].y);
  s:=0;
  for i:=1 to n do
    for j:=1 to n do
      if(i<>j) then
      begin
        l:=Line(p[i], p[j]);
        d:=Dist(p[i], p[j]);
        k:=Find(i, j);
        if(s<d*f(k)) then
          s:=d*f(k);
      end;
  writeln(s/2:0:10);
  close(input); close(output);
end.