{$O+,R-,S-,Q-}
{$M 80000000,80000000}
uses
	sysutils;
type
    int = longint;
const
    NMAX = 3001;
var
	x, y: array [1..NMAX] of int64;
	ans: int64;
	n: int;

function pl(a, b, c: int): int64;
begin
	pl := abs((x[a] - x[b]) * (y[a] + y[b]) + (x[b] - x[c]) * (y[b] + y[c]) + (x[c] - x[a]) * (y[c] + y[a]));
end;

procedure make(l, r, now: int);
var
	i, gnow, lnow: int;
	sq, tmp: int64;
	
begin
	for i := 2 to n do begin
		inc(l);
		inc(r);
		if r > n then r := 1;
		sq := pl(l, r, now);

		lnow := now - 1;
		if lnow < 1 then lnow := n;
		tmp := abs((x[l] - x[r]) * (y[l] + y[r]) + (x[r] - x[lnow]) * (y[r] + y[lnow]) + (x[lnow] - x[l]) * (y[lnow] + y[l]));
		if tmp > sq then begin
			sq := tmp;
			now := lnow
		end;

		gnow := now + 1;
		if gnow > n then gnow := 1;
		tmp := abs((x[l] - x[r]) * (y[l] + y[r]) + (x[r] - x[gnow]) * (y[r] + y[gnow]) + (x[gnow] - x[l]) * (y[gnow] + y[l]));
		if tmp > sq then begin
			sq := tmp;
			now := gnow
		end;
		if sq > ans then ans := sq;
	end;
end;

procedure find(dl: int);
var
	i, l, r, now: int;
	sq, tmp: int64;

begin
	l := 1;
	r := l + dl;

	now := l;
	sq := 0;
	for i := l to r do begin
		tmp := abs((x[l] - x[r]) * (y[l] + y[r]) + (x[r] - x[i]) * (y[r] + y[i]) + (x[i] - x[l]) * (y[i] + y[l]));
		if tmp > sq then begin
			sq := tmp;
			now := i;
		end;
	end;
	if sq > ans then ans := sq;
	make(l, r, now);

	now := l;
	sq := 0;
	for i := 1 to l do begin
		tmp := abs((x[l] - x[r]) * (y[l] + y[r]) + (x[r] - x[i]) * (y[r] + y[i]) + (x[i] - x[l]) * (y[i] + y[l]));
		if tmp > sq then begin
			sq := tmp;
			now := i;
		end;
	end;
	for i := r to n do begin
		tmp := abs((x[l] - x[r]) * (y[l] + y[r]) + (x[r] - x[i]) * (y[r] + y[i]) + (x[i] - x[l]) * (y[i] + y[l]));
		if tmp > sq then begin
			sq := tmp;
			now := i;
		end;
	end;
	if sq > ans then ans := sq;
	make(l, r, now);
end;

var
	i: int;
	start: real;

begin
	start := now;
	read(n);
	for i := 1 to n do
		read(x[i], y[i]);

	ans := 0;
	for i := 1 to n shr 1 do
		if (now - start) * 24 * 3600 < 1.9 then find(i)
			else break;
	writeln(ans / 2: 0: 3);
end.