#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int FMAX = 50;
const int rmax = 50;
int64 f[FMAX+1], r[rmax+1];

bool calc (int n, int p)
{
	if (n <= 1)
	{
		if (p == 1)
			return 0;
		else
			return 1;	
	}
	if (f[n-1] >= p)
		return calc (n-1, p);
	else
		return calc (n-1, p-f[n-1]);	
	return 0;
}

bool go (int n, int64 x, int64 y)
{
	if (x > y)
		return 1;
	if (n <= 2)
	{
		if (x == y)
			return 1;
		if (x == 1 && y == 3)
			return 1;
		return 0;		
	}
	if (r[n-1] >= y)
		return go (n-1, x, y);
	int64 len = r[n];
	int64 c = (len+1)/2;
	int64 d = max (x-1, len-y);
	if (d*2 < len)
	{
		if (len-d == y && d == x-1)
			return 1;
		if (len-d == y)
			y = d+1;
		else
			x = len-d;	
	}
	if (x > y)
		swap (x, y);
	if (x > c)
	{
		x = 1+len-x;
		y = 1+len-y;
	}	
	if (x > y)
		swap (x, y);
	return go (n-1, x, y);	
}

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
	f[0] = 1;
	f[1] = 2;
	for (int i = 2; i <= FMAX; i ++)
		f[i] = f[i-1] + f[i-2];
	r[0] = 0;
	r[1] = 1;
	for (int i = 2; i <= rmax; i ++)
		r[i] = r[i-1] + r[i-2] + 2;
	int n;
	scanf ("%d", &n);
	forn (i, n)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		y = x + y - 1;
		bool res = go (rmax, x, y);
		if (res)
			printf ("TAK\n");
		else
			printf ("NIE\n");	
	}	
	return 0;
}
