{$O+,R-,S-,Q-}
{$M 80000000,80000000}
type
    int = longint;
const
    NMAX = 50;
	lenmax = 1000000000;
	ITER = 200;
var
	len: array [1..NMAX] of int;
	n, num: int;

function sim(k, p: int): boolean;
begin
	if k = 1 then begin
		sim := false;
		exit;
	end;
	if k = 2 then begin
		if p = 1 then sim := false	
			else sim := true;
		exit;
	end;

	if p > len[k - 1] then sim := sim(k - 2, p - len[k - 1])
		else sim := sim(k - 1, p);
end;

var
	i, l, r, j, t, tmp: int;
	s1, s2, good: boolean;

begin
	len[1] := 1;
	len[2] := 2;
	for i := 3 to NMAX do begin
		len[i] := len[i - 1] + len[i - 2];
		if len[i] > lenmax then begin
			num := i;
			break;
		end;
	end;

	randseed := 3746736;
	read(n);
	for t := 1 to n do begin
		read(l, tmp);
		r := l + tmp - 1;
		
		good := true;
		if r - l < ITER then begin
			for i := l to r do
				if sim(num, i) <> sim(num, r - i + l) then begin
					good := false;
					break;
				end;
		end
		else begin
			for j := 1 to ITER do begin
				i := l + random(r - l);
				if i <= len[num] then s1 := sim(num, i)
					else s1 := sim(num - 1, i - len[num]);
				if r - i + l <= len[num] then s2 := sim(num, r - i + l)
					else s2 := sim(num - 1, r - i + l - len[num]);
				if s1 <> s2 then begin
					good := false;
					break;
				end;
			end;
		end;

		if good then
			writeln('TAK')
		else
			writeln('NIE');
	end;
end.