{$O+,R-,S-,Q-}
{$M 80000000,80000000}
type
    int = longint;
	list = ^node;
	node = record
		num: int;
		name: string;
		next: list;
	end;
const
    NMAX = 100001;
	HMAX = 100009;
var
	h: array [1..NMAX] of list;
	vertex, edge, value: array [1..NMAX] of int;
	n, now, q: int;

function read_word: string;
var
	s: string;
	ch: char;
begin
	s := '';
	read(ch);
	while ord(ch) <= 32 do
		read(ch);
	while ord(ch) > 32 do begin
		s := s + ch;
		read(ch);
	end;
	read_word := s;
end;

procedure add(s: string);
var
	t: list;
	hv, l, i: int;

begin
	l := length(s);
	hv := 0;
	for i := 1 to l do
		hv := (hv * 13 + ord(s[i])) mod HMAX;

	t := h[hv];
	inc(now);
	while t <> nil do begin
		if (t^.name = s) then begin
			t^.num := now;
			exit;
		end;
		t := t^.next;
	end;
	new(t);
	t^.name := s;
	t^.num := now;
	t^.next := h[hv];
	h[hv] := t;
end;

function find(s: string): int;
var
	t: list;
	hv, l, i: int;

begin
	l := length(s);
	hv := 0;
	for i := 1 to l do
		hv := (hv * 13 + ord(s[i])) mod HMAX;

	t := h[hv];
	while t <> nil do begin
		if (t^.name = s) then begin
			find := t^.num;
			exit;
		end;
		t := t^.next;
	end;
	find := 0;
end;

var
	name, tmp: string;
	i, v, poz, number: int;
	ch: char;

begin
	readln(n);
	readln(name);
	now := 0;
	add(name);
	readln(q);

	for i := 1 to q do begin
		read(ch);
		name := read_word;
		read(poz);
		if ch = 'S' then begin
			read(number);
			tmp := read_word;
			if seekeoln then readln;

			add(tmp);
			v := find(name);
			vertex[now] := v;
			edge[now] := poz;
			value[now] := number;
		end;
		if ch = 'G' then begin
			v := find(name);
			while (poz <> edge[v]) and (v <> 1) do
				v := vertex[v];
			if v > 1 then writeln(value[v])
				else writeln(0);
			flush(output);
			readln;
		end;
	end;
end.