#include <iostream>
#include <string>

using namespace std;

const int maxlen=2000;
const int p=57;
		
string sp="0";
string s="01";
unsigned int HLR[maxlen], HRL[maxlen];
int n;

int step(int a, int x)
{
	int b=1;
	
	while (x>0)
		if (x%2==0)
	{
		x/=2;
		a=a*a;
	}
	else
	{
		x--;
		b=b*a;
	}
	return b;
}

int HashLR(int l, int r)
{
	if (r==0)
		return HLR[0];
	return HLR[r]-HLR[l-1]*step(p,r-l+1);
}

int HashRL(int l, int r)
{
	if (l==s.length()-1)
		return HRL[l];
	return HRL[l]-HRL[r+1]*step(p,r-l+1);
}

int main()
{
	string ns;
	for (int i=0; s.length()<maxlen;i++)
		ns=s+sp, sp=s, s=ns;
	
// 	int kn=0;
// 	for (int i=0; i<s.length(); i++)
// 		if (s[i]=='0')
// 			kn++;
// 		else
// 		{
// 			cout << kn << endl;
// 			kn=0;
// 		}
	
	unsigned int hash=0;
	for (int i=0; i<s.length(); i++)
		HLR[i]=hash=hash*p+s[i];
	
	hash=0;
	for (int i=s.length()-1; i>=0; i--)
		HRL[i]=hash=hash*p+s[i];
	cin >> n;
	for (int i=0; i<n; i++)
	{
		int l,r,len;
		cin >> l >> len;
		l--;
		r=l+len-1;
		if (HashLR(l,r)==HashRL(l,r))
			cout << "TAK" << endl;
		else
			cout << "NIE" << endl;
	}
}