#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int64,int64> pii;
typedef long double real;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 35;
const int64 NEED = (int64) 1e9;

int64 s[nmax*2];
int n = 35;

int gen_c(int x, int y){
	if (y == 0) return 0;
	if (y == 1) return x;
	if (x < s[y-1])
		return gen_c(x,y-1);
	else
		return gen_c(x-s[y-1],y-2);
}

void pre_calc(){
	s[0] = 1;
	s[1] = 2;
	
	for (int i = 2; i < nmax+5; i++)
		s[i] = s[i-1] + s[i-2];
}

int main(){
     	freopen("input.txt","rt",stdin);
     	freopen("output.txt","wt",stdout);
 	
	pre_calc();
	
	int tst;
	cin >> tst;
	forn(i,tst){
		int l,r,len;
		scanf("%d %d",&l,&len);
		l--;
		r = l+len-1;
		bool eq = true;
		while (l < r){
			if (gen_c(l,n) != gen_c(r,n)){
				eq = false;
				break;
			}
			l ++;
			r --;
		}
		if (eq)
			puts("TAK");
		else
			puts("NIE");
	}
	
	
	return 0;
}
