Type Integer=LongInt;

{$H+}

Const HashC = 1000007;
      good : set of char = ['a'..'z']+['0'..'9'];

Type TData = record
		 	cell,key,from,nextSameHash:Integer; 
		 	name:String;
		 end;



Var data:Array[1..100000]of TData;
		hash:Array[0..HashC]of Integer;
		needCell,t,p,q,i,x,k,n,totalVersions:Integer;
		s,tmp:String;
		ch:Char;
		
Procedure Search(t,k:Integer);
var cur:Integer;
Begin
	cur:=t;
	while cur<>1 do begin
		if data[cur].cell = k then begin
			WriteLn(data[cur].key);exit;
		end else cur:=data[cur].from;
	end;
	WriteLn(0);
End;

Function HashF(var s:String):Integer;
var cur,i:Integer;
Begin
	cur:=0;
	for i:=1 to length(s) do cur:=(cur*128+ord(s[i]))mod HashC;
	HashF:=cur;
End;

Procedure Add2Hash(i:Integer);
Var k:Integer;
Begin
	k:=hashF(data[i].name);
	if hash[k] = 0 then hash[k]:=i else begin
		data[i].nextSameHash:=hash[k];
		hash[k]:=i;
	end;
End;

Function NewVersion(var s:String):Integer;
Begin
	Inc(totalVersions);
	data[totalVersions].name:=s;
	NewVersion:=totalVersions;
End;

Function FindVersion(var s:String):Integer;
Var cur:Integer;
Begin
	cur:=hash[hashF(s)];
	while cur<>0 do begin
		if (data[cur].nextSameHash = 0) or (data[cur].name = s) then begin
			FindVersion:=cur;
			exit;
		end else cur:=data[cur].nextSameHash;
	end;
End;

Procedure AddEdit(mn,p,q,from:Integer);
Begin
	data[mn].cell:=p;
	data[mn].key:=q;
	data[mn].from:=from;
End;


Begin

{	Assign(input,'in.txt');
	Assign(output,'out.txt');
	Reset(input);ReWrite(output);}
 
 fillchar(hash,sizeof(hash),0);


	totalVersions:=0;
	
	ReadLn(n);
	ReadLn(s);
	x:=NewVersion(s);
	Add2Hash(x);
	ReadLn(k);
	for i:=1 to k do begin
		Read(ch);
		if ch = 'S' then begin
			Read(ch);Read(ch);tmp:='';
			while ch in good do begin
				tmp:=tmp+ch;Read(ch);
			end;
			t:=FindVersion(tmp);
			Read(p,q);
			Read(ch);Read(ch);tmp:='';
			while ch in good do begin
				tmp:=tmp+ch;Read(ch);
			end;
			x:=NewVersion(tmp);
			Add2Hash(x);
			AddEdit(x,p,q,t);
		end else begin
			Read(ch);Read(ch);tmp:='';
			while ch in good do begin
				tmp:=tmp+ch;Read(ch);
			end;
			t:=FindVersion(tmp);
			ReadLn(needCell);
			if t=1 then WriteLn(0) else 
				if data[t].cell = needCell then WriteLn(data[t].key) 
					else Search(t,needCell);
			flush(output);	
		end;
	end;
End.