#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;

char x[9]={'6', '7', '8', '9', 'T', 'J', 'Q', 'K', 'A'}, y[4]={'H', 'S', 'C', 'D'};
int c[9][4], nc[5], zc[5], g[9][4], cc, pk, vz, kol=36;

int ztoi(char c) {
	int f=0; while(x[f]!=c) f++;
	return f;
}

int mtoi(char c) {
	int s=0; while(y[s]!=c) s++;
	return s;
}

int ctoi(string s) {
	return ztoi(s[0])*4+mtoi(s[1]);
}

double otb(int f, int s, int k) {
	double x=0, y=0, z=0;
	
	int t=c[f][s];
	c[f][s]=-1;
		
	for (int i=1; i<=4; i++) zc[i]=0;
	
	for (int i=0; i<9; i++)
		for (int j=0; j<4; j++) {
			if (c[i][j]>0) zc[c[i][j]]++;
			else if (c[i][j]==0) z++;
		}	
	
	for (int i=f+1; i<9; i++)
		if (c[i][s]==k) x++;
		else if (c[i][s]==0) y++;
		
	if (s)
		for (int i=0; i<9; i++)
			if (c[i][0]==k) x++;
			else if (c[i][0]==0) y++;
	
	if (z) x+=(nc[k]-zc[k])*y/z;
	
	c[f][s]=t;
	
	return x/nc[k];
}

int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	
	string s; int k;
	char ch; cin >> s >> ch;
	swap(y[0], y[mtoi(ch)]);
	
	for (;;) {
		cin >> s;
		if (s=="give") {
			cin >> k >> s;
			if (k==1) {
				int z=ctoi(s);
				c[z/4][z%4]=1;
			}
			nc[k]++, kol--;
		}
		else if (s=="move") {
			for (int i=0; i<9; i++)
				for (int j=0; j<4; j++)
					if (g[i][j]) g[i][j]=0;
			int x, y, z;
			cin >> x >> y >> s;
			if (!nc[x]) x^=2;
			if (!nc[y]) y^=2;
			cc=z=ctoi(s);
			g[z/4][z%4]=1; 
			c[z/4][z%4]=-1;
			pk=y, vz=0, nc[x]--;
		}
		else if (s=="add") {
			int x, y, z;
			cin >> x >> y >> s;
			if (!nc[x]) x^=2;
			if (!nc[y]) y^=2;
			cc=z=ctoi(s);
			nc[x]--;
			g[z/4][z%4]=1;
			c[z/4][z%4]=-1;
			if (vz) {
				c[z/4][z%4]=pk;
				nc[pk]++;
			}
		}
		else if (s=="beat") {
			int x, z;
			cin >> x >> s;
			if (!nc[x]) x^=2;
			z=ctoi(s);
			g[z/4][z%4]=1;
			c[z/4][z%4]=-1;
			nc[x]--;
		}	
		else if (s=="take") {
			int x; cin >> x; vz=1;
			if (!nc[x]) x^=2;
			for (int i=0; i<9; i++)
				for (int j=0; j<9; j++)
					if (g[i][j])
						c[i][j]=x, nc[x]++;
		}
		else if (s=="out") {
			int x; cin >> x;
			nc[x]=0;
		}	
		else if (s=="MOVE") {
			int t=(nc[2] ? 2 : 4), f=-1, s;
			for (int i=8; i>=0; i--)
				for (int j=1; j<4; j++)
					if (c[i][j]==1) f=i, s=j;
			if (f<0)
				for (int i=8; i>=0; i--)
					if (c[i][0]==1) f=i, s=0;	
			printf ("%c%c\n", x[f], y[s]);
			fflush(stdout);
		}
		else if (s=="BEAT") {
			int x=cc/4, y=cc%4;
			int f=-1, s;
			for (int i=8; i>x; i--)
				if (c[i][y]==1)
					f=i, s=y;
			if (f<0)
				for (int i=8; i>=0; i--)
					if (c[i][0]==1)
						f=i, s=0;
			if (f<0) printf ("NO\n");
			else printf ("%c%c\n", ::x[f], ::y[s]);
			fflush(stdout);
		}
		else if (s=="ADD") {
			int h[9], f=-1, s;
			for (int i=0; i<9; i++) {
				h[i]=0;
				for (int j=0; j<4; j++)
					if (g[i][j]) h[i]=1;
			}
			for (int i=8; i>=0; i--)
				if (h[i])
					for (int j=1; j<4; j++)
						if (c[i][j]==1) f=i, s=j;
			if (f<0)
				for (int i=8; i>=0; i--)
					if (h[i] && c[i][0]==1) 
						f=i, s=0;
			if (f<0) printf ("NO\n");
			else printf ("%c%c\n", x[f], y[s]);
			fflush(stdout);
		}
		
	}
	return 0;
} 
