{$MODE DELPHI}
{$H+}

uses
  SysUtils;

var
  n,i,x,y,kir,nowbeats,kz,lmm,bestm:integer;
  kc:array[1..4] of integer;
  c:array[1..4,1..36] of string;
  ingame:array[1..4] of boolean;
  inround:array[1..36] of string;
  wasrang:array[6..14] of boolean;
  where:array[1..4,6..14] of integer;
  nowround,nowtakes,debug:boolean;
  lastmoved,tobeat,s:string;
  smallest,hm:array[1..4] of integer;
  f:string;
  
function m2i(m:char):integer;
begin
  if m='H' then m2i:=1 else
  if m='S' then m2i:=2 else
  if m='C' then m2i:=3 else
                m2i:=4;
 end;

function r2i(r:char):integer;
begin
  if r in ['6'..'9'] then r2i:=ord(r)-ord('0') else
  if r='T' then r2i:=10 else
  if r='J' then r2i:=11 else
  if r='Q' then r2i:=12 else
  if r='K' then r2i:=13 else
                r2i:=14;
end;

function i2m(m:integer):char;
begin
  if m=1 then i2m:='H' else
  if m=2 then i2m:='S' else
  if m=3 then i2m:='C' else
              i2m:='D';
end;

function i2r(r:integer):char;
begin
  if r in [6..9] then i2r:=chr(r+ord('0')) else
  if r=10 then i2r:='T' else
  if r=11 then i2r:='J' else
  if r=12 then i2r:='Q' else
  if r=13 then i2r:='K' else
               i2r:='A';
end;

function mr2c(m,r:integer):string;
begin
  mr2c:=i2r(r)+i2m(m);
end;
  
procedure take;
var i:integer;
begin
  for i:=1 to kir do
  begin
    c[nowbeats,kc[nowbeats]+i]:=inround[i];
    where[m2i(inround[i][2]),r2i(inround[i][1])]:=nowbeats;
  end;
  inc(kc[nowbeats],kir);
  kir:=0;
  //fillchar(wasrang,sizeof(wasrang),0);
end;

function iskz(card:string):boolean;
begin
  iskz:=m2i(card[2])=kz;
end;
  
function bigger(c1,c2:string):boolean;
var kz1,kz2:boolean; m1,m2,r1,r2:integer;
begin
  kz1:=iskz(c1);
  kz2:=iskz(c2);
  m1:=m2i(c1[2]);
  m2:=m2i(c2[2]);
  r1:=r2i(c1[1]);
  r2:=r2i(c2[1]);
  bigger:=((kz1) and (not kz2)) or ((m1=m2) and (r1>r2));
end;
  
procedure endround;
var i:integer;
begin
  if not nowround then exit;
  if nowtakes then take else
    for i:=1 to kir do where[m2i(inround[i][2]),r2i(inround[i][1])]:=-1;
  nowround:=false;
  nowtakes:=false;
  kir:=0;
  nowbeats:=0;
  fillchar(wasrang,sizeof(wasrang),0);
end;

procedure find(p:integer;card:string);
var i,wh:integer;
begin
  wh:=-1;
  for i:=1 to kc[p] do
  if (wh=-1) and (c[p,i]='??') then wh:=i else
  if c[p,i]=card then
  begin
    wh:=i;
    break;
  end;
  dec(kc[p]);
  for i:=wh to kc[p] do c[p,i]:=c[p,i+1];
  where[m2i(card[2]),r2i(card[1])]:=5;//this card now in round
  wasrang[r2i(card[1])]:=true;
end;

procedure move(p:integer;card:string);
begin
  find(p,card);
  lastmoved:=card;
  lmm:=m2i(card[2]);
  inc(kir);
  inround[kir]:=card;
end;

procedure mymove(nowmove:boolean);
var i,j:integer;
begin
  fillchar(smallest,sizeof(smallest),0);
  fillchar(hm,sizeof(hm),0);
  for i:=1 to 4 do
  for j:=6 to 14 do
  if (where[i,j]=1) and (nowmove or wasrang[j]) then
  begin
    smallest[i]:=j;
    break;
  end;
  for i:=1 to 4 do
  if smallest[i]<>0 then
  for j:=smallest[i] to 14 do
  if where[i,j]=y then inc(hm[i]);
  bestm:=0;
  for i:=1 to 4 do
  if (kz<>i) and (smallest[i]<>0) and ((bestm=0) or (hm[i]<hm[bestm])) then bestm:=i;
  if (smallest[kz]<>0) and (bestm=0) then bestm:=kz;
  if bestm=0 then writeln('NO') else
  begin
    //move(1,mr2c(bestm,smallest[bestm]));
    writeln(mr2c(bestm,smallest[bestm]));
  end;
  flush(output);
end;

begin
  debug:=false;
  if debug then
  begin
    assign(input,'a.in');
    assign(output,'a.out');
    reset(input);
    rewrite(output);
  end;
  randomize;
  //readln(s);
  //f:=inttostr(random(100));
  //assign(output,);
  //rewrite(output);
  
  
  fillchar(kc,sizeof(kc),0);
  for i:=1 to 4 do ingame[i]:=true;
  fillchar(wasrang,sizeof(wasrang),0);
  fillchar(where,sizeof(where),0);
  kir:=0;
  nowbeats:=0;
  nowround:=false;
  nowtakes:=false;
  
  while ((debug) and (not eof)) or (not debug) do
  begin
    readln(s);
    //writeln(output,s);
    if (s='') and (debug) then break;
    if s[1]='g' then
    begin
      x:=ord(s[6])-ord('0');
      if (x=3) and (not ingame[3]) then x:=1;
      inc(kc[x]);
      c[x,kc[x]]:=s[8]+s[9];
      if x=1 then where[m2i(s[9]),r2i(s[8])]:=1;
      endround;
    end else
    if s[1]='o' then
    begin
      x:=ord(s[5])-ord('0');
      if x=1 then halt;
      ingame[x]:=false;
    end else
    if s[1]+s[2]='tr' then
    begin
      kz:=m2i(s[7]);
    end else 
    if s[1]+s[2]='ta' then
    begin
      nowtakes:=true;
      take;
    end else
    if s[1]='m' then
    begin
      endround;
      x:=ord(s[6])-ord('0');
      y:=ord(s[8])-ord('0');
      nowround:=true;
      nowbeats:=y;
      kir:=0;
      move(x,s[10]+s[11]);
    end else
    if s[1]='a' then
    begin
      x:=ord(s[5])-ord('0');
      y:=ord(s[7])-ord('0');
      kir:=0;
      move(x,s[9]+s[10]);
    end else
    if s[1]='b' then
    begin
      x:=ord(s[6])-ord('0');
      move(x,s[8]+s[9]);
    end else
    if s='BEAT' then
    begin
      tobeat:='NO';
      for i:=6 to 14 do
      if (where[lmm,i]=1) and (bigger(mr2c(lmm,i),lastmoved)) then
      begin
        tobeat:=mr2c(lmm,i);
        break;
      end;
      if tobeat='NO' then
      for i:=6 to 14 do
      if (where[kz,i]=1) and (bigger(mr2c(kz,i),lastmoved)) then
      begin
        tobeat:=mr2c(kz,i);
        break;
      end;
      writeln(tobeat);
      flush(output);
    end else
    if s='MOVE' then
    begin
      //endround;
      if not ingame[2] then y:=4 else y:=2;
      mymove(true);
    end else
    if s='ADD' then
    begin
      y:=nowbeats;
      mymove(false);
    end else
  end;
end.

