#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int64, int64> point;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

const string F0 = "6789TJQKA";
string F1;
vector <string> a[6];
bool u[5];
bool uc[36];
int mv = -100;
int from, to;
int last = 36;
int np;
int par[5];
bool surr;

int value (string s)
{
	if (s[1] < '3')
		return s[0] - '0';
	else
		return s[0] - '0' + 9;	
}

bool less1 (string s1, string s2)
{
	return value (s1) < value (s2);
}

string parse (string s)
{
	if (isdigit (s[1]))
	{
		s[0] = F0[s[0] - '0'];
		s[1] = F1[s[1] - '0'];	
	}
	else
	{
		forn (i, F0.length())
			if (F0[i] == s[0])
			{
				s[0] = i + '0';
				break;
			}
		forn (i, F1.length())
			if (F1[i] == s[1])
			{
				s[1] = i + '0';
				break;
			}
	}
	return s;
}

void try_erase (int v, string st)
{
	forn (i, a[v].size())
		if (a[v][i] == st)
		{
			swap (a[v][i], a[v][last(a[v])]);
			a[v].pop_back();
			return;
		}
	forn (i, a[v].size())
		if (a[v][i] == "??")
		{
			swap (a[v][i], a[v][last(a[v])]);
			a[v].pop_back();
			return;
		}
}

void check ()
{
	int rs = 0;
	forn (i, 6)
		rs += a[i].size();
	cerr << rs << endl;	
	if (rs < 36)
		return;
	int k = 0;
	for (int i = 2; i <= 4; i ++)
	{
		int ok = 0;
		forn (j, a[i].size())
			if (a[i][j] == "??")
				ok = 1;
		k += ok;		
	}		
	if (k != 1)
		return;
	for (int i = 2; i <= 4; i ++)
	{
		int ok = 0;
		forn (j, a[i].size())
			if (a[i][j] == "??")
				ok = 1;
		if (ok)
		{
			seta (uc, 0);
			forn (I, 6)
				forn (J, a[I].size())
					uc[(a[I][J][0]-'0')*4 + (a[I][J][1]-'0')] = 1;
			vector <string> tmp;
			forn (j, 36)
				if (!uc[j])
				{
					string str = "??";
					str[0] = j/4 + '0';
					str[1] = j%4 + '0';
					tmp.pb (str);
				}	
			forn (j, a[i].size())		
				if (a[i][j] == "??")
				{
					a[i][j] = tmp[last(tmp)];
					tmp.pop_back();
				}	
		}		
	}		
}

int vc[20];

void MOVE ()
{
	int v1 = mv;
	int v2 = mv + 1;
	if (v2 > 4)
		v2 -= 4;
	if (!u[v1])
		v1 = par[v1];
	if (!u[v2])
		v2 = par[v2];
	from = v1;
	to = v2;			
	seta (vc, 0);
	forn (i, a[1].size())
		vc[value (a[1][i])] ++;
	forn (i, a[3].size())
		if (a[3][i] != "??")
			vc[value (a[3][i])] ++;	
	sort (all (a[1]), less1);
	int mv = value (a[1][0]);
	int k = 1;
	forn (i, a[1].size())	
		if (value (a[1][i]) <= mv+(int)a[1].size()-2)
			k = max (k, vc[value (a[1][i])]);
	forn (i, a[1].size())
		if (k == vc[value (a[1][i])])
		{
			printf ("%s\n", parse (a[1][i]).data());
			break;
		}		
	fflush (stdout);
}

void BEAT ()
{
	string st = a[5][last(a[5])];
	sort (all (a[1]), less1);
	int v = value (st);
	forn (i, a[1].size())
		if ((value (a[1][i]) > v) && (a[1][i][1] == '3' || a[1][i][1] == st[1]))
		{
			printf ("%s\n", parse (a[1][i]).data());
			fflush (stdout);
			return;
		}
	printf ("NO\n");
	fflush (stdout);
}

bool lc[9];

void ADD ()
{
	seta (lc, 0);
	forn (i, a[5].size())
		lc[value(a[5][i])%9] = 1;
	sort (all (a[1]), less1);
	int mv = value (a[1][0]);
	int maxv = mv + a[1].size()-2;
	if (surr)
		maxv = min (maxv, 8);
	forn (i, a[1].size())	
		if (value (a[1][i]) <= maxv && lc[value (a[1][i])%9])
		{
			printf ("%s\n", parse (a[1][i]).data());
			fflush (stdout);
			return;
		}		
	printf ("NO\n");	
	fflush (stdout);
}

int main ()
{	
// 	freopen ("input.txt", "r", stdin);
	string st, move;
	forn (i, 5)
		a[i].clear ();
	seta (u, 0);
	forn (i, 4)
		u[i+1] = 1;
	np = 4;	
	par[1] = 3;
	par[3] = 1;
	par[2] = 4;
	par[4] = 2;
	F1 = "SCDH";
	while (cin >> move)
	{
		check ();
		if (move == "trump")
		{
			forn (i, 6)
				forn (j, a[i].size())
					a[i][j] = parse (a[i][j]); 
			char ch;
			cin >> ch;
			if (ch == 'H')
				F1 = "SCDH";
			else
			if (ch == 'S')
				F1 = "CDHS";
			else
			if (ch == 'C')
				F1 = "DHSC";
			else
				F1 = "HSCD";			
			forn (i, 6)
				forn (j, a[i].size())
					a[i][j] = parse (a[i][j]); 
		}
		if (move == "give")
		{
			int v;
			cin >> v;
			if (!u[v])
				v = par[v];	
			cin >> st;
			st = parse (st);
			a[v].pb (st);	
			last --;
		}	
		else
		if (move == "move")
		{
			if (surr)
				a[5].clear ();
			surr = 0;
			forn (i, a[5].size())
				a[0].pb (a[5][i]);
			a[5].clear ();
			int v1, v2;
			cin >> v1 >> v2 >> st;
			if (!u[v1])
				v1 = par[v1];
			if (!u[v2])
				v2 = par[v2];	
			st = parse (st);
			from = v1;
			to = v2;
			if (mv < 1)
				mv = v1;
			try_erase (v1, st);
			a[5].pb (st);
			mv ++;
			if (mv == 5)
				mv = 1;	
		}
		else
		if (move == "add")
		{
			int v1, v2;
			cin >> v1 >> v2 >> st;
			if (!u[v1])
				v1 = par[v1];
			if (!u[v2])
				v2 = par[v2];	
			st = parse (st);
			try_erase (v1, st);
			if (surr)
				a[to].pb (st);
			else
				a[5].pb (st);	
		}
		else
		if (move == "beat")
		{
			int v1;
			cin >> v1 >> st;
			if (!u[v1])
				v1 = par[v1];
			st = parse (st);
			try_erase (v1, st);
			a[5].pb (st);
		}
		else
		if (move == "take")
		{
			int v1;
			cin >> v1;
			if (!u[v1])
				v1 = par[v1];
			surr = 1;
			forn (i, a[5].size())
				a[v1].pb (a[5][i]);
			mv ++;
			if (mv == 5)
				mv = 1;
		}
		else
		if (move == "out")
		{
			int v1;
			cin >> v1;
			if (!u[v1])
				v1 = par[v1];
			u[v1] = 0;
			if (v1 == 1)
				return 0;
			np --;
		}
		else
		if (move == "MOVE")
			MOVE();
		else
		if (move == "BEAT")
			BEAT ();
		else
		if (move == "ADD")
			ADD ();		
/*		cerr << move << " " << a[1].size() << " " << a[2].size() << " " << a[3].size() << " " << a[4].size() << endl;*/
	}	
	return 0;
}
