{$MODE DELPHI}
uses SysUtils, Math;
type tCard=string[2];
     charset=set of char;
var num, whoAdd, whoBeat, LastMove:Integer;
    com:String;
    trump:char;
    finished:array[1..4]of Boolean;
    CardsNum:array[1..5]of Integer;
    Card:array[1..5, 1..36]of tCard;
    RoundCardsNum:Integer;
    RoundCards:array[1..36]of tCard;
    Was:array[char]of Boolean;
    WhatBeat:array[char] of charset;
    hidden:Integer;
    round_mode_take:Boolean;
    cCard:tCard;
function NextToken:String;
var c:char;
begin
  result:='';
  while(result='') do
  begin
    while(eoln) do readln;
    c:=' ';
    while(not(eoln))and(c=' ') do read(c);
    while(c<>' ') do
    begin
      result:=result+c;
      if(eoln) then break else read(c);
    end;
  end;
end;
procedure AddCard(player:Integer; ccard:tCard);
begin
  inc(CardsNum[player]);
  Card[Player, CardsNum[player]]:=ccard;
end;
procedure DelCard(player:Integer; ccard:tCard);
var i, j:Integer;
begin
  j:=0;
  for i:=1 to CardsNum[player] do
    if(card[Player, i]=ccard) then
    begin
      j:=i;
      break;
    end;
  if(j=0) then
    for i:=1 to CardsNum[player] do
      if(card[Player, i]='??') then
      begin
        j:=i;
        break;
      end;
  assert(j<>0);
  for i:=j to CardsNum[Player]-1 do
    Card[player, i]:=Card[Player, i+1];
  Dec(CardsNum[player]);
end;
procedure EndLastRound;
var i:Integer;
begin
  if(Round_Mode_Take) then
    for i:=1 to RoundCardsNum do
      AddCard(whoBeat, RoundCards[i])
  else
    for i:=1 to RoundCardsNum do
      AddCard(5, RoundCards[i]);
end;
procedure AddRoundCard(card:tCard);
begin
  inc(RoundCardsNum);
  RoundCards[RoundCardsNum]:=card;
  was[card[1]]:=true;
end;
procedure ClearRound;
begin
  Round_Mode_Take:=false;
  RoundCardsNum:=0;
  fillchar(was, sizeof(was), 0);
end;
function GameOver:Boolean;
begin
  if(Finished[1]) then
    result:=true
  else
  if(Finished[2])and(Finished[4]) then
    result:=true
  else
    result:=false;
end;
function DefineMove:Integer;
begin
  if(Finished[2]) then result:=4 else
  if(Finished[4]) then result:=2 else
  if(not(Finished[3])) then
    result:=2
  else
    if(LastMove=4) then result:=2 else result:=4;
end;
procedure SetAdd(var a:charset; b:CharSet);
begin
  a:=a+b;
end;
procedure InitializeGame;
begin
  fillchar(finished, sizeof(finished), 0);
  fillchar(card, sizeof(card), 0);
  fillchar(RoundCards, sizeof(RoundCards), 0);
  hidden:=36;
  fillchar(whatBeat, sizeof(whatBeat), 0);
  SetAdd(whatBeat['K'], ['A']);
  SetAdd(whatBeat['Q'], WhatBeat['K']+['K']);
  SetAdd(whatBeat['J'], WhatBeat['Q']+['Q']);
  SetAdd(whatBeat['T'], WhatBeat['J']+['J']);
  SetAdd(whatBeat['9'], WhatBeat['T']+['T']);
  SetAdd(whatBeat['8'], WhatBeat['9']+['9']);
  SetAdd(whatBeat['7'], WhatBeat['8']+['8']);
  SetAdd(whatBeat['6'], WhatBeat['7']+['7']);
end;
function CardMore(c1, c2:tCard):Boolean;
begin
  if(c1[2]=c2[2]) then
    result:=c1[1] in WhatBeat[c2[1]]
  else
    result:=(c1[2]=trump);
end;
procedure assert(t:Boolean);
begin
  if(not(t)) then writeln(':(');
end;
function qOrd(c:char):Integer;
begin
{if(c in ['6', '7', '8']) then
    result:=6
  else
  if(c in ['9', 'T', 'J']) then
    result:=9
  else
    result:=11;}
  case c of
    '6': result:=6;
    '7': result:=6;
    '8': result:=6;
    '9': result:=9;
    'T': result:=9;
    'J': result:=10;
    'Q': result:=10;
    'K': result:=11;
    'A': result:=11;
  end;
end;
function cost(c:tCard):Integer;
begin
  result:=QOrd(c[1])*(1+ord(c[2]=trump));
end;
procedure DoYourBest(whoBeat:Integer; must:Boolean=false);
var i, possible:Integer;
begin
  possible:=0;
  for i:=1 to CardsNum[1] do
  if(must or was[card[1, i][1]]) then
    if(possible=0)or(Cost(card[1, i])<cost(card[1, possible])) then possible:=i;
  if(not(must))and(Cost(card[1, i])>=QOrd('Q'))and((hidden=0)and(CardsNum[WhoBeat]>2)or(Hidden>0)) then
    possible:=0;
  if(must)and(possible=0) then possible:=1;
  if(possible=0) then
    writeln('NO')
  else
    writeln(card[1, possible]);
end;
procedure BeatYourBest(c:tCard);
var i, possible, optima:Integer;
begin
  possible:=0;
  optima:=0;
  for i:=1 to CardsNum[1] do
    if(CardMore(Card[1, i], c)) then
      if(possible=0)or(Cost(card[1, i])<cost(card[1, possible])) then possible:=i;
  if(possible<>0)and(RoundCardsNum<=3)and(Hidden>=6)and(Cost(card[1, possible])>=QOrd('Q')) then possible:=0;
  if(possible=0) then
    writeln('NO')
  else
    writeln(card[1, possible]);
end;
begin
  //assign(input, 'input.txt');
  //assign(output, 'output.txt');
  reset(input); rewrite(output);
  assert(NextToken='trump');
  trump:=NextToken[1];
  InitializeGame;
  while(not(gameover)) do
  begin
    com:=NextToken;
    if(com='give') then
    begin
      dec(hidden);
      num:=StrToInt(NextToken);
      AddCard(num, NextToken);
    end;
    if(com='move') then
    begin
      EndLastRound;
      ClearRound;
      whoadd:=StrToInt(NextToken);
      whobeat:=StrToInt(NextToken);
      LastMove:=whoadd;
      cCard:=NextToken;
      DelCard(whoAdd, cCard);
      AddRoundCard(cCard);
    end;
    if(com='add') then
    begin
      whoadd:=StrToInt(NextToken);
      assert(StrToInt(NextToken)=whoBeat);
      cCard:=NextToken;
      DelCard(whoAdd, cCard);
      AddRoundCard(cCard);
    end;
    if(com='beat') then
    begin
      assert(StrToInt(NextToken)=whoBeat);
      cCard:=NextToken;
      DelCard(whoBeat, cCard);
      AddRoundCard(cCard);
    end;
    if(com='take') then
    begin
      assert(StrToInt(NextToken)=whoBeat);
      Round_mode_take:=true;
    end;
    if(com='out') then
      Finished[StrToInt(NextToken)]:=true;
    if(com='ADD') then
      DoYourBest(whoBeat);
    if(com='MOVE') then
    begin
      num:=DefineMove;
      DoYourBest(num, true);
      whoBeat:=num;
    end;
    if(com='BEAT') then
      BeatYourBest(RoundCards[RoundCardsNum]);
    flush(output);
  end;
end.