#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <functional>

using namespace std;

#define PB push_back
#define MP make_pair

const char allcards[9] = {'6', '7', '8', '9', 'T', 'J', 'Q', 'K', 'A'};
const int mincards[19] = {0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 5, 6 };
//                           6  7  8  9  T  J  Q  K  A  6  7  8  9  T  J  Q  K  A
//                           1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18

char w[10];
char g[10];
char trump;
int last, mva, mvb, cur, r, istake, deck;
int ingame[4];
vector<pair<char, char> > cards[4];
vector<pair<char, char> > beat;
pair<pair<char, char>, pair<char, char> > table[1000];

int erase (int i, pair<char, char> a) {
	int ii = -1;
	for (int j = 0; j < cards[i].size (); j++)
		if (cards[i][j] == a) {
			cards[i].erase (cards[i].begin () + j);
			return 0;
		} else 
		if (cards[i][j].first == '?') ii = j;
	cards[i].erase (cards[i].begin () + ii);
	return 0;
}

int getmove (int cur) {
	if (ingame[cur]) mva = cur; else mva = (cur + 2) % 4;
	if (ingame[(cur + 1) % 4]) mvb = (cur + 1) % 4; else mvb = (cur + 3) % 4;
	return 0;
}


int myless (pair<char, char> a, pair<char, char> b) {
	if (b.second == trump && a.second != trump) return 1;
	if (b.second != a.second) return 0;
	int aa = 0, bb = 0;
	for (int i = 0; i < 9; i++) {
		if (a.first == allcards[i]) aa = i + 1;
		if (b.first == allcards[i]) bb = i + 1;
	}
	if (aa < bb) return 1;
	return 0;
}

int cost2 (pair<char, char> cur) {
	int tmp = 0;
	for (int i = 0; i < 9; i++)
		if (cur.first == allcards[i]) tmp = i + 1;
	if (cur.second == trump) tmp += 9;
	return tmp;
}

int cost (pair<char, char> cur) {
/*	if (deck == 0) {
		int tmp = 0;
		for (int i = 0; i < 9; i++)
			if (cur.first == allcards[i]) tmp = i + 1;
		int ctmp = tmp;
		if (cur.second == trump) ctmp += 9;
		if (cur.second == trump) tmp = 9 - tmp; else tmp = 18 - tmp;
		int fe = 0;
		for (int i = 0; i < 4; i++)
			for (int j = 0; j < cards[i].size (); j++)
				if (cards[i][j].first == '?') fe++; else
				if (myless (cur, cards[i][j])) tmp--;
		for (int i = 0; i < beat.size (); i++)
			if (myless (cur, beat[i])) tmp--;
		int x = 0, fe2 = 0;
		for (int i = 0; i < cards[mvb].size (); i++)
			if (cards[mvb][i].first == '?') fe2++; else
			if (myless (cur, cards[mvb][i])) x++;
//		printf ("%c%c = %d %d\n", cur.first, cur.second, tmp, ctmp * fe + x * fe + tmp * fe2);
		int k = -1;
		for (int i = 0; i < cards[2].size (); i++) 
			if (cards[2][i] == cur) k++;
		for (int i = 0; i < cards[0].size (); i++) 
			if (cards[0][i] == cur) k++;
		if (cur.first != 'K' && cur.first != 'A' || cards[0].size () + cards[2].size () < 5) {
			if (k == 1) k = 10;
			if (k == 2) k = 50;
			if (k == 3) k = 1000;
		}
		return ;
	} else {*/
		int tmp = 0;
		for (int i = 0; i < 9; i++)
			if (cur.first == allcards[i]) tmp = i + 1;
		if (tmp <= 4) tmp = 1; else
		if (tmp <= 5) tmp = 2; else
		if (tmp <= 6) tmp = 3; else
		if (tmp <= 7) tmp = 4; else
		if (tmp <= 8) tmp = 5; else
		if (tmp <= 9) tmp = 6;
		int kk = 1, kkk = 0, k1;
		int ok = 0;
		vector<pair<char, char> > cm; cm.clear ();
		int use[40];
		for (int i = 0; i < r; i++)
			if (table[i].first.first == cur.first) kkk++;
		for (int i = 0; i < cards[0].size (); i++)
			if (cards[0][i].first == cur.first) {
				cm.PB (cards[0][i]);
				kk++;
				k1++;
				if (cards[0][i].second == trump) ok = 1;
			}
		for (int i = 0; i < cards[2].size (); i++)
			if (cards[2][i].first == cur.first) {
				cm.PB (cards[2][i]);
				kk++;
				if (cards[2][i].second == trump) ok = 1;
			}
		memset (use, 0, sizeof (use));
// 		fprintf (stderr, "%c%c = %d %d %d %d\n", cur.first, cur.second, tmp, kk, ok, tmp * 10 + 10 - (kk + kkk) + 20 * ok);
// 		fflush (stderr);
		if (!istake) {
			return tmp * 5 - 5 * (kk + kkk - 1) * (kk + kkk - 1) - 30 * ok + 60 * int (cur.second == trump);
		} else {
			if (k1 == kk && cards[0].size () == k1 && k1 + r <= cards[1].size () && k1 + r <= 6) return 0; else
			if (k1 == cards[0].size () && kk - k1 == cards[2].size () && kk + r <= cards[1].size () && kk + r <= 6) return 0; else return tmp + (kk - 1) * 10000 + ok * 100000;
		}
					
// 	}
}

int can (pair<char, char> a) {
	for (int i = 0; i < r; i++)
		if (a.first == table[i].first.first || a.first == table[i].second.first) return 1;
	return 0;
}

int print_all () {
	for (int i = 0; i < 4; i++) {
		fprintf (stderr, "player #%d: ", i + 1);
		if (ingame[i]) {
			for (int j = 0; j < cards[i].size (); j++)
				fprintf (stderr, "%c%c ", cards[i][j].first, cards[i][j].second);
		} else fprintf (stderr, "not in game");
		fprintf (stderr, "\n");
	}
	for (int i = 0; i < r; i++)
		fprintf (stderr, "%c%c - %c%c\n", table[i].first.first, table[i].first.second, table[i].second.first, table[i].second.second);
	fprintf (stderr, "Current move: %d  (%d -> %d)\n", cur + 1, mva + 1, mvb + 1);
	fprintf (stderr, "Beat: ");
	for (int i = 0; i < beat.size (); i++) fprintf (stderr, "%c%c ", beat[i].first, beat[i].second);
	fprintf (stderr, "\n");
	fprintf (stderr, "\n");
}

int get (int x) {
	if (ingame[x]) return x; else return (x + 2) % 4;	
}

int main () {
//   	int randseed;
//   	freopen ("/dev/urandom", "rt", stderr);
//   	fread (&randseed, 4, 1, stderr);
//   	srand (randseed);
//   	char fname[3];
//   	fname[0] = rand () % 26 + 'a';
//   	fname[1] = rand () % 26 + 'a';
//   	fname[2] = 0;
//   	freopen (fname, "wt", stderr);
 	for (int i = 0; i < 4; i++) ingame[i] = 1;
 	scanf ("%s %c", w, &trump);
//  	fprintf (stderr, "%s %c\n", w, trump);
//  	fflush (stderr);
	mvb = -1; last = -1;
	r = istake = 0;
	int round = 0;
	cur = -1;
	deck = 36;
	while (true) {
		scanf (" %s", w);
//  		fprintf (stderr, "%s\n", w);
// 		fflush (stderr);
		string ws = string (w);
		if (ws == "give") {
			deck--;
			if (round == 1 || istake) {
				if (round == 1)	cur = (cur + 1 + istake) % 4;
				if (!istake)
				for (int i = 0; i < r; i++) {
					beat.push_back (table[i].first);
					if (table[i].second.first != 0) beat.push_back (table[i].second);
				}
				istake = 0;
				r = 0;
				round = 0;
				getmove (cur);
			}
			int a;
			scanf ("%d %s", &a, g); a--;
// 			fprintf (stderr, "%d %s\n", a, g);
			a = get (a);
			if (a == 0 && g[0] == '?') return 0;
			cards[a].PB (MP (g[0], g[1]));
		} else
		if (ws == "move") {
			round = 1;
			int a, b;
			scanf ("%d %d %s", &a, &b, g); a--; b--;
			a = get (a); b = get (b);
			if (a != mva || b != mvb || istake) {
// 				printf ("cool\n");
				while  (a != mva || b != mvb) {
					if (cur == -1) {cur = a; getmove (cur); } else {
						cur = (cur + 1 + istake) % 4;
						getmove (cur);
					}
				}
				if (!istake)
				for (int i = 0; i < r; i++) {
					beat.push_back (table[i].first);
					if (table[i].second.first != 0) beat.push_back (table[i].second);
				}
				istake = 0;
				r = 0;
			}			
			erase (a, MP (g[0], g[1]));
			table[r].first = MP (g[0], g[1]);
			table[r++].second = MP (0, 0);
// 			printf ("\n");
// 			fflush (stdout);
		} else 
		if (ws == "add") {
			int a, b;
			scanf ("%d %d %s", &a, &b, g); a--; b--;
			a = get (a); b = get (b);
			erase (a, MP (g[0], g[1]));
			if (istake) cards[b].PB (MP (g[0], g[1])); else {
				table[r].first = MP (g[0], g[1]);
				table[r++].second = MP (0, 0);
			}
// 			printf ("\n");
// 			fflush (stdout);
		} else
		if (ws == "beat") {
			int a;
			scanf ("%d %s", &a, g); a--;
			a = get (a);
			erase (a, MP (g[0], g[1]));
			table[r - 1].second = MP (g[0], g[1]);
// 			printf ("\n");
// 			fflush (stdout);
		} else 
		if (ws == "take") {
			istake = 1;
			int a;
			scanf ("%d", &a); a--;
			a = get (a);
			for (int i = 0; i < r; i++) {
				cards[a].PB (table[i].first);	
				if (table[i].second.first != 0) cards[a].PB (table[i].second);
			}
// 			printf ("\n");
// 			fflush (stdout);
		} else
		if (ws == "out") {
			int a;
			scanf ("%d", &a); a--;
			a = get (a);
			ingame[a] = 0;
			if (a == 0) return 0;
// 			printf ("\n");
// 			fflush (stdout);
		} else
		if (ws == "MOVE") {
			if (istake || round == 1 && mva != 0) {
				if (!istake)
					for (int i = 0; i < r; i++) {
					beat.push_back (table[i].first);
					if (table[i].second.first != 0) beat.push_back (table[i].second);
					}
				r = 0;
				round = 0;
				cur = (cur + 1 + istake) % 4;
				getmove (cur);
				istake = 0;
			}
			round = 1;
			pair<char, char> cc;
			cc.first = cc.second = 0;
			for (int i = 0; i < cards[0].size (); i++)
				if ((r == 0 || r > 0 && can (cards[0][i])) && (cc.first == 0 || cost (cc) > cost (cards[0][i]))) cc = cards[0][i];
			printf ("%c%c\n", cc.first, cc.second);
//  			fflush (stderr);
			fflush (stdout);
		} else 
		if (ws == "BEAT") {
			pair<char, char> cc;
			cc.first = cc.second = 0;
			for (int i = 0; i < cards[0].size (); i++)
				if (myless (table[r - 1].first, cards[0][i]) && (cc.first == 0 || cost2 (cc) > cost2 (cards[0][i]))) cc = cards[0][i];
//			printf ("%c%c < %c%c = %d\n", table[r]);
// 			fprintf (stderr, "%c%c = %d\n", cc.first, cc.second, cost (cc));
			if (cc.first == 0) printf ("NO\n"); else {
				if (deck > 0 && cost2 (table[r - 1].first) < mincards[cost2 (cc)] && r <= 2) printf ("NO\n"); else printf ("%c%c\n", cc.first, cc.second);
			}
			fflush (stdout);
		} else 
		if (ws == "ADD") {
			pair<char, char> cc;
			cc.first = cc.second = 0;
			for (int i = 0; i < cards[0].size (); i++)
				if (can (cards[0][i]) && (cc.first == 0 || cost (cc) > cost (cards[0][i]))) cc = cards[0][i];
			if (mvb % 2 == 0 || cc.first == 0 || cost (cc) > 2000) printf ("NO\n"); else printf ("%c%c\n", cc.first, cc.second);
			fflush (stdout);
		}
//   	  		print_all ();
	}
}