{$MODE DELPHI}

uses
  Math;

var
  n,i,j,md,mi,mj,d,minx,maxx,miny,maxy,minz,maxz:integer;
  x,y,z:array[1..1000000] of integer;
  
function rho(x1,y1,z1,x2,y2,z2:integer):integer;
begin
  rho:=abs(x1-y2)+abs(y1-z2)+abs(z1-x2);
end;
  
function topmark(x,y,z:integer):integer;
var i,j,k:integer;
begin
  result:=max(max(max(rho(x,y,z,minx,miny,minz),rho(x,y,z,minx,miny,maxz)),max(rho(x,y,z,minx,maxy,minz),rho(x,y,z,minx,maxy,maxz))),max(max(rho(x,y,z,maxx,miny,minz),rho(x,y,z,maxx,miny,maxz)),max(rho(x,y,z,maxx,maxy,minz),rho(x,y,z,maxx,maxy,maxz))))
end;

procedure toolong;
begin
  writeln(md);
  writeln(mi,' ',mj);
end;

begin
  {assign(input,'c.in');
  assign(output,'c.out');
  reset(input);
  rewrite(output);}
  
  readln(n);
  minx:=maxint;
  miny:=maxint;
  minz:=maxint;
  maxx:=-maxint;
  maxy:=-maxint;
  maxz:=-maxint;
  for i:=1 to n do
  begin
    readln(x[i],y[i],z[i]);
    minx:=min(minx,x[i]);
    miny:=min(miny,y[i]);
    minz:=min(minz,z[i]);
    maxx:=max(maxx,x[i]);
    maxy:=max(maxy,y[i]);
    maxz:=max(maxz,z[i]);
  end;
  md:=-1;
  for i:=n downto 1 do
  begin
    if topmark(x[i],y[i],z[i])<=md then continue;
    for j:=1 to n do
    begin
      d:=rho(x[i],y[i],z[i],x[j],y[j],z[j]);
      if d>md then
      begin
        md:=d;
        mi:=i;
        mj:=j;
      end;
    end;
  end;
  toolong;
end.



