#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;

const int inf = (1 << 30) - 1;

int n;
int x[1001000], y[1001000], z[1001000];
int num[8][2], sum[8][2];

void answer (string s, int tp)
{
	cout << s << endl;
	exit (tp);
}

void check (int res, int a, int b)
{
	if (a == b)
		answer ("WA, a == b", 1);
	if (abs (x[a] - y[b]) + abs (y[a] - z[b]) + abs (z[a] - x[b]) != res)
		answer ("WA, res != p(a,b)", 1);
	int rs = 0;
	forn (i, n)
		forn (j, n)
			if (i != j)
				rs = max (rs, abs (x[i] - y[j]) + abs (y[i] - z[j]) + 
				abs (z[i] - x[j]));
	if (res != rs)
		answer ("WA, res != rs", 1);
	answer ("OK", 0);					
}

int main ()
{	
// 	freopen ("c.in", "r", stdin);
// 	freopen ("c.out", "w", stdout);
	scanf ("%d", &n);
	forn (i, n)
		scanf ("%d%d%d", &x[i], &y[i], &z[i]);
	seta (num, 255);
	forn (i, 8)
		forn (j, n)
		{
			int s = 0;
			if (i & 1)
				s += y[j];
			else
				s -= y[j];
			if (i & 2)
				s += z[j];
			else
				s -= z[j];
			if (i & 4)				
				s += x[j];
			else
				s -= x[j];
			ford (k, 2)
				if (num[i][k] == -1 || sum[i][k] < s)
				{
					if (k == 1)
					{
						sum[i][0] = sum[i][1];
						num[i][0] = num[i][1];
					}
					sum[i][k] = s;
					num[i][k] = j;
					break;
				}
		}		
	int resn1 = -1;
	int resn2 = -1;
	int ress = 0;
	forn (i, n)
		forn (j, 8)
		{
			int s = 0;
			if (j & 1)
				s += x[i];
			else
				s -= x[i];
			if (j & 2)
				s += y[i];
			else
				s -= y[i];
			if (j & 4)
				s += z[i];
			else
				s -= z[i];
			int k = 1;	
			if (num[j][k] == i)
				k --;
			if (sum[j][k] - s > ress || resn1 == -1)
			{
				ress = sum[j][k] - s;
				resn1 = i;
				resn2 = num[j][k];
			}							
		}		
	printf ("%d\n%d %d\n", ress, resn1+1, resn2+1);	
//	check (ress, resn1, resn2);
	return 0;
}
