{$MODE DELPHI}

uses
  SysUtils;//,Math;
  
const
  debug=false;
  gentest=false;
  nn=1000000;
  kswaps=1000;

var
  n,i,j,md,mi,mj,d,minx,maxx,miny,maxy,minz,maxz,a,b:integer;
  x,y,z,r:array[1..1000000] of integer;
  st:real;
  //mx,my,mz:array[-100000..100000] of integer;
  //wx,wy,wz:array[-100000..100000] of boolean;

function max(x,y:integer):integer;
begin
  if x>=y then max:=x else max:=y;
  
end;

function min(x,y:integer):integer;
begin
  if x<=y then min:=x else min:=y;
end;
  
function rho(x1,y1,z1,x2,y2,z2:integer):integer;
begin
  rho:=abs(x1-y2)+abs(y1-z2)+abs(z1-x2);
end;
  
{function topmark(x,y,z:integer):integer;
//var nx,ny,nz:integer;
begin
  //result:=max(max(max(rho(x,y,z,minx,miny,minz),rho(x,y,z,minx,miny,maxz)),max(rho(x,y,z,minx,maxy,minz),rho(x,y,z,minx,maxy,maxz))),max(max(rho(x,y,z,maxx,miny,minz),rho(x,y,z,maxx,miny,maxz)),max(rho(x,y,z,maxx,maxy,minz),rho(x,y,z,maxx,maxy,maxz))));
  //if abs(x-maxy)>abs(x-miny) then ny:=maxy else ny:=miny;
  //if abs(y-maxz)>abs(y-minz) then nz:=maxz else nz:=minz;
  //if abs(z-maxx)>abs(z-minx) then nx:=maxx else nx:=minx;
  //result:=rho(x,y,z,nx,ny,nz);
  result:=max(abs(x-maxy),abs(x-miny))+max(abs(y-maxz),abs(y-minz))+max(abs(z-maxx),abs(z-minx));
end;}

procedure toolong;
begin
  writeln(md);
  writeln(mi,' ',mj);
  halt;
end;

procedure swap(var a,b:integer);
var c:integer;
begin
  c:=a;
  a:=b;
  b:=c;
end;

begin
  st:=now;
  randomize;
  if debug then
  begin
    if gentest then
    begin
      assign(output,'c.in');
      rewrite(output);
      writeln(nn);
      for i:=1 to nn do
        writeln(random(200001)-100000,' ',random(200001)-100000,' ',random(200001)-100000);
      close(output);
    end;
    assign(input,'c.in');
    assign(output,'c.out');
    reset(input);
    rewrite(output);
  end;
  
  readln(n);
  minx:=maxint;
  miny:=maxint;
  minz:=maxint;
  maxx:=-maxint;
  maxy:=-maxint;
  maxz:=-maxint;
  //fillchar(wx,sizeof(wx),0);
  //fillchar(wy,sizeof(wy),0);
  //fillchar(wz,sizeof(wz),0);
  for i:=1 to n do
  begin
    readln(x[i],y[i],z[i]);
    //wx[x[i]]:=true;
    //wy[y[i]]:=true;
    //wz[z[i]]:=true;
    minx:=min(minx,x[i]);
    miny:=min(miny,y[i]);
    minz:=min(minz,z[i]);
    maxx:=max(maxx,x[i]);
    maxy:=max(maxy,y[i]);
    maxz:=max(maxz,z[i]);
  end;
  //for i:=minx to maxx do if wx[i] then mx[i]:=max(abs(i-maxy),abs(i-miny));
  //for i:=miny to maxy do if wy[i] then my[i]:=max(abs(i-maxz),abs(i-minz));
  //for i:=minz to maxz do if wz[i] then mz[i]:=max(abs(i-maxx),abs(i-minx));
  md:=-1;
  for i:=1 to n do r[i]:=i;
  for i:=1 to kswaps do
  begin
    a:=random(n)+1;
    b:=random(n)+1;
    swap(r[a],r[b]);
  end; 
  for i:=n downto 1 do
  begin
    if {mx[x[i]]+my[y[i]]+mz[z[i]]}max(abs(x[r[i]]-maxy),abs(x[r[i]]-miny))+max(abs(y[r[i]]-maxz),abs(y[r[i]]-minz))+max(abs(z[r[i]]-maxx),abs(z[r[i]]-minx))<=md then continue;
    //if (now-st)*24*60*60*1000>1900 then toolong;
    for j:=1 to i-1 do
    begin
      d:=rho(x[r[i]],y[r[i]],z[r[i]],x[r[j]],y[r[j]],z[r[j]]);
      if d>md then
      begin
        md:=d;
        mi:=r[i];
        mj:=r[j];
      end;
    end;
    for j:=i+1 to n do
    begin
      d:=rho(x[r[i]],y[r[i]],z[r[i]],x[r[j]],y[r[j]],z[r[j]]);
      if d>md then
      begin
        md:=d;
        mi:=r[i];
        mj:=r[j];
      end;
    end;
  end;
  toolong;
end.



