#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

const string allc[3] = {"R", "G", "B"};

map<string, pair<int, int> > res;

string w;

string smin (string s) {
	char w[150];
	int a = 0, b = 0, c = 0;
	for (int i = 0; i < s.size (); i++) {
		a += int (s[i] == 'B');
		b += int (s[i] == 'G');
		c += int (s[i] == 'R');
	}
	if (a >= b && b >= c) { w['B'] = 'B'; w['G'] = 'G'; w['R'] = 'R'; } else
	if (a >= c && c >= b) { w['B'] = 'B'; w['R'] = 'G'; w['G'] = 'R'; } else
	if (b >= a && a >= c) { w['G'] = 'B'; w['B'] = 'G'; w['R'] = 'R'; } else
	if (b >= c && c >= a) { w['G'] = 'B'; w['R'] = 'G'; w['B'] = 'R'; } else
	if (c >= a && a >= b) { w['R'] = 'B'; w['B'] = 'G'; w['G'] = 'R'; } else
	if (c >= b && b >= a) { w['R'] = 'B'; w['G'] = 'G'; w['B'] = 'R'; }
	for (int i = 0; i < s.size (); i++)
		s[i] = w[s[i]];
	string cur = s;
	for (int i = 0; i < s.size (); i++) {
		if (s < cur) cur = s;
		s += s[0];
		s.erase (s.begin ());
	}
	return cur;
}

int calc (string s) {
	int ok = 1;
	for (int i = 1; i < s.size (); i++)
		if (s[i] != s[i - 1]) {
			ok = 0;
			break;
		}
	if (ok) {
// 		cout << smin (s) << " " << s.size () << " " << s.size () << endl;
		res[s] = make_pair (s.size (), s.size ());
		return 0;
	}
	string ss = smin (s);
	if (res.count (ss)) {
		res[s] = res[ss];
		return 0;
	}
	int nmin = 10000, nmax = -1;
	for (int i = 0; i < s.size (); i++) {
		int j = (i + 1) % s.size ();
		if (s[i] != s[j]) {
			string nw = "";
			for (int k = 0; k < 3; k++)
				if (allc[k][0] != s[i] && allc[k][0] != s[j]) {
					nw = allc[k];
					break;
				}
			string tmp = s, tmp2 = "";
			if (i < j) {
				tmp.erase (tmp.begin () + i);
				tmp.erase (tmp.begin () + i);
				for (int k = 0; k < i; k++) tmp2 += tmp[k];
				tmp2 += nw;
				for (int k = i; k < tmp.size (); k++) tmp2 += tmp[k];
			} else {
				tmp.erase (tmp.begin () + i);
				tmp.erase (tmp.begin ());
				tmp2 = nw + tmp;
			}
			calc (tmp2);
			pair<int, int> cur = res[tmp2];
			if (cur.first < nmin) nmin = cur.first;
			if (cur.second > nmax) nmax = cur.second;
		}
	}
/*	int a = 0, b = 0, c = 0, ab = 0, bc = 0,ca = 0, aa = 0, bb = 0, cc = 0;
	for (int i = 0; i < s.size (); i++) {
		a += int (s[i] == 'R');
		b += int (s[i] == 'G');
		c += int (s[i] == 'B');
		ab += int (s[i] == 'R' && s[i % s.size () + 1] == 'G' || s[i] == 'G' && s[i % s.size () + 1] == 'R');
		bc += int (s[i] == 'G' && s[i % s.size () + 1] == 'B' || s[i] == 'B' && s[i % s.size () + 1] == 'G');
		ca += int (s[i] == 'B' && s[i % s.size () + 1] == 'R' || s[i] == 'R' && s[i % s.size () + 1] == 'B');		
		aa += int (s[i] == 'R' && s[i % s.size () + 1] == 'R');
		bb += int (s[i] == 'G' && s[i % s.size () + 1] == 'G');
		cc += int (s[i] == 'B' && s[i % s.size () + 1] == 'B');
	}*/		
// 	cout << smin (s) << " " << nmin << " " << nmax << " (" << a << ", " << b << ", " << c << ")" << " (" << ab << ", " << bc << ", " << ca << ")" << " (" << aa << ", " << bb << ", " << cc << ")" << endl;
	res[s] = res[ss] = make_pair (nmin, nmax);
	return 0;
}

int main () {
	int n;
	cin >> n >> w;
	calc (w);
	printf ("%d %d\n", res[w].first, res[w].second);
}