{$MODE DELPHI}

uses
  SysUtils,Math;
  
const
  checktl=true;
  debug=false;
  gentest=false;
  nn=15;

var
  n,i,mkb,la,lb,oh,th,h:integer;
  tbo,ts,mb,ms,a,b,c,mi:array[1..30] of integer;
  u:array[1..30] of boolean;
  st:real;
  
procedure swap(var a,b:integer);
var c:integer;
begin
  c:=a;
  a:=b;
  b:=c;
end;
  
procedure getstate(var a,b,c:integer;const state:integer);
begin
  case state of
    2: swap(b,c);
    3: swap(a,b);
    4: begin swap(b,c); swap(a,c); end;
    5: begin swap(a,b); swap(a,c); end;
    6: swap(a,c);
  end;
end;

procedure tl;
var i:integer;
begin
  writeln(h);
  writeln(mkb);
  for i:=1 to mkb do
  begin
    write(mb[i],' ');
    getstate(a[mb[i]],b[mb[i]],c[mb[i]],ms[i]);
    writeln(a[mb[i]],' ',b[mb[i]],' ',c[mb[i]]);
  end;
  halt;
end;
  
procedure find(x:integer);
var i,j,ta,tb,tc,mla,mlb:integer;
begin
  if h-th>oh then exit;
  if th>h then
  begin
    h:=th;
    mkb:=x-1;
    for i:=1 to x-1 do
    begin
      ms[i]:=ts[i];
      mb[i]:=tbo[i];
    end;
  end;
  if x>n then exit;
  
  if (checktl) and ((now-st)*24*60*60*1000>1920) then tl;
  
  mla:=la;
  mlb:=lb;
  for i:=n downto 1 do
  if not u[i] then
  begin
    ta:=a[i];
    tb:=b[i];
    tc:=c[i];
    for j:=1 to 6 do
    begin
      //getstate(ta,tb,tc,j);
      case j of
        2: swap(tb,tc);
        3: begin swap(tb,ta); swap(ta,tc); end;
        4: swap(tb,tc);
        5: begin swap(tb,tc); swap(ta,tc); end;
        6: swap(tb,tc);
      end;
      if (ta>la) or (tb>lb) then continue;
      u[i]:=true;
      oh:=oh-mi[i];
      th:=th+tc;
      tbo[x]:=i;
      ts[x]:=j;
      la:=ta;
      lb:=tb;
      find(x+1);
      th:=th-tc;
      oh:=oh+mi[i];
      u[i]:=false;
      la:=mla;
      lb:=mlb;
    end;
  end;
end;

begin
  st:=now;
  if debug then
  begin
    if gentest then
    begin
      assign(output,'b.in');
      rewrite(output);
      randomize;
      writeln(nn);
      for i:=1 to nn do
      writeln(random(1000000)+1,' ',random(1000000)+1,' ',random(1000000)+1);
      close(output);
    end;
    assign(input,'b.in');
    assign(output,'b.out');
    reset(input);
    rewrite(output);
  end;
  
  readln(n);
  oh:=0;
  for i:=1 to n do
  begin
    readln(a[i],b[i],c[i]);
    mi[i]:=max(max(a[i],b[i]),c[i]);
    oh:=oh+mi[i];
  end;
  la:=maxint;
  lb:=maxint;
  th:=0;
  h:=0;
  fillchar(u,sizeof(u),0);
  find(1);
  tl;
end.

