#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

int n, a[30][6][3];
bool g[30][6][30][6];
int t[65536][16][6], pv[65536][16][6], pr[65536][16][6];

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
	scanf ("%d", &n);
	forn (i, n)
	{
		vector <int> A;
		A.resize (3);
		scanf ("%d%d%d", &A[0], &A[1], &A[2]);
		sort (all (A));
		forn (j, 6)
		{
			forn (k, 3)
				a[i][j][k] = A[k];
			next_permutation (all (A));	
		}
	}
	seta (g, 0);
	forn (i, n)
		forn (x, 6)
			forn (j, n)
				forn (y, 6)
					if (a[i][x][0] <= a[j][y][0] && 
					    a[i][x][1] <= a[j][y][1])
						g[i][x][j][y] = 1;
	seta (t, 0);
	seta (pv, 255);
	seta (pr, 255);
	forn (i, n)
		forn (j, 6)
			t[1<<i][i][j] = a[i][j][2];
	forn (i, 1<<n)
	  forn (j, n)
	    forn (k, 6)
	      if (i & (1 << j))		
	        if (t[i][j][k])
	          forn (v, n)
	            if (!(i&(1<<v)))
	              forn (y, 6)
	                if (g[j][k][v][y])
	                  if (t[i][j][k] + a[v][y][2] > t[i|(1<<v)][v][y])
	                  {
	                  	t[i|(1<<v)][v][y] = t[i][j][k] + a[v][y][2];
	                  	pv[i|(1<<v)][v][y] = j;
	                  	pr[i|(1<<v)][v][y] = k;
	                  }
	int ai, aj, ak;
	ai = aj = ak = 0;
	forn (i, 1 << n)
		forn (j, n)
			forn (k, 6)
				if (t[i][j][k] > t[ai][aj][ak])
				{
					ai = i;
					aj = j;
					ak = k;
				}
	printf ("%d\n", t[ai][aj][ak]);
	vector < vector <int> > ans;
	ans.clear ();
	while (aj >= 0)
	{
		vector <int> tmp;
		tmp.resize (4);
		tmp[0] = aj+1;
		tmp[1] = a[aj][ak][0];
		tmp[2] = a[aj][ak][1];
		tmp[3] = a[aj][ak][2];
		int j = pv[ai][aj][ak];
		int k = pr[ai][aj][ak];
		ai -= 1 << aj;
		aj = j;
		ak = k;
		ans.pb (tmp);
	}
	printf ("%d\n", ans.size());
//	reverse (all (ans));
	forn (i, ans.size())
	{
		forn (j, ans[i].size())
			printf ("%d ", ans[i][j]);
		printf ("\n");	
	}
	return 0;
}
