program z3;
type integer=longint;
     pnode=^node;
     node=record
       v,n: integer;
       next: pnode;
     end;
     GArr=array[1..100000] of integer;
var list,en,listo,eno: array[1..100000] of pnode;
    p1,p2,st,d1,d2: GArr;
    i,t,a,b,n,m: integer;

procedure add(a,b,n: integer);
var x: pnode;
begin
  new(x);
  x^.v:=b;
  x^.n:=n;
  x^.next:=nil;
  if list[a]=nil then list[a]:=x
  else en[a]^.next:=x;
  en[a]:=x;

  new(x);
  x^.v:=a;
  x^.n:=n;
  x^.next:=nil;
  if listo[b]=nil then listo[b]:=x
  else eno[b]^.next:=x;
  eno[b]:=x;
end;

procedure solve(var p,d: GArr);
var i,j: integer;
    q,enq,x,t: pnode;

procedure addq(v: integer);
var x: pnode;
begin
  new(x);
  x^.v:=v;
  x^.next:=nil;
  if q=nil then q:=x
  else enq^.next:=x;
  enq:=x;
end;

function get: integer;
begin
  get:=q^.v;
  q:=q^.next;
end;

begin
  q:=nil;
  for i:=1 to n do
    if st[i]=0 then begin
      p[i]:=2;
      d[i]:=0;
      addq(i);
    end;
  while q<>nil do begin
    j:=get;
    if p[j]=2 then begin
      x:=listo[j];
      while x<>nil do begin
        if p[x^.v]=0 then begin
          p[x^.v]:=1;
          d[x^.v]:=d[j]+1;
          addq(x^.v);
        end;
        x:=x^.next;
      end;
    end else begin
      x:=listo[j];
      while x<>nil do begin
        if p[x^.v]=0 then begin
          t:=list[x^.v];
          p[x^.v]:=2;
          while t<>nil do begin
            if p[t^.v]=0 then begin p[x^.v]:=0; break; end;
            if p[t^.v]=2 then begin p[x^.v]:=1; break; end;
            t:=t^.next;
          end;
          if p[x^.v]<>0 then begin
            addq(x^.v);
            d[x^.v]:=d[j]+1;
          end;
        end;
        x:=x^.next;
      end;
    end;
  end;
end;

procedure Init(var p,d: GArr);
var i: integer;
begin
  fillchar(list,sizeof(list),0);
  fillchar(listo,sizeof(listo),0);
  fillchar(st,sizeof(st),0);
  fillchar(p,sizeof(p),0);
  fillchar(d,sizeof(d),0);
  ReadLn(n,m);
  for i:=1 to m do begin
    Read(a,b);
    add(a,b,i);
    inc(st[a]);
  end;
  solve(p,d);
end;

begin
  Init(p1,d1);
  Init(p2,d2);
  ReadLn(t);
  for i:=1 to t do
  begin
    Read(a,b);
    if ((p1[a]=2) and (d1[a]<=d2[b])) or ((p2[b]=2) and (d2[b]<=d1[a])) then WriteLn('second')
    else WriteLn('first');
  end;
end.