Type Integer=LongInt;

Const inf:Integer = 1000000;

Var a,b,n1,m1,n2,m2,i,t,x,y:Integer;
		g1,g2,next1,next2:Array[1..100000]of Integer;
		head1,head2:Array[1..100000]of Integer;
		res1,res2:Array[1..100000]of Integer;
		minPath1,maxPath1,minPath2,maxPath2:Array[1..100000]of Integer;
		
Procedure Add1(v1,v2,i:Integer);
Begin
	g1[i]:=v2;
	next1[i]:=head1[v1];
	head1[v1]:=i;
End;

Procedure Add2(v1,v2,i:Integer);
Begin
	g2[i]:=v2;
	next2[i]:=head2[v1];
	head2[v1]:=i;
End;


Procedure DFS1(v:Integer);
Var i,curMin,curMax:Integer;
Begin
	i:=head1[v];
	res1[v]:=-1;
	curMin:=inf;
	curMax:=-1;
	while i<>0 do begin
		if res1[g1[i]] = 0 then DFS1(g1[i]);
		if res1[g1[i]] = -1 then res1[v]:=1;
		if (res1[g1[i]] = -1) and (maxPath1[g1[i]]+1<curMin) then curMin:=maxPath1[g1[i]]+1;
		if (minPath1[g1[i]]+1>curMax) then curMax:=minPath1[g1[i]]+1;
		i:=next1[i];
	end;
	if curMin = inf then minPath1[v]:=0 else minPath1[v]:=curMin;
	if curMax = -1 then maxPath1[v]:=0 else maxPath1[v]:=curMax;
End;

Procedure DFS2(v:Integer);
Var i,curMin,curMax:Integer;
Begin
	i:=head2[v];
	res2[v]:=-1;
	curMin:=inf;
	curMax:=-1;
	while i<>0 do begin
		if res2[g2[i]] = 0 then DFS2(g2[i]);
		if res2[g2[i]] = -1 then res2[v]:=1;
		if (res2[g2[i]] = -1) and (maxPath2[g2[i]]+1<curMin) then curMin:=maxPath2[g2[i]]+1;
		if (minPath2[g2[i]]+1>curMax) then curMax:=minPath2[g2[i]]+1;
		i:=next2[i];
	end;
	if curMin = inf then minPath2[v]:=0 else minPath2[v]:=curMin;
	if curMax = -1 then maxPath2[v]:=0 else maxPath2[v]:=curMax;
End;


Begin
	
{	Assign(input,'in.txt');
	Assign(output,'out.txt');
	Reset(input);ReWrite(output);}
	
	Read(n1,m1);
	for i:=1 to m1 do begin
		Read(a,b);
		Add1(a,b,i);
	end;
	Read(n2,m2);
	for i:=1 to m2 do begin
		Read(a,b);
		Add2(a,b,i);
	end;
	fillchar(res1,sizeof(res1),0);
	fillchar(res2,sizeof(res2),0);
	for i:=1 to n1 do
		if res1[i] = 0 then DFS1(i);
	for i:=1 to n2 do
		if res2[i] = 0 then DFS2(i);
	Read(t);
	for i:=1 to t do begin
		Read(x,y);
		if (res1[x] = 1) and (res2[y] = 1) then WriteLn('first');
		if (res1[x] = -1) and (res2[y] = -1) then WriteLn('second');
		if (res1[x] = 1) and (res2[y] = -1) then begin
			if minPath1[x] > maxPath2[y] then WriteLn('second');
			if minPath1[x] < maxPath2[y] then WriteLn('first');	
			if minPath1[x] = maxPath2[y] then WriteLn('Hello, jury!');
		end;
		if (res1[x] = -1) and (res2[y] = 1) then begin
			if maxPath1[x] > minPath2[y] then WriteLn('first');
			if maxPath1[x] < minPath2[y] then WriteLn('second');	
			if maxPath1[x] = minPath2[y] then WriteLn('Hello, jury!');
		end;
	end;
End. 
