#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define w first
#define dl second
#define pb push_back
#define mp make_pair

const int nmax = 110000;

vector<int> g1[nmax];
vector<int> g2[nmax];
int n1,n2,m1,m2;
pii f1[nmax];
pii f2[nmax];
bool used[nmax];

void calc1(int v){
	if(used[v])return;
	used[v] = true;
	bool win = 0;
	forn(i,g1[v].size()){
		int to = g1[v][i];
		if(!used[to])
			calc1(to);
		if (f1[to].w == 0)
			win = 1;
	}
	if (win == 1){
		int dlin = n1;
		forn(i,g1[v].size()){
			int to = g1[v][i];
			if (f1[to].w == 0 && f1[to].dl < dlin)
				dlin = f1[to].dl;
		}
		f1[v] = mp(1,dlin+1);
		return;
	}
	int dlin = 0;
	forn(i,g1[v].size()){
		int to = g1[v][i];
		if (f1[to].w == 1 && f1[to].dl > dlin)
			dlin = f1[to].dl;
	}
	if (g1[v].size() > 0)dlin++;
	f1[v] = mp(0,dlin);
	return;
}
	
void calc2(int v){
	if(used[v])return;
	used[v] = true;
	bool win = 0;
	forn(i,g2[v].size()){
		int to = g2[v][i];
		if(!used[to])
			calc2(to);
		if (f2[to].w == 0)
			win = 1;
	}
	if (win == 1){
		int dlin = n1;
		forn(i,g2[v].size()){
			int to = g2[v][i];
			if (f2[to].w == 0 && f2[to].dl < dlin)
				dlin = f2[to].dl;
		}
		f2[v] = mp(1,dlin+1);
		return;
	}
	int dlin = 0;
	forn(i,g2[v].size()){
		int to = g1[v][i];
		if (f2[to].w == 1 && f2[to].dl > dlin)
			dlin = f2[to].dl;
	}
	if (g2[v].size() > 0)dlin++;
	f2[v] = mp(0,dlin);
	return;
}



void pre_calc(){
	forn(i,n1)
		used[i] = 0;
	forn(i,n1)
		if(!used[i])
			calc1(i);
	forn(i,n2)
		used[i] = 0;
	forn(i,n2)
		if(!used[i])
			calc2(i);
}	

void read(){
	scanf("%d %d",&n1,&m1);
	forn(i,m1){
		int v,u;
		scanf("%d %d",&v,&u);
		v--,u--;
		g1[v].pb(u);
	}
	scanf("%d %d",&n2,&m2);
	forn(i,m2){
		int v,u;
		scanf("%d %d",&v,&u);
		v--,u--;
		g2[v].pb(u);
	}
}	


int main(){
// 	freopen("c.in","rt",stdin);
// 	freopen("c.out","wt",stdout);
	
	read();
	pre_calc();
	int tst;
	cin >> tst;
	
// 	forn(i,n2)
// 		cout << f2[i].w << " ";
// 	cout << endl;
// 	
// 	return 0;
	
	forn(i,tst){
		int v,u;
		scanf("%d %d",&v,&u);
		v--,u--;
		int res = 0;
		/*if (f1[v].w == 1 && f2[u].w == 1)
			res = 1;
		if (f1[v].w == 0 && f2[u].w == 0)
			res = 0;
		*/
/*		cerr << f1[v].dl << " " << f2[u].dl << endl;
		cerr << f1[v].w << " " << f2[u].w << endl;
		cerr << endl;*/
		if (f1[v].dl < f2[u].dl)
			res = f1[v].w;
		else
			res = f2[u].w;
		if (res)
			printf("first\n");
		else
			printf("second\n");
	}
	
	return 0;
}
