#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;

int const N=100010;

int n[2], m[2], st[4][N], ne[4][N], en[4][N], dg[2][N], np[2][N], sg[2][N], len[2][N], w[N];

inline void add(int i, int k, int p, int q) {
	ne[i][k]=st[i][p];
	st[i][p]=k;
	en[i][k]=q;
}

void bfs(int k) {
	static int q[N];
	q[0]=0;
	for (int i=1; i<=n[k]; i++)
		if(!dg[k][i]) 
			sg[k][i]=0, len[k][i]=0, q[++q[0]]=i;
	
	int b=0;
	while(b<q[0]) {
		int c=q[++b];
		
		for (int j=st[k+2][c]; j; j=ne[k+2][j])
			if (dg[k][en[k+2][j]] == ++np[k][en[k+2][j]])
				q[++q[0]] = en[k+2][j];			
			
		memset(w, 0, (dg[k][c]+1)*sizeof(w[0]));
		
		for (int j=st[k][c]; j; j=ne[k][j])
			if (sg[k][en[k][j]]<=dg[k][c])
				w[sg[k][en[k][j]]]=1;
		for (sg[k][c]=0; w[sg[k][c]]; sg[k][c]++);
		
		
		if (!sg[k][c]) {
			len[k][c]=0;
			for (int j=st[k][c]; j; j=ne[k][j])
				len[k][c]=max(len[k][c], len[k][en[k][j]]+1);	
		}
		else {
			len[k][c]=N;
			for (int j=st[k][c]; j; j=ne[k][j])
				len[k][c]=min(len[k][c], len[k][en[k][j]]+1);	
		}		
	}
}

int main () {
// 	freopen ("c.in", "r", stdin);
// 	freopen ("c.out", "w", stdout);	
	
	scanf ("%d%d", &n[0], &m[0]);
	
	for (int i=1; i<=m[0]; i++) {
		int p, q;
		scanf ("%d%d", &p, &q);
		add(0, i, p, q);
		add(2, i, q, p);
		dg[0][p]++;
	}
	
	scanf ("%d%d", &n[1], &m[1]);
	for (int i=1; i<=m[1]; i++) {
		int p, q;
		scanf ("%d%d", &p, &q);
		add(1, i, p, q);
		add(3, i, q, p);
		dg[1][p]++;
	}
	bfs(0);
	bfs(1);
	
	int t;
	scanf ("%d", &t);
	for (int i=1; i<=t; i++) {
		int x, y;
		scanf ("%d%d", &x, &y);
		
		if (len[0][x]<=len[1][y] && sg[0][x] || len[0][x]>=len[1][y] && sg[1][y]) 
			printf ("first\n");
		else 
			printf ("second\n");
	}
	return 0;
} 
