#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 100000;
const int tmax = 43;

int n;
int a[nmax];

int have[nmax];

int t[nmax];
int p[nmax];
int h[nmax];
long long start;
	
vector<int> now;
int res = 0;
pii op[nmax];
int tip[nmax];


int step(int x){
	int res = 0;
	while (x % 2 == 0){
		res ++ ;
		x /= 2;
	}
	return res;
}
	
	
	
void go(int x){
	if (have[x])
		return;
	int pr = p[x];
	have[x] = true;
	if (h[x] == 1){
		go(pr);
		res;
		op[res] = mp(pr,step(x/pr));
		tip[res] = 1;
		res++;
		return;
	}
	if (h[x] == 2){
		go(pr);
		go(x - pr);
		op[res] = mp(pr,x-pr);
		tip[res] = 2;
		res++;
		return;
	}
	go(pr);
	go(pr-x);
	op[res] = mp(pr,pr-x);
	tip[res] = 3;
	res++;
}
		
	
void make(int x){
	now.clear();
	go(x);
}
	

void recalc(){
	forn(i,tmax)
		t[i] = 10000;
	forn(i,tmax)
		if (have[i])
			t[i] = 0;
	forn(qwe,10*tmax){	
		for (int i = 1; i < tmax; i++){
			forn(j,6){
				int now = i << j;
				if (t[now] >= t[i] +1){
					t[now] = t[i] + 1;
					p[now] = i;
					h[now] = 1;
				}
			}
		}
		for (int i = 1; i < tmax; i++)
			for (int j = 1; j < tmax; j++){
			if(t[i+j] > t[i] + t[j] + 1){
				t[i+j] = t[i]+t[j] + 1;
				p[i+j] = i;
				h[i+j] = 2;
			}
			if(i > j && t[i-j] > t[i] + t[j] + 1){
				t[i-j] = t[i]+t[j] + 1;
				p[i-j] = i;
				h[i-j] = 3;
			}
			}
	}		
}
int main(){
// 	freopen("b.in","rt",stdin);
// 	freopen("b.out","wt",stdout);
	
	forn(i,tmax)
		t[i] = 10000;
	have[1] = 1;
	recalc();
	
	cin >> n;
	forn(i,n){
		cin >> a[i];
		/*cout << t[a[i]] << " ";
		continue;
		*/make(a[i]);
		recalc();
	}
	cout << res << endl;
	forn(i,res){
		if (tip[i] == 1)
			printf("%d<<%d\n",op[i].fs,op[i].sc);
		if (tip[i] == 2)
			printf("%d+%d\n",op[i].fs,op[i].sc);
		if (tip[i] == 3)
			printf("%d-%d\n",op[i].fs,op[i].sc);
	}
		
	return 0;
}
