#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;

int const S=10010, N=1010, K=26;
char s[N];
int n, t[N], a[K][N], r[S][N];

inline void copy(int *r, int *a) {
	for (int i=1; i<=n; i++)
		r[i]=a[i];
}
inline void mul(int *r, int *a, int *b) {
	for (int i=1; i<=n; i++)
		r[i]=b[a[i]];
}

void pow(int *r, int *a, int k) {
	int i=k;
	while(i & i-1) 
		i &= i-1;
	
	copy(r, a);
	
	for (i >>= 1; i; i >>=1) {
		mul(t, r, r);
		copy(r, t);
		if (k&i) {
			mul(t, r, a);
			copy(r, t);
		}
	}
}

int rec(int x) {
	
	for (int i=1; i<=n; i++)
		r[x][i]=i;
		
	
	for (;;)
		if (islower(s[x])) {
			mul(r[x+1], r[x], a[s[x]-'a']);
			x++;
		}		
		else if (s[x]=='(') {
			int y=rec(x+1), k=0, z;
			for (z=y+1; isdigit(s[z]); z++)
				k=10*k+s[z]-'0';
			pow(r[y+1], r[y], k);
			mul(r[z], r[x], r[y+1]);
			x=z;
		}
		else
			return x;
}	

int main () {
	
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	
	scanf("%s%d", s, &n);
	
	for (int i=1; i<=n; i++)
		for (int j=0; j<K; j++)
			scanf ("%d", &a[j][i]);
	
	int x=rec(0);
		
	for (int i=1; i<=n; i++)
		printf ("%d ", r[x][i]);	
	
	return 0;
} 
