#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 1100;
const int mmax = 3000;
const int depmax = 2000;

int g[nmax][26];
int res[depmax][nmax];
string s;
int n;


string repack(string s){
	string res = "";
	forn(i,s.size()){
		if (s[i] == '('){
			int l,r;
			l = r = i + 1;
			
			int dep = 1;
			
			while (dep != 0){
				if (s[r] == ')')dep--;
				if (s[r] == '(')dep++;
				r++;
			}
			string now = repack(s.substr(l,r-l-1));
			int p = r;
			int kol = 0;
			while(p < (int)s.size() && isdigit(s[p])){
				kol = kol * 10 + s[p] - '0';
				p++;
			}
			forn(q,kol)
				res += now;
			i = r;
			continue;
		}
		res += s[i];
	}
	return res;
}


void go(int dep,int &i){
	cerr << i << " " << s[i] << endl;
	forn(j,n)
		res[dep][j] = j;
	while (i < (int)s.size()){
		if (s[i] == '('){
			i++;
			go(dep+1,i);
			int x = 0;
			while (i < (int)s.size() && isdigit(s[i])){
				x = x * 10 + i;
				i++;
			}
			while (x > 0){
				if (x & 1){
					forn(j,n)
						res[dep][j] = res[dep+1][res[dep][j]];
					x--;
				}else{
					forn(j,n)
						res[dep+1][j] = res[dep+1][res[dep+1][j]];
					x /= 2;
				}
			}
			continue;
		}
		if (s[i] == ')'){
			i++;
			return;
		}
		forn(j,n)
			res[dep][j] = g[res[dep][j]][s[i]-'a'];
		i++;
	}
}
		

void solve(){
	int i = 0;
	go(0,i);
}


void read(){
	getline(cin,s);
	scanf("%d",&n);
	forn(i,n)
		forn(j,26){
		scanf("%d",&g[i][j]);
		g[i][j] --;
		}
}

void write(){
	forn(i,n)
		printf("%d ",res[0][i]+1);
	cout << endl;
}

int main(){
// 	freopen("a.in","rt",stdin);
// 	freopen("a.out","wt",stdout);
	
	
	read();
	solve();
	write();
	
	return 0;
}
