#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

int const N=1010;
using namespace std;
double r[N][N], pr;

void init() {
	for (int i=0; i<N; i++)
		for (int j=0; j<N; j++)
			r[i][j]=-1;
}

double rec(int n, int k=1) {
	if (r[n][k]>=0) return r[n][k];
	if (n==k) return r[n][k]=0;
	if (k==1) {
		double cr=0, p=1;
		for (int i=1; i<n-1; i++)
			cr+=p*(1-pr)*(rec(n-1, i)+(i>=2)), p*=pr;
		return r[n][k]=cr+p*(n-1>=2);	
	}
	else{
		double cr=0, p=1;
		for (int i=0; i<n-k; i++)
			cr+=p*(1-pr)*(rec(n-1, k-1+i)+(i>=2)), p*=pr;
		return r[n][k]=cr+p*(n-k>=2);	
	}
}

int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	
	int n;
	cin >> n >> pr;
	pr*=0.01;
	init();
	
	cout << fixed << setprecision(9) << rec(n) << endl;
	
	return 0;
} 
