#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;

int const N=7510;
double cr[N], ne[N], p, pr;

int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	int m, pc;
	cin >> m >> pc;
	if (m == 1 || pc == 0) {
		cout << fixed << setprecision(9) << double(0) << endl;
		return 0;
	}
	if (pc==100) {
		cout << fixed << setprecision(9) << double(m>=3) << endl;
		return 0;
	}	 
	pr=pc*0.01;
	for (int n=2; n<=m; n++) {		
		if (n>2)
			ne[n-1]=(1-pr)*cr[n-2];			
		for (int k=n-1; k>2; k--)
			ne[k-1]=pr*ne[k]+(1-pr)*cr[k-2];
		if (n>2) 
			ne[1]=ne[2];
		for (int k=1; k<n; k++)
			cr[k] = ne[k] + (n-k>=2 ? (k==1 ? pr : pr*pr) : 0);
// 		cout << fixed << setprecision(9) << cr[1] << endl;
	}
			
	cout << fixed << setprecision(9) << cr[1] << endl;
		
	return 0;
} 
