#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef double real;
const real inf = 1e18;
const real eps = 1e-8;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int tst = 10000;
const int nmax = 20;

int n;
int a[nmax];
int b[nmax];
int res;

long long rdtsc(){
	asm("rdtsc");
}

bool check(){
	forn(i,n)
		if (b[i] != i + 1)
			return false;
	return true;
}

int main(){
// 	freopen("d.in","r",stdin);
// 	freopen("d.out","w",stdout);
	
	cin >>n ;
	forn(i,n)
		cin >> a[i];
	forn(q,tst){
		forn(i,n)
			b[i] = a[i];
		srand(rdtsc());
		int dep = 0;
		while(!check()){
			if (dep > 1500) break;
			dep ++;
			int v = rand() % n;
			int u = rand() % n;
			while (v == u){
				v = rand() % n;
				u = rand() % n;
			}				
			swap(b[v],b[u]);
		}
		res += dep;
	}
	res /= tst;
	if (res % 10 < 5) res -= res % 10;
	if (res % 10 > 5) res += 10 - res % 10;
	cout << res << endl;	
	
	return 0;
}
