#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int mmax = 27;
const int bmax = 101;
const int kmax = 101;
const int64 mod = (int)1e9 + 9;

int64 cnt[mmax][kmax][kmax];
int64 t[mmax][kmax];
int64 cnt1[bmax][bmax];
int64 cnt2[bmax][bmax];
int64 c[mmax * bmax][bmax];
int64 s[mmax*2];
int64 b[mmax];
int64 n,m,k,bm;

void pre_calc(){
	s[0] = 0;
	forn(i,m)
		s[i+1] = (s[i] + b[i])% mod;

	cnt1[0][0] = 1;
	forn(i,bmax)
		forn(j,bmax)
			for (int k = 1; k < bmax-j; k++)
				cnt1[i+1][j+k] = (cnt1[i+1][j+k] + cnt1[i][j]) % mod;
	cnt2[0][0] = 1;
	forn(i,bmax)
		forn(j,bmax)
			for (int k = 0; k < bmax-j; k++)
				cnt2[i+1][j+k] = (cnt2[i+1][j+k] + cnt2[i][j]) % mod;
	forn(i,mmax * bmax)
		forn(j,bmax)
			c[i][j] = 0;
	c[0][0] = 1;
	
	
	forn(i,mmax * bmax)
		forn(j,min(i+1,bmax)){
			if (i == 0) continue;
			c[i][j] = c[i-1][j];
			if (j) c[i][j] += c[i-1][j-1];
			c[i][j] %= mod;
		}
	for (int64 i = 1; i < m; i++)
		for (int64 q = 0; q <= min(s[i],k); q++){
			for (int64 j = 0; j <= k; j++)
				cnt[i][j][q] = 0;
			for (int64 y = 0; y <= b[i]; y++)
				for (int64 z = 0; z <= min(s[i]-q,b[i]-y) && z+q <= k; z++){
					int64 now = ((int64)c[s[i]-q][z] * (int64)cnt1[z][b[i]-y]) % mod;
					now = (now * (int64)cnt2[q+1][y]) % mod;
					cnt[i][z][q] = (cnt[i][z][q] + now) % mod;
				}
			}
}

void solve(){
	pre_calc();
	t[1][0] = 1;
	for (int64 i = 1; i < m; i++)
		for (int64 j = 0; j <= k; j++)
			for (int64 l = 0; l <= k-j; l++){
				int64 now = ((int64)t[i][j] * (int64)cnt[i][l][j]) % mod;
				t[i+1][j+l] = (t[i+1][j+l] + now) % mod;
			}
}

void read(){
	scanf("%lld %lld",&k, &m);
	n = bm = 0;
	forn(i,m){
		scanf("%lld",&b[i]);
		n += b[i];
		bm = max(bm,b[i]);
	}
}
	
void write(){
	printf("%lld\n",t[m][k]);
}

int main(){
 	freopen("input.txt","rt",stdin);
 	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
