#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=102, TMS=(1<<15)-1, TL=1.9*CLOCKS_PER_SEC;
double res, cst[N];
int cnt, msk, n, be[N], ne[N+N], en[N+N];
char w[N];

int dfs(int x) {
	int res=w[x]=1;
	for (int j=be[x]; j; j=ne[j])
		if((msk>>(j>>1)&1) && !w[en[j]]) 
			res+=dfs(en[j]);
	return res;
}

void f(int c) {
	msk=c;
	double e=0, m=1;
	memset(w+1, 0, n);
	for (int i=1; i<=n; i++)
		if (!w[i]) m*=dfs(i);
	for (int i=1; i<n; i++)
		if (!(msk>>i&1)) e+=cst[i];
	if (res<m*e) res=m*e;
}

void stup(int n, int k, int msk=0) {
	if (!n) {
		f(msk);
		if (!(++cnt & TMS) && clock()>TL) {
			cout << setprecision(15) << res << endl;
			exit(0);
		}
	}
	else {		
		if (k) stup(n-1, k-1, msk|1<<n);
		if (n-k) stup(n-1, k, msk);
	}
}
int main () {
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);	
	int k;
	cin >> n >> k;
	for (int i=1; i<n; i++) {
		int p, q; double c;
		cin >> p >> q >> c;
		ne[i+i]=be[p];
		be[p]=i+i;
		en[i+i]=q;
		ne[i+i+1]=be[q];
		be[q]=i+i+1;
		en[i+i+1]=p;
		cst[i]=c;
	}
	stup(n-1, n-k);
	cout << setprecision(15) << res << endl;
	return 0;
} 
