#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const int nmax = 190;
const int D = 25000;

string st[190];
char u[30][30], us[30][30];
int res, s, k;

inline bool chk (int x, int y)
{
    return u[x][y] || (!u[x+1][y] || !u[x][y+1] || !u[x-1][y] || !u[x][y-1]);
}

void go_23 (int n, int x, int y)
{
	if (s == 0)
	{
		if (k == res)
		{
			forn (i, n)
			{
				forn (j, i+1)
					printf ("%c", u[i][j]);
				printf ("\n");	
			}	
// 			cerr << clock() / 1000 << endl;
			exit (0);
		}
		res ++;
		return;
	}
	if (y > x)
	{
		x ++;
		y = 0;
		go_23 (n, x, y);
		return;
	}
	if (us[x][y])
	{
		if (u[x][y] == 'A')
		{
			us[x][y] = us[x+1][y] = us[x+1][y+1] = 0;
			s -= 3;
			if (chk (x, y+1) && chk (x+1, y+2))
				go_23 (n, x, y);
			s += 3;
			u[x][y] = u[x+1][y] = u[x+1][y+1] = 0;
		if (!u[x][y] && !u[x+1][y+1] && !u[x][y+1])
		{
			u[x][y] = u[x+1][y+1] = u[x][y+1] = 'B';
			s -= 3;
			if (chk (x+1, y) && chk (x, y+2) && chk (x+1, y+2))
			    go_23 (n, x, y);
			s += 3;
			u[x][y] = u[x+1][y+1] = u[x][y+1] = 0;
		}
		}
		else
		{
			us[x][y] = us[x+1][y+1] = us[x][y+1] = 0;
			s -= 3;
			if (chk (x+1, y) && chk (x, y+2) && chk (x+1, y+2))
		    		go_23 (n, x, y);
			s += 3;
			u[x][y] = u[x+1][y+1] = u[x][y+1] = 0;
		}
		return;
	}
	if (u[x][y])
	{
		go_23 (n, x, y+1);
		return;
	}
	if (!u[x][y] && !u[x+1][y] && !u[x+1][y+1])
	{
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 'A';
		s -= 3;
		if (chk (x, y+1) && chk (x+1, y+2))
			go_23 (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 0;
	}
	if (!u[x][y] && !u[x+1][y+1] && !u[x][y+1])
	{
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 'B';
		s -= 3;
		if (chk (x+1, y) && chk (x, y+2) && chk (x+1, y+2))
		    go_23 (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 0;
	}
}

void go_back (int n, int x, int y)
{
	if (s == 0)
	{
		if (k == res)
		{
			forn (i, n)
			{
				forn (j, i+1)
					printf ("%c", u[i][j]);
				printf ("\n");	
			}	
// 			cerr << clock() / 1000 << endl;
			exit (0);
		}
		res ++;
		return;
	}
	if (y > x)
	{
		x ++;
		y = 0;
		go_back (n, x, y);
		return;
	}
	if (u[x][y])
	{
		go_back (n, x, y+1);
		return;
	}
	if (!u[x][y] && !u[x+1][y+1] && !u[x][y+1])
	{
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 'B';
		s -= 3;
		if (chk (x+1, y) && chk (x, y+2) && chk (x+1, y+2))// && chk (x+2, y+1) )
		    go_back (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 0;
	}
	if (!u[x][y] && !u[x+1][y] && !u[x+1][y+1])
	{
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 'A';
		s -= 3;
		if (chk (x, y+1) && chk (x+1, y+2))// && chk (x+2, y) && chk (x+2, y+1))
			go_back (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 0;
	}
}

void go (int n, int x, int y)
{
	if (s == 0)
	{
		if (k == res)
		{
			forn (i, n)
			{
				forn (j, i+1)
					printf ("%c", u[i][j]);
				printf ("\n");	
			}	
// 			cerr << clock() / 1000 << endl;
			exit (0);
		}
		res ++;
		return;
	}
	if (y > x)
	{
		x ++;
		y = 0;
		go (n, x, y);
		return;
	}
	if (u[x][y])
	{
		go (n, x, y+1);
		return;
	}
	if (!u[x][y] && !u[x+1][y] && !u[x+1][y+1])
	{
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 'A';
		s -= 3;
		if (chk (x, y+1) && chk (x+1, y+2))// && chk (x+2, y) && chk (x+2, y+1))
			go (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y] = u[x+1][y+1] = 0;
	}
	if (!u[x][y] && !u[x+1][y+1] && !u[x][y+1])
	{
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 'B';
		s -= 3;
		if (chk (x+1, y) && chk (x, y+2) && chk (x+1, y+2))// && chk (x+2, y+1) )
		    go (n, x, y);
		s += 3;
		u[x][y] = u[x+1][y+1] = u[x][y+1] = 0;
	}
}

int calc (int v)
{
	seta (u, 1);
	res = 0;
	forn (i, v)
		forn (j, v)
			if (i >= j)
				u[i][j] = 0;
	s = v * (v + 1) / 2;
	if (s % 3)
		return 0;
	u[0][0] = u[1][0] = u[1][1] = 'A';
	s -= 3;
	if (v > 3)
	{
		u[v-1][v-1] = u[v-1][v-2] = u[v-2][v-2] = 'A';
		s -= 3;
	}	
	if (v == 21)
	{
		if (k < 185327 - k)
			go (v, 0, 0);
		else
		{
			k = 185327 - k;
			go_back	(v, 0, 0);			
		}	
	}
	go (v, 0, 0);	
	return res;		
}

int parse (char c)
{
	if (isdigit (c))
		return c - '0';
	else
		return c - 'A' + 10;	
}

int calc_23 ()
{

st[0] = "0C985B22C65964CB0B2D96459632CB2CB2659616596CB2C8E2CE3E67E6AD6AD0108100";
st[1] = "0C985B22C65964CE0B4D9345B8627F46EA32406B63C84E506DF1B24F38B6D6B0490840";
st[2] = "0C985B22C659658E134C7359682C9B0FF27ABE1405CCD810E931BE7F38AD56B0100840";
st[3] = "0C985B22C659C5F315AC085EF6294B066263A6134D6DC70896763F3F26AB56D0040900";
st[4] = "0C985B22C67168C98B7193E5B532402FFF65551C000D3FFC9AAABF8000AB6DB0049240";
st[5] = "0C985B22C6716988D188C98EF7114466663AEE7C23EBF9A815703C03FEADB550124000";
st[6] = "0C985B22C671F8D58811B6C4927FFB5552000637F9C4AAD1B00989FFF8DAAAB1200040";
st[7] = "0C985B22C671F8D7C82B78095B182471B62C9263FB69AA48703633FF26B556D0400900";
st[8] = "0C985B22CC5A643B32396681D37F3455A300997FFF0AABCC0016BFFC20AAADB0001240";
st[9] = "0C985B22CC5A646B342D36469C69F34D5A1C0865EF6B294838C63F9CE6AB5AD0042100";
st[10] = "0C985B22CC723865B5910BC6CA39632C7264761D91DF2CD158B98099F8DB5AB1242040";
st[11] = "0C985B22CC726838F3896981377FC45566003A7BDCCA53F018D5BCE408AD6DB0109240";
st[12] = "0C985B22CC7268699C70B2CCE2169E64D43B43349B84DA7DB91A89FC80DAADB1201240";
st[13] = "0C985B2386991CF20ACD8747687C9E56D402433FDB85527D80DA8FE480D56DB1009240";
st[14] = "0C985B23869934DC09D9B4849B37A425366C72139FDFAD51508180FFF8DAAAB1200040";
st[15] = "0C985B23869934F40A799A85C1E3B24D2C3465B99647ECB1A8B38819F8DB5AB1242040";
st[16] = "0C985B23869935FC1578029B63249C37F6D2A22301E65B29F1380F3F9ED6AB51080400";
st[17] = "0C985B238F9AB4041BFC955F802AFF00AA6D801276CDFC90956DBF0248AB6DB0049240";
st[18] = "0C985B238F9AB40437BD29433065CF596A0E206D1BC932506FB1B27938B6B6B0484840";
st[19] = "0C985B238F9AB4043FFD5540003DB62924636F1C928D6D9884973FFF3EAAAB50000400";
st[20] = "0C985E24C1DE44B303AF68493C1B53D21A4DB80E4BD9F6516A71821F38DB56B1240840";
st[21] = "0C985E24C1F678B582137FE9551800737E2D2A6260C9B8D072C9B3E7F8B56AB0408040";
st[22] = "0C985E24C35B845B192CFE4D56100B6FF225566C01C937F06E55B27C08B6ADB0481240";
st[23] = "0C985E24C35B845E194CE34D38135EDA1449B30DCE993E996D4702433EDB6B51248400";
st[24] = "0C985E24C35B847F3EAD404036364E277C6D2B12309FE7FD55AA800800DB6DB1249240";
st[25] = "0C985E24C35E849B0D39CF87EB7D04503603123F9BC57E5182B18F8138D5B6B1024840";
st[26] = "0C985E24C37388599970E2CD32137FFE2A5580007DEDB52892183FFF9EAAAB50000400";
st[27] = "0C985E24C37388719A709ACDC212DE6C9427633F93857F5982A10F81FED5B551024000";
st[28] = "0C985E24C37688998D71C2C7F2355E20146DE312538DB35893A13FF9FEAAB550004000";
st[29] = "0C987342379158C38B7192C5B2625B4D9234B638C96596C99C4E0FCFE6D5AAD1020100";
st[30] = "0C987342379158C38FF3EACA0200DB789229FE335565C0099DB60FC926D5B6D1024900";
st[31] = "0C987342379170C4CE69AE042DED92496C1B25E4B64B64B025B3BFC9F8AADAB0012040";
st[32] = "0C9873423D925833B3F16AC1026DEF494A3F303AE9E409A98C700E73FED6B551084000";
st[33] = "0C9873423D9258639CD0B4CC9A1DA669342371BC96456CB184B38FF9F8D55AB1002040";
st[34] = "0C9873423D92707CF56902036F64945B66093A36DC6492C9B6CE0927E6DB6AD1248100";
st[35] = "0C9873423F12981ADF08AD8C259FF26AAC20073F6F85497D83628F9380D5B5B1024240";
st[36] = "0C9873423F12981BBD114CC1BA3E262B1C61CB1DAC8D21D89B693F927EAB6D50049000";
st[37] = "0C98734266E12CD909FDB544806DFB49521E0C653E6B35683A043F9FFEAB5550040000";
st[38] = "0C98734266E12DB1126CDA4E4C1F736A7E21F47FD06AA0F8006A3FF206AAB6D0004900";
st[39] = "0C98734266E13EDA8901B6C4923F6F2A4A61B017C9ECADA8E0903E7FFEAD5550100000";
st[40] = "0C98734266E13EFE8A8181E5B532402DBFC49527B006A4FDC36A8FF200D56DB1009240";
st[41] = "0C98734267A146CC8BB191C58E339F2D6A64201DBFDF25515B018093F8DB6AB1248040";
st[42] = "0C98734267A14CC70E59AC843FFBEA5280061FF97D4ACA000E0DBFE7C8AAD5B0010240";
st[43] = "0C98734267A14CCD0E8FE64AD6010E6DB42491BDEC4529318C6F8E7278D6B6B1084840";
st[44] = "0C9873426DA2463CB2B16161796CAC4B0E316E3993E7EFE9A8A808181EDB5B51242400";
st[45] = "0C9873426DA246789D308DD8E22766345CD0CB26EC8691D9CC690FCE7ED5AD51021000";
st[46] = "0C9873426DA24C6D1C8CB6589623CB32E27C261E0DDF671145F180CF38DAD6B1210840";
st[47] = "0C9873426DA24C7F1D58808CDB1D2468F626523766C48E91B1CD89CFC8DAD5B1210240";
st[48] = "0C9873426FE2AC011BD8949F8DAB92016CD825A47E46CAB1CB038F9FF8D5AAB1020040";
st[49] = "0C9873426FE2AC0136D92487FB6AA4401E3FCA6AACC801D06DB9B249F8B6DAB0492040";
st[50] = "0C9873426FE2AC013FD954800DFB12526C06E5F92C4AD930096FBFF278AAB6B0004840";
st[51] = "0C9873426FE2BE02B60123C78A6A66435C370B396C87C9D9AB6908127EDB6D51249000";
st[52] = "0C9877C560236C491BD8949F8DAB92016CFC272BB6802499B1B709C93EDADB51212400";
st[53] = "0C9877C560236C4936D92487FB6AA440361ED26526CB3F903AADBF8048AB6DB0049240";
st[54] = "0C9877C560236C493FD954800DFB12526C07A7794F8ACD7C0E82BFE780AAD5B0010240";
st[55] = "0C9877C560237E4AB60126C37264B65B24096DED92492DB06C93B27FF8B6AAB0480040";
st[56] = "0C9877C56023DE52B18138C3B2645E59940BE36CF3896B7C6422B3FF80B555B0400240";
st[57] = "0C9877C56023FC55180CEC4D26136E6E4425B36C4E8936986E47327F3EB6AB50480400";
st[58] = "0C9877C56026DE92878329EB3505C079DE2B4A6098C9BE7072B5B3E108B56DB0409240";
st[59] = "0C9877C56026FC95061B3E8B5184326DAC2485B7BC44A531B18F89CE78DAD6B1210840";
st[60] = "0C9877C56027B6A483F1F56501306C2C4E646E1D93FF2DA95890009FFEDB5551240000";
st[61] = "0C9877C56027ECA9006FF24AFE00ABFC0255BC004A6DFE68955C3F00FEAB6D50049000";
st[62] = "0C9877C56027FEAA8001B6C49237FB25526C0612D9CD93F096D5BF2408AB6DB0049240";
st[63] = "0C9877C5F0530046DE48AD982723DC3296DC622271E66B29F4380F3F9ED6AB51080400";
st[64] = "0C9877C5F053004D9B9096CF12147E66542EC3322F8599599D610FC3FED5B551024000";
st[65] = "0C9877C5F053004DBF9157E0153780251E6CCA12EC6D91C8963E3F39E6AB5AD0042100";
st[66] = "0C9877C5F05780AD8091B7E4953D80293FC6D5272006B6FDC24A8FFF80D555B1000240";
st[67] = "0C9877C5F05780AFC0AB78097D9852700C2CC763A689A698734733F33EB56B50408400";
st[68] = "0CB098EC85985CF20ACF0749B80E76CEE47E5B0AC49813FD6DAA824800DB6DB1249240";
st[69] = "0CB098EC859874DC09D9B4849B7FA4553F00757B100A4CFC1BEABC9E00ADADB0121240";
st[70] = "0CB098EC859874F40A799A8741B4F223ACD907258F863959CD610FC3FED5B551024000";
st[71] = "0CB098EC859875FC15D8048D8D93926D6C2425EFDE4952B060C3B3E7F8B56AB0408040";
st[72] = "0CB099A702DB245B1938BF8CAB1C0469B626927F1FEAB2A803803FF9FEAAB550004000";
st[73] = "0CB099A702DB24761A4C9B4DC812FFFCAA5700009B7F9A495736003F26DB56D1240900";
st[74] = "0CB099A702DB247F3EB94080637B9C53F60FA23E8365034983260F9FE6D5AAD1020100";
st[75] = "0CB099A702DE249E0D4DC345E8629B4CD235CC687E69B5F8720A33FE06B556D0400900";
st[76] = "0CB099A702F3285999D0B4D89A27A6353470731F1F8D4D5886813FE7FEAAD550010000";
st[77] = "0CB099A702F32871BE715AC04236DB2492FDB62A49C07FF1B555890008DB6DB1249240";
st[78] = "0CB099A702F628998DD1C4671934EC268BDA1924DD86D239C8C70FE73ED56B51008400";
st[79] = "0CB099A703B34847B6512CC62E399F2D6AC420237EC64A91F60D8F27C8D6D5B1090240";
st[80] = "0CB099A703B3484DB69126C6D2691E4D9434B3398E85A69993470FF33ED56B51008400";
st[81] = "0CB099A703B3484FFFA950000F7F945566002E36F2C49591B61D893FC8DB55B1240240";
st[82] = "0CB099A703B7C8AD8093FFCAAA00067EF42A51B06647CEB1AB438813F8DB6AB1248040";
st[83] = "0CB099A703B7C8BF8153C06AD901386DF324BF36C5049C0DB6B6892120DB6DB1249240";
st[84] = "0CB099A703FB54401EFCA5586020B63324DDFDA22A466031F5B38F09F8D6DAB1092040";
st[85] = "0CB099A703FB544037F92A860369B4472632FE3B2BE470298E600E7E7ED6AD51081000";
st[86] = "0CB099A703FFD4A0006DE2451E632E4EC43473686B89B85872D933E4FEB56D50409000";
st[87] = "0CB099A703FFD4A000FF7D49401836D1A44C9F9ADD4E1200ED8DBE49C8ADB5B0124240";
st[88] = "0CB099AD047994F80F3DAD44207EDE549403F37BAB8A405818D93CE4FEAD6D50109000";
st[89] = "0CB099AD04D8E596164C3B4DC812FFD8AA49801B7FCE4550EC01BE4FF8ADAAB0120040";
st[90] = "0CB099AD04D9A4E30B3B1689931AF470A62D9A325C65B2C992CE0FE7E6D56AD1008100";
st[91] = "0CB099AD04D9A5A3132C7659162CCE0EFC7A2B14C08CDFD8E8A93E607EAD6D50109000";
st[92] = "0CB099AD04F0E99196703ADB42246F364A73F81DD7CD205098C1BF9CF8AB5AB0042040";
st[93] = "0CB099AD04F1A8E18B7312C9E21A9BD0D24F4C1A9A6E1A68ED1C3E4CFEADAD50121000";
st[94] = "0CB099AD04F1A9A0D3C8D58E059DB2F92C5F6702969E0C9958B700993EDB5B51242400";
st[95] = "190792C0B79158C2CEC9A584C7371C259FFCB52AC80016D9B649093FFEDB5551240000";
st[96] = "190792C0B79158C38ED3E46AD9012C7BCE295A3304C5C6D19C498FCFF8D5AAB1020040";
st[97] = "190792C0B79159839370D2CE621F9E6BF420A36F03895B58612133FFFEB55550400000";
st[98] = "190792C0BD925832F3896981376DC449663F3A6AB46804C86DBE3249E6B6DAD0492100";
st[99] = "190792C0BD9258639C70B2CCB21C7FF9AA5F8002B6DE04915B6D809248DB6DB1249240";
st[100] = "190792C0BD927034F2696E013B3FE42AB660121FF7ED54A880603FFE7EAAAD50001000";
st[101] = "190792C0BF12980F98F09BEDC51380F73F52D503200C7FFC9AAABF8000AB6DB0049240";
st[102] = "190792C0BF12981B9F10ACD82E231F326ADDA0224DE66D29F4980F3F9ED6AB51080400";
st[103] = "190792C0E6E12CD909D9B4849FBFEA2A80C01FA3DD465201F18D8F39C8D6B5B1084240";
st[104] = "190792C0E6E12CF10A799A8743347C26566F8213CDFFBF29515800C09EDADB51212400";
st[105] = "190792C0E6E12DF915D8048D8F13946D66243A3FDCC553F180D58FE408D56DB1009240";
st[106] = "190792C0E6E13EDA8903DECA52061EDC144B330CEE99F8996AC702073EDB6B51248400";
st[107] = "190792C0E6E13FFA950006DB1224DB1B92C9F62DA96120C9B6CE0927E6DB6AD1248100";
st[108] = "190792C0E7A1478C93B0D17A1923EC328E7C1A1E7CCD6BF08415BFFC08AAADB0001240";
st[109] = "190792C0E7A14CCD0B9996859362DC4C9F35B5684809B6FC724AB3FF80B555B0400240";
st[110] = "190792C0E7A14D8D138CD64E1C1DF3697E26147F006AB36803A43FF9FEAAB550004000";
st[111] = "190792C0EDA2466CB4B11966596B2C438E1B9A64FCCFEAD05409B03FF8B6AAB0480040";
st[112] = "190792C0EDA24C3D328D6641D63D0B29B263961CF9CD6AD08409BFFFF8AAAAB0000040";
st[113] = "190792C0EDA24C6D348D36469C69F3475A32083E36C79C91AD6D884248DB6DB1249240";
st[114] = "190792C0EFE2AC011B6C925B7E24AE3604D261A6D0469331CDAF8FC878D5B6B1024840";
st[115] = "190792C0EFE2AC011FECAA580626CE34FC73EF96A14C8000ED8DBE49C8ADB5B0124240";
st[116] = "190792C0EFE2AC013DF94A80C331F426A3DA19247D86CA39CB070F9F3ED5AB51020400";
st[117] = "190792C0EFE2BE029B009FCFEA150360323F9635716404C9B63E0939E6DB5AD1242100";
st[118] = "190793813C73902CF0E96E013B6FE44AB6301239FEC7EA91A80D881FC8DB55B1240240";
st[119] = "190793813CD2E017B6512CC63A38E32CB2659616596CB2C8E2CE3E67E6AD6AD0108100";
st[120] = "190793813CD2E01DB69126C7F23AB6202466DB17248CBFD8E2A93E607EAD6D50109000";
st[121] = "190793813CD2E01FFFA950001B37A4251E6CCA13ACCDA1D091B9BFC9F8AADAB0012040";
st[122] = "190CE16642DB245B1938B6989323DC32967C321E0BCD665085F1BFCF38AAD6B0010840";
st[123] = "190CE16642DB24761A4C8F4F28159BC1D24DCC1A7E6E3568E2043E7FFEAD5550100000";
st[124] = "190CE16642DB247F3EB94080337E5C559F00FD3FD405503D80DA8FE480D56DB1009240";
st[125] = "190CE16642DE249E0D4DC345B832762FE4657F160A8CB018E2373E793EAD5B50102400";
st[126] = "190CE16642F3285999D0B4CC9A1FE36AE220267BCD6A570818763CFF26AD56D0100900";
st[127] = "190CE16642F328719A709BEDC513807F3F2AD5602009BFD872A933E07EB56D50409000";
st[128] = "190CE16642F628998D7343E9B51A4071B62C9233EFC7E951A8C1881CF8DB5AB1242040";
st[129] = "190CE16643B34847B6512CC32E659659640E3B6D348934D86E69327E7EB6AD50481000";
st[130] = "190CE16643B3484DB69126C3D2651B59920EEC7F126AB3F803AA3FF806AAB6D0004900";
st[131] = "190CE16643B3484FFFA950000DBD92296C66271D1E8D32989AC73F873EAB6B50048400";
st[132] = "190CE16643B7C8AD8093FDEAA50060FDC654E201F36DAFC890563FF026AAB6D0004900";
st[133] = "190CE16643B7C8BF815180C4DA7F2655FC00AB7F808AA6FC01CABFCF80AAD5B0010240";
st[134] = "190CE16643FB54401EFCA54C601CFEFB54510300DB8D925896D93F24FEAB6D50049000";
st[135] = "190CE16643FB544037F92A8601B9B23F2C6BE5905C5F8131518F80CE78DAD6B1210840";
st[136] = "190CE16643FFD4A0006DB244EC6F934BFA18A86703CB5FD02151BFF038AAB6B0004840";
st[137] = "190CE16643FFD4A000FDFD4540303F2DAA64801FF7ED54A880603FFE7EAAAD50001000";
st[138] = "190CE16C447994F80F3DAD44206DFE49541B0364EF8B695824613FF3FEAAB550004000";
st[139] = "190CE16C44D8E596164C2F4F28159B61D23B4C7C9A6ADA68091C3FFCFEAAAD50001000";
st[140] = "190CE16C44D9A4E30B399F87EB35042036FF122A9BC01A51B731893F38DB56B1240840";
st[141] = "190CE16C44D9A4E60FCFEB4A0801BF6D2A24C037A364A649B1F609CF26DAD6D1210900";
st[142] = "190CE16C44F0E99196703ACDC213EFDF4A4A180C0779F3496AE60207E6DB6AD1248100";
st[143] = "190CE16C44F1A8E18B7193E7F57D40507E01AA7E40CAB6D00249BFFFF8AAAAB0000040";
st[144] = "190CE16C44F1A9A0D188C99BFDA2A2300C7FDF1EA79F037D462280E780DAD5B1210240";
st[145] = "190CE1F6A2036C491B78928DB312746DA6249A3DFCC52AD18C098E7FF8D6AAB1080040";
st[146] = "190CE1F6A2036C491FF8AA8C031DFC695F23056CF8096AD8640933FFFEB55550400000";
st[147] = "190CE1F6A2036C493F6D5240363C4B29B2639C1CEE6D69F8846A3FF206AAB6D0004900";
st[148] = "190CE1F6A2037E4A9E00A3D8CA2766347470D316E68C9698EC473E4F3EADAB50120400";
st[149] = "190CE1F6A203DE529980B8D8B2267F35AAD08023DBC65251F1B18F3938D6B6B1084840";
st[150] = "190CE1F6A203F654B03131C69A39A63F346AD310269FB699524700FF3EDAAB51200400";
st[151] = "190CE1F6A203FC55301936869338DC2C9667621F936D5B4881263FFFE6AAAAD0000100";
st[152] = "190CE1F6A206F6948C3341C99A1AE370B22D966271C9B4D07239B3F9F8B55AB0402040";
st[153] = "190CE1F6A207B6A481B3C96BF902ACF00E56FE012BFFB029526000FE7EDAAD51201000";
st[154] = "190CE1F6A207ECA9006DB244B6364E25FC78AB14C08CD6FCE84ABE7F80AD55B0100240";
st[155] = "190CE1F6A207ECA900FDB544807B6F524A0FD83EA765034983260F9FE6D5AAD1020100";
st[156] = "190CE1F6A207FEAA8003F6CA9201EF6D4A24183DE5E52B298C380E7F9ED6AB51080400";
st[157] = "190CE1FFA5000CD909DBF48A9B00E478BF299531F0073CFDAD6A884200DB6DB1249240";
st[158] = "190CE1FFA5000DB1123CF15A9821AF370A72D81F25ED5B2881383FFF9EAAAB50000400";
st[159] = "190CE1FFA5000DF915FC054F0014F6C6A44E0D8FE259E9B168D3821CF8DB5AB1242040";
st[160] = "190CE1FFA5001EFE8A8180C5B2327F2DAA648017FB6CAA48E0363E7F26AD56D0100900";
st[161] = "190CE1FFA5001FFA95000FCDAA12036DB2249C3FFE6555F9800A0FFE06D556D1000900";
st[162] = "190DA23327611CC70E59AC842DFF9255FC0055B78044BFB1B15389C0F8DADAB1212040";
st[163] = "190DA23327611CCD0E8DA644763C8B2B3261D616E1CC97F0EC55BE4C08ADADB0121240";
st[164] = "190DA23327611D8D1398D69A11A3F232ACD60721F686D499C8370FF93ED55B51002400";
st[165] = "190DA23327C1E6D68843FFCAAA00066DB424933F7B854A7D831A8F9C80D5ADB1021240";
st[166] = "190DA2332D62166C9CB0F96D5910387FF32AAD600209BFFC72AAB3E000B56DB0409240";
st[167] = "190DA2332D621C37327D6D41206DEF494A36186905E9B32872F833E79EB56B50408400";
st[168] = "190DA2332D621C6D1C98FB8D4B1064DE764AD218236E3648E2763E7F26AD56D0100900";
st[169] = "190DA2332D621C7F357D01436064FE5FD40A833C06856C9984B70FF93ED55B51002400";
st[170] = "190DA261CCB2C816DE48AF0C299F1AFA7050FF803D4D9A00970DBF3FC8AB55B0040240";
st[171] = "190DA261CCB2C81D9B9096DB1224DE3694D261A7F046AB31C02F8FFE78D556B1000840";
st[172] = "190DA261CCB2C81DBF9157E0157EC054B601926C77E934A86E60327E7EB6AD50481000";
st[173] = "190DA261CCB38826F3497181C73D1C299663B21C8EDF669145CD80CFC8DAD5B1210240";
st[174] = "190DA261CCFAD4101ED8A48C6F1C946B6321397EF58A943806373F393EAB5B50042400";
st[175] = "190DA261CCFAD41037BD29463039C62D64642D9FF24D55B08013BFFFF8AAAAB0000040";
st[176] = "190DA261CCFAD4103FFD5540003FFF2AAA600017FFECAAA8E0003E7FFEAD5550100000";
st[177] = "190DA263471964CB0B3B1689930FB4CF265ADA0424DFFFF15555800008DB6DB1249240";
st[178] = "190DA263471964CE0FCFEFCA140003FCDA55C8007DEDB52892183FFF9EAAAB50000400";
st[179] = "190DA2634719C4D309ADB844BC7E53571A0138366B64B849B3B609F926DAB6D1204900";
st[180] = "190DA263473168C8CBCB1589858FB2CF2C5AC584265FB6B1524380FFF8DAAAB1200040";
st[181] = "190DA263473168C98ED1A4C46E3C9F2B6AC12023DBC65251F1B18F3938D6B6B1084840";
st[182] = "190DA2634731698991F0CBFB8522003336D7D221E366D649C8760FFF26D556D1000900";
st[183] = "190DA2634731F8D588136FC92A1F86D5F440531B038E4658EC593E4CFEADAD50121000";
st[184] = "190DA2634731F9F594100DEFE5156060463FE27D51EA032806F83F279EAB6B50048400";
st[185] = "190DA2634D1A646B1C2CEC4D2611BEF13C536F83915E76015A4D809FC8DB55B1240240";
st[186] = "190DA2634D1A646E1C4CB358E8239E33F47FA31E839F037D462280E780DAD5B1210240";
st[187] = "190DA2634D323867DDA88818DB27241F7ECF2A2D606108C9B6CE0927E6DB6AD1248100";
st[188] = "190DA2634D326839B3F16BE10536C024BF6D9512701FFCFD556A800200DB6DB1249240";
st[189] = "190DA2634D3268699CD0FC6D71104C6C3E241E3D9AC52E118CED8E7E48D6ADB1081240";

	int v = 23;
	seta (u, 1);
	res = 0;
	seta (us, 0);
	forn (i, v)
		forn (j, v)
			if (i >= j)
			{
				u[i][j] = 'A';
				us[i][j] = 1;
			}	
	s = v * (v + 1) / 2;
	if (s % 3)
		return 0;
	int pos = 0;
	while (pos+1 < nmax && D <= k)
	{
		pos ++;
		k -= D;
	}
	int step = 8;
	int cpos = 0;
	int d = parse (st[pos][cpos]);
	int it = 0;
	forn (i, v)
	{
		forn (j, i+1)
		{
			if (d & step)
				u[i][j] = 'B';
			step /= 2;	
			it ++;
			if (it == 4)
			{
				cpos ++;
				d = parse (st[pos][cpos]);
				step = 8;
				it = 0;
			}		
		}	
	}	
	go_23 (v, 0, 0);	
	return res;		
}

int main ()
{	
// 	freopen ("c.in", "r", stdin);
// 	freopen ("c.ans", "w", stdout);
	int n;
	scanf ("%d%d", &n, &k);
	if (n <= 21)
		calc (n);
	else
		calc_23 ();
	return 0;
}
