#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <math.h>
#include <set>
#include <map>

using namespace std;

const int hmod = 1000000000 + 7;

int w[200000], was[700000], q[700000], d[700000], last[700000], pc[700000], c[700000];
int first[700000], ee[2500000], next[2500000];
int o, ct;

int addedge (int a, int b) {
	ee[o] = b;
	next[o] = first[a];
	first[a] = o;
	o++;	
}

int main () {
	int n, m, t;
	scanf ("%d%d%d", &n, &m, &t);
	for (int i = 0; i < t; i++) { scanf ("%d", &w[i]); w[i]--; }
	int nn = n;
	o = 1;
	memset (first, 0, sizeof (first));
	for (int i = 0; i < m; i++) {
		int a, b;
		scanf ("%d%d", &a, &b); a--; b--;
		addedge (a, nn);
		addedge (nn, b);
		addedge (nn, a);
		addedge (b, nn);
		nn++;
	}
	memset (was, 0, sizeof (was));	
	memset (d, 0, sizeof (d));
	int l = 0, r = 0;
	for (int i = 0; i < t; i++) {
		was[w[i]] = i + 1;
		q[r++] = w[i];
	}
	int lans = -1;
	while (l < r) {
		int x = q[l++];
		for (int j = first[x]; j != 0; j = next[j]) {
			int y = ee[j];
			if (!was[y]) {
				was[y] = was[x];
				d[y] = d[x] + 1;
				q[r++] = y;
			} else
			if (was[y] != was[x]) {
				lans = d[y];
				break;
			}
		}
		if (lans != -1) break;
	}
	memset (was, 0, sizeof (was));
	memset (d, 0, sizeof (d));
	memset (c, 0, sizeof (c));
	ct = 0;
	int cans = 0;
	for (int i = 0; i < t; i++) {
		ct++;
		int l = 0, r = 1;
		q[0] = w[i];
		c[w[i]] = 1;
		while (l < r) {
			int x = q[l++];
			int xd = d[x];
			int xc = c[x];
			for (int j = first[x]; j != 0; j = next[j]) {
				int y = ee[j];
				if (!was[y]) {
					was[y] = ct;
					d[y] = xd + 1;
					c[y] = (c[y] + xc) % hmod;
					if (d[y] < lans) q[r++] = y;
				} else 
				if (was[y] == ct){
					if (d[y] == xd + 1) {
						c[y] = (c[y] + xc ) % hmod;
					}
				} else {				
					if (last[y] != ct) {
						c[y] = (c[y] + pc[y]) % hmod;
						pc[y] = 0;
						last[y] = ct;
					}
					pc[y] = (pc[y] + xc) % hmod;
					long long tmp = (long long)c[y] * xc;
					if (tmp >= hmod) tmp = tmp - (tmp / hmod) * hmod;
					cans += tmp;
					while (cans >= hmod) cans -= hmod;					
				}
			}
		}
	}
	printf ("%d %d\n", lans, cans);
}