#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 1000000;

int64 x[nmax];
int64 y[nmax];
int64 z[nmax];

int n;
int64 res;
int v,u;

bool ls(pii a, pii b){
	return a.fs > b.fs;
}

bool ls1(pii a, pii b){
	return a.fs < b.fs;
}


int calc(int v, int u){
	return abs(x[v] - y[u]) + abs(y[v]-z[u]) + abs(z[v]-x[u]);
}

void solve(){
	res = 0;
	v = 0;
	u = 1;
	forn(j,8){
		int p1,p2,p3;
		p1 = p2 = p3 =1;
		if (j & 1)p1= -1;
		if (j & 2)p2= -1;
		if (j & 4)p3= -1;
		vector<pii> q,w;
		forn(i,n){
			int now = x[i]*p1 + y[i]*p2 + z[i]*p3;
			if (w.size() < 2){
				w.pb(mp(now,i));
				sort(all(w),ls);
			}else{
				assert(w.size() == 2);
				if (ls(mp(now,i),w[1]))
					w[1] = mp(now,i);
				if (ls(mp(now,i),w[0])){
					w[1] = w[0];
					w[0] = mp(now,i);
				}
			}
			now = y[i]*p1 + z[i]*p2 + x[i]*p3;
			if (q.size() < 2){
				q.pb(mp(now,i));
				sort(all(q),ls1);
			}else{
				if (ls1(mp(now,i),q[1]))
					q[1] = mp(now,i);
				if (ls1(mp(now,i),q[0])){
					q[1] = q[0];
					q[0] = mp(now,i);
				}
			}
			
		}
		forn(i,2)
			forn(j,2)
				if (w[i].sc != q[j].sc){
					if (w[i].fs-q[j].fs > res){
						res = w[i].fs - q[j].fs;
						v = w[i].sc;
						u = q[j].sc;
					}	
				}	
					
	}
}

void read(){
	cin >> n;
	forn(i,n)
		scanf("%lld %lld %lld",&x[i],&y[i],&z[i]);
}

void write(){
 	printf("%lld\n%d %d\n",res,v+1,u+1);	
}

int main(){
//   	freopen("c.in","rt",stdin);
//   	freopen("c.out","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
