{$MODE DELPHI}

var n, m, i, j, free, s, t, w, num:Integer;
    wadd:Int64;
    list, start, p:array[0..500000]of Integer;
    was, rwas:array[0..500000]of Boolean;
    h, pos, u, v, incom, outgo, color:array[0..500000]of Integer;
    d:array[0..500000]of Int64;
    r:array[1..500000]of record toV, frv, num, next:Integer; w:Int64; end;
procedure Add(rnum, rfrv, rtov, rw:Integer);
begin
  inc(free);
  with r[free] do
  begin
    toV:=rtov;
    num:=rnum;
    frv:=rfrv;
    w:=rw;
    next:=start[frv];
  end;
  start[rfrv]:=free;
end;
procedure dfs(i:Integer);
var j:Integer;
begin
  was[i]:=true;
  j:=start[i];
  while(j<>0) do
  begin
    if(not(was[r[j].toV])) then dfs(r[j].toV);
    j:=r[j].next;
  end;
  inc(list[0]);
  list[list[0]]:=i;
end;
procedure dfs2(i:Integer);
var j:Integer;
begin
  color[i]:=num;
  j:=start[i];
  while(j<>0) do
  begin
    if(color[r[j].toV]=0) then dfs2(r[j].toV);
    j:=r[j].next;
  end;
end;
procedure swap(var a, b:Integer);
var c:Integer;
begin
  c:=a; a:=b; b:=c;
end;
procedure hswap(i, j:Integer);
begin
  swap(h[i], h[j]);
  pos[h[i]]:=i; pos[h[j]]:=j;
end;
procedure MoveUp(i:Integer);
begin
  while(i>1)and(d[h[i div 2]]>d[h[i]]) do
  begin
    hswap(i, i div 2);
    i:=i div 2;
  end;
end;
procedure MoveDown(i:Integer);
var min:Integer;
begin
  while(i*2<=h[0]) do
  begin
    if(d[h[i*2]]<d[h[i]]) then min:=i*2 else min:=i;
    if(i*2+1<=h[0])and(d[h[i*2+1]]<d[h[min]]) then min:=i*2+1;
    if(min<>i) then
    begin
      hswap(i, min);
      i:=min;
    end else break;
  end;
end;
procedure Insert(i:Integer);
begin
  inc(h[0]);
  h[h[0]]:=i;
  pos[i]:=h[0];
  MoveUp(h[0]);
end;
function ExtractMin:Integer;
begin
  if(h[0]=0) then result:=0 else
  begin
    result:=h[1];
    hswap(1, h[0]);
    dec(h[0]);
    MoveDown(1);
  end;
end;
begin
  //assign(input, 'd.in');
  //assign(output, 'd.out');
  reset(input); rewrite(output);
  read(n, m);

  free:=0;
  fillchar(start, sizeof(start), 0);
  list[0]:=0;
  for i:=1 to m do
  begin
    read(u[i], v[i]);
    Add(i, u[i], v[i], 0);
  end;
  fillchar(was, sizeof(was), 0);
  for i:=1 to n do
    if(not(was[i])) then dfs(i);
  
  free:=0;
  fillchar(start, sizeof(start), 0);
  for i:=1 to m do
    Add(i, v[i], u[i], 0);
  fillchar(was, sizeof(was), 0);
  num:=0;
  for i:=n downto 1 do
    if(color[list[i]]=0) then
    begin
      inc(num);
      dfs2(list[i]);
    end;
  for i:=1 to m do
  begin
    if(color[u[i]]=color[v[i]]) then continue;
    inc(outgo[u[i]]);
    inc(incom[v[i]]);
  end;
  for i:=1 to n do
  begin
    //write(color[i], ' ');
    if(incom[color[i]]=0) then s:=i;
    if(outgo[color[i]]=0) then t:=i;
  end;
  
  //writeln(s, ' ', t);
  
  free:=0;
  fillchar(start, sizeof(start), 0);
  list[0]:=0;
  for i:=1 to m do
    Add(i, u[i], v[i], 0);
  
  readln(m);
  fillchar(rwas, sizeof(rwas), 0);
  wadd:=0;
  for i:=1 to m do
  begin
    read(u[i], v[i], w);
    if(w>=0) then
      Add(i, u[i], v[i], w)
    else
    begin
      Add(i, u[i], v[i], 0);
      rwas[i]:=true;
      wadd:=wadd+w;
    end;
  end;
  fillchar(d, sizeof(d), $17);
  fillchar(was, sizeof(was), 0);
  d[t]:=0;
  for i:=1 to n do
    Insert(i);
  while(true) do
  begin
    i:=ExtractMin;
    if(i=0)or(was[i]) then break;
    was[i]:=true;
    j:=start[i];
    while(j<>0) do
    begin
      if(d[r[j].toV]>d[i]+r[j].w) then
      begin
        d[r[j].toV]:=d[i]+r[j].w;
        p[r[j].toV]:=j;
        MoveUp(Pos[r[j].toV]);
      end;
      j:=r[j].next;
    end;
  end;
  if(d[s]>=1663823975275763479) then
  begin
    writeln('NO');
    Halt;
  end;
  writeln('YES');
  writeln(wadd+d[s]);
  i:=s;
  while(i<>t) do
  begin
    rwas[r[p[i]].num]:=true;
    i:=r[p[i]].frv;
  end;
  j:=0;
  for i:=1 to m do
    if(rwas[i]) then inc(j);
  writeln(j);
  for i:=1 to m do
    if(rwas[i]) then write(i, ' ');
  close(input); close(output);
end.