#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int64, int64> point;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int n;
point a[2100];

int64 operator * (point p1, point p2)
{
	int64 res = p1.x * p2.y - p1.y * p2.x;
	if (res < 0)
		res *= -1;
	return res;	
}

point operator - (point p1, point p2)
{
	return mp (p1.x - p2.x, p1.y - p2.y);
}

int main ()
{	
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);
	scanf ("%d", &n);
	forn (i, n)
		scanf ("%lld%lld", &a[i].x, &a[i].y);
	int64 ans = 0;	
	for (int i = 1; i+1 < n; i ++)	
	{
		int pos = i+1;
		for (int j = 0; j < n; j ++)
		{
			int x = j;
			int y = (i+j)%n;
			int npos = (pos+1)%n;
			while ((a[x] - a[pos]) * (a[y] - a[pos]) < 
			       (a[x] - a[npos]) * (a[y] - a[npos]))
			{
				pos = npos;
				npos = (pos+1)%n;
			}
			ans = max (ans, (a[x] - a[pos]) * (a[y] - a[pos]));	
		}
	}
	printf ("%lld.", ans/2);
	if (ans&1)
		printf ("5\n");
	else
		printf ("0\n");
	return 0;
}
