#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define seta(a,x) memset (a, x, sizeof (a));
#define I (int)

typedef long long int64;
typedef long double ldb;
typedef pair <int64, int64> point;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int n, m;
unsigned int a[10100][330];
int s[65536];

inline int f (int x) 
{
	return s[x >> 16] + s[x & 65535];
}

inline void paint (int x, int y)
{
	a[x][y/31] |= (1 << (y % 31));
}

int calc (int x, int y)
{
	int res = 0;
	forn (i, 330)
		res += f(a[x][i] & a[y][i]);
	return res;	
}

int main ()
{	
//	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);
	seta (s, 0);
	forn (i, 65536)
		s[i] = s[i/2] + (i&1);
	scanf ("%d%d", &n, &m);
	seta (a, 0);
	int64 res = 0;
	forn (i, m)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		x --;
		y --;
		res += (int64)calc (x, y);
		paint (x, y);
		paint (y, x);
	}
	cout.precision (2);
	cout << fixed << ((ldb)res / (ldb)4.0) << endl;
	return 0;
}
