#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 30;

int a[nmax][nmax];
int n,k;

void write(){
	forn(i,n){
		forn(j,i+1)
			if (a[i][j] == 0)
				printf("A");
			else 
				printf("B");
		printf("\n");
	}	
	exit(0);
}

bool check(int x, int y){
	if (x >= n || y > x) return false;
	if (x < 0 || y < 0) return false;
	if (a[x][y] != -1) return false;
	return true;
}

void go(int x, int y){
	if (y > x){
		x ++;
		y = 0;
	}
	if (x >= n){
		if (k == 0)write();
		k--;
		return;
	}
	if (a[x][y] >= 0){
		go(x,y+1);
		return;
	}
	if (check(x+1,y) && check(x+1,y+1)){
		a[x][y] = a[x+1][y] = a[x+1][y+1] = 0;
		go(x,y+1);
		a[x][y] = a[x+1][y] = a[x+1][y+1] = -1;
	}
	if (check(x,y+1) && check(x+1,y+1)){
		a[x][y] = a[x][y+1] = a[x+1][y+1] = 1;
		go(x,y+2);
		a[x][y] = a[x][y+1] = a[x+1][y+1] = -1;
	}
}



int main(){
//   	freopen("input.txt","rt",stdin);
//   	freopen("output.txt","wt",stdout);

	cin >> n >> k;
	forn(i,nmax)
		forn(j,nmax)
			a[i][j] = -1;
	go(0,0);
	assert(0);
	
	return 0;
}
