{$MODE DELPHI}

{$O-}

uses
  Math;

var
  n,i,j,z,k,b,t,res,wh:integer;
  l,r,u,kfr:array[1..300] of integer;
  c:array[1..600] of integer;
  found:boolean;
  free:array[1..600] of boolean;
  kfs:array[1..600] of integer;
  moved:array[1..300] of boolean;
  
procedure swap(var a,b:integer);
var c:integer;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure sorto;
var i,j:integer;
begin
  for i:=1 to n do
    for j:=1 to n-1 do
    if r[j]-l[j]<r[j+1]-l[j+1] then
    begin
      swap(l[j],l[j+1]);
      swap(r[j],r[j+1]);
      swap(u[j],u[j+1]);
    end;
end;

procedure sortf(left,right:integer);
var i,j:integer;
begin
  for i:=left to right do
    for j:=left to right-1 do
    if (kfr[j]<kfr[j+1]) or ((kfr[j]=kfr[j+1]) and (l[j]>l[j+1])) then
    begin
      swap(l[j],l[j+1]);
      swap(r[j],r[j+1]);
      swap(kfr[j],kfr[j+1]);
      swap(u[j],u[j+1]);
    end;
end;

procedure sortc;
var i,j:integer;
begin
  for i:=1 to k do
    for j:=1 to k-1 do
    if c[j]>c[j+1] then swap(c[j],c[j+1]);
end;

begin
  assign(input,'b.in');
  assign(output,'b.out');
  reset(input);
  rewrite(output);

  readln(n);
  for i:=1 to n do readln(l[i],r[i]);
  
  k:=0;
  for i:=1 to n do
  begin
    found:=false;
    for j:=1 to k do
    if c[j]=l[i] then
    begin
      found:=true;
      break;
    end;
    if not found then
    begin
      inc(k);
      c[k]:=l[i];
    end;
    //left-right borders
    found:=false;
    for j:=1 to k do
    if c[j]=r[i] then
    begin
      found:=true;
      break;
    end;
    if not found then
    begin
      inc(k);
      c[k]:=r[i];
    end;
  end;
  sortc;
  for i:=1 to n do
  begin
    for j:=1 to k do
    if c[j]=l[i] then
    begin
      l[i]:=j;
      break;
    end;
    for j:=1 to k do
    if c[j]=r[i] then
    begin
      r[i]:=j;
      break;
    end;
  end;

  //for i:=1 to n do writeln(l[i],' ',r[i]);
  
  for i:=1 to n do u[i]:=i;
  sorto;
  
  //for i:=1 to n do write(u[i],' ');
  //writeln;
  
  t:=0;
  b:=0;
  while b<n do
  begin
    t:=b+1;
    b:=t;
    while (b<n) and (r[b+1]-l[b+1]=r[b]-l[b]) do inc(b);
    for i:=1 to k do
    begin
      free[i]:=true;
      for j:=b+1 to n do
      if (i>=l[j]) and (i<=r[j]) then
      begin
        free[i]:=false;
        break;
      end;
    end;
    for i:=t to b do
    begin
      kfr[i]:=0;
      for j:=l[i] to r[i] do
      if free[j] then inc(kfr[i]);
    end;
    sortf(t,b);
  end;
  
  //for i:=1 to n do write(u[i],' ');
  //writeln;
  
  i:=n;
  fillchar(moved,sizeof(moved),0);
  //for i:=n downto 1 do
  while i>=1 do
  begin
    if moved[u[i]] then
    begin
      dec(i);
      continue;
    end;
    wh:=i;
    for j:=l[i] to r[i] do
    begin
      kfs[j]:=i;
      for z:=n{i-1} downto 1 do
      if (z<>i) and (l[z]<=j) and (j<=r[z]) then break else kfs[j]:=z;
      wh:=min(wh,kfs[j]);
    end;
    for j:=i downto wh+1 do
    begin
      swap(l[j],l[j-1]);
      swap(r[j],r[j-1]);
      swap(u[j],u[j-1]);
    end;
    moved[u[wh]]:=true;
    if wh=i then dec(i);
  end;
  
  res:=0;
  for i:=1 to n do
  begin
    for j:=l[i] to r[i] do
    begin
      free[j]:=true;
      for z:=i+1 to n do
      if (j>=l[z]) and (j<=r[z]) then
      begin
        free[j]:=false;
        break;
      end;
      if free[j] then
      begin
        inc(res);
        break;
      end;
    end;
  end;
  
  writeln(res);
  for i:=1 to n do write(u[i],' ');
end.

