#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NMAX 51
#define TMAX 1001

int* pmax[2][TMAX];
int d[NMAX], p[NMAX];
int i, j, k, a, c, N, X, T, vbest, vbest1, vbest2, T1N, T2N;

int main()
{
	freopen("core2.in", "r", stdin);
	freopen("core2.out", "w", stdout);

	scanf("%d %d %d", &N, &X, &T);
	for (i = 1; i <= N; i++)
		scanf("%d %d", &d[i], &p[i]);
	scanf("%d %d", &T1N, &T2N);

	fprintf(stderr, "N=%d, X=%d, T=%d\n", N, X, T);

	for (c = 0; c < 2; c++)
		for (i = 0; i <= T; i++)
		{
			pmax[c][i] = (int*) malloc((T + 1) * sizeof(int));
			memset(pmax[c][i], 0, (T + 1) * sizeof(int));
		}

	// set 1
	for (k = 1; k <= X; k++)
	{
		for (i = T; i >= 0; i--)
			for (j = i; j <= T; j++)
			{
				if (d[k] <= i && pmax[0][i - d[k]][j] + p[k] > pmax[0][i][j])
					pmax[0][i][j] = pmax[0][i - d[k]][j] + p[k];

				if (d[k] <= T - j && pmax[0][i][j + d[k]] + p[k] > pmax[0][i][j])
					pmax[0][i][j] = pmax[0][i][j + d[k]] + p[k];
			}
	}

	// set 2
	for (k = X + 1; k < N; k++)
	{
		for (i = T; i >= 0; i--)
			for (j = i; j <= T; j++)
			{
				if (d[k] <= i && pmax[1][i - d[k]][j] + p[k] > pmax[1][i][j])
					pmax[1][i][j] = pmax[1][i - d[k]][j] + p[k];

				if (d[k] <= T - j && pmax[1][i][j + d[k]] + p[k] > pmax[1][i][j])
					pmax[1][i][j] = pmax[1][i][j + d[k]] + p[k];
			}
	}

	// when the application N is not scheduled
	vbest1 = pmax[0][T][T] + pmax[1][T][T];

	// when the application N is scheduled
	vbest2 = 0;

	for (i = T1N; i <= T2N - d[N]; i++)
		if (pmax[0][i][i + d[N]] + pmax[1][i][i + d[N]] + p[N] > vbest2)
			vbest2 = pmax[0][i][i + d[N]] + pmax[1][i][i + d[N]] + p[N];

	vbest = vbest1;
	if (vbest2 > vbest)
		vbest = vbest2;

	fprintf(stderr, "game N not scheduled: %d\n", vbest1);
	fprintf(stderr, "game N scheduled: %d\n", vbest2);
	fprintf(stderr, "maximum profit: %d\n", vbest);

	freopen("core2.out", "w", stdout);
	printf("%d\n", vbest);

	return 0;
}
