// O(4^N) per test

#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define xc(i) (p[i].first)
#define yc(i) (p[i].second)

vector<pair<int, int> > p;
int amax;
int i, j, k, N, XMAX, YMAX, x, y;

void rec(int i, int xmin, int xmax, int ymin, int ymax)
{
	if (i >= N)
		amax = (xmax - xmin) * (ymax - ymin);
	else
	{
		if (xc(i) > xmin && xc(i) < xmax && yc(i) > ymin && yc(i) < ymax)
		{
			// 4 ways to split the rectangle
			
			// up
			if ((ymax - yc(i)) * (xmax - xmin) > amax)
				rec(i + 1, xmin, xmax, yc(i), ymax);

			// down
			if ((yc(i) - ymin) * (xmax - xmin) > amax)
				rec(i + 1, xmin, xmax, ymin, yc(i));

			// left
			if ((ymax - ymin) * (xc(i) - xmin) > amax)
				rec(i + 1, xmin, xc(i), ymin, ymax);

			// right
			if ((ymax - ymin) * (xmax - xc(i)) > amax)
				rec(i + 1, xc(i), xmax, ymin, ymax);
		}
		else
			rec(i + 1, xmin, xmax, ymin, ymax);
	}
}

int main()
{
  int T;

  freopen("dr.in", "r", stdin);
  freopen("dr.out", "w", stdout);

  scanf("%d", &T);

  while (T--)
  {
    scanf("%d %d %d", &N, &XMAX, &YMAX);

    p.clear();

    for (i = 0; i < N; i++)
    {
      scanf("%d %d", &x, &y);
      p.push_back(make_pair(x, y));
    }

    amax = 0;
	rec(0, 0, XMAX, 0, YMAX);

    fprintf(stderr, "%d\n", amax);
	printf("%d\n", amax);
  }

  return 0;
}
