#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> x;
vector<unsigned int> d;
int i, j, N, K;
unsigned int L;

int main()
{
  int T;

  freopen("kcover.in", "r", stdin);
  freopen("kcover.out", "w", stdout);

  scanf("%d", &T);
  while (T--)
  {
    scanf("%d %d", &N, &K);
    
    x.clear();
    for (i = 0; i < N; i++)
    {
      scanf("%d", &j);
      x.push_back(j);
    }

    sort(x.begin(), x.end());

    d.clear();
    for (i = 1; i < N; i++)
      d.push_back((unsigned int)((long long)x[i] - (long long)x[i - 1]));

    L = (unsigned int) ((long long) x[N - 1] - (long long) x[0]);

    sort(d.begin(), d.end());

    for (j = N - 2; j > N - 2 - K + 1; j--)
      L -= d[j];

    printf("%u\n", L);
  }

  return 0;
}
