#include <stdio.h>
#include <string.h>

long ti, tj, n;
unsigned char t[100][100];
long dist[100][100];
struct {
	long i, j;
} pos[1001];

void read_in(void)
{
	int i, cnt, xi, xj, xn, xw, xe, xs;
	
	freopen("teste\\grader_test10.in", "r", stdin);
	scanf("%d%d%d%d%d%d", &n, &ti, &tj, &pos->i, &pos->j, &cnt);
	for(; cnt--; t[xi][xj] = xn | (xe << 1) | (xs << 2) | (xw << 3))
		scanf("%d%d%d%d%d%d", &xi, &xj, &xn, &xe, &xs, &xw);
	for(i = 1; i <= n; i++)
		scanf("%d%d", &pos[i].i, &pos[i].j);
}

#define TEST(xi, xj) \
	if(!dist[xi][xj]) \
		dist[xi][xj] = cnt, top->i = (xi), (top++)->j = (xj)
		
void get_dists(int i, int j)
{
	struct {
		int i, j;
	} q[10000], *bot, *top, *brk;
	int cnt = 1;
	
	memset(dist, 0, sizeof(dist));
	dist[q->i = i][q->j = j] = -1;
	for(bot = q, brk = top = q + 1; bot < top; bot++) {
		if(bot == brk)
			cnt++, brk = top;
		i = bot->i, j = bot->j;
		if(!(t[i][j] & 1))
			TEST(i, j + 1);
		if(!(t[i][j] & 2))
			TEST(i + 1, j);
		if(!(t[i][j] & 4))
			TEST(i, j - 1);
		if(!(t[i][j] & 8))
			TEST(i - 1, j);
	}
	dist[q->i][q->j] = 0;
}

int main()
{
	long a[1001], i, j, k;
	
	read_in();
	*a = 0;
	for(i = 1; i <= n; i++) {
		get_dists(pos[i].i, pos[i].j);
		k = dist[pos[i - 1].i][pos[i - 1].j];
		for(j = 0; j < i; j++)
			a[j] += k;
		for(j = 0; j < i; j++)
			if(a[i - 1] > a[j] - k + dist[pos[j].i][pos[j].j])
				a[i - 1] = a[j] - k + dist[pos[j].i][pos[j].j];
		a[i] = a[i - 1] + k;
	}
	fprintf(fopen("exit.out", "w"), "%d\n", a[n]);
	return(0);
}
