#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <vector>
#include <map>
using namespace std;

#define NMAX 50100
#define VISITED 1
#define MATCHED 2

vector<int> v[NMAX], sons[NMAX];
map<int, char> e[NMAX];
char marked[NMAX];
int i, j, k, p, q, N, M, li, ls, prevson;

int main()
{
	freopen("g2mm.in", "r", stdin);
	freopen("g2mm.out", "w", stdout);

	scanf("%d %d", &N, &M);

	for (k = 0; k < M; k++)
	{
		scanf("%d %d", &i, &j);
		v[i].push_back(j);
		v[j].push_back(i);

		e[i][j] = 1;
		e[j][i] = 1;
	}

	printf("1\n");

	memset(marked, 0, sizeof(marked));

	for (i = 1; i <= N; i++)
		if (!marked[i])
		{
			// search for a node at distance 2
			for (j = 0; j < v[i].size() && !marked[i]; j++)
			{
				k = v[i][j];

				for (p = 0; p < v[k].size() && !marked[i]; p++)
				{
					q = v[k][p];

					if (!marked[q] && !e[i][q] && q != i)
					{
						marked[i] = marked[q] = 1;
						printf("%d %d\n", i, q);
						break;
					}
				}
			}

			if (!marked[i])
			{
				// search for a node at distance 1

				for (j = 0; j < v[i].size(); j++)
				{
					k = v[i][j];

					if (!marked[k])
					{
						marked[i] = marked[k] = 1;
						printf("%d %d\n", i, k);
						break;
					}
				}

				if (!marked[i])
				{
					//fprintf(stderr, "bad choice: i=%d\n", i);
					do
					{
						j = 1 + (rand() % N);
					}
					while (i == j || marked[j]);

					marked[i] = marked[j] = 1;
					printf("%d %d\n", i, j);
				}
			}
		}

	return 0;
}
