#include <stdio.h>
#include <string.h>

#define KMAX 101
#define PMOD 41143

#define max(a, b) ((a) > (b) ? (a) : (b))

int np[2][KMAX], sumnp[2][KMAX];
int i, j, p, N, K, c, a;

int main()
{
	freopen("pkinv.in", "r", stdin);
	scanf("%d %d", &N, &K);

	memset(sumnp, 0, sizeof(sumnp));
	memset(np, 0, sizeof(np));

	np[a = c = 0][0] = 1 % PMOD;
	sumnp[0][0] = np[0][0];
	for (j = 1; j <= K; j++)
		sumnp[0][j] = (sumnp[0][j - 1] + np[0][j]) % PMOD;

	for (i = 1; i <= N; i++)
	{
		c = 1 - a;

		for (j = 0; j <= K; j++)
		{
			p = max(0, j - i + 1);

			if (p > 0)
				np[c][j] = (sumnp[a][j] - sumnp[a][p - 1] + PMOD) % PMOD;
			else
				np[c][j] = (sumnp[a][j]) % PMOD;
		}

		sumnp[c][0] = np[c][0];
		for (j = 1; j <= K; j++)
			sumnp[c][j] = (sumnp[c][j - 1] + np[c][j]) % PMOD;

		a = c;
	}

	freopen("pkinv.out", "w", stdout);
	printf("%d\n", np[c][K]);

	return 0;
}
