#include <cstdio>
#include <cassert>
#include <algorithm>

#ifdef WIN32
# define LL "%I64d"
#else
# define LL "%lld"
#endif

using namespace std;

int main()
{
  freopen("aisle.in", "r", stdin);
  freopen("aisle.out", "w", stdout);
  long long n, l, w, x, y, a;
  assert(scanf(LL LL LL LL LL LL, &n, &l, &w, &x, &y, &a) == 6);
  assert(1 <= n && n <= 10000);
  assert(1 <= l && l <= (int)1e9);
  assert(1 <= w && w <= (int)1e9);
  assert(1 <= x && x <= (int)1e9);
  assert(1 <= y && y <= (int)1e9);
  assert(1 <= a && a <= (int)1e9);
  if ((l / x) * ((w - a) / y) < n)
    puts("-1");
  else
    printf(LL "\n",
      min(n, 2 * ((w - (n + (l / x) - 1) / (l / x) * y) / a) * (l / x)));
  return 0;
}
