//  "  "
//       
//   :  ,  stankev@gmail.com      (???)
//  :  , ulyantsev@rain.ifmo.ru

//     Java,    ""  
//      ---   +  .
//  ,          

import java.io.*;
import java.util.*;

public class codes_vu_2 implements Runnable {
	final static String FILE = "codes";
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new codes_vu_2()).start();
	}

	public codes_vu_2() {
		try {
			in = new BufferedReader(new FileReader(FILE + ".in"));
			out = new PrintWriter(new File(FILE + ".out"));
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}	

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	int max;
	ArrayList<String> ans = new ArrayList();
	final int maxlen = 200;
	char[] prnt = new char[maxlen];
	char[] currentWord;

	class Node {
		boolean isEnd;
		Node[] child;             
		Node() {
			isEnd = false;
			child = new Node['z' + 1];
		}

		boolean add(int pos) {
			//System.out.println(pos + " " + s[pos]);
			if (pos == currentWord.length) {
				isEnd = true;
				return true; 
			}
			if (pos == max && child[currentWord[pos]] != null)
				return false;
			
			if (child[currentWord[pos]] == null) {
				child[currentWord[pos]] = new Node();
			}
			return child[currentWord[pos]].add(pos + 1);
		}
		
		void print(int len) {
			for (char i = 'a'; i <= 'z'; i++) {
				if (child[i] != null) {
					prnt[len] = i;
					child[i].print(len + 1);
				}
			}
			if (isEnd) {     
				String t = "";
				for (int i = 0; i < len; i++) {
					t += prnt[i];
				}
				ans.add(t);
			}
		}
	}	

	public void solve() throws IOException {
		int n = nextInt();
		max = nextInt();

		Node root = new Node();

		for (int i = 0; i < n; i++) {
			currentWord = nextToken().toCharArray();
			root.add(0);
		}

		//root.print(0);
		out.println(ans.size());
		for (String s : ans) {
			out.println(s);
		}

		in.close();
		out.close();
	}
}
