#include <cstdio>
#include <cassert>
#include <string>
#include <algorithm>

using namespace std;

#define m 100100
#define ml 202

int n, k, is[m];
char t[ml];
string s[m];

int lcp( string a, string b )
{
  int i = 0;
  while (i < a.length() && i < b.length() && a[i] == b[i])
    i++;
  return i;
}

int main()
{
  freopen("codes.in", "r", stdin);
  freopen("codes.out", "w", stdout);
  assert(scanf("%d%d", &n, &k) == 2);
  assert(1 <= n && n <= 100000);
  assert(0 <= k && k <= 200);
  gets(t);
  int sl = 0;
  for (int i = 0; i < n; i++)
  {
    assert(gets(t));
    s[i] = t;
    assert(s[i].length() <= 200);
    sl += s[i].length();
    is[i] = 0;
  }
  assert(sl <= 1000000);
  sort(s, s + n);
  int ans = 1;
  is[0] = 1;
  for (int i = 1; i < n; i++)
  {
    assert(s[i] != s[i - 1]);
    if (lcp(s[i - 1], s[i]) <= k)
      is[i] = 1, ans++;
  }
  printf("%d\n", ans);
  for (int i = 0; i < n; i++)
    if (is[i])
      puts(s[i].c_str());
  return 0;
}
