//  "  "
// 9-      
//  :  ,  
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class dfs_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new dfs_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "dfs";

	int[] a;

	ArrayList<Integer> ansx = new ArrayList<Integer>();
	ArrayList<Integer> ansy = new ArrayList<Integer>();

	void process(int l, int r) {
		ArrayList<Integer> stack = new ArrayList<Integer>();
		for (int i = l + 1; i <= r; i++) {
			if (stack.size() != 0 && a[i] == stack.get(stack.size() - 1)) {
				stack.remove(stack.size() - 1);
			} else {
				stack.add(a[i - 1]);
				for (int j = 0; j < stack.size(); j++) {
					if (j == stack.size() - 1 || (stack.get(j + 1) < a[i])) {
						ansx.add(stack.get(j));
						ansy.add(a[i]);
					}
				}
			}
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int l = nextInt();
		a = new int[l];
		for (int i = 0; i < l; i++) {
			a[i] = nextInt() - 1;
		}
		for (int i = 0; i < l; i++) {
			int j = l - 1;
			while (a[i] != a[j]) {
				j--;
			}
			process(i, j);
			i = j;
		}
		out.println(ansx.size());
		for (int i = 0; i < ansx.size(); i++) {
			out.println((ansx.get(i) + 1) + " " + (ansy.get(i) + 1));
		}
	}
}
