#include <stdio.h>

#define PROBLEM_ID      "gems"
#define MAXN            100000

char seq[MAXN + 1];
int good[26][26];
int count[26];

int main() {
    unsigned int answer;
    int n, k, i, u, v;
    char cur[3];

    freopen(PROBLEM_ID ".in", "r", stdin);
    freopen(PROBLEM_ID ".out", "w", stdout);

    scanf("%d %d\n", &n, &k);
    gets(seq);

    for (i = 0; i < k; i++) {
        gets(cur);
        u = cur[0] - 'a';
        v = cur[1] - 'a';
        good[u][v] = 1;
    }

    answer = 0;
    for (i = 0; i < n; i++) {
        int current = seq[i] - 'a';
        for (u = 0; u < 26; u++) {
            answer += (good[u][current] ? count[u] : 0);
        }
        count[current]++;
    }
    printf("%u\n", answer);
    return 0;
}
