#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

void out( vector <int> & v )
{
  int n = v.size();
  for (int i = 0; i < n; i++)
    printf("%d%c", v[i] + 1, i + 1 < n ? ' ' : '\n');
}

int main( void )
{
  freopen("shelves.in", "r", stdin);
  freopen("shelves.out", "w", stdout);
  int n, m;
  vector <int> a, b, ra, rb;
  int pa = 0, pb = 0;
  long long ha = 0, hb = 0, h = 0;
  
  scanf("%d%d", &n, &m);
  
  a = vector <int> (n);
  b = vector <int> (m);

  for (int i = 0; i < n; i++)
    scanf("%d", &a[i]);

  for (int i = 0; i < m; i++)
    scanf("%d", &b[i]);

  while (pa < n || pb < m)
  {
    if (pb == m || pa < n && ha + a[pa] < hb + b[pb])
      ra.push_back(pa), ha += a[pa++], h = ha;
    else
      rb.push_back(pb), hb += b[pb++], h = hb;
    while (pa < n && ha < h)
      ha += a[pa++];
    while (pb < n && hb < h)
      hb += b[pb++];
  }
  
  printf("%d %d\n", ra.size(), rb.size());
  out(ra);
  out(rb);
 
  return 0;
}