// Задача "Шкафы"
// IX Всероссийская командная олимпиада школьников по программированию
// Автор задачи: Владимир Гуровиц
// Автор решения: Олег Давыдов, burunduk3@gmail.com
#include <cstdio>
#include <vector>

using namespace std;

typedef long long ll;
typedef vector <int> vi;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

#define maxn 100010

int m, n;
int a[maxn], b[maxn];

int main()
{
  freopen("shelves.in", "r", stdin);
  freopen("shelves.out", "w", stdout);

  scanf("%d%d", &m, &n);
  forn (i, m)
    scanf("%d", &a[i]);
  forn (i, n)
    scanf("%d", &b[i]);

  int i = 0, j = 0;
  ll ha = 0, hb = 0, hh = 0;
  vi va, vb;
  while (i < m || j < n)
  {
    if (j == n || i < m && ha + a[i] < hb + b[j])
      va.pb(i), ha += a[i++], hh = ha;
    else
      vb.pb(j), hb += b[j++], hh = hb;
    while (i < m && ha < hh)
      ha += a[i++];
    while (j < n && hb < hh)
      hb += b[j++];
  }

  printf("%d %d\n", va.size(), vb.size());
  forn (i, va.size())
    printf("%d%c", va[i] + 1, "\n "[i < (int)va.size() - 1]);
  forn (i, vb.size())
    printf("%d%c", vb[i] + 1, "\n "[i < (int)vb.size() - 1]);

  return 0;
}
