//  " "
//       
//   :  , ulyantsev@rain.ifmo.ru
//  :  , ulyantsev@rain.ifmo.ru

//  ,   .  vu_slow   .
// Up:  !   

uses
	math;
const
	maxv = 100;
	maxt = 1000;
	inf = 1000000000;
	
var
	v, r, t : longint;
	w : extended;
	fi, minx, miny, maxx, maxy : extended;
	eps : extended;

procedure relax(x : extended; y : extended);
begin
	maxx := max(x, maxx);
	maxy := max(y, maxy);
	minx := min(minx, x);
	miny := min(miny, y);
end;

begin
	assign(input, 'spiral.in');
	reset(input);
	assign(output, 'spiral.out');
	rewrite(output);

	read(w, v, r, t);
	assert((1 <= w) and (w <= maxv), 'w is out of bounds');
	assert((1 <= v) and (v <= maxv), 'v is out of bounds');		
	assert((0 <= r) and (r <= maxv), 'r is out of bounds');
	assert((1 <= t) and (t <= maxt), 't is out of bounds');
	minx := inf;
	miny := inf;
	maxx := -inf;
	maxy := -inf;

	//  
	w := w * PI / 180;
	
	//eps := 5e-7 * min(2 * PI, w * t);
	eps := 1e-5 * 2 * PI;
	fi := w * t;
	while (fi >= max(w * t - 2 * PI, 0)) do begin
		relax((r + v * fi / w) * cos(fi), (r + v * fi / w) * sin(fi));
		fi := fi - eps;
	end;
	relax(r, 0);

	writeln(minx:0:10, ' ', miny:0:10);
	writeln(maxx:0:10, ' ', maxy:0:10);
end.
