//  "-"
// XVI    -  
//  :  , feskov@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class fitness_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new fitness_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "fitness";

	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		int c = 0;
		for (int i = 0; i < n; i++) {
			int a = nextInt();
			int b = nextInt();
			c = Math.max(c - a, b);
		}
		out.println(k - c);
	}
}
