//  " "
// XVI    -  
//  :  , ulyantsev@rain.ifmo.ru
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class lucky_sp_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new lucky_sp_wrong()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "lucky";

	public void solve() throws IOException {
		String s = br.readLine();
		int n = s.length();
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = s.charAt(i) - '0';
		}
		
		{
			int i = n - 1;
			while (i >= 0 && a[i] == 9) {
				i++;
			}
			if (i < 0) {
				out.println("NO");
				return;
			}
			a[i]++;
			for (i++; i < n; i++) {
				a[i] = 0;
			}
		}
		
		int s1 = 0;
		int s2 = 0;
		for (int i = 0; i < n; i++) {
			if ((n - i) % 2 == 1) {
				s1 += a[i];
			} else {
				s2 += a[i];
			}
		}
		
		int t = Math.abs(s1 - s2);
		for (int i = n - 1; i >= 0; i--) {
			if ((s1 < s2 && (n - i) % 2 == 1) || (s1 > s2 && (n - i) % 2 == 0)) {
				if (t >= 9 - a[i]) {
					t -= 9 - a[i];
					a[i] = 9;
				} else {
					a[i] += t;
					t = 0;
				}
			} 
			if ((s1 > s2 && (n - i) % 2 == 1) || (s1 < s2 && (n - i) % 2 == 0)) {
				if (t > a[i]) {
					t -= a[i];
					a[i] = 0;
				} else {
					a[i] -= t - 1;
					t = 1;
				}
			}
			if (t == 0) {
				break;
			}
		}
		
		if (t != 0) {
			out.println("NO");
			return;
		}
		for (int i = 0; i < n; i++) {
			out.print(a[i]);
		}
	}
}
