import java.io.*;
import java.util.*;

public class palin_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new palin_aa()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "palin";

	private void solve() throws IOException {
		char[] a = nextToken().toCharArray();
		int k = (a.length + 1) % 2;
		for (int i = 0; i < a.length; i++) {
			boolean good = true;
			for (int j = 0; j <= a.length / 2; j++) {
				good &= a[(i + j) % a.length] == a[(i - k - j + a.length)
						% a.length];
			}
			if (good) {
				out.println("yes");
				return;
			}
		}
		out.println("no");
	}

}
