//  ""
// XVI    -  
//  :  , burunduk3@gmail.com
//  :  , poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class theater_sp_wrong implements Runnable {

	public static void main(String[] args) {
		new Thread(new theater_sp_wrong()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "theater";
	
	double[][] tab;
	double[] dist;
	int[] last;
	
	void countDist(int n) {
		for (int i = 4; i < (1 << n); i++) {
			if ((i & 3) != 3) {
				continue;
			}
			for (int j = 2; j < n; j++) {
				if ((i & (1 << j)) != 0) {
					double d = dist[i ^ (1 << j)];
					d += tab[last[i ^ (1 << j)]][j] + tab[j][1] - tab[last[i ^ (1 << j)]][1];
					if (dist[i] > d) {
						dist[i] = d;
						last[i] = j;
					}
				}
			}
		}
	}

	public void solve() throws IOException {
		int w = nextInt();
		int l = nextInt();
		int v1 = nextInt();
		int v2 = nextInt();
		int n = nextInt();
		int[] x = new int[n];
		int[] y = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = nextInt();
			y[i] = nextInt();
		}
		tab = new double[n + 2][n + 2];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				tab[i + 2][j + 2] = Math.hypot(x[i] - x[j], y[i] - y[j]);
				tab[j + 2][i + 2] = tab[i + 2][j + 2];
			}
		}
		
		for (int i = 0; i < n; i++) {
			tab[0][i + 2] = x[i];
			tab[i + 2][0] = x[i];
			tab[1][i + 2] = x[i];
			tab[i + 2][1] = x[i];
		}
		dist = new double[1 << (n + 2)];
		last = new int[1 << (n + 2)];
		Arrays.fill(dist, Double.POSITIVE_INFINITY);
		dist[3] = 0;
		countDist(n + 2);
		double[] d1 = dist;

		for (int i = 0; i < n; i++) {
			tab[0][i + 2] = l - x[i];
			tab[i + 2][0] = l - x[i];
			tab[1][i + 2] = l - x[i];
			tab[i + 2][1] = l - x[i];
		}
		dist = new double[1 << (n + 2)];
		last = new int[1 << (n + 2)];
		Arrays.fill(dist, Double.POSITIVE_INFINITY);
		dist[3] = 0;
		countDist(n + 2);
		double[] d2 = dist;

		tab[0][1] = l;
		tab[1][0] = l;
		for (int i = 0; i < n; i++) {
			tab[0][i + 2] = x[i];
			tab[i + 2][0] = x[i];
			tab[1][i + 2] = l - x[i];
			tab[i + 2][1] = l - x[i];
		}
		dist = new double[1 << (n + 2)];
		last = new int[1 << (n + 2)];
		Arrays.fill(dist, Double.POSITIVE_INFINITY);
		dist[3] = l;
		countDist(n + 2);
		double[] d3 = dist;
		
		int m = nextInt();
		boolean[] oldstate = new boolean[n];
		{
			int tn = nextInt();
			for (int i = 0; i < tn; i++) {
				oldstate[nextInt() - 1] = true;
			}
		}
		double[][] a = new double[m][4];
		for (int ii = 0; ii < m - 1; ii++) {
			boolean[] state = new boolean[n];
			int tn = nextInt();
			for (int i = 0; i < tn; i++) {
				state[nextInt() - 1] = true;
			}
			
			int q1 = 3;
			int q2 = 3;
			for (int i = 0; i < n; i++) {
				if (state[i] && !oldstate[i]) {
					q1 |= (1 << (i + 2));
				}
				if (!state[i] && oldstate[i]) {
					q2 |= (1 << (i + 2));
				}
			}
			a[ii + 1][0] = a[ii][0] + Math.max(d1[q1] / v1, d1[q2] / v2);
			a[ii + 1][0] = Math.min(a[ii + 1][0], a[ii][1] + Math.max(d1[q1] / v1, d3[q2] / v2));
			a[ii + 1][0] = Math.min(a[ii + 1][0], a[ii][2] + Math.max(d3[q1] / v1, d1[q2] / v2));
			a[ii + 1][0] = Math.min(a[ii + 1][0], a[ii][3] + Math.max(d3[q1] / v1, d3[q2] / v2));

			a[ii + 1][1] = a[ii][0] + Math.max(d1[q1] / v1, d3[q2] / v2);
			a[ii + 1][1] = Math.min(a[ii + 1][0], a[ii][1] + Math.max(d1[q1] / v1, d2[q2] / v2));
			a[ii + 1][1] = Math.min(a[ii + 1][0], a[ii][2] + Math.max(d3[q1] / v1, d3[q2] / v2));
			a[ii + 1][1] = Math.min(a[ii + 1][0], a[ii][3] + Math.max(d3[q1] / v1, d2[q2] / v2));

			a[ii + 1][2] = a[ii][0] + Math.max(d3[q1] / v1, d1[q2] / v2);
			a[ii + 1][2] = Math.min(a[ii + 1][0], a[ii][1] + Math.max(d3[q1] / v1, d3[q2] / v2));
			a[ii + 1][2] = Math.min(a[ii + 1][0], a[ii][2] + Math.max(d2[q1] / v1, d3[q2] / v2));
			a[ii + 1][2] = Math.min(a[ii + 1][0], a[ii][3] + Math.max(d2[q1] / v1, d3[q2] / v2));

			a[ii + 1][3] = a[ii][0] + Math.max(d3[q1] / v1, d3[q2] / v2);
			a[ii + 1][3] = Math.min(a[ii + 1][0], a[ii][1] + Math.max(d3[q1] / v1, d2[q2] / v2));
			a[ii + 1][3] = Math.min(a[ii + 1][0], a[ii][2] + Math.max(d2[q1] / v1, d3[q2] / v2));
			a[ii + 1][3] = Math.min(a[ii + 1][0], a[ii][3] + Math.max(d2[q1] / v1, d2[q2] / v2));
			oldstate = state;
		}
		double ans = Math.min(a[m - 1][0], Math.min(a[m - 1][1], Math.min(a[m - 1][2], a[m - 1][3])));
		out.println(ans);
	}
}
