#define _CRT_SECURE_NO_WARNINGS

#include <vector>
#include <algorithm>
#include <set>
#include <cstdio>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

const int MAXN = 200000;
const int MAXM = 200000;

int n, m;
vector<int> e[MAXN + 2];
int cnt[MAXM];
int ans;

void outdata() {
}

void solve() {
    ans = 0;
    forn(i, n) {
        int x;
        scanf("%d", &x);
        assert(1 <= x && x <= n);
        --x;
        vector<int>& q = e[x];
        forn(t, q.size()) {
            if (!(--cnt[q[t]])) {
                ++ans;                
            }
        }
        printf("%d\n", ans);
        fflush(stdout);
    }
}

void readdata() {
    scanf("%d", &n);
    assert(1 <= n && n <= MAXN);
    scanf("%d", &m);
    assert(1 <= m && m <= MAXM);
    forn(i, m) {
        int l, r;
        scanf("%d%d", &l, &r);
        assert(1 <= l && l <= r && r <= n);
        --l;
        --r;
        for(int j = l; j <= r; ++j) {
            e[j].push_back(i);
        }
        cnt[i] = r - l + 1;
    }
}

int main() {
	readdata();
	solve();
	outdata();
	return 0;
}
