#include <cstdio>
#include <cctype>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

const int mlen = (int)1e6 + 1;

struct num
{
  static int zero;
  int a[mlen];

  int & operator [] ( int i )
  {
    return (0 <= i && i < mlen) ? a[i] : zero;
  }
};
int num::zero = 0;

void Read( num &a )
{
  static char s[mlen];
  gets(s);
  int n = strlen(s);
  reverse(s, s + n);
  forn(i, n)
    a[i] = s[i] - (isdigit(s[i]) ? '0' : 'A' - 10);
}

num a, b, c;
int f[31 * 31];

int main()
{
  forn(i, 31 * 31)
    f[i] = (i + 30) / 31;
  Read(a), Read(b);

  int k = 0;
  while (b[k] == 0)
    k++;
  forn(i, mlen)
    a[i] = a[i + k], b[i] = b[i + k];

  int rev = 1;
  while ((rev * b[0]) % 31 != 1)
    rev++;
  scanf("%d", &k);
  int *a1 = a.a - 1, *b1 = b.a;
  forn(i, k)
  {
    a1++;
    int x = (rev * a1[0]) % 31;
    c[i] = x;
    if (!x)
      continue;
    forn(j, k - i)
      if ((a1[j] -= b1[j] * x) < 0)
      {
        int t = f[-a1[j]];
        a1[j] += 31 * t;
        a1[j + 1] -= t;
      }
  }
  for (int i = k - 1; i >= 0; i--)
    printf("%c", c[i] < 10 ? ('0' + c[i]) : ('A' + c[i] - 10));
  return 0;
}
