#include <cstdio>
#include <cassert>

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 16

int n, k = 0, x[maxn], zero, one;
char f[(1 << maxn) + 1];
int res[256];
int res2[65536];

int gen( int i, int pr )
{
  if (i == n - 1)
  {
    int f0 = f[pr] - '0', f1 = f[pr | (1 << (n - i - 1))] - '0';
    int res[2][2] = {{zero, -n}, {n, one}};
    return res[f0][f1];
  }

  int st = 0, st2 = 0;
  if (i == n - 3)
  {
    forn(j, 1 << 3)
      st |= (f[pr | j] - '0') << j;
    assert(0 <= st && st < 256);
    if (res[st])
      return res[st];
  }
  if (i == n - 4)
  {
    forn(j, 1 << 4)
      st2 |= (f[pr | j] - '0') << j;
    assert(0 <= st2 && st2 < 65536);
    if (res2[st2])
      return res2[st2];
  }

  int t0 = gen(i + 1, pr);
  int t1 = gen(i + 1, pr | (1 << (n - i - 1)));

  printf("& %d %d\n", -(i + 1), t1), k++;
  printf("& %d %d\n", (i + 1), t0), k++;
  printf("| %d %d\n", k - 1, k), k++;

  if (i == n - 3)
    res[st] = k;
  if (i == n - 4)
    res2[st2] = k;
  return k;
}

int main()
{
  scanf("%d ", &n);
  gets(f);
  forn(i, n)
    printf("! %d\n", -(i + 1)), ++k;
  printf("& %d %d\n", 1, -1), zero = ++k;
  printf("| %d %d\n", 1, -1), one = ++k;
  gen(0, 0);
  return 0;
}
