#include <cstdio>
#include <cassert>
#include <map>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 16

int n, k = 0, x[maxn], zero, one;
char f[(1 << maxn) + 1];

typedef unsigned long long ll;

map <ll, int> m[maxn];

int gen( int i, int pr )
{
  if (i == n - 1)
  {
    int f0 = f[pr] - '0', f1 = f[pr | (1 << (n - i - 1))] - '0';
    int res[2][2] = {{zero, -n}, {n, one}};
    return res[f0][f1];
  }

  ll st = 0;
  if (n - i <= 6)
  {
    forn(j, 1 << (n - i))
      st |= (ll)(f[pr | j] - '0') << j;
    if (m[i][st])
      return m[i][st];
  }

  int t0 = gen(i + 1, pr);
  int t1 = gen(i + 1, pr | (1 << (n - i - 1)));

  printf("& %d %d\n", -(i + 1), t1), k++;
  printf("& %d %d\n", (i + 1), t0), k++;
  printf("| %d %d\n", k - 1, k), k++;

  if (n - i <= 6)
    m[i][st] = k;
  return k;
}

int main()
{
  scanf("%d ", &n);
  gets(f);
  forn(i, n)
    printf("! %d\n", -(i + 1)), ++k;
  printf("& %d %d\n", 1, -1), zero = ++k;
  printf("| %d %d\n", 1, -1), one = ++k;
  gen(0, 0);
  return 0;
}
