#include <cstdio>
#include <cassert>
#include <map>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 16

int out, p[maxn];
int cur, ans = (int)1e9, mp[maxn];

int n, k, x[maxn], zero, one;
char f[(1 << maxn) + 1];

typedef unsigned long long ll;

map <ll, int> m[maxn];

int gen( int i, int pr )
{
  if (i == n - 1)
  {
    int f0 = f[pr] - '0', f1 = f[pr | (1 << (n - p[i] - 1))] - '0';
    int res[2][2] = {{zero, -(p[i] + 1)}, {p[i] + 1, one}};
    return res[f0][f1];
  }

  ll st = 0;
  if (n - i <= 6)
  {
    forn(j, 1 << (n - i))
    {
      int pr1 = pr;
      forn(t, n - i)
        if ((j >> t) & 1)
          pr1 |= 1 << (n - p[i + t] - 1);
      st |= (ll)(f[pr1] - '0') << j;
    }
    if (m[i][st])
      return m[i][st];
  }

  int t0 = gen(i + 1, pr);
  int t1 = gen(i + 1, pr | (1 << (n - p[i] - 1)));

  if (out) printf("& %d %d\n", -(p[i] + 1), t1); k++;
  if (out) printf("& %d %d\n", (p[i] + 1), t0); k++;
  if (out) printf("| %d %d\n", k - 1, k); k++;

  if (n - i <= 6)
    m[i][st] = k;
  return k;
}

int Solve()
{
  k = 0;
  forn(i, n)
    m[i].clear();
  forn(j, n)
  {
    if (out) printf("! %d\n", -(j + 1)); ++k;
  }
  if (out) printf("& %d %d\n", 1, -1); zero = ++k;
  if (out) printf("| %d %d\n", 1, -1); one = ++k;
  gen(0, 0);
  fprintf(stderr, "%d\n", k);
  return k;
}

int main()
{
  scanf("%d ", &n);
  gets(f);

  forn(i, n)
    p[i] = i;
  out = 0;
  forn(t, 50)
  {
    if (ans > (cur = Solve()))
      memcpy(mp, p, sizeof(p)), ans = cur;
    random_shuffle(p, p + n);
  }
  out = 1;
  memcpy(p, mp, sizeof(p));
  fprintf(stderr, "ans=%d\n", ans);
  Solve();
  return 0;
}
