#include <cstdio>
#include <cassert>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

#define maxn 16

int out, p[maxn];
int cur, ans = (int)1e9, mp[maxn];

int n, k, x[maxn], zero, one;
char f[(1 << maxn) + 1];

typedef unsigned long long ll;

map <ll, int> m[maxn];

int gen( int i, int pr )
{
  if (i == n - 1)
  {
    int f0 = f[pr] - '0', f1 = f[pr | (1 << (n - p[i] - 1))] - '0';
    int res[2][2] = {{zero, -(p[i] + 1)}, {p[i] + 1, one}};
    return res[f0][f1];
  }

  ll st = 0;
  if (n - i <= 6)
  {
    forn(j, 1 << (n - i))
    {
      int pr1 = pr;
      forn(t, n - i)
        if ((j >> t) & 1)
          pr1 |= 1 << (n - p[i + t] - 1);
      st |= (ll)(f[pr1] - '0') << j;
    }
    if (m[i][st])
      return m[i][st];
  }

  int t0 = gen(i + 1, pr);
  int t1 = gen(i + 1, pr | (1 << (n - p[i] - 1)));

  printf("& %d %d\n", -(p[i] + 1), t1), k++;
  printf("& %d %d\n", (p[i] + 1), t0), k++;
  printf("| %d %d\n", k - 1, k), k++;

  if (n - i <= 6)
    m[i][st] = k;
  return k;
}

int Solve()
{
  k = 0;
  if (out)
  {
    forn(i, n)
      m[i].clear();
    forn(j, n)
      printf("! %d\n", -(j + 1)), k++;
    printf("& %d %d\n", 1, -1), zero = ++k;
    printf("| %d %d\n", 1, -1), one = ++k;
    gen(0, 0);
    return 0;
  }

  k = n + 2;
  for (int i = 0; n - i > 6; i++)
    k += (1 << i) * 3;
  for (int i = n - 6; i < n - 3; i++)
  {
    static int m[1 << maxn];
    int mk = 0;

    forn(x, 1 << i)
    { 
      int pr = 0;
      forn(t, i)
        if ((x >> t) & 1)
          pr |= 1 << (n - p[t] - 1);

      int st = 0;
      forn(j, 1 << (n - i))
      {
        int pr1 = pr;
        forn(t, n - i)
          if ((j >> t) & 1)
            pr1 |= 1 << (n - p[i + t] - 1);
        st |= (ll)(f[pr1] - '0') << j;
      }
      m[mk++] = st;
    }
    sort(m, m + mk);
    forn(i, mk)
      if (!i || m[i - 1] != m[i])
        k += 3;
  }
  for (int i = n - 3; i < n - 1; i++)
    k += 3 * (1 << (1 << (n - i)));

//  fprintf(stderr, "%d\n", k);
  return k;
}

int main()
{
  scanf("%d ", &n);
  gets(f);

  forn(i, n)
    p[i] = i;
  out = 0;
  forn(t, 500)
  {
    if (ans > (cur = Solve()))
      memcpy(mp, p, sizeof(p)), ans = cur;
    random_shuffle(p, p + n);
  }
  out = 1;
  memcpy(p, mp, sizeof(p));
  fprintf(stderr, "ans=%d\n", ans);
  forn(i, n)
    fprintf(stderr, "%d ", p[i]);
  fprintf(stderr, "\n");
  Solve();
  return 0;
}
