#include <cstdio>
#include <cstring>

#ifdef _WIN32
#  define I64 "%I64d"
#else
#  define I64 "%Ld"
#endif

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef unsigned long long ll;

#define rest(a, i) ((a) & ((1 << (i)) - 1))

#define maxn (int)1e7
#define maxk 15

int N, K, P, Q, a[maxn];

int st, num[maxk][1 << maxk];
ll sum;

void dfs( int i, int x, int y )
{
  int z = x + y;
  if (!num[i][x] || !num[i][y])
    return;
  if (i == 0)
  {
    if ((z >> st) & 1)
      sum += (ll)num[i][x] * num[i][y];
  }
  else
    forn(x1, 2)
      forn(y1, 2)
        dfs(i - 1, x * 2 + x1, y * 2 + y1);
}

int main()
{
  scanf("%d%d%d%d", &N, &K, &P, &Q);
  a[0] = 1;
  for (int i = 1; i < N; i++)
    a[i] = rest(a[i - 1] * P + Q, K);
  forn(i, K + 1)
  {
    st = i, sum = 0;
    memset(num, 0, sizeof(num));
    for (int x = st; x >= 0; x--)
      forn(j, N)
        num[x][rest(a[j] >> x, st + 1 - x)]++;
    forn(x, 2)
      forn(y, 2)
        dfs(st, x, y);
    printf(I64 " ", sum);
  }
  return 0;
}
