#include <cstdio>
#include <cstring>

#ifdef _WIN32
#  define I64 "%I64d"
#else
#  define I64 "%Ld"
#endif

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef unsigned long long ll;

#define rest(a, i) ((a) & ((1 << (i)) - 1))

#define maxn (int)1e6
#define maxk 21

int N, K, P, Q, a[maxn];

int mpos = 0, mem[1 << (maxk + 1)];
int st, *num[maxk];
ll sum;

void dfs( int i, int x, int y )
{
  int z = x + y;
  if (!num[i][x] || !num[i][y])
    return;
  if (i == 0 || (i != st && (z & 1) == 0))
  {
    if ((z >> (st - i)) & 1)
      sum += (ll)num[i][x] * num[i][y];
  }
  else
    forn(x1, 2)
      forn(y1, 2)
        dfs(i - 1, x * 2 + x1, y * 2 + y1);
}

int main()
{
  scanf("%d%d%d%d", &N, &K, &P, &Q);
  a[0] = 1;
  for (int i = 1; i < N; i++)
    a[i] = rest(a[i - 1] * P + Q, K);
  forn(i, K + 1)
  {
    st = i, sum = 0, mpos = 0;
    for (int x = st; x >= 0; x--)
    {
      int len = st - x + 1;
      num[x] = mem + mpos; mpos += 1 << len;
      memset(num[x], 0, sizeof(int) << len);
      forn(j, N)
        num[x][rest(a[j] >> x, len)]++;
    }
    forn(x, 2)
      forn(y, 2)
        dfs(st, x, y);
    printf(I64 " ", sum);
  }
  return 0;
}
