#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

#define m 100100
#define mod 1000000007
#define inv2 500000004

int n, k, t, q[m], fi, la, l[m], o[m], w[m];
bool is[m], u[m];
vector <int> c[m], z[m], p[m];

int main()
{
  assert(scanf("%d%d%d", &n, &k, &t) == 3);
  assert(2 <= n && n <= 100000);
  assert(1 <= k && k <= 500000);
  assert(2 <= t && t <= n);
  for (int i = 0; i < n; i++)
    w[i] = 0, is[i] = false, u[i] = false;
  fi = la = 0;
  for (int i = 0; i < t; i++)
  {
    int x;
    assert(scanf("%d", &x) == 1);
    assert(1 <= x && x <= n);
    x--;
    assert(!is[x]);
    is[x] = true;
    l[x] = 0, o[x] = x, u[x] = true, q[la++] = x;
  }
  for (int i = 0; i < k; i++)
  {
    int a, b;
    assert(scanf("%d%d", &a, &b) == 2);
    assert(1 <= a && a <= n);
    assert(1 <= b && b <= n);
    assert(a != b);
    a--, b--;
    c[a].push_back(b);
    c[b].push_back(a);
  }
  for (int i = 0; i < n; i++)
  {
    sort(c[i].begin(), c[i].end());
    for (int j = 1; j < (int)c[i].size(); j++)
      assert(c[i][j] != c[i][j - 1]);
  }
  while (fi < la)
  {
    int x = q[fi++], lx = l[x] + 1;
    for (int i = 0; i < (int)c[x].size(); i++)
    {
      int v = c[x][i];
      if (!u[v])
        q[la++] = v, u[v] = true, l[v] = lx, o[v] = o[x];
      else if (l[v] == lx)
        z[v].push_back(o[x]);
    }
  }
  for (int i = 0; i < n; i++)
    assert(u[i]);
  for (int i = 0; i < n; i++)
    p[l[i]].push_back(i);
  for (int i = 0; i < n; i++)
    if (is[i])
      w[i] = 1;
  for (int i = 0; i < n; i++)
    for (int j = 0; j < (int)p[i].size(); j++)
    {
      int v = p[i][j];
      for (int k = 0; k < (int)c[v].size(); k++)
      {
        int u = c[v][k];
        if (o[u] == o[v] && l[u] == l[v] + 1)
          w[u] = (w[u] + w[v]) % mod;
      }
    }
  int ansl = n + 1, ansv = 0;
  for (int i = 0; i < n; i++)
  {
    if (z[i].size() > 0)
    {
      int t = l[i] * 2;
      if (ansl > t)
        ansl = t, ansv = 0;
      if (ansl == t)
      {
        vector <pair <int, int> > a;
        for (int j = 0; j < (int)c[i].size(); j++)
        {
          int v = c[i][j];
          if (o[v] != o[i] && l[v] + 1 == l[i])
            a.push_back(make_pair(o[v], w[v]));
        }
        sort(a.begin(), a.end());
        int cur = 0, sum = w[i], sumsq = (int)(((long long)w[i] * w[i]) % mod);
        for (int j = 0; j < (int)a.size(); j++)
        {
          sum += a[j].second;
          if (j == 0 || a[j].first == a[j - 1].first)
            cur += a[j].second;
          else
          {
            sumsq = (int)((sumsq + (long long)cur * cur) % mod);
            cur = a[j].second;
          }
        }
        sumsq = (int)((sumsq + (long long)cur * cur) % mod);
        ansv = (int)((ansv + (long long)sum * sum - sumsq) % mod);
      }
    }
    for (int j = 0; j < (int)c[i].size(); j++)
    {
      int v = c[i][j];
      if (o[v] != o[i] && l[i] == l[v])
      {
        int t = l[v] + l[i] + 1;
        if (ansl > t)
          ansl = t, ansv = 0;
        if (ansl == t)
          ansv = (int)((ansv + (long long)w[v] * w[i]) % mod);
      }
    }
  }
  assert(ansl <= n);
  ansv = (int)(((long long)ansv * inv2) % mod);
  printf("%d %d\n", ansl, ansv);
  return 0;
}
