#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "triangles"

using namespace std;

const int MinN = 1, MaxN = 26, MaxL = 1 << MaxN; // , MaxH = 1 << 20;

int f [2] [MaxL];
// int h [2] [MaxH];
int n;

//   1 2         x 2
//  0 . .  ->   0 1 .

int main (void)
{
 int b, i, j, k, m;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
// while (scanf (" %d %d", &n, &m) != EOF)
 for (n = MaxN; n <= MaxN; n++)
 {
  assert (MinN <= n && n <= MaxN);
  b = 0;
  memset (f[b], 0, sizeof (f[b]));
  f[b][0] = 1;
  for (i = 1; i <= n; i++)
  {
   m = 1 << i;
   b ^= 1;
   memset (f[b], 0, sizeof (f[b]));
   for (k = 0; k < m; k++)
    f[b][k << 1] = f[!b][k];
   m <<= 1;
   for (j = 1; j <= i; j++)
   {
    b ^= 1;
    memset (f[b], 0, sizeof (f[b]));
    for (k = 0; k < m; k++) if (f[!b][k])
     if (k & (1 << j))
     {
      f[b][k ^ (1 << j)] += f[!b][k];
     }
     else
     {
      if (!(k & (1 << (j - 1))))
       f[b][k ^ (3 << (j - 1))] += f[!b][k];
      if (j < i && !(k & (1 << (j + 1))))
       f[b][k ^ (3 << j)] += f[!b][k];
     }
    int count = 0;
    for (k = 0; k < m; k++)
     if (f[b][k])
      count++;
    printf ("i = %d, j = %d, count = %d\n", i, j, count);
   }
   printf ("%d: %d\n", i, f[b][0]);
   fflush (stdout);
  }
 }
 return 0;
}
