#include <iostream>
#include <fstream>
#include <cstdio>
#include <cassert>

using namespace std;

const int MAXL = 10000;

char s[MAXL];
int l;

void Load()
{
	char c = getchar();
	while (! ((c >= 'a') && (c <= 'z'))) c = getchar();
	l = 0;
	while ((c >= 'a') && (c <= 'z'))
	{
		s[l++] = c;
		c = getchar();
	}
}

bool EQ(int i1, int j1, int i2, int j2)
{
	int k1, k2;
	for (k1 = i1, k2 = i2; k1 <= j1 && k2 <= j2; k1++, k2++)
	{
		if (s[k1] != s[k2]) return false;
	}
	return true;
}

void Solve()
{
	int i, j, k;
	int mres = l + 1;
	int mi, mj;
	mi = 0;
	mj = l - 1;
	for (i = 0; i < l; i++)
	{
		for (j = i; j < l; j++)
		{
			int cnum = 0;
			for (k = 0; k < l; )
			{
				if (k + (j - i) < l && EQ(i, j, k, k + (j - i)))
				{
					cnum++;
					k += (j - i + 1);
				}
				else
				{
					k++;
				}
			}
			//cerr << "i = " << i << " j = " << j << " cnum = " << cnum << "\n";
			int cr = l - (j - i + 1) * cnum + cnum + (j - i + 1);
			if (cr < mres)
			{
				mres = cr;
				mi = i;
				mj = j;
			}
		}
	}
	if (mres > l)
	{
		printf("\n%s\n", s);
		return;
	}
	for (i = mi; i <= mj; i++) printf("%c", s[i]);
	printf("\n");
	for (k = 0; k < l; )
	{
		if (k + (mj - mi) < l && EQ(mi, mj, k, k + (mj - mi)))
		{
			printf("A");
			k += (mj - mi + 1);
		}
		else
		{
			printf("%c", s[k]);
			k++;
		}
	}
	printf("\n");
}

int main()
{
	Load();
	Solve();
	return 0;
}
