#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

typedef long long int64;

using namespace std;

const int MinN = 1, MaxN = 10000;
const int Prime = 262139, MaxHash = 1 << 15, AndHash = MaxHash - 1, NA = -1;

char s [MaxN + 2];
char a [MaxN + 2];
int64 c [MaxN];
short v [MaxN];
int64 h [MaxHash];
short p [MaxHash];
short r [MaxHash];
int n;

int main (void)
{
 int i, j, k, l, res, temp;
 while (scanf (" %10001s", s) != EOF)
 {
  n = strlen (s);
  assert (MinN <= n && n <= MaxN);
  for (i = 0; i < n; i++)
   assert ('a' <= s[i] && s[i] <= 'z');
  for (i = 0; i < n; i++)
   s[i] -= 'a';
  memset (h, NA, sizeof (h));
  res = n;
  a[0] = '\0';

  memset (c, 0, sizeof (c));
  for (l = 1; l + l < n; l++)
  {
   temp = 0;
   j = NA;
   for (i = 0; i <= n - l; i++)
   {
    c[i] = c[i] * Prime + s[i + l - 1];
    int cur = c[i] & AndHash;
    while (h[cur] != c[i] && h[cur] != NA)
     cur = (cur + 1) & AndHash;
    v[i] = cur;
    if (h[cur] == NA)
    {
     h[cur] = c[i];
     p[cur] = i + l;
     r[cur] = 1;
    }
    else if (p[cur] <= i)
    {
     p[cur] = i + l;
     r[cur]++;
    }
    if (temp < r[cur])
    {
     temp = r[cur];
     j = i;
    }
   }

   temp = n + l - temp * (l - 1);
   if (res > temp)
   {
    res = temp;
    for (k = 0; k < l; k++)
     a[k] = s[j + k] + 'a';
    a[l] = '\0';
   }

   for (i = 0; i <= n - l; i++)
    h[v[i]] = NA;
  }

  for (i = 0; i < n; i++)
   s[i] += 'a';
  printf ("%s\n", a);
  l = strlen (a);
  for (i = 0; i < n; i++)
   if (a[0] != '\0' && strstr (s + i, a) == s + i)
   {
    putchar ('A');
    i += l - 1;
   }
   else
    putchar (s[i]);
  putchar ('\n');
 }
 return 0;
}
