#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

long long area(const vector<long long>& xs, const vector<long long>& ys, int a, int b, int c) {
  long long res = xs[a] * ys[b] - xs[b] * ys[a] + xs[b] * ys[c] - xs[c] * ys[b] + xs[c] * ys[a] - xs[a] * ys[c];
  if (res < 0)
    res = -res;
  return res;
}

int main() {
  int n;
  cin >> n;
  vector<long long> xs(n, 0);
  vector<long long> ys(n, 0);
  for (int i = 0; i < n; ++i) {
    cin >> xs[i] >> ys[i];
  }
  long long res = 0;
  for (int i = 0; i < n; ++i) {
    for (int j = 1, k = 1; j < n; ++j) {
      if (k < j)
        k = j;
      long long cur = 0;
      for (; k < n; ++k) {
        long long next = area(xs, ys, i, (i + j) % n, (i + k) % n);
        if (next < cur)
          break;
        cur = next;
      }
      --k;
      res = max(res, cur);
    }
  }
  cout << fixed << setprecision(1) << res / 2.0 << endl;
}
