#include <cstdio>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>

using namespace std;

#ifdef _WIN32
#  define I64 "%I64d"
#else
#  define I64 "%Ld"
#endif

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef long long ll;

const int minn = 3, maxn = 2000; // works for up to 5000
const int M = (int)1e7;

int n, x[maxn * 2], y[maxn * 2];

int main()
{
  scanf("%d", &n);
  assert(minn <= n && n <= maxn);
  forn(i, n)
  {
    scanf("%d%d", &x[i], &y[i]);
    assert(abs(x[i]) <= M && abs(y[i]) <= M);
  }
  x[n] = x[0], y[n] = y[0];
  ll s = 0;
  forn(i, n)
    s += (ll)x[i] * y[i + 1] - (ll)x[i + 1] * y[i];
  if (s < 0)
  {
    reverse(x, x + n);
    reverse(y, y + n);
  }
  forn(i, n)
    x[i + n] = x[i], y[i + n] = y[i];
  forn(i, n)
    assert((ll)(x[i + 1] - x[i]) * (y[i + 2] - y[i]) - (ll)(y[i + 1] - y[i]) * (x[i + 2] - x[i]) > 0);
  
  ll ans = 0;
  forn(i, n)
  {
    int k = 0;
    for (int j = i + 1; j < n - 1; j++)
    {
      if (k < j + 1)
        k = j + 1;
      ll s = abs((ll)(x[k] - x[i]) * (y[j] - y[i]) - (ll)(y[k] - y[i]) * (x[j] - x[i]));
//      printf("%d %d %d %I64d\n", i, j, k, s);
      while (++k < n)
      {
        ll t = abs((ll)(x[k] - x[i]) * (y[j] - y[i]) - (ll)(y[k] - y[i]) * (x[j] - x[i]));
        if (t < s)
          break;
        s = t;
      }
      k--;
      if (s > ans)
        ans = s;
    }
  }

  printf(I64, ans / 2);
  if (ans & 1)
    printf(".5");
  else
    printf(".0");
  puts("");
  return 0;
}
