#include <ctime>
#include <cstdio>
#include <cstring>

#include <algorithm>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef long long ll;

const int maxn = 5000;

int n, x[maxn * 2], y[maxn * 2];

int main()
{
  int start = clock();

  scanf("%d", &n);
  forn(i, n)
    scanf("%d%d", &x[i], &y[i]);
  forn(i, n)
    x[i + n] = x[i], y[i + n] = y[i];
  int st = rand() % n;
  forn(i, n)
    x[i] = x[i + st], y[i] = y[i + st];
  
  ll ans = 0;
  forn(i, n)
  {
    if (clock() - start > 1.8 * CLOCKS_PER_SEC)
    {
      fprintf(stderr, "%d of %d\n", i, n);
      break;
    }

    for (int j = i + 1; j < n; j++)
      x[j] -= x[i], y[j] -= y[i];
    for (int j = i + 1; j < n - 1; j++)
      for (int k = j + 1; k < n; k++)
      {
        ll s = abs((ll)x[k] * y[j] - (ll)y[k] * x[j]);
        if (s > ans)
          ans = s;
      }
    for (int j = i + 1; j < n; j++)
      x[j] += x[i], y[j] += y[i];
  }

  printf("%.1lf\n", ans * 0.5);
  return 0;
}
