{$C+,Q+,R+}

type integer = longint;

const maxh = 1000000;
var st:array[0..maxh] of string;

function h1(s:string):integer;
var i,r:integer;
begin
	r:=0;
	for i:=1 to length(s) do 
		r:=ord(s[i])*17+3;
	h1:=r;
end;

function h2(s:string):integer;
var i,r:integer;
begin
	r:=0;
	for i:=1 to length(s) do 
		r:=ord(s[i])*239+101;
	h2:=r;
end;

function hash(s:string):integer;
var h,hh:integer;
begin
	h:=h1(s) mod 1000000;
	hh:=h2(s) mod 1000000;
	while (st[h]<>s) and (st[h]<>'') do begin
		inc(h,hh);
		if (h>=maxh) then dec(h,maxh);
	end;
	st[h]:=s;
	hash:=h;
end;

const 
	MINN = 1; 
	MAXN = 100000;
	MINK = 1;
	MAXK = 100000;
	MAXl = 10;
	FREQ = 1;
	MAXR = 2*MAXK div FREQ;

	
procedure reads(var s:string);
var c:char;
begin
	s:='';
	read(c);
	while (ord(c)<=32) do read(c);
	while (ord(c)>32) do begin
		s:=s + c;
		read(c);
	end;
end;

var _,i,z,n,k,v,index,value,name,namenew,vn,arrnum:integer;
	s:string;
	depth,w,arr,ind,vl,p:array[0..maxk] of integer;
	a:array[0..maxr,1..maxn] of integer;
	names,namenews:string;
	vertex:array[0..maxh] of integer;
	t:char;
	g:array[1..maxn] of boolean;
begin
	readln(n);
	assert((n>=MINN) and (n<=MAXN));
	readln(s);
	assert((length(s)>=1) and (length(s)<=MAXL));
	readln(k);
	assert((k>=MINK) and (k<=MAXK));
	vertex[hash(s)]:=0;
	arr[0]:=0;
	fillchar(a[0],sizeof(a[0]),0);

	vn:=0;
	arrnum:=0;
	for _:=1 to k do begin
		read(t); 
		while (ord(t)<=32) do read(t);
		reads(names); name:=vertex[hash(names)]; 
		read(index);
		if (t='G') then begin		
			v:=name;
			repeat
				if (arr[v]>=0) then begin
					writeln(a[arr[v]][index]);
					flush(output);
					break;
				end else begin
					if (ind[v]=index) then begin
						writeln(vl[v]);
						flush(output);
						break;
					end;
				end;
				v:=p[v];
			until false;
		end else begin
			read(value);
			reads(namenews); inc(vn); namenew:=vn; vertex[hash(namenews)]:=vn;
			p[namenew]:=name;
			ind[namenew]:=index;
			vl[namenew]:=value;
			depth[namenew]:=depth[name]+1;
			arr[namenew]:=-1;
			if (depth[namenew] mod freq = 0) then begin
				inc(arrnum);
				arr[namenew]:=arrnum;
				fillchar(g,sizeof(g),0);
				v:=namenew;
				z:=0;
				while (arr[v]=-1) or (v=namenew) do begin
					inc(z);
					w[z]:=v;
					v:=p[v];
				end;
				a[arrnum]:=a[arr[v]];
				for i:=1 to z do if (not g[ind[w[i]]]) then begin
					a[arrnum][ind[w[i]]]:=vl[w[i]];
					g[ind[w[i]]]:=true;
				end;
			end;
		end;
	end;
end.
