#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>
#include <map>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define mp make_pair

const int maxn = 50;
const int maxk = maxn * 3 + 1;

int n, a[3];
int k = 0, l[maxk], w[maxk], h[maxk], ind[maxk];
int c[maxk][maxk], need[maxk][maxn];

map < pair<int, int>, pair<int, int> > m;

int go( int i, int pr )
{
  forn(j, n)
    if (!need[i][j])
      pr &= ~(1U << j);

  if (m.count(mp(i, pr)))
    return m[mp(i, pr)].first;

  int ma = 0;
  for (int x = 0; x < n; x++)
    if (!((pr >> x) & 1))
    {
      int tmp = 0;
      for (int j = i + 1; j < k; j++)
        if (ind[j] == x)
          tmp = max(tmp, h[j]);
      ma += tmp;
    }
  
  int res = 0, ri = -1;
  for (int j = i + 1; j < k; j++)
    if (c[i][j] && !((pr >> ind[j]) & 1))
    {
      int tmp = h[j] + go(j, pr | (1 << ind[j]));
      if (res < tmp)
        res = tmp, ri = j;
      if (res == ma)
        break;
    }
    
  m[mp(i, pr)] = mp(res, ri);
  return res;
}

int main()
{
  scanf("%d", &n);
  forn(i, n)
  {
    forn(j, 3)
      scanf("%d", &a[j]);
    forn(j, 3)
    {
      l[k] = a[(j + 0) % 3];
      w[k] = a[(j + 1) % 3];
      h[k] = a[(j + 2) % 3];
      if (l[k] > w[k])
        swap(l[k], w[k]);
      ind[k++] = i;
    }
  }
  l[k] = w[k] = h[k] = 0;
  ind[k++] = n;

  forn(i, k)
    for (int j = i + 1; j < k; j++)
      if (mp(l[i], w[i]) > mp(l[j], w[j]) || (mp(l[i], w[i]) == mp(l[j], w[j]) && ind[i] > ind[j]))
      {
        swap(l[i], l[j]);
        swap(w[i], w[j]);
        swap(h[i], h[j]);
        swap(ind[i], ind[j]);
      }

  forn(i, k)
    forn(j, k)
      c[i][j] = (l[i] <= l[j] && w[i] <= w[j] && ind[i] != ind[j]);

  for (int x = 0; x < k; x++)
    for (int y = x + 1; y < k; y++)
      for (int z = y + 1; z < k; z++)
        if (ind[x] == ind[z] && c[x][y] && c[y][z])
          for (int i = x; i <= z; i++)
            need[i][ind[x]] = 1;
          
  int res = go(0, 0);
  printf("%d\n", res);

  int i = 0, pr = 0;
  vector <int> ans;
  while (1)
  {
    forn(j, n)
      if (!need[i][j])
        pr &= ~(1U << j);
    i = m[mp(i, pr)].second;
    if (i == -1)
      break;
    ans.push_back(i);
    pr |= 1 << ind[i];
  }
  reverse(ans.begin(), ans.end());
  printf("%d\n", ans.size());
  forn(i, ans.size())
  {
    int j = ans[i];
    printf("%d %d %d %d\n", ind[j] + 1, l[j], w[j], h[j]);
  }
  return 0;
}
