#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <vector>
#include <map> 
#include <set> 

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define mp make_pair

const int maxn = 600;

int n, m, u[maxn], pr[maxn];
char cnt[maxn][maxn];
map < pair<int, int>, set<int> > indM;

int dfs_sum = 0;

void dfs( int v )
{
  u[v] = 1, dfs_sum++;
  forn(i, n)
    if (cnt[v][i] > 0 && !u[i])
      dfs(i), pr[i] = v;
}

int ra[maxn], rb[maxn], k[maxn];

int mdep = 0;

vector < pair<int, int> > v;

int getInd( int a, int b )
{
  if (a > b)
    swap(a, b);
  int x = *indM[mp(a, b)].begin();
  indM[mp(a, b)].erase(x);
  return x + 1;
}

int go_cnt = 0;
void go( int *col, int dep, int i )
{
  if (dep > mdep)
  {
    mdep = dep;
//    fprintf(stderr, "max = %d\n", mdep);
  }
  go_cnt++;
//  if (go_cnt > 500 && mdep < n - 3)
//    return;
  
  if (dep == n - 1)
  {
//    puts("spaning tree #1");
    forn(i, dep)
      printf("%d ", getInd(ra[i], rb[i]));
    puts("");

    memset(u, 0, sizeof(u));
    memset(pr, -1, sizeof(pr));
    dfs(0);
//    puts("spaning tree #2");
    forn(i, n)
      if (pr[i] != -1)
        printf("%d ", getInd(i, pr[i]));
    puts("");
    
    exit(0);
  }

  int num = k[dep];// + (mdep == n - 2);
  while (num > 0 && i < (int)v.size())
  {
    int a = v[i].first, b = v[i].second;
    i++;
    if (col[a] != col[b])
    {
      if (cnt[a][b] == 1)
      {
        cnt[a][b]--, cnt[b][a]--;
        memset(u, 0, sizeof(u));
        dfs_sum = 0;
        dfs(0);
        cnt[a][b]++, cnt[b][a]++;
      }
      if (cnt[a][b] > 1 || dfs_sum == n)
      {
        int col1[maxn];
        forn(j, n)
          if (col[j] == col[a])
            col1[j] = col[b];
          else
            col1[j] = col[j];
        ra[dep] = a, rb[dep] = b;

        cnt[a][b]--, cnt[b][a]--;
        go(col1, dep + 1, i);
        cnt[a][b]++, cnt[b][a]++;

        num--;
      }
    }
  }
}

int main()
{
  scanf("%d%d", &n, &m);
  assert(1 <= n && n <= maxn);
  assert(m == 2 * (n - 1));

  forn(i, m)
  {
    int a, b;
    scanf("%d%d", &a, &b), a--, b--;
    assert(0 <= a && a < n && 0 <= b && b < n);
    if (a == b)
      continue;
    cnt[a][b]++, cnt[b][a]++;
    indM[mp(min(a, b), max(a, b))].insert(i);
  }
  memset(u, 0, sizeof(u));
  dfs_sum = 0;
  dfs(0);
  assert(dfs_sum == n);

  forn(i, n)
    forn(j, i)
      if (cnt[i][j])
        v.pb(mp(i, j));

  forn(i, n)
    k[i] = 1;
  int j = n - 1, t = 0;

  while (1)
  {
    random_shuffle(v.begin(), v.end());
    if (++t == 3)
      k[j--]++, t = 0;
    if (j == n - 10)
      j = n - 1;

    int col[maxn];
    forn(i, n)
      col[i] = i;
    mdep = go_cnt = 0;
    go(col, 0, 0);
  }
  return 0;
}
