#include <cstdio>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define sz(a) (int)(a).size()

const int maxn = (int)1e4;
const int maxm = (int)1e5;

int n, m, a[maxm], b[maxm];
unsigned c[maxn][maxn / 32 + 1];
char bn[1 << 16];

int main()
{
  bn[0] = 0;
  forn(i, 1 << 16)
    bn[i] = bn[i >> 1] + (i & 1);

  scanf("%d%d", &n, &m);
  forn(i, m)
  {
    scanf("%d%d", &a[i], &b[i]);
    a[i]--, b[i]--;
    if (a[i] > b[i])
      swap(a[i], b[i]);
    c[b[i]][a[i] >> 5] |= (1U << (a[i] & 31));
  }

  int sum = 0;
  forn(i, m)
  {
    int x = a[i], y = b[i], k = min(x, y) / 32;
    unsigned tmp;
    forn(j, k + 1)
      if ((tmp = (c[x][j] & c[y][j])) != 0)
        sum += bn[tmp >> 16] + bn[tmp & 65535];
  }
  printf("%.2lf\n", sum / 4.0);
  return 0;
}
