{$O+,R-,S-,Q-}
uses
	math;
const
    NMAX = 100001;
	infinity = 1000000000;
type
    int = longint;
	list = ^node;
	node = record
		inf: int;
		next: list;
	end;
	bolmass = array [1..NMAX] of boolean;
	intmass = array [1..NMAX] of int;
var
	g: array [1..NMAX] of list;
	st, q, dist1, dist2: intmass;
	grandi1, grandi2: bolmass;
	n, m, k: int;

procedure add(x, y: int);
var
	t: list;
begin
	new(t);
	t^.inf := y;
	t^.next := g[x];
	g[x] := t;
end;

procedure make(var ans: bolmass; var dist: intmass);
var
	t: list;
	i, tail, head, v, x, y: int;

procedure update(v, u: int);
begin
	if ans[v] and (not ans[u]) then begin
		dist[u] := max(dist[u], dist[v] + 1);
		exit;
	end;
	if (not ans[v]) and (not ans[u]) then begin
		ans[u] := true;
		dist[u] := dist[v] + 1;
		exit;
	end;
	if (not ans[v]) and ans[u] then begin
		dist[u] := min(dist[u], dist[v] + 1);
		exit;
	end;
end;

begin
	read(n, m);
	fillchar(st, sizeof(st), 0);
	for i := 1 to n do
		g[i] := nil;
	for i := 1 to m do begin
		read(x, y);
		inc(st[x]);
		add(y, x);
	end;

	head := 1;
	tail := 0;
	fillchar(ans, sizeof(ans), 0);
	fillchar(dist, sizeof(dist), 0);
	for i := 1 to n do 
		if st[i] = 0 then begin
			inc(tail);
			q[tail] := i;
		end;

	while head <= tail do begin
		v := q[head];
		inc(head);
		t := g[v];
		while t <> nil do begin
			update(v, t^.inf);
			dec(st[t^.inf]);
			if st[t^.inf] = 0 then begin
				inc(tail);
				q[tail] := t^.inf;
			end;
			t := t^.next;
		end;
	end;
end;

var
	v1, v2, i, bad, good: int;
	may: boolean;

begin
	make(grandi1, dist1);
	make(grandi2, dist2);
	read(k);
	for i := 1 to k do begin
		read(v1, v2);
		may := true;
		if (not grandi1[v1]) and (not grandi2[v2]) then may := false;
		bad := infinity;
		good := 0;
		if (not grandi1[v1]) and grandi2[v2] then begin
			bad := dist1[v1];
			good := dist2[v2];
		end;
		if (not grandi2[v2]) and grandi1[v1] then begin
			bad := dist2[v2];
			good := dist1[v1];
		end;

		if (not may) or (bad <= good) then writeln('second')
			else writeln('first');
	end;
end.