#include <cstdio>
#include <cstring>

#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back

typedef unsigned long long ll;

const int maxn = (int)1e5;
const int maxh = (int)5e6 + 11;

vector <int> c[2][maxn];
ll ha[maxh];
char hf[maxh];

int cnt = 0;

int go( int a, int b )
{
  ll h = a * 239017LL + b * 103LL + 13;
  int hi = h % maxh;
  while (hf[hi] != 0 && ha[hi] != h)
    if (++hi == maxh)
      hi = 0;
  if (ha[hi] == h)
    return hf[hi] - 1;
  ha[hi] = h;
  cnt++;

  int res = 0;
  forn(i, c[0][a].size())
    forn(j, c[1][b].size())
      if (go(c[0][a][i], c[1][b][j]) == 0)
        res = 1, i = j = maxn;
  hf[hi] = res + 1;
  return res;
}

int main()
{
  int n, e, a, b;
  forn(t, 2)
  {
    scanf("%d%d", &n, &e);
    while (e--)
    {
      scanf("%d%d", &a, &b), a--, b--;
      c[t][a].pb(b);
    }
  }
  scanf("%d", &n);
  while (n--)
  {
    scanf("%d%d", &a, &b), a--, b--;
    puts(go(a, b) ? "first" : "second");
  }
  return 0;
}
