#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>

using namespace std;
int const N=10010;

int be[2][N], ne[2][N], en[2][N], q[N]; 

char w[N];


void bfs(int x) {
	int z=0;
	while(z<q[0]) {
		int c=q[++z];
		for (int j=be[x][c]; j; j=ne[x][j])
			if (!w[en[x][j]]) 
				w[en[x][j]]=1, q[++q[0]]=en[x][j];
	}	
}


int main () {
	//freopen ("b.in", "r", stdin);
	//freopen ("b.out", "w", stdout);
	int n, m;
	scanf ("%d%d", &n, &m);
	for (int i=1; i<=m; i++) {
		int p, q;
		scanf ("%d%d", &p, &q);
		ne[0][i]=be[0][p];
		be[0][p]=i;
		en[0][i]=q;
		ne[1][i]=be[1][q];
		be[1][q]=i;
		en[1][i]=p;
	}	
	int res=0;
	for (int i=1; i<=n; i++) {
		memset(w+1, 0, n*sizeof w[0]);
		q[q[0]=1]=i, w[i]=1;
		bfs(1); bfs(0);
		res+=q[0];
	}
	printf ("%d\n", res);
	return 0;
} 
