#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>

using namespace std;
int const N=10010;

int be[2][N], en[2][N], q[N]; 

char w[N];

void bfs(int x) {
	int z=0;
	while(z<q[0]) {
		int c=q[++z];
		for (int j=be[x][c]; j<be[x][c+1]; j++)
			if (!w[en[x][j]]) 
				w[en[x][j]]=1, q[++q[0]]=en[x][j];
	}	
}

vector< pair<int,int> > aa, bb;
int main () {
	freopen ("b.in", "r", stdin);
	freopen ("b.out", "w", stdout);
	int n=10000, m=10000;
 	scanf ("%d%d", &n, &m);
	for (int i=1; i<=m; i++) {
		int p=i, q=i%n+1;
		scanf ("%d%d", &p, &q);
		aa.push_back(make_pair(p, q));
		bb.push_back(make_pair(q, p));
	}
	sort(aa.begin(), aa.end());
	sort(bb.begin(), bb.end());
	int c[2]={0, 0};
	for (int i=1; i<=n; i++) {
		for (; c[0]<m && aa[c[0]].first<i; c[0]++);
		for (; c[1]<m && bb[c[1]].first<i; c[1]++);
		be[0][i]=c[0], be[1][i]=c[1];
	}
	be[0][n+1]=be[1][n+1]=m;
	for (int i=0; i<m; i++) {
		en[0][i]=aa[i].second;
		en[1][i]=bb[i].second;
	}
	int res=0;
	for (int i=1; i<=n; i++) {
		memset(w+1, 0, n*sizeof w[0]);
		q[q[0]=1]=i, w[i]=1;
		bfs(1); bfs(0);
		res+=q[0];
	}
	printf ("%d\n", res);
	fprintf (stderr, "%d\n", clock());
	return 0;
} 
