#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;

const int inf = (1 << 30) - 1;

struct rec
{
	int v, next;
};

int n, m, list;
int ver[10010], vert[10010], q[10010];
rec reb[20020];
bool u[10010];

void push (int &l, int v)
{
	list ++;
	reb[list].v = v;
	reb[list].next = l;
	l = list;
}

int calc (int v)
{
	seta (u, 0);
	int h, t;
	h = t = 0;
	q[h] = v;
	u[v] = 1;
	while (h <= t)
	{
		v = q[h];
		h ++;
		for (int ptr = vert[v]; ptr != -1; ptr = reb[ptr].next)
			if (!u[reb[ptr].v])
			{
				u[reb[ptr].v] = 1;
				t ++;
				q[t] = reb[ptr].v;
			}
	}
	h = 0;
	while (h <= t)
	{
		v = q[h];
		h ++;
		for (int ptr = ver[v]; ptr != -1; ptr = reb[ptr].next)
			if (!u[reb[ptr].v])
			{
				u[reb[ptr].v] = 1;
				t ++;
				q[t] = reb[ptr].v;
			}
	}
	return t + 1;
}

int main ()
{	
// 	freopen ("c.in", "r", stdin);
// 	freopen ("c.out", "w", stdout);
// 	scanf ("%d%d", &n, &m);
	seta (ver, 255);
	seta (vert, 255);
	list = -1;
	n = m = 10000;
	forn (i, m)
	{
		int x, y;
// 		scanf ("%d%d", &x, &y);
// 		x --;
// 		y --;
		x = i;
		y = (i + 1) % m;
		push (ver[x], y);
		push (vert[y], x);
	}
	int res = 0;
	forn (i, n)
		res += calc (i);
	printf ("%d\n", res);
	int time_1 = (int)clock () / 1000;
	assert (time_1 < 1800);	
// 	printf ("10000 10000\n");
// 	forn (i, 9999)
// 		printf ("%d %d\n", i+1, i+2);
// 	printf ("10000 1\n");	
	return 0;
}
