#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
 
using namespace std;

typedef long long int64;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10010;

vector<int> g[nmax];
vector<int> g1[nmax];
int p[nmax];
int sz[nmax];
int son[nmax];
int st[nmax];
int n,m,res;
bool used[nmax];

vector<int> ts;

int calc(int v){
	if (p[v] == v) return v;
	return p[v] = calc(p[v]);
}

void join(int v, int u){
	v = calc(v);
	u = calc(u);
	if (rand() & 1){
		p[v] = u;
		sz[u] += sz[v];
		sz[v] = 0;
	}else{
		p[u] = v;
		sz[v] += sz[u];
		sz[u] = 0;
	}
}

void pre_calc(){
	forn(i,n)
		p[i] = i;
	forn(i,n)
		sz[i] = 1;
}

void make_ts(int v){
	used[v] = 1;
	forn(i,g[v].size())
		if(!used[g[v][i]])make_ts(g[v][i]);
	ts.pb(v);
}

void go(int v){
	used[v] = 1;
	forn(i,g[v].size())
		if (!used[g[v][i]]){
			go(g[v][i]);
			join (v,g[v][i]);
		}
}

void condence(){
	ts.clear();
	forn(i,n)
		used[i] = 0;
	
	forn(i,n)
		if (!used[i])
			make_ts(i);
/*	forn(i,n)
		cout << ts[i] << " ";
	cout << endl;*/
	forn(i,n)
		used[i] = 0;
	forn(i,n)
		if (!used[ts[i]]) go(ts[i]);
}
	
void go(int v, int &q, int &w){
	used[v] = true;
	son[v] = sz[v];
	w += sz[v];
	forn(i,g1[v].size())
		if (used[g1[v][i]]) q += son [g1[v][i]];
	forn(i,g1[v].size())
		if (!used[g1[v][i]])
			go (g1[v][i],q,w);
	forn(i,g1[v].size())
		son[v] += son[g1[v][i]];
}
	
void solve_tree(){
	forn(i,n)
		forn(j,g[i].size())
			if (calc(i) != calc(g[i][j]))
				g1[calc(i)].pb(calc(g[i][j]));
	forn(i,n)
		if (g1[i].size() > 1){
		sort(all(g1[i]));
		int now = 1;
		for (int j = 1; j < (int)g1[i].size(); j++)
			if (g1[i][j] != g1[i][j-1])
				g1[i][now++] = g1[i][j];
		g1[i].resize(now);
	}
	forn(i,n)
		st[i] = 0;
	forn(i,n)
		forn(j,g1[i].size())
			st[g1[i][j]] ++;
	
/*	forn(i,n){
		forn(j,g1[i].size())
			cout << g1[i][j] << " ";
		cout << endl;
	}*/
	
	
	
	forn(i,n)
		used[i] = 0;
	
	forn(i,n)
		if (st[i] == 0 && sz[i] > 0){
			int q,w;
			w = q = 0;
			go(i,q,w);
			res += w * w + 2 * q * w;
/*			cout << q << " " << w << endl;*/
		}
}


void solve(){
	res = 0;
	pre_calc();
	condence();
/*	forn(i,n)
		cout << calc(i) << " ";	
	cout << endl;*/
	/*forn(i,n)
		res += sz[calc(i)];
	*/solve_tree();
}

void read(){
	scanf("%d %d",&n,&m);
	forn(i,m){
		int u,v;
		scanf("%d %d",&u,&v);
		u--, v--;
		g[u].pb(v);
	}
}

void write(){
	cout << res << endl;
}

int main(){

// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
