program zA;
type integer=longint;
     pnode=^node;
     node=record
       st,fn,kl: integer;
       next,pred: pnode;
     end;
var st,fn,kl: array[1..200000] of integer;
    list,en,x,t: pnode;
    n,m,i,a,rez: integer;

procedure swap(var a,b: integer);
var t: integer;
begin
  t:=a; a:=b; b:=t;
end;

procedure qsort(l,r: integer);
var i,j,x: integer;
begin
  i:=l; j:=r; x:=st[l+random(r-l+1)];
  repeat
    while st[i]<x do inc(i);
    while st[j]>x do dec(j);
    if i<=j then begin
      swap(st[i],st[j]);
      swap(fn[i],fn[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;

procedure add(st,fn: integer);
var x: pnode;
begin
  new(x);
  x^.st:=st;
  x^.fn:=fn;
  x^.kl:=0;
  x^.next:=nil;
  x^.pred:=en;
  if list=nil then list:=x
  else en^.next:=x;
  en:=x;
end;

procedure del(var x: pnode);
var next,pred: pnode;
begin
  next:=x^.next;
  pred:=x^.pred;
  if x=list then list:=next;
  if next<>nil then next^.pred:=pred;
  if pred<>nil then pred^.next:=next;
  dispose(x);
end;

begin
  list:=nil;
  en:=nil;
  Read(n,m);
  for i:=1 to m do
    Read(st[i],fn[i]);
  qsort(1,m);
  for i:=1 to m do
    add(st[i],fn[i]);
  for i:=1 to n do
  begin
    Read(a);
    x:=list;
    while (x<>nil) and (x^.st<=a) do begin
      t:=nil;
      if x^.fn>=a then inc(x^.kl);
      if x^.kl=x^.fn-x^.st+1 then begin
        inc(rez);
        t:=x;
      end;
      x:=x^.next;
      if t<>nil then del(t);
    end;
    WriteLn(rez);
    flush(output);
  end;
end.
