#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
 
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 100100;

int64 g[nmax];
int64 e[nmax];
int64 c[nmax], f[nmax], d[nmax];

int n;
int64 res;

void solve(){
	int l = 0;
	res = 0;
	forn(i,n){
		while (d[i] > 0){
			int64 cost = f[i],take = c[i],id = i;
			for (int j = l; j < i; j++)
				if (c[j] > 0 && g[j] > 0 && f[j] < cost){
					cost = f[j];
					take = min(c[j],g[j]);
					id = j;
				}
			if (take == 0){
				puts("-1");
				exit(0);
			}
			int64 add = min(d[i],take);
			res += cost * add;
			c[id] -= add;
			if (id != i)g[id] -= add;
			d[i] -= add;
			int64 now = g[i-1];
			for (int j = i-1; j >= 0; j--){
				g[j] = min(g[j],now);
				now = min(now,g[j]);
			}
			//while (l < n && c[l] == 0 && g[l] == 0)l++;
		}
		if (i) g[i-1] += d[i];
		int64 now = g[i];
		for (int j = i; j >= 0; j--){
			g[j] = min(g[j],now);
			now = min(now,g[j]);
			f[j] += e[i];
		}
		
	}
}

void read(){
	scanf("%d",&n);
	forn(i,n)
		scanf("%lld %lld %lld",&c[i],&f[i],&d[i]);
	forn(i,n-1)
		scanf("%lld %lld",&g[i],&e[i]);
/*	forn(i,n-1)
		g[i] += d[i+1];*/
}

void write(){
	cout << res << endl;
}

int main(){

 	freopen("input.txt","rt",stdin);
 	freopen("output.txt","wt",stdout);
 	
	read();
	solve();
	write();
	
	return 0;
}
