#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define l first
#define r second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int n, m, s[200000], res;
vector <pii> A;
pii a[200000];

int calc (int v)
{
	int l = 1;
	int r = m;
	while (l < r)
	{
		int mid = (l + r + 1) >> 1;
		if (a[mid].l > v)
			r = mid - 1;
		else
			l = mid;	
	}
	for (int i = l; i >= 0; i --)
		if (a[i].l <= v && v <= a[i].r)
		{
			s[i] --;
			if (s[i] == 0)
				res ++;
		}
	return res;	
}

int main ()
{	
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.ans", "w", stdout);
	scanf ("%d%d", &n, &m);
	A.resize (m);
	forn (i, m)
		scanf ("%d%d", &A[i].l, &A[i].r);
	sort (all (A));
	forn (i, m)
		a[i] = A[i];
	forn (i, m)
		s[i] = a[i].r - a[i].l + 1;
	res = 0;
	forn (i, n)
	{
		int x;
		scanf ("%d", &x);
		printf ("%d\n", calc (x));
		fflush (stdout);
	}		
	return 0;
}
