#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <math.h>
#include <set>
#include <map>

using namespace std;

struct tlong {
	short val[1001000];
	int len;
};

bool operator>= (tlong a, tlong b) {
	if (a.len > b.len) return true;
	if (a.len < b.len) return false;
	for (int i = a.len - 1; i >= 0; i--) {
		if (a.val[i] < b.val[i]) return false;
		if (a.val[i] > b.val[i]) return true;
	}
	return true;
}

tlong rotate (tlong a) {
	for (int i = 0; i < a.len - i - 1; i++) {
		int tmp = a.val[i];
		a.val[i] = a.val[a.len - i - 1];
		a.val[a.len - i - 1] = tmp;
	}
	return a; 
}

char wa[1001000], wb[1001000];
tlong xa, xb, xc;
int ans[1001000];

int main () {
	scanf ("%s\n", wa);
	scanf ("%s\n", wb);
	int na = 0, nb = 0;
	while (wa[na]) {
		if (wa[na] >= '0' && wa[na] <= '9') xa.val[na] = wa[na] - '0'; else xa.val[na] = wa[na] - 'A' + 10;
		na++;
	}
	while (wb[nb]) {
		if (wb[nb] >= '0' && wb[nb] <= '9') xb.val[nb] = wb[nb] - '0'; else xb.val[nb] = wb[nb] - 'A' + 10;
		nb++;
	}
	int n;
	scanf ("%d", &n);
	xa.len = na;
	xb.len = nb;
	xb = rotate (xb);
	int first = 1, r = 0;
	memset (ans, 0, sizeof (ans));
	for (int i = 0; i < na; i++) {
		for (int j = xc.len; j > 0; j--) xc.val[j] = xc.val[j - 1];
		xc.val[0] = xa.val[i];
		xc.len++;
		int k = 0;
		while (xc >= xb) {
			k++;
			for (int i = 0; i < xc.len; i++) {
				xc.val[i] -= xb.val[i];
				if (xc.val[i] < 0) {
					xc.val[i] += 31;
					xc.val[i + 1]--;
				}
			}
			while (xc.len > 0 && xc.val[xc.len - 1] == 0) xc.len--;
		}
		if (!k) first = 0;
		if (!first) ans[r++] = k;
	}
	for (int i = 0; r - i - 1 > i; i++) {
		int tmp = ans[i];
		ans[i] = ans[r - i - 1];
		ans[r - i - 1] = tmp;
	}
	for (int i = n - 1; i >= 0; i--)
		if (ans[i] < 10) printf ("%d", ans[i]); else printf ("%c", ans[i] - 10 + 'A');
	printf ("\n");
}