#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 5000;

string s;
int n;

int a[nmax];
int b[nmax];
int res = 0;

bool eq(char a, char b){
	if (a == '?' || b == '?' || a == b) return true;
	return false;
} 

void calc(){
	forn(i,n){
		int l,r;
		l = i-a[i];
		r = i+a[i];
		while (l >= 0 && r < n && eq(s[l],s[r])){
			a[i]++;
			l--;
			r++;
			res++;
		}
	}
	forn(i,n){
		int l,r;
		l = i-b[i];
		r = i+b[i]+1;
		while (l >= 0 && r < n && eq(s[l],s[r])){
			b[i]++;
			l--;
			r++;
			res++;
		}
	}
	printf("%d\n",res);
	fflush(stdout);
}
	
		

int main(){

// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
	
	forn(i,nmax)
		a[i] = b[i] = 0;
	res = 0;
	
	getline(cin,s);
	n = s.size();
	
	calc();
	
	forn(i,n){
		int p;
		scanf("%d",&p);
		s[p] = '?';
		calc();
	}
	
	return 0;
}
