#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define l first
#define r second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;
const int64 P = 1000000007;

int d[100001], p[100001], time1[100001];
int n, m, k, res;
int q[100001];
int64 s[100001], sum;
vector < vector <int> > a;

int main ()
{	
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	scanf ("%d%d%d", &n, &m, &k);
	forn (i, k)
		scanf ("%d", &q[i]);
	forn (i, k)
		q[i] --;	
	a.resize (n);
	forn (i, n)
		a[i].clear ();
	forn (i, m)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		x --;
		y --;
		a[x].pb (y);
		a[y].pb (x);
	}		
	int h = 0;
	int t = k - 1;
	memset (d, 255, sizeof (d));
	memset (p, 255, sizeof (p));
	memset (s, 0, sizeof (s));
	res = inf;
	sum = 0;
	forn (i, k)
	{
		d[q[i]] = 0;
		p[q[i]] = q[i];
		s[q[i]] = 1;
		time1[q[i]] = i;
	}
	while (h <= t)
	{
		int v = q[h];
		h ++;
		forn (i, a[v].size())
		{
			int w = a[v][i];
			if (d[w] == -1)
			{
				d[w] = d[v] + 1;
				p[w] = p[v];
				s[w] = s[v];
				t ++;
				time1[w] = t;
				q[t] = w;
			}
			else
			if (p[v] == p[w])
			{
				if (d[w] == d[v] + 1)
					s[w] = (s[w] + s[v]) % P;
			}
			else
			if (time1[v] < time1[w])
			{
				if (d[v] + d[w] + 1 < res)
				{
					res = d[v] + d[w] + 1;
					sum = (s[v] * s[w]) % P;
				}
				else
					sum = (sum + s[v] * s[w]) % P;
			}
		}
	}
	cout << res << " " << sum << endl;
	return 0;
}
