#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <math.h>
#include <set>
#include <map>

using namespace std;

char w[20000];
int l[30000], r[30000], first[30000], next[60000], prev[60000], num[60000], q[40000];
int h, n;

int add (int i, int x) {
	if (x < 0 || x >= n) return 0;
	next[i] = first[x];
	prev[i] = -1;
	if (first[x] != -1) prev[first[x]] = i;
	first[x] = i;
	return 0;
}

int del (int i, int x) {
	if (prev[i] == -1) first[x] = next[i]; else next[prev[i]] = next[i];
	if (next[i] != -1) prev[next[i]] = prev[i];
	return 0;
}

int main () {
	scanf ("%s", w);
	n = 0;
	int o = 0;
	while (w[n]) n++;
	int ans = n;
	for (int i = 0; i < n; i++) {
		l[o] = i;
		r[o++] = i;
		if (i > 0) {
			l[o] = i;
			r[o++] = i - 1;
		}
	}
	for (int i = 0; i < o; i++)
		while (l[i] - 1 >= 0 && r[i] + 1 < n && w[l[i] - 1] == w[r[i] + 1]) {
			l[i]--;
			r[i]++;
			ans++;
		}
	for (int i = 0; i < n; i++) first[i] = -1;
	h = 0;
	for (int i = 0; i < o; i++)
		if (r[i] + 1 < n && l[i] - 1 >= 0) {
			add (i * 2, l[i] - 1);
			add (i * 2 + 1, r[i] + 1);
		}
	printf ("%d\n", ans);
	fflush (stdout);
	for (int j = 0; j < n; j++) {
		int x;
		scanf ("%d", &x); x--;
		w[x] = '?';
		for (int k = first[x]; k != -1; ) {
			int i = k / 2;
			int nk = next[k];
			if (l[i] - 1 != x && r[i] + 1 != x) return 0;
			del (i * 2, l[i] - 1);
			del (i * 2 + 1, r[i] + 1);
			while (l[i] - 1 >= 0 && r[i] + 1 < n && (w[l[i] - 1] == w[r[i] + 1] || w[l[i] - 1] == '?' || w[r[i] + 1] == '?')) {
				l[i]--;
				r[i]++;
				ans++;
			}
			if (r[i] + 1 < n && l[i] - 1 >= 0) {
				add (i * 2, l[i] - 1);
				add (i * 2 + 1, r[i] + 1);
			}
			k = nk;
		}
		printf ("%d\n", ans);
		fflush (stdout);
	}
}