{$o+}
type
    int32=longint;
    bool=boolean;
    plist=^tlist;
    tlist=record
        key:int32;
        next:plist;
    end;
    TEdges=record
        u:int32;
        v:int32;
        w:int32;
        ind:int32;
    end;
    
var
   a,a_,com,com_:array [0..100000] of plist;
   e:array [0..500000] of TEdges;
   u:array [0..100000] of bool;
   f,color:array [0..100000] of int32;
   added:array [0..500000] of int32;
   ok:bool;
   n,m1,m2,i,kol,p,time,x,y,size,sumw,j:int32;

   procedure list_insert(var l:plist; key:int32);
   var x:plist;
   begin
        new(x);
        x^.key:=key;
        x^.next:=l;
        l:=x;
   end;
   
   procedure swap(i,j:int32);
   var c:TEdges;
   begin
        c:=e[i]; e[i]:=e[j]; e[j]:=c;
   end;
   
   procedure qsort(var a:array of TEdges; l,r:int32);
   var i,j,x:int32;
   begin
        i:=l; j:=r; x:=a[(l+r) div 2].w;
        repeat
              while a[i].w<x do i:=i+1;
              while x<a[j].w do j:=j-1;
              if i<=j then
              begin
                   swap(i,j);
                   i:=i+1; j:=j-1;
              end;
        until i>j;
        if l<j then qsort(a,l,j);
        if i<r then qsort(a,i,r);
   end;
   
   procedure dfs(k:int32);
   var x,l:plist;
   begin
        list_insert(com[k],k);
        x:=a[k];
        u[k]:=true;
        while x<>nil do
        begin
             if u[x^.key]=false then dfs(x^.key);
             l:=com[x^.key];
             while l<>nil do
             begin
                  list_insert(com[k],l^.key);
                  l:=l^.next;
             end;
             x:=x^.next;
        end;
        time:=time+1;
        f[k]:=time;
   end;
   
   procedure dfs_(k:int32);
   var x,l:plist;
   begin
        list_insert(com_[k],k);
        x:=a_[k];
        u[k]:=true;
        while x<>nil do
        begin
             if u[x^.key]=false then dfs_(x^.key);
             l:=com_[x^.key];
             while l<>nil do
             begin
                  list_insert(com_[k],l^.key);
                  l:=l^.next;
             end;
             x:=x^.next;
        end;
   end;
   
   procedure complete;
   var x:plist;
       a:array [0..100000] of int32;
       i,j:int32;
   begin
        for i:=1 to n do
        begin
             fillchar(a,sizeof(a),0);
             x:=com[i];
             while x<>nil do
             begin
                  a[x^.key]:=1;
                  x:=x^.next;
             end;
             x:=com_[i];
             while x<>nil do
             begin
                  if (a[x^.key]=1) then a[x^.key]:=2;
                  x:=x^.next;
             end;
             p:=0;
             for j:=1 to n do
             begin
                  if a[j]=2 then
                  begin
                       if p=0 then p:=j;
                       color[j]:=color[p];
                  end;
             end;
        end;
   end;
   
   procedure condence();
   var q,i:int32;
       ord:array [0..100000] of int32;
   begin
        fillchar(f,sizeof(f),0);
        fillchar(u,sizeof(u),false);
        time:=0;
        for q:=1 to n do
             if u[q]=false then dfs(q);
        for i:=1 to n do
            ord[f[i]]:=i;
        fillchar(u,sizeof(u),false);
        for i:=1 to n do
             if u[ord[i]]=false then dfs_(ord[i]);
        complete;
   end;
    
begin
     {assign(input,'in.txt');
     reset(input);
     assign(output,'out.txt');
     rewrite(output);}
     readln(n);
     readln(m1);
     for i:=1 to n do
         color[i]:=i;
     for i:=1 to m1 do
     begin
          readln(x,y);
          list_insert(a[x],y);
          list_insert(a_[y],x);
     end;
     readln(m2);
     size:=0;
     for i:=1 to m2 do
     begin
         size:=size+1;
         readln(e[size].u,e[size].v,e[size].w);
         e[size].ind:=i;
     end;
     qsort(e,1,size);
     condence;
     i:=1; ok:=true; kol:=0; sumw:=0;
     while (i<=size)and(ok) do
     begin
          if color[e[i].u]<>color[e[i].v] then
          begin
               list_insert(a[e[i].u],e[i].v);
               list_insert(a_[e[i].v],e[i].u);
               kol:=kol+1;
               added[kol]:=e[i].ind;
               sumw:=sumw+e[i].w;
               fillchar(com,sizeof(com),0);
               fillchar(com_,sizeof(com_),0);
               condence;
               ok:=false; p:=0;
               for j:=1 to n do
               begin
                    if p=0 then p:=j;
                    if color[j]<>color[p] then
                    begin
                         ok:=true;
                         break;
                    end;
               end;
          end;
          i:=i+1;
     end;
     if ok then writeln('NO')
           else
           begin
                writeln('YES');
                writeln(sumw);
                writeln(kol);
                for i:=1 to kol do write(added[i],' ');
           end;
end.
