#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define l first
#define r second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

struct rec
{
	int v, next, w, num;
};

int ver[100001], vert[100001], list, q[100001], pv[100001], pr[100001];
rec reb[1100000];
int n, m, s, t, m1;
int64 answ;
bool u[100001];
vector <int> ans;
int64 d[100001], tr[262144];

void push (int &l, int v, int w, int num)
{
	list ++;
	reb[list].v = v;
	reb[list].num = num;
	reb[list].w = w;
	reb[list].next = l;
	l = list;
}

void dfs_s (int v)
{
	if (u[v])
		return;
	u[v] = 1;
	for (int ptr = ver[v]; ptr != -1; ptr = reb[ptr].next)
		dfs_s (reb[ptr].v);
	q[0] ++;
	q[q[0]] = v;
}

void dfs_t (int v)
{
	if (u[v])
		return;
	u[v] = 1;
	for (int ptr = vert[v]; ptr != -1; ptr = reb[ptr].next)
		dfs_t (reb[ptr].v);
	q[0] ++;
	q[q[0]] = v;
}

void update (int v)
{
	int64 x;
	if (u[v])
		x = inf64;
	else
		x = d[v];
	v = v + list;
	tr[v] = x;
	while (v > 1)
	{
		v >>= 1;
		tr[v] = min (tr[v*2], tr[v*2+1]);
	}		
}

int ext_min ()
{
	int v = 1;
	while (v < list)
		if (tr[v*2] == tr[v])
			v = v * 2;
		else
			v = v * 2 + 1;
	return v - list;	
}

int main ()
{	
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	scanf ("%d%d", &n, &m);
	list = -1;
	seta (ver, 255);
	seta (vert, 255);
	forn (i, m)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		x --;
		y --;
		push (ver[x], y, 0, -i);
		push (vert[y], x, 0, -i);
	}
	seta (q, 0);
	seta (u, 0);
	forn (i, n)
		dfs_s (i);
	s = q[q[0]];
	seta (q, 0);
	seta (u, 0);
	forn (i, n)
		dfs_t (i);
	t = q[q[0]];
	ans.clear ();
	answ = 0;
	scanf ("%d", &m1);
	forn (i, m1)
	{
		int x, y, w;
		scanf ("%d%d%d", &x, &y, &w);
		x --;
		y --;
		if (w <= 0)
		{
			answ += (int64)w;
			ans.pb (i+1);
			push (ver[x], y, 0, i+1);
		}
		else
			push (ver[x], y, w, i+1);
	} 
	forn (i, n)
		d[i] = inf64;
	list = 1;
	while (list < n)
		list *= 2;
	forn (i, list*2)
		tr[i] = inf64;
	seta (u, 0);
	d[t] = 0;
	update (t);	
	seta (pv, 255);
	while (tr[1] < inf64)
	{
		int v = ext_min ();
		u[v] = 1;
		update (v);
		for (int ptr = ver[v]; ptr != -1; ptr = reb[ptr].next)
		{
			int w = reb[ptr].v;
			if (d[w] > d[v] + reb[ptr].w)
			{
				d[w] = d[v] + (int64)reb[ptr].w;
				update (w);
				pv[w] = v;
				pr[w] = reb[ptr].num;
			}
		}
	}		
	if (d[s] == inf64)
	{
		printf ("NO\n");
		return 0;
	}
	printf ("YES\n");
	printf ("%lld\n", answ + d[s]);
	while (s != t)
	{
		if (pr[s] > 0)
			ans.pb (pr[s]);
		s = pv[s];	
	}
	sort (all (ans));
	ans.resize (unique (all (ans)) - ans.begin());
	printf ("%d\n", ans.size());
	forn (i, ans.size())
		printf ("%d ", ans[i]);
	printf ("\n");	
	return 0;
}
