Const inf = 10000000000000000;

Type integer=longint;

Var nm,m,i,j,n,m1,m2,a,b:Integer;
		
		cur,x,s,t:Integer;
		use:Array[1..100000]of Boolean;
		g,next,gR,nextR:Array[1..2000000]of Integer;
		head,headR:Array[1..100000]of Integer;
		color,list:array[1..100000]of Integer;
		income,outcome:Array[1..100000]of Integer;
		edgeCost:Array[1..2000000] of Int64;
		realNum:array[1..2000000]of Integer;
		min,c,cost:Int64;
		ans:Array[0..500000]of Integer;
		d:Array[1..100000]of Int64;
		fr_v,fr_e:Array[1..100000]of Integer;

Procedure DFS1(v:Integer);
Var i:Integer;
Begin
	use[v]:=true;
	i:=head[v];
	while i<>0 do begin
		if not use[g[i]] then DFS1(g[i]);
		i:=next[i];
	end;
	list[cur]:=v;
	Dec(cur);
End;

Procedure DFS2(v,col:Integer);
Var i:Integer;
Begin
	color[v]:=col;
	i:=headR[v];
	while i<>0 do begin
		if color[gR[i]] = 0 then DFS2(gr[i],col);
		i:=nextR[i];
	end;
End;

Procedure Add(v1,v2:Integer;cost:Int64;realNumber:Integer);
Begin
	Inc(m);
	g[m]:=v2;
	next[m]:=head[v1];
	head[v1]:=m;
	
	gR[m]:=v1;
	nextR[m]:=headR[v2];
	headR[v2]:=m;
	
	edgeCost[m]:=cost;
	realNum[m]:=realNumber;
End;

Begin
	fillchar(use,sizeof(use),false);
	fillchar(income,sizeof(income),0);
	fillchar(outcome,sizeof(outcome),0);
	fillchar(color,sizeof(color),0);
	
	m:=0;
	Read(n,m1);
	for i:=1 to m1 do begin
		Read(a,b);
		Add(a,b,0,0);
	end;
	
	//Finding s and t
	cur:=n;
	for i:=1 to n do
		if not use[i] then DFS1(i);
	
	cur:=0;
	for i:=1 to n do
		if color[list[i]] = 0 then begin
			Inc(cur);
			DFS2(list[i],cur);
		end;
	
	for j:=1 to n do begin
		i:=head[j];
		while (i<>0) do begin
			Inc(income[color[g[i]]]);Inc(outcome[color[j]]);
			i:=next[i];
		end;
	end;
	
	for i:=1 to cur do if income[i] = 0 then begin
		x:=i;break;
	end;
	
	for i:=1 to n do if color[i] = x then begin
		s:=i;break;
	end;
	
	for i:=1 to cur do if outcome[i] = 0 then begin
		x:=i;break;
	end;
	
	for i:=1 to n do if color[i] = x then begin
		t:=i;break;
	end;
	
	//Solving problem
	
	cost:=0;ans[0]:=0;
	Read(m2);
	for i:=1 to m2 do begin
		Read(a,b,c);
		if c<=0 then begin
			Add(a,b,0,0);
			cost:=cost+c;
			Inc(ans[0]);
			ans[ans[0]]:=i;
		end else Add(a,b,c,i);
	end;
	
	for i:=1 to n do d[i]:=inf;
	d[t]:=0;
	fillchar(use,sizeof(use),false);
	
	while true do begin
		nm:=-1;min:=inf;
		for i:=1 to n do
			if (not use[i]) and (d[i]<min) then begin
				nm:=i;min:=d[i];
			end;
		if nm = -1 then break;
		i:=head[nm];
		while (i<>0) do begin
			if (not use[g[i]]) and (d[g[i]] > d[nm] + edgeCost[i]) then begin
				d[g[i]] := d[nm] + edgeCost[i];fr_v[g[i]]:=nm;
				fr_e[g[i]]:=realNum[i];
			end;
			i:=next[i];
		end;
		use[nm]:=true;
	end;
	
	if d[s]=inf then begin
		Write('NO');halt;
	end;
	
	WriteLn('YES');
	WriteLn(d[s]+cost);
	cur:=s;
	while cur<>t do begin
		if fr_e[cur]<>0 then begin Inc(ans[0]);
		ans[ans[0]]:=fr_e[cur];end;
		cur:=fr_v[cur];
	end;
	
	WriteLn(ans[0]);
	for i:=1 to ans[0] do Write(ans[i],' ');
	
End.
 
