#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int n, k;
int l[100], r[100], ld[100], s[100];
double w[100];
ldb res;
bool u[100];

int leader (int v)
{
	if (l[v] != v)
		l[v] = leader (l[v]);
	return l[v];	
}

inline void unite (int v, int w)
{
	v = leader (v);
	w = leader (w);
	if (rand()&1)
		l[w] = v;
	else
		l[v] = w;	
}

void check ()
{
	ldb rs = 0;
	forn (i, n-1)
		if (u[i])
			rs += w[i];
	forn (i, n)
		l[i] = i;
	forn (i, n-1)
		if (!u[i])
			unite (l[i], r[i]);
	forn (i, n)
		s[i] = 0;
	forn (i, n)
		l[i] = leader (i);	
	forn (i, n)
		s[l[i]] ++;
	ldb rs1 = 1;
	forn (i, n)
		if (l[i] == i)
			rs1 *= (ldb)s[i];
	rs *= rs1;
	res = max (res, rs);					
}

void go (int v, int l)
{
	if (n-1-v < l)
		return;
	if (v == n-1)
	{
		check();
		return;
	}	
	go (v+1, l);
	if (l > 0)
	{
		u[v] = 1;
		go (v+1, l-1);
		u[v] = 0;
	}	
}

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
	cin >> n >> k;
	forn (i, n-1)
		cin >> l[i] >> r[i] >> w[i];
	forn (i, n-1)
	{
		l[i] --;
		r[i] --;
	}
	res = 0;
	seta (u, 0);
	k --;
	go (0, k);
	cout.precision (20);
	cout << fixed << res << endl;	
	return 0;
}
