#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=100010, M=500010, Z=1000000000;
long long const INF=1e17;
int n, col, st1[N], ne1[M], en1[M], st2[N], ne2[M], en2[M], st3[N], ne3[M], be3[M], en3[M], cst[M], q[N], cl[N], pr[N];
long long d[N];
char w[N], fr[N], to[N];

void add(int k, int p, int q) {
	ne1[k]=st1[p];
	st1[p]=k;
	en1[k]=q;
	ne2[k]=st2[q];
	st2[q]=k;
	en2[k]=p;	
}

void add3(int k, int p, int q, int c) {
	ne3[k]=st3[p];
	st3[p]=k;
	be3[k]=p;
	en3[k]=q;
	cst[k]=c;
}

void dfs1(int x) {
	w[x]=1;
	for (int j=st1[x]; j; j=ne1[j])
		if (!w[en1[j]]) 
			dfs1(en1[j]);
	q[++q[0]]=x;	
}

void dfs2(int x) {
	w[x]=1, cl[x]=col;
	for (int j=st2[x]; j; j=ne2[j])
		if (!w[en2[j]]) 
			dfs2(en2[j]);
}

int res[M];
priority_queue< pair<int,int> > qu; 
int main () {
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	int m;
// 	n=100000, m=99999;
	scanf ("%d%d", &n, &m);
	for (int i=1; i<=m; i++) {
		int p, q;
// 		p=i, q=i+1;
		scanf ("%d%d", &p, &q);
		add(i, p, q);
	}
	
	for (int i=1; i<=n; i++)
		if (!w[i]) 
			dfs1(i);
	
	memset(w+1, 0, n);
	for (int i=q[0]; i>=1; i--)
		if (!w[q[i]]) 
			++col, dfs2(q[i]);
	
	int s=0, t=0;
	for (int i=1; i<=m; i++)
		if (cl[en2[i]]!=cl[en1[i]])
			fr[cl[en2[i]]]=1, to[cl[en1[i]]]=1;
	
	for (int i=1; i<=col; i++) {
		if (!fr[i]) t=i;
		if (!to[i]) s=i;
	}
	
	int m1;
// 	m1=99999;
	scanf ("%d", &m1); 
	
	for (int i=1; i<=m1; i++) {
		int p, q, c;
// 		p=i+1, q=i, c=rand()%Z;
		scanf ("%d%d%d", &p, &q, &c);
		if (c<0) res[i]=1, add3(i, cl[p], cl[q], 0);
		else add3(i, cl[p], cl[q], c);
	}
	for (int i=1; i<=m; i++)
		if (cl[en2[i]]!=cl[en1[i]])
			add3(i+m1, cl[en2[i]], cl[en1[i]], 0);
	
	for (int i=0; i<=col; i++) 
		d[i]=INF;
	d[t]=0;
	qu.push(make_pair(0, t));
	
	memset(w, 0, sizeof w);
	while(!qu.empty()) {
		int x=qu.top().second; qu.pop();
		if (w[x]) continue;
		w[x]=1;
		for (int j=st3[x]; j; j=ne3[j])
			if (d[en3[j]]>d[be3[j]]+cst[j])
				d[en3[j]]=d[be3[j]]+cst[j], pr[en3[j]]=j, qu.push(make_pair(-d[en3[j]], en3[j]));
	}
	if (d[s]!=INF) {
		for (int c=s; c!=t; c=be3[pr[c]]) 
			res[pr[c]]=1;
		long long cs=0; printf ("YES\n");
		for (int i=1; i<=m1; i++) 
			if (res[i]) 
				res[0]++, cs+=cst[i];;
		printf ("%lld\n%d\n", cs, res[0]);
		for (int i=1; i<=m1; i++)
			if (res[i])
				printf ("%d ", i);
	}
	else printf ("NO\n");	
	return 0;
}
