#include <cstdio>
#include <string>

using namespace std;

const int di[4] = {0, 1, 0, -1};
const int dj[4] = {1, 0, -1, 0};

char w[3001];
bool g[3001][3001];
int d[3001][3001];
int qc[9000001];
int f[6002][6002];
int n, m, ans, ai, aj, ax;

int calc (int i, int j, int x) {
	return f[i + x][j + x] - f[i - x - 1][j + x] - f[i + x][j - x - 1] + f[i - x - 1][j - x - 1];
}

int check (int i, int j, int x) {
	int tmp = calc (i + j + 1, i - j + m + 1, x);
	if (tmp > ans) {
		ans = tmp;
		ai = i;
		aj = j;
		ax = x;				
	}
	return 0;
}

int main () {
	scanf ("%d%d\n", &n, &m);
	memset (f, 0, sizeof (f));
	for (int i = 0; i < n; i++) {
		scanf ("%s", w);
		for (int j = 0; j < m; j++) {
			g[i][j] = (w[j] == '*');
			d[i][j] = 1000000;
			if (g[i][j]) f[i + j + 1][i - j + m + 1] = 1;
		}
	}
	for (int i = 1; i <= n + m + 1; i++)
		for (int j = 1; j <= n + m + 1; j++)
			f[i][j] += f[i - 1][j] + f[i][j - 1] - f[i - 1][j - 1];
	int r = 0, l = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			if (g[i][j]) {
				bool tmp = 0;
				if (i > 0) tmp |= g[i - 1][j];
				if (j > 0) tmp |= g[i][j - 1];
				if (i + 1 < n) tmp |= g[i + 1][j];
				if (j + 1 < m) tmp |= g[i][j + 1];
				if (tmp) {
					d[i][j] = 0;
					qc[r++] = i * 10000 + j;
				}
			}
			if (d[i][j] && (i == 0 || i + 1 == n || j == 0 || j + 1 == m)) {
				d[i][j] = 0;
				qc[r++] = i * 10000 + j;
			}
		}
	ans = 0;
	ai = aj = ax = 0;
	while (l < r) {
		int i = qc[l] / 10000;
		int j = qc[l++] % 10000;
		int x = d[i][j];
		check (i, j, x);
		for (int k = 0; k < 4; k++) {
			int ni = i + di[k], nj = j + dj[k];
			if (ni >= 0 && nj >= 0 && ni < n && nj < m && d[ni][nj] > x + 1) {
				d[ni][nj] = x + 1;
				qc[r++] = ni * 10000 + nj;
			}
		}
	}
	printf ("%d %d %d %d\n", ans, aj + 1, ai + 1, ax);
}