#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

struct seg
{
	int l,r;
	int len;
	int kol;
	int id;
	seg()
	{
		this->l=this->r=this->len=this->kol=this->id=0;
	};
};

bool operator< (const seg a,const seg b)
{
	return (a.len<b.len);
}

bool InBound(int x, int l, int r)
{
	return (l<=x && x<=r);
}
		
bool InBound(const seg a, const seg b)
{
	return (InBound(a.l,b.l,b.r) && InBound(a.r,b.l,b.r));
}

vector<seg> Segs;
vector<int> coordq;
vector<int> coord;
vector<seg> line;
deque<int> ans;
int n, kolcol=0;

int main()
{
	Segs.clear();
	coordq.clear();
	cin >> n;
	for (int i=0; i<n ; i++)
	{
		seg buf;
		cin >> buf.l >> buf.r;
		buf.len=buf.r-buf.l;
		buf.id=i;
		Segs.push_back(buf);
		coordq.push_back(buf.l);
		coordq.push_back(buf.r);
	}
	
	sort(coordq.begin(),coordq.end());
	sort(Segs.begin(),Segs.end());
	
	coord.push_back(coordq[0]);
	for (int i=1; i<coordq.size(); i++)
		if (coordq[i]!=coordq[i-1])
			coord.push_back(coordq[i]);
	
	for (int i=1; i<coord.size(); i++)
	{
		seg buf;
		buf.l=coord[i-1];
		buf.r=coord[i];
		line.push_back(buf);
	}
	
	for (int i=0; i<Segs.size(); i++)
		for (int j =0; j<line.size(); j++)
			if (InBound(line[j],Segs[i]))
				line[j].kol++;
	
	for (int i=Segs.size()-1; i>=0; i--)
	{
		bool f=false;
		for (int j=0; j<line.size() && !f; j++)
			if (InBound(line[j],Segs[i]))
				f = ((line[j].kol==1) || f);
		
		if (f)
			ans.push_back(Segs[i].id), kolcol++;
		else
			ans.push_front(Segs[i].id);
		
		for (int j=0; j<line.size(); j++)
			if (InBound(line[j],Segs[i]))
				line[j].kol--;
	}
	
	cout << kolcol << endl;
	
	for (deque<int>::iterator i = ans.begin(); i!=ans.end(); i++)
		cout << *i+1 << ' ';
}