{$MODE DELPHI}
const
  upright=true;
  upleft=true;
  downright=false;
  downleft=false;
var h, w, i, j, x, y, n, maxx, maxy, maxn, maxr, r:Integer;
    c:char;
    table:array[0..2000, 0..2000]of Boolean;
    resv, resh, respv, resph:array[0..2000, boolean, 0..2000]of Integer;
    sumv, sumh, sumpv, sumph:array[0..2000, 0..2000]of Integer;
function Diagonal(x, y, x1, x2:Integer; dir:Boolean):Integer;
begin
  if(x>y) then
    result:=resh[x-y+1, dir, x2]-resh[x-y+1, dir, x1-1]
  else
    result:=resv[y-x+1, dir, x2]-resv[y-x+1, dir, x1-1];
end;
function PDiagonal(x, y, x1, x2:Integer; dir:Boolean):Integer;
begin
  if(x+y<n) then
    result:=respv[x+y-1, dir, x1]-respv[x+y-1, dir, x2]
  else
    result:=resph[x+y-1, dir, x1]-resph[x+y-1, dir, x2];
end;
function DiagonalS(x, y, x1, x2:Integer):Integer;
begin
  inc(x1); dec(x2);
  if(x>y) then
    result:=sumh[x-y+1, x2]-sumh[x-y+1, x1-1]
  else
    result:=sumv[y-x+1, x2]-sumv[y-x+1, x1-1];
end;
function PDiagonalS(x, y, x1, x2:Integer):Integer;
begin
  inc(x1); dec(x2);
  if(x+y<n) then
    result:=sumpv[x+y-1, x1]-sumpv[x+y-1, x2]
  else
    result:=sumph[x+y-1, x1]-sumph[x+y-1, x2];
end;

function Extend(x, y:Integer; Var r:Integer; var n:Integer):Boolean;
begin
  result:=false;
  if(x>r+1)and(y>r+1)and(w-x>r)and(h-y>r)and
    (Diagonal(x, y+r, x, x+r, upright)+Diagonal(x, y-r, x-r, x, downleft)+
     PDiagonal(x, y+r, x-r, x, upleft)+PDiagonal(x, y-r, x, x+r, downright)=0) then
  begin
    result:=true;
    inc(r);
    Inc(n, DiagonalS(x, y+r, x, x+r)+DiagonalS(x, y-r, x-r, x)+
     PDiagonalS(x, y+r, x-r, x)+PDiagonalS(x, y-r, x, x+r));
    if(table[x, y+r]) then inc(n);
    if(table[x, y-r]) then inc(n);
    if(table[x+r, y]) then inc(n);
    if(table[x-r, y]) then inc(n);
  end;
end;
begin
  //assign(input, 'c.in'); reset(input);
  //assign(output, 'c.out'); rewrite(output);
  readln(h, w);
  for i:=1 to h do
  begin
    for j:=1 to w do
    begin
      read(c);
      table[i, j]:=(c='*');
    end;
    readln;
  end;
  for i:=1 to h do
  begin
    x:=1; y:=i;
    while(y<=h)and(x<=w) do
    begin
      resv[i, upright, x]:=resv[i, upright, x-1];
      resv[i, downleft, x]:=resv[i, downleft, x-1];
      sumv[i, x]:=sumv[i, x-1];
      if(table[x, y]) then inc(sumv[i, x]);
      if(table[x][y])and(table[x][y-1] or table[x+1][y]) then
        inc(resv[i, upright, x]);
      if(table[x][y])and(table[x][y+1] or table[x-1][y]) then
        inc(resv[i, downleft, x]);
      inc(x); inc(y);
    end;
  end;
  for i:=1 to w do
  begin
    x:=i; y:=1;
    while(y<=h)and(x<=w) do
    begin
      resh[i, upright, x]:=resh[i, upright, x-1];
      resh[i, downleft, x]:=resh[i, downleft, x-1];
      sumv[i, x]:=sumh[i, x-1];
      if(table[x, y]) then inc(sumh[i, x]);
      if(table[x][y])and(table[x][y-1] or table[x+1][y]) then
        inc(resh[i, upright, x]);
      if(table[x][y])and(table[x][y+1] or table[x-1][y]) then
        inc(resh[i, downleft, x]);
      inc(x); inc(y);
    end;
  end;
  for i:=1 to h do
  begin
    x:=w; y:=1;
    while(x>=1)and(y<=h) do
    begin
      resph[i, upleft, x]:=resph[i, upleft, x+1];
      resph[i, downright, x]:=resph[i, downright, x+1];
      sumph[i, x]:=sumph[i, x+1];
      if(table[x, y]) then inc(sumph[i, x]);
      if(table[x][y])and(table[x][y-1] or table[x-1][y]) then
        inc(resph[i, upleft, x]);
      if(table[x][y])and(table[x][y+1] or table[x+1][y]) then
        inc(resph[i, downright, x]);
      dec(x); inc(y);
    end;
  end;
  for i:=1 to w do
  begin
    x:=i; y:=1;
    while(y<=h)and(x<=w) do
    begin
      respv[i, upleft, x]:=respv[i, upleft, x+1];
      respv[i, downright, x]:=respv[i, downright, x+1];
      sumpv[i, x]:=sumpv[i, x+1];
      if(table[x, y]) then inc(sumpv[i, x]);
      if(table[x][y])and(table[x][y-1] or table[x-1][y]) then
        inc(respv[i, upleft, x]);
      if(table[x][y])and(table[x][y+1] or table[x+1][y]) then
        inc(respv[i, downright, x]);
      dec(x); inc(y);
    end;
  end;
  maxn:=0; maxx:=1; maxy:=1; maxr:=1;
  for x:=1 to h do
    for y:=1 to w do
    begin
      if(table[x, y]) then n:=1 else n:=0;
      r:=0;
      while(Extend(x, y, r, n)) do;
      if(n>maxn) then
      begin
        maxn:=n;
        maxx:=x;
        maxy:=y;
        maxr:=r;
      end;
    end;
  writeln(maxn, ' ', maxy, ' ', maxx, ' ', maxr);
  close(input); close(output);
end.