#include <iostream>
#include <vector>

using namespace std;

const int maxn=300;

struct edge
{
	int x, w;
	edge* next;
	edge()
	{
		this->x=this->w=0;
		this->next=0;
	}	
};

struct vertex
{
	edge* E;
	char gr;
	int sumA,sumB;
	vertex()
	{
		this->E=0;
		this->gr=0;
		this->sumA=this->sumB=0;
	}
};

vertex V[maxn];
int n,m;
int sum=0;
int anssum;
vector<int> ansA;
vector<int> A;

void AddEdge(int a, int b, int w)
{
	edge * t = new edge;
	t->x=b;
	t->w=w;
	t->next=V[a].E;
	V[a].E=t;
	if (V[a].gr==1)
		V[b].sumA+=w;
	else
		V[b].sumB+=w;
}

void update(int v)
{
	V[v].sumA=V[v].sumB=0;
	
	for (edge* t= V[v].E; t; t=t->next)
		if (V[t->x].gr==1)
			V[v].sumA+=t->w;
		else
			V[v].sumB+=t->w;
}

int main()
{
	A.clear();
	ansA.clear();
	
	cin >> n;

	for (int i=0; i<n; i++)
		V[i].gr=2;
	
	cin >> m;
	
	for (int i=0; i<m; i++)
	{
		int a,b,w;
		cin >> a >> b >>w;
		a--,b--;
		AddEdge(a,b,w);
		AddEdge(b,a,w);
	}
	//////////////////////////////////////
	int minid=0;
	
	for (int i=0; i<n; i++)
		if (V[minid].sumB>V[i].sumB)
			minid=i;
	
	V[minid].gr=1;
	A.push_back(minid);
	ansA.push_back(minid);
	sum = anssum = V[minid].sumB;
	
	for (edge* t = V[minid].E; t; t=t->next)
		update(t->x);
	////////////////////////////////////////////////
	for (int k=1; k<n; k++)
	{
		int maxid=0;
		
		for (int i=0; i<n; i++)
			if (V[i].gr==2)
			{
				maxid=i;
				break;
			}
		
		for (int i=0; i<n; i++)
			if (V[i].gr==2 && (V[i].sumA-V[i].sumB > V[maxid].sumA-V[maxid].sumB))
				maxid=i;
		
		if (maxid==minid)
			break;
		int change = V[maxid].sumA-V[maxid].sumB;
		if ((sum-change)>sum)
			break;
		sum = sum-change;
		V[maxid].gr=1;
		A.push_back(maxid);
		
		if (A.size()%2==1)
		{
			anssum=sum;
			ansA=A;
		}
		
		for (edge* t = V[maxid].E; t; t=t->next)
				update(t->x);
	}
	
	cout << anssum << endl;
	
	cout << ansA.size() << endl;
	
	for (int i=0; i<ansA.size(); i++)
		cout << ansA[i]+1 << ' ';
}