#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 5000;

struct line{
	int l,r,d,n;
	line(){};
};

bool ls(line a, line b){
	if (a.l != b.l) return a.l < b.l;
	return a.d < b.d;
}

int n;
int l[nmax];
int r[nmax];
int c[nmax];
int res;
vector<line> a;
vector<line> p,np;

void recalc(){
	vector<int> h;
	forn(i,n){
		h.pb(l[i]);
		h.pb(r[i]);
		h.pb(l[i]+1);
		h.pb(r[i]+1);
		h.pb(l[i]-1);
		h.pb(r[i]-1);
	}
	sort(all(h));
	h.erase(unique(all(h)),h.end());
	forn(i,n){
		l[i] = lower_bound(all(h),l[i])-h.begin();
		r[i] = lower_bound(all(h),r[i])-h.begin();
	}		
/*	forn(i,n)
		printf("%d %d\n",l[i],r[i]);*/
}


void paint(int l, int r, int col){
	for (int x = l; x < r; x ++)
		c[x] = col;
}


void solve(){
	a.resize(n);
	forn(i,n){
		a[i].l = l[i];
		a[i].r = r[i];
		a[i].n = i;
		a[i].d = r[i]-l[i];
	}
	sort(all(a),ls);
	forn(i,n){
		if (i && a[i].l > a[i-1].l){
			int add = a[i].l - a[i-1].l;
			forn(j,p.size())
				p[j].d -= add;
		}
		np.clear();
		bool ins = false;
		forn(j,p.size())
			if (p[j].d < a[i].d || ins)
				np.pb(p[j]);
			else{
				line t;
				bool rt = false;
				if (j >=2 && p[j-2].d < 0 && p[j-1].d > 0){
					t = p[j-1];
					np.pop_back();
					rt = true;
				}
				ins = true;
				np.pb(a[i]);
				if (rt)
					np.pb(t);
				np.pb(p[j]);
			}
		if (!ins){
			line t;
			bool rt = false;
			if (p.size() ==2 && p[0].d <= 0 && p[1].d > 0){
				t = p[1];
				np.pop_back();
				rt = true;
			}
			ins = true;
			np.pb(a[i]);
			if (rt)
				np.pb(t);
		}
		p = np;
	}
	forn(i,nmax)
		c[i] = -1;
	ford(i,p.size())
		paint (p[i].l,p[i].r,p[i].n);
	set<int> h;
	forn(i,nmax)
		if (c[i] != -1)
			h.insert(c[i]);
	res = h.size();
}	

void read(){
	scanf("%d",&n);
	forn(i,n)
		scanf("%d %d",&l[i],&r[i]);
}

void write(){
	cout << res << endl;
	ford(i,p.size())
		printf("%d ",p[i].n+1);
}

int main(){
//    	freopen("input.txt","rt",stdin);
//    	freopen("output.txt","wt",stdout);
// 	
	read();
	recalc();
	solve();
	write();
	
	return 0;
}
