#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=3010, TL=1.9*CLOCKS_PER_SEC;
char s[N][N];
int res, x, y, r;

int main () {
// 	freopen ("c.in", "r", stdin);
// 	freopen ("c.out", "w", stdout);	
	int n, m;
	scanf ("%d%d", &n, &m);
	for (int i=1; i<=n; i++)
		scanf ("%s", s[i]+1);
	for (int i=1; i<=n; i++)
		for (int j=1; j<=m; j++) {
			if (clock()>TL) 
				goto ans;
			
			int cur=(s[i][j]=='*');
			
			if (res<cur) 
				res=cur, x=j, y=i, r=0;
			
			if (i==1 || i==n || j==1 || j==m || cur && (s[i-1][j]=='*' || s[i+1][j]=='*' || s[i][j-1]=='*' || s[i][j+1]=='*'))
				continue;
			
			cur+=(s[i-1][j]=='*') + (s[i+1][j]=='*') + (s[i][j-1]=='*') + (s[i][j+1]=='*');
			
			if (res<cur) 
				res=cur, x=j, y=i, r=1;
// 			
			for (int k=1; k<i-1 && k<j-1 && k<n-i && k<m-j; k++) {
				for (int x=1; x<k; x++)
					if (s[i+x][j+(k-x)]=='*' && (s[i+x+1][j+(k-x)]=='*' || s[i+x][j+(k-x)+1]=='*')) 
						goto fail;
				for (int x=1; x<k; x++)
					if (s[i-x][j+(k-x)]=='*' && (s[i-x-1][j+(k-x)]=='*' || s[i-x][j+(k-x)+1]=='*'))
						goto fail;
				for (int x=1; x<k; x++)
					if (s[i+x][j-(k-x)]=='*' && (s[i+x+1][j-(k-x)]=='*' || s[i+x][j-(k-x)-1]=='*'))
						goto fail;
				for (int x=1; x<k; x++)
					if (s[i-x][j-(k-x)]=='*' && (s[i-x-1][j-(k-x)]=='*' || s[i-x][j-(k-x)-1]=='*'))
						goto fail;
				if (s[i][j+k]=='*' && (s[i+1][j+k]=='*' || s[i-1][j+k]=='*' || s[i][j+k+1]=='*'))
					goto fail;
				if (s[i][j-k]=='*' && (s[i+1][j-k]=='*' || s[i-1][j-k]=='*' || s[i][j-k-1]=='*'))
					goto fail;
				if (s[i+k][j]=='*' && (s[i+k][j+1]=='*' || s[i+k][j-1]=='*' || s[i+k+1][j]=='*'))
					goto fail;
				if (s[i-k][j]=='*' && (s[i-k][j+1]=='*' || s[i-k][j-1]=='*' || s[i-k-1][j]=='*'))
					goto fail;				
				for (int x=1; x<=k; x++)
					cur+=(s[i+x][j+(k+1-x)]=='*')+(s[i-x][j+(k+1-x)]=='*')+(s[i+x][j-(k+1-x)]=='*')+(s[i-x][j-(k+1-x)]=='*');
				cur+=(s[i][j+k+1]=='*')+(s[i][j-k-1]=='*')+(s[i+k+1][j]=='*')+(s[i-k-1][j]=='*');
				if (res<cur) 
					res=cur, x=j, y=i, r=k+1;
			}
fail:;
		}
ans:printf ("%d %d %d %d\n", res, x, y, r);
	return 0;
} 
