#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

vector<int> vx;
int l[1000], r[1000], was[1000], col[1000], use[1000];
int g[1000][1000];
int n;
map<int, int> rc;
set<pair<pair<int, int>, int> > all;
vector<int> ans;

int dfs (int x) {
	was[x] = 1;
	for (int i = 0; i < n; i++)
		if (g[x][i] && !was[i]) dfs (i);
	ans.push_back (x);
}

int main () {
	scanf ("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf ("%d%d", &l[i], &r[i]);
		vx.push_back (l[i]);
		vx.push_back (r[i]);
	}
	sort (vx.begin (), vx.end ());
	int q = 0;
	for (int i = 0; i < vx.size (); i++)
		if (i == 0 || vx[i] != vx[i - 1]) {
			q++;
			rc[vx[i]] = q;
		}
	for (int i = 0; i < n; i++) {
		l[i] = rc[l[i]];
		r[i] = rc[r[i]];
	}
	memset (g, 0, sizeof (g));
	for (int i = 1; i < q; i++) {
		for (int j = 0; j < n; j++) {
			if (l[j] == i) all.insert (make_pair (make_pair (-r[j], l[j]), j));
			if (r[j] == i) all.erase (make_pair (make_pair (-r[j], l[j]), j));
		}
		set<pair<pair<int, int>, int> >::iterator it;
		int last = -1;
		for (it = all.begin (); it != all.end (); it++) {
			int j = it->second;
			if (last != -1)	g[j][last] = 1;
			last = j;
		}
	}
	memset (was, 0, sizeof (was));
	for (int i = 0; i < n; i++)
		if (!was[i]) dfs (i);
	memset (col, 0, sizeof (col));
	for (int i = 0; i < n; i++) {
		int k = ans[i];
		for (int j = l[k]; j < r[k]; j++)
			col[j] = k + 1;
	}
	memset (use, 0, sizeof (use));
	for (int j = 1; j < q; j++)
		use[col[j]] = 1;
	int cans = 0;
	for (int j = 1; j <= n; j++) cans += use[j];
	printf ("%d\n", cans);
	for (int i = 0; i < n; i++)
		printf ("%d ", ans[i] + 1);
	printf ("\n");
}