#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define day first
#define s second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii1;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;
const int64 P = 1000000009;

int a[200][200], d[200], wmin;
vector <int> ans, q;
int n, m, it;
bool u[200];

void answer ()
{
	printf ("%d\n", wmin);
	printf ("%d\n", ans.size());
	forn (i, ans.size())
		printf ("%d ", ans[i]+1);
	printf ("\n");	
	cerr << clock() / 1000 << endl;		
	exit (0);
}

void go (int v, int sn, int sum)
{
	if (v == n)
		return;
	if ((sn & 1) && (sum < wmin))
	{
		wmin = sum;
		ans = q;
	}	
	go (v+1, sn, sum);
	u[v] = 1;
	it ++;
	if (it == 1000)
	{
		if ((int)clock() / 1000 > 1900)
			answer ();
		it = 0;
	}		
	forn (i, n)
		if (u[i])
			sum -= a[v][i];
		else
			sum += a[v][i];	
	q.pb (v);
	go (v+1, sn+1, sum);
	q.pop_back();		
	u[v] = 0;
}

int main ()
{	
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);
	scanf ("%d%d", &n, &m);
	seta (a, 0);
	forn (i, m)
	{
		int x, y, w;
		scanf ("%d%d%d", &x, &y, &w);
		x --;
		y --;
		a[x][y] += w;
		a[y][x] += w;
	}
	seta (d, 0);
	forn (i, n)
		forn (j, n)
			d[i] += a[i][j];
	int res = 0;
	forn (i, n)
		if (d[i] < d[res])
			res = i;
	ans.clear ();
	ans.pb (res);		
	wmin = d[res];
	seta (u, 0);
	q.clear ();
	it = 0;
	go (0, 0, 0);
	answer ();
	return 0;
}
