#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=10010, R=239, MOD=(1<<14)-1, TL=1.95*CLOCKS_PER_SEC;
int n, m, res[N], p[N], f[N+N];
int r[N], h[N], ky[MOD+1];
pair< vector<int>, int> tb[MOD+1];
char w[MOD+1];

inline int hash(int x) {
	int j=(x>>8 & MOD);
	for (; w[j] && ky[j]!=x;)
		if (++j>MOD) j=0;
	if (!w[j])
		w[j]=1, ky[j]=x, tb[j].first.clear(), tb[j].second=0;
	return j;
}

inline int cl() {
	memset(f+1, 0, n*sizeof f[0]);
	memset(w, 0, sizeof w);
}
char s[N];
int main () {
	
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
// 	for (int i=1; i<=5000; i++) s[i]=rand()%26+'a';
	
// 	for (int i=2; i*i<=R; i++)
// 		if (!(R%i)) {
// 			cerr << "not prime\n";
// 			break;
// 		}
		
	scanf ("%s", s+1);
	n=strlen(s+1);
	r[0]=1, h[0]=0;
	for (int i=1; i<=n; i++) {
		h[i]=h[i-1]+s[i]*r[i-1];
		r[i]=r[i-1]*R;
	}
	int res=0, L, I;
	for (int l=2; l<=n && clock()<TL; l++) {
		cl();
		for (int i=l; i<=n; i++) {
			int h=(::h[i]-::h[i-l])*r[n-i], tt=hash(h); 
			vector<int> &u=tb[tt].first;
			int &q=tb[tt].second;
			u.push_back(i);
			while(u[q]<=i-l) q++;
			if (q>0) f[i]=f[u[q-1]]+1;
			else f[i]=1; 
			if (res<f[i]*(l-1)-l)
				res=f[i]*(l-1)-l, L=l, I=i;
		}
	}
	if (!res)
		printf ("\n%s\n", s+1);
	else {
		cl();
		for (int i=L; i<=n; i++) {
			int h=(::h[i]-::h[i-L])*r[n-i], tt=hash(h); 
			vector<int> &u=tb[tt].first;
			int &q=tb[tt].second;
			u.push_back(i);
			while(u[q]<=i-L) q++;
			if (q>0) f[i]=f[u[q-1]]+1, p[i]=u[q-1];
			else f[i]=1;
		}
		for (int j=I-L+1; j<=I; j++)
			printf ("%c", s[j]);
		printf ("\n");
		for (int j=I; j; j=p[j]) {
			s[j]='A';
			for (int x=j-L+1; x<j; x++)
				s[x]='B';
		}			
		for (int i=1; i<=n; i++)
			if (s[i]=='A' || islower(s[i])) 
				printf ("%c", s[i]);
	}
// 	cerr << clock() << endl;
	return 0;
} 
