#include <iostream>
#include <vector>

using namespace std;

const int maxw=1000;

int w,h;
vector< pair<int,int> > stars;
vector<int> ans;
char mat[maxw][maxw];

int abs(int a)
{
	return ((a<0)?(-a):a);
}

bool InBound(int x, int l, int r)
{
	return (l<=x && x<=r);
}

int check(int x, int y, int r)
{
	int res=0;
	for (int i=0; i<stars.size(); i++)
		if ((abs(stars[i].first-x)+abs(stars[i].second-y))<=r)
	{
		for (int xch=-1; xch<=1; xch++)
				for (int ych=-1; ych<=1; ych++)
					if (abs(xch)!=abs(ych))
					{
						int nx=stars[i].first+xch;
						int ny=stars[i].second+ych;
						if (InBound(nx,0,w-1)&&InBound(ny,0,h-1))
							if (mat[nx][ny]==1)
								if ((abs(x-nx)+abs(y-ny))<=r)
									return -1;
					
					}
		res++;
	}
	return res;
}

int main()
{
	stars.clear();
	memset(mat,0,sizeof(mat));
	
	cin >> h >> w;
	
	for (int y=0; y<h; y++)
	{
		string s;
		cin >> s;
		for (int x=0; x<w; x++)
			if (s[x]=='*')
			{
				pair<int,int> buf(x,y);
				stars.push_back(buf);
				mat[x][y]=1;
			}
	}
	
	ans.clear();
	ans.push_back(-1);
	
	for (int c=0; (c*2+1)<=min(w,h); c++)
		for (int x=c; x<w-c; x++)
			for (int y=c;y<h-c; y++)
			{
				int n = check(x,y,c);
				if (n>ans[0])
				{
					ans.clear();
					ans.push_back(n);
					ans.push_back(x);
					ans.push_back(y);
					ans.push_back(c);
				}
			}
	
	cout << ans[0] << ' ' << ans[1]+1 << ' ' << ans[2]+1 <<  ' ' << ans[3];
}