#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10000;
const int inf = (int)1e9;

struct rec{
	int l,r;
	int64 h;
	rec(){};
	rec(int l1,int r1, int64 h1){
		l = l1;
		r = r1;
		h = h1;
	};
};
	
bool ls(rec a, rec b){
	if (a.h != b.h) return a.h < b.h;
	if (a.l != b.l) return a.l < b.l;
	return a.r < b.r;
}

vector<int> a;

int64 ha[nmax];

string s,res,ans;
int best;
int pos,dlin;
int n;


void solve(){
	n = s.size();
	vector<rec> e;
	forn(i,n)
		ha[i] = 0;
	int nl = 0,nr = 0,best = inf;
		
	for (int dlin = 1; dlin < n ;dlin ++){
		e.clear();
		for (int i = 0; i + dlin-1 < n; i++){
			ha[i] = ha[i] * 779 + s[i + dlin-1];
			e.pb(rec(i,i+dlin-1,ha[i]));
		}
		sort(all(e),ls);
		forn(i,e.size()){
			int l = i;
			int r = i;
			while (r < (int)e.size() && e[r].h == e[l].h) r++;
			r--;
			int now,kol;
			now = kol = 0;
			for (int j = l; j <= r; j++)
				if (e[j].l >= now){
					now = e[j].r+1;
					kol++;
				}
			if (dlin + n - (dlin-1)*kol < best){
				best = dlin +n - (dlin-1)*kol;
				nl = e[i].l;
				nr = e[i].r;
			}
			i = r;
		}
	}
		//cerr << nl << " " << nr <<" " << best << endl;
	res = s.substr(nl,nr-nl+1);
	int dlin = nr-nl+1;
	for (int i = 0; i < n; i++){
		if (i + dlin -1 >= n || s.substr(i,dlin) != res)
			ans += s[i];
		else{
			ans += 'A';
			i += dlin-1;
		}
	}
}

void read(){
	getline(cin,s);
}

void write(){
	printf("%s\n%s",res.data(),ans.data());
}


int main(){
//  	freopen("input.txt","rt",stdin);
//  	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
