#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long int64;
typedef pair<int64,int64> pii;
typedef long double real;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 15000;

int64 a[nmax];
int64 p[nmax];
int64 c[nmax];
int64 l[nmax], r[nmax];
int64 s,m;
int n,k;

vector<pii> g[nmax];

void bad_luck(){
	puts("Bad luck");
	exit(0);
}

void make(){
	forn(i,n)
		p[i] = c[i] = a[i];
	forn(i,n){
		s -= p[i];
		g[i].clear();
		int add = 0;
		forn(j,n)
			if (i != j){
			add = a[j]+p[j]-s;
			while (a[m]-add > s - p[m])add++;
// 			cerr << i << " " << j << " " << add << " " <<s << endl;
			if (add > 0){
				g[i].pb(mp(j,add));
				a[j] -= add;
				p[i] -= add;
				if (p[i] < add) bad_luck();
			}
		}
		forn(j,n)
			if (i != j && a[j] > 0){
				if (p[i] == 0)break;
				add = min(p[i],a[j]);
				g[i].pb(mp(j,add));
				p[i] -= add;
				a[j] -= add;
			}
	}
	forn(i,n)
		sort(all(g[i]));
/*	forn(i,n){
		forn(j,g[i].size())
			cout << g[i][j].fs << " " << g[i][j].sc << endl;
		cout << endl;
	}*/
}
		
void print(int64 l, int64 r){
	l--;
	r--;
	int64 now = 0;
/*	cerr << l << " " << r << " " << now << endl;*/
	forn(i,n){
			
		if (now + c[i] < l){
			now += c[i];
			continue;
		}
		if (now > r)break;
		forn(j,g[i].size()){
			if (now > r)break;
			if (now + g[i][j].sc < l){
				now += g[i][j].sc;
				continue;
			}
			int k;
			if (now >= l)
				k = 0;
			else{
				k = l - now;
				now = l;
			}
			//cerr << now << " " << l << " " << r << " " << k << endl;
			while (k < g[i][j].sc && now <= r){
				printf("%lld ",g[i][j].fs+1);
				k++;
				now++;
			}
		}
	}
	printf("\n");
}

void solve(){
	s = 0;
	m = 0;
	forn(i,n){
		s += a[i];
		m = max(m,a[i]);
	}
	if (2*m > s) bad_luck();
	make();	
	puts("Ok");
/*	cerr << k << endl;*/
	forn(i,k)
		print(l[i],r[i]);
}

void read(){
	scanf("%d",&n);
	forn(i,n)
		scanf("%lld",&a[i]);
	scanf("%d",&k);
	forn(i,k)
		scanf("%lld %lld",&l[i],&r[i]);
}


int main(){
//     	freopen("input.txt","rt",stdin);
//     	freopen("output.txt","wt",stdout);
 	
	read();
	solve();
//	write();
	
	return 0;
}
