#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define sz(a) (int)(a).size()

typedef long long ll;

#define maxn 20010

struct item
{
  int i, a;

  item() {}
  item( int i_, int a_ ) : i(i_), a(a_) {}
};

int n, a[maxn];
vector <item> r, b;
vector <int> rs;

bool aless( int i, int j )
{
  return a[i] > a[j];
}

void finalize( int t )
{
  forn(i, n)
    if (i == t)
      forn(j, n)
        r.pb(item(j, a[j]));
    else
      r.pb(item(t, a[i]));
}

int main()
{
  scanf("%d", &n);
  forn(i, n)
    scanf("%d", &a[i]);
  
  ll sum = 0;
  forn(i, n)
    sum += a[i];
  forn(i, n)
    if (a[i] * 2 > sum)
    {
      puts("Bad luck");
      return 0;
    }

  int i = 0;
  while (i < n)
  {
    if (!a[i])
    {
      i++;
      continue;
    }
    
    ll cur = sum - 2 * a[i];
    
    int s = 0, j = i + 1;
    while (s + a[j] < a[i])
      s += a[j++];
    
    int get = a[i] - s;
    int t = a[j] - get, mi = j;
    for (int k = j + 1; k < n; k++)
      if (t < a[k])
        t = a[k], mi = k;
    if (2 * t <= cur)
    {
      for (int k = i + 1; k < j; k++)
        r.pb(item(k, a[k])), a[k] = 0;
      r.pb(item(j, get)), a[j] -= get;
      r.pb(item(i, a[i])), a[i] = 0;
      i = j;
      sum = cur;
    }
    else
    {
      int num = 2 * a[i] - (2 * t - cur), t;
      #define F(k, x) { t = min(x, num); num -= t; r.pb(item(k, t)); a[k] -= t; }
      for (int k = i + 1; k < j; k++)
        F(k, a[k]);
      F(j, get);
      F(i, a[i]);
      finalize(mi);
    }
  }

  puts("Ok");
  rs.pb(0);
  forn(i, sz(r))
    rs.pb(rs[i] + r[i].a);
  int tn;
  scanf("%d", &tn);
  while (tn--)
  {
    int a, b;
    scanf("%d%d", &a, &b), a-- ,b--;

    int mi = 0, ma = sz(r) - 1, av;
    while (mi < ma)
      if (rs[av = (mi + ma + 1) / 2] > a)
        ma = av - 1;
      else
        mi = av;

    for (int i = a; i <= b; i++)
    {
      while (rs[mi] + r[mi].a <= i)
        mi++;
      printf("%d ", r[mi].i + 1);
    }
  }
  puts("");
  return 0;
}
