{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
  { you can add units after this };
const
  MaxN=10001;
  MaxM=200001;
type
  edge=record
    x,y,d:longint;
    i,j:longint;
  end;
var
  i,j,n,m:longint;
  s:array[0..MaxN]of string;
  a:array[0..MaxM]of edge;
  u:array[0..MaxM]of boolean;
  p:array[0..MaxN]of longint;
  pf:array[0..MaxN]of longint;
  sum:longint;
Procedure Sort(l,r:longint);
var
  i,j,x:longint;
  h:edge;
Begin
  i:=l;j:=r;x:=a[(l+r)shr 1].d;
  repeat
    while a[i].d>x do inc(i);
    while x>a[j].d do dec(j);
    if i<=j then begin
      h:=a[i];a[i]:=a[j];a[j]:=h;
      inc(i);dec(j);
    end;
  until i>j;
  if (l<j) then Sort(l,j);
  if (i<r) then Sort(i,r);
End;
Function Root(v:longint):longint;
Begin
  if p[v]<>v then p[v]:=Root(p[v]);
  result:=p[v];
end;
Procedure Union(i,j,k:longint);
Begin
  if (k and 1 = 0) then p[i]:=j else p[j]:=i;
End;
Function Make(x,y:longint):edge;
var
  i,j,k:longint;
  t:string;
  n,m:longint;
Begin
  result.x:=x;
  result.y:=y;
  result.d:=-1;
  if length(s[x])>length(s[y]) then begin
    i:=x;
    x:=y;
    y:=i;
  end;
  t:=s[x]+'$'+s[y];
  n:=length(t);
  m:=length(s[x]);
  for i:=1 to m do begin
    pf[1]:=0;k:=0;
    for j:=2 to n do begin
      while (k>0)and(t[k+1]<>t[j]) do k:=pf[k];
      if (t[k+1]=t[j]) then inc(k);
      pf[j]:=k;
      if (result.d<k)and(j>m) then begin
        result.d:=k;
        result.i:=i;
        result.j:=j-k-m+i-1;
      end;
    end;
    delete(t,1,1);
    dec(n);
  end;
End;
Begin
  //assign(input,'a.in');reset(input);assign(output,'a.out');rewrite(output);
  readln(n);
  for i:=1 to n do readln(s[i]);
  m:=0;
  for i:=1 to n do
    for j:=i+1 to n do begin
      inc(m);
      a[m]:=Make(i,j);
    end;
  Sort(1,m);
  fillchar(u,sizeof(u),0);
  sum:=0;
  for i:=1 to n do
    p[i]:=i;
  for i:=1 to m do
    if Root(a[i].x)<>Root(a[i].y) then begin
      Union(a[i].x,a[i].y,a[i].d);
      sum:=sum+a[i].d;
      u[i]:=true;
    end;
  writeln(sum);
  for i:=1 to m do if u[i] then writeln(a[i].x,' ',a[i].y,' ',a[i].i,' ',a[i].j,' ',a[i].d);
  close(input);close(output);
End.