#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define pb push_back
#define sz(a) (int)(a).size()

typedef long long ll;

#define maxn 20010

struct item
{
  int i, a;

  item() {}
  item( int i_, int a_ ) : i(i_), a(a_) {}
};

int n, a[maxn], a0[maxn];
vector <item> r;
vector <int> rs;

bool aless( int i, int j )
{
  return a[i] > a[j];
}

int main()
{
  scanf("%d", &n);
  forn(i, n)
    scanf("%d", &a[i]), a0[i] = a[i];
  
  ll sum = 0;
  forn(i, n)
    sum += a[i];
  forn(i, n)
    if (a[i] * 2 > sum)
    {
      puts("Bad luck");
      return 0;
    }

  int i = 0;
  while (i < n)
  {
    if (!a[i])
    {
      i++;
      continue;
    }
    
    ll cur = sum - 2 * a[i];
    
    int s = 0, j = i + 1;
    while (s + a[j] < a[i])
      s += a[j++];

    int get = a[i] - s;
    int t = a[j] - get, mi = j;
    for (int k = j + 1; k < n; k++)
      if (t < a[k])
        t = a[k], mi = k;
    
//     printf("i=%d j=%d sum=%Ld cur=%Ld\n", i, j, sum, cur);

    ll rest = cur - t;
    if (t <= rest)
    {
      for (int k = i + 1; k < j; k++)
        r.pb(item(k, a[k])), a[k] = 0;
      r.pb(item(j, get)), a[j] -= get;
      r.pb(item(i, a[i])), a[i] = 0;
      i = j;
      sum = cur;
    }
    else
    {
      int num = 2 * a[i] - (t - rest), tmp;
      if (mi == j)
      {
        num -= get;
        if (num < a[i])
          num -= get;
      }
      int len = -num;
      for (int k = i; k < mi; k++)
        len += a[k];
      
//       printf("num=%d t=%d mi=%d\n", num, t, mi);
      #define F(k, x) { tmp = min(x, num); num -= tmp; r.pb(item(k, tmp)); a[k] -= tmp; }
      for (int k = i + 1; k < j; k++)
        F(k, a[k]);
      F(j, get);
      F(i, a[i]);
/*      printf("num=%d t=%d mi=%d len=%d\n", num, t, mi, len);
      forn(i, n)
        printf("%d : %d\n", i, a[i]);*/
      
      r.pb(item(mi, len));
      forn(i, n)
        if (i != mi)
          r.pb(item(i, a[i]));
      r.pb(item(mi, a0[mi] - len));
      break;
    }
  }

//   forn(i, sz(r))
//     printf("%d %d\n", r[i].i + 1, r[i].a);

  puts("Ok");
  rs.pb(0);
  forn(i, sz(r))
    rs.pb(rs[i] + r[i].a);
  int tn;
  scanf("%d", &tn);
  while (tn--)
  {
    int a, b;
    scanf("%d%d", &a, &b), a-- ,b--;

    int mi = 0, ma = sz(r) - 1, av;
    while (mi < ma)
      if (rs[av = (mi + ma + 1) / 2] > a)
        ma = av - 1;
      else
        mi = av;

    for (int i = a; i <= b; i++)
    {
      while (rs[mi] + r[mi].a <= i)
        mi++;
      printf("%d ", r[mi].i + 1);
    }
  }
  puts("");
  return 0;
}
