#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;
int const N=500010;
char s[N+N], *b[N];
int pr[N], pf[N];
int ck, jk;
struct node {
	int c, i, j, x, y;
	node(int c=0, int i=0, int j=0, int x=0, int y=0): c(c), i(i), j(j), x(x), y(y) {}
};
vector<node> v, res;
void kmp(char *s, char *p, int n, int m) {
	int i=0, j=-1;
	pf[0]=-1;
	while(i<n) {
		for (; j>=0 && s[i]!=s[j]; j=pf[j]);
		i++, j++;
		if (s[i]==s[j]) pf[i]=pf[j];
		else pf[i]=j;
	}
	i=0, j=0, ck=0;
	while(i<m) {
		for (; j>=0 && p[i]!=s[j]; j=pf[j]);
		i++, j++;
		if (ck<j)
			ck=j, jk=i-j;
	}
}	
void num(char *s, char *p, int n, int m, node &res) {
	for (int i=0; i<n; i++) {
		kmp(s+i, p, n-i, m);
		if (ck>res.c)
			res.c=ck, res.i=i, res.j=jk;
	}	
}
int uni(int x, int y) {
	if (rand()&1) pr[x]=y;
	else pr[y]=x;
}
int find(int x) {
	if (!pr[x]) return x;
	return pr[x]=find(pr[x]);
}
	
struct lsf : public binary_function < node, node, bool > {
	inline bool operator()(const node &a, const node &b) const {
		return a.c>b.c;
	}
}; 
int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	int n; scanf ("%d", &n);
	int c=0;
	for (int i=0; i<n; i++) {
		scanf ("%s", s+c);
		b[i]=s+c;
		c+=strlen(s+c)+1;
	}
	b[n]=s+c;
	for (int i=0; i<n; i++)
		for (int j=i+1; j<n; j++) {
			v.push_back(node(0, 0, 0, i, j));
			num(b[i], b[j], b[i+1]-b[i]-1, b[j+1]-b[j]-1, *(--v.end()));
		}
	sort(v.begin(), v.end(), lsf());
	int rs=0;
	for (int i=0; i<v.size(); i++) {
		int x=find(v[i].x), y=find(v[i].y);
		if (x!=y)
			uni(x, y), res.push_back(v[i]), rs+=v[i].c;
	}	
	printf ("%d\n", rs);
	for (int i=0; i<res.size(); i++)
		printf ("%d %d %d %d %d\n", res[i].x+1, res[i].y+1, res[i].i+1, res[i].j+1, res[i].c);
	return 0;
} 
