#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long long int64;
typedef pair<int,int> pii;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define l first
#define r second
#define pb push_back
#define mp make_pair

const int nmax = 110000;

pii a[nmax];
int n,m,k;
int t[nmax];
int res[nmax];
int sum;

void solve(){
	sum = 0;
	forn(j,k){
		vector<pii> b;
		forn(i,n)
			if (res[i] == 0){
				b.pb(mp(a[i].l,-1));
				b.pb(mp(a[i].r,1));
			}
		sort(all(b));
		int pos = 0;
		int best = 0;
		int now = 0;
		forn(i,b.size()){
			now -= b[i].r;
			if (now > best){
				pos = b[i].l;
				best = now;
			}
		}
		t[j] = pos;
		now = 0;
		forn(i,n)
			if (res[i] == 0 && now < m && a[i].l <= pos && pos <= a[i].r){
				now ++;
				sum++;
				res[i] = j+1;
			}
	}
}
				
			

void read(){
	scanf("%d %d %d",&n,&m,&k);
	forn(i,n)
		scanf("%d %d",&a[i].l,&a[i].r);
}

void write(){
	cout << sum << endl;
	forn(i,k)
		printf("%d ",t[i]);
	printf("\n");
	forn(i,n)
		printf("%d ",res[i]);
	printf("\n");
}

int main(){
//  	freopen("input.txt","rt",stdin);
//  	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
