Type TEdge=record
		  st,en,w,sp1,sp2:Integer; 
		 end;

Var edge:Array[1..1000000]of TEdge;
		use:Array[1..1000000]of Boolean;
		color:Array[1..10000]of Integer;
		v1,v2,comp,i,uk,cost,n,m,j:Integer;
		dl:Array[1..10000]of Integer;
		s:Array[1..10000]of String;
		
		


function find(v:Integer):Integer;
Begin
	if (color[v]=v) then begin
		find:=v;exit;
	end else begin
		color[v]:=find(color[v]);
		find:=color[v];
	end;
End;

procedure Union(v1,v2:Integer);
Begin
	if odd(v1+v2) then color[v2]:=v1 else color[v1]:=v2;
End;


Procedure Swap(var a,b:TEdge);
var c:TEdge;
Begin
	c:=a;a:=b;b:=c;
End;


Procedure sort(l,r:Integer);
Var i,j:Integer;
		x:TEdge;
Begin
	x:=edge[(l+r) div 2];
	i:=l;j:=r;
	repeat
		while edge[i].w>x.w do Inc(i);
		while x.w>edge[j].w do Dec(j);
		if i<=j then begin
			Swap(edge[i],edge[j]);
			Inc(i);Dec(j);
		end;
	until i>j;
	if l<j then Sort(l,j);
	if i<r then Sort(i,r);
End;


Procedure Add(v1,v2:Integer);
Var k,i,j,max,max1,max2,max3:Integer;
Begin
	max:=0;max1:=1;max2:=1;max3:=0;
	for i:=1 to dl[v1] do
		for j:=1 to dl[v2] do begin
			k:=0;
			while (i+k<=dl[v1]) and (j+k<=dl[v2]) and (s[v1][i+k] = s[v2][j+k]) do Inc(k);
			if k>max then begin max:=k;max1:=i;max2:=j;max3:=k;end;
		end;
	Inc(m);
	edge[m].st:=v1;edge[m].en:=v2;
	edge[m].w:=max3;
	edge[m].sp1:=max1;
	edge[m].sp2:=max2;
End;

begin
	ReadLn(n);m:=0;
	for i:=1 to n do begin
		ReadLn(s[i]);dl[i]:=length(s[i]);
	end;
	for i:=1 to n do
		for j:=i+1 to n do begin
			Add(i,j);
		end;
	Sort(1,m);cost:=0;
	
	uk:=1;comp:=n;
	for i:=1 to n do color[i]:=i;
	while comp<>1 do begin
		v1:=find(edge[uk].st);
		v2:=find(edge[uk].en);
		if v1<>v2 then begin
			Dec(comp);
			use[uk]:=true;
			cost:=cost+edge[uk].w;
			Union(v1,v2);
		end;
		Inc(uk);
	end;
	
	WriteLn(cost);
	for i:=1 to uk do begin
		if use[i] then WriteLn(edge[i].st,' ',edge[i].en,' ',edge[i].sp1,' ',edge[i].sp2,' ',edge[i].w);
	end;
	
end. 
