{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
  { you can add units after this };
type
  edge=record
    s,t:longint;
    nom:longint;
  end;
const
  MaxN=500;
  MaxK=1000;
var
  i,j,n,m,k:longint;
  d:array[0..MaxN]of edge;
  st:array[0..MaxN]of longint;
  ot,kol,uk,ans_uk,ans_ot:array[0..MaxN]of longint;
  v:longint;
  sum:longint;
  ans_sum:longint;
  start:extended;
Procedure qSort(l,r:longint);
var
  i,j,x:longint;
  h:longint;
Begin
  i:=l;j:=r;x:=st[(l+r)shr 1];
  repeat
    while st[i]<x do inc(i);
    while x<st[j] do dec(j);
    if i<=j then begin
      h:=st[i];st[i]:=st[j];st[j]:=h;
      inc(i);dec(j);
    end;
  until i>j;
  if (l<j) then qSort(l,j);
  if (i<r) then qSort(i,r);
End;

Procedure Sort(l,r:longint);
var
  i,j,x:longint;
  h:edge;
Begin
  i:=l;j:=r;x:=d[(l+r)shr 1].t;
  repeat
    while d[i].t<x do inc(i);
    while x<d[j].t do dec(j);
    if i<=j then begin
      h:=d[i];d[i]:=d[j];d[j]:=h;
      inc(i);dec(j);
    end;
  until i>j;
  if (l<j) then Sort(l,j);
  if (i<r) then Sort(i,r);
End;
Procedure Perebor(v,p:longint);
var
  i:longint;
Begin
  if (v=k+1) then begin
    fillchar(kol,sizeof(kol),0);
    fillchar(uk,sizeof(uk),0);
    sum:=0;
    v:=1;
    i:=1;
    while (i<=n)and(v<=k) do begin
      if (d[i].s<=ot[v])and(ot[v]<=d[i].t) then begin
        uk[d[i].nom]:=v;
        inc(kol[v]);
        inc(sum);
      end;
      inc(i);
      if kol[v]=m then inc(v);
    end;
    if (sum>ans_sum) then begin
      ans_sum:=sum;
      ans_ot:=ot;
      ans_uk:=uk;
    end;
    if (now-start)*24*60*60>1.85 then begin
        writeln(ans_sum);
        for i:=1 to k do write(ans_ot[i],' ');
        writeln('');
        for i:=1 to n do write(ans_uk[i],' ');
        halt(0);
    end;
  end else begin
    for i:=p to n do begin
      ot[v]:=st[i];
      Perebor(v+1,i);
    end;
  end;
End;
Begin
  start:=now;
  //assign(input,'d.in');reset(input);assign(output,'d.out');rewrite(output);
  read(n,m,k);
  for i:=1 to n do begin
    read(d[i].s,d[i].t);
    st[i]:=d[i].s;
    d[i].nom:=i;
  end;
  Sort(1,n);
  qsort(1,n);
  Perebor(1,1);
  writeln(ans_sum);
  for i:=1 to k do write(ans_ot[i],' ');
  writeln('');
  for i:=1 to n do write(ans_uk[i],' ');
  close(input);close(output);
End.