#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

char s[1000001], w[1000001];
int l[1000001], p[1000001];
int x[1000001], f[1000001], y[1000001];
int q[1000001][2];
int cnt[26], rev[26];
vector<int> all[1000001];
vector<pair<pair<int, int>, pair <int, int> > > edges[1000001];
int a1[500001], a2[500001], a3[500001], a4[500001], a5[500001];
int par[1000001], fr[1000001];

int o;

int getp (int x) {
	if (par[x] == x) return x; else {
		par[x] = getp (par[x]);
		return par[x];
	}
}

int main () {
	int n;
	scanf ("%d", &n);
	o = 0;
	for (int i = 0; i < n; i++) {
		scanf ("%s", s);
		l[i] = 0;
		fr[i] = o;
		while (s[l[i]]) {
			p[o] = i;
			w[o++] = s[l[i]];
			l[i]++;
		}
		l[i] = o;
	}
	memset (x, 0, sizeof (x));
	memset (cnt, 0, sizeof (cnt));
	for (int i = 0; i < o; i++) cnt[w[i] - 'a']++;
	int r = 0;
	for (int i = 0; i < 26; i++) {
		if (cnt[i] > 0) r++;
		rev[i] = r;
	}
	for (int i = 0; i < o; i++) x[i] = rev[w[i] - 'a'];
	for (int i = 0; (1 << i) < o; i++) {
		int k = (1 << i);
		for (int j = 0; j < o; j++) {
			q[j][0] = x[j];
			q[j][1] = x[j + k];
			f[j] = j;
		}
		for (int k = 1; k >= 0; k--) {
			for (int j = 0; j <= o; j++) all[j].clear ();
			for (int j = 0; j < o; j++)
				all[q[f[j]][k]].push_back (f[j]);
			int r = 0;
			for (int j = 0; j <= o; j++)
				for (int l = 0; l < all[j].size (); l++)
					f[r++] = all[j][l];
		}
		int r = 0;
		for (int j = 0; j < o; j++) {
			if (j == 0 || q[f[j]][0] != q[f[j - 1]][0] || q[f[j]][1] != q[f[j - 1]][1]) r++;
			x[f[j]] = r;
		}
	}
	for (int i = 0; i < o; i++) x[i]--;
	for (int i = 0; i < o; i++) y[x[i]] = i;
	y[o] = -1;
	int z = 0;
	int cur = 0;
	for (int i = 0; i < o; i++) {
		int a = i;
		int b = y[x[i] + 1];
		cur = max (0, cur - 1);
		if (b == -1) {
			cur = 0;
			continue;
		}
		while (a + cur < o && b + cur < o && w[a + cur] == w[b + cur]) cur++;
		if (p[a] != p[b]) {
			edges[min (l[p[a]] - a, min (l[p[b]] - b, cur))].push_back (make_pair (make_pair (p[a], p[b]), make_pair (a - fr[p[a]] + 1, b - fr[p[b]] + 1))); 
		}
	}
	long long ans = 0;
	int d = 0;
	for (int i = 0; i < n; i++) par[i] = i;
	for (int i = o; i >= 0; i--) 
		for (int j = 0; j < edges[i].size (); j++){
			int a = edges[i][j].first.first;
			int b = edges[i][j].first.second;
			int c = i;
			int pa = getp (a);
			int pb = getp (b);
			if (pa != pb) {
				ans += c;
				a1[d] = a + 1;
				a2[d] = b + 1;
				a3[d] = edges[i][j].second.first;
				a4[d] = edges[i][j].second.second;
				a5[d++] = c;
				if (rand () % 2 == 0) par[pa] = pb; else par[pb] = pa;
			}
		}
	printf ("%lld\n", ans);
	for (int i = 0; i < d; i++)
		printf ("%d %d %d %d %d\n", a1[i], a2[i], a3[i], a4[i], a5[i]);
}