#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=100002, M=10002;

char s[10], p[N+M];
int n, m, k, c[5], l[5];
long long f[5][N+M];
inline bool eq(char x, char y) {
	return x && y && (x=='?' || y=='?' || x==y);
}
inline void get(char &c, int &i) {
	scanf ("%c", &c);
	if (c!='-') scanf (" %c %d\n", &c, &i);
	else scanf ("%d\n", &i);
}

inline void put(long long i) {
	printf ("%lld\n", i);
	fflush(stdout);
}

inline long long fn() {
	for (int x=1; x<=c[0]; x++)
		for (int i=0; i<n; i++) {
			int j=0;
			while(eq(p[i+j], s[c[x]+j])) j++;
			f[x][i]=(j==l[x]); 	
		}
	if (s[0]=='*')
		for (int i=n-1; i>=0; i--)
			if (f[1][i]) {
				for (int j=0; j<=i; j++)
					f[1][i]=1;
				break;
			}
	for (int x=2; x<=c[0]; x++) {
		for (int i=1; i<n; i++)
			f[x-1][i]+=f[x-1][i-1];
		for (int i=0; i<n; i++)
			f[x][i]+=f[x-1][i-l[x-1]];
	}
	if (s[m-1]=='*')
		for (int i=0; i<n; i++)
			if (f[c[0]][i]) {
				for (int j=i+1; j<=n-l[c[0]]; j++)
					f[c[0]][j]+=f[c[0]][i];
				break;
			}
	long long res=0;
	for (int i=0; i<n; i++)
		res+=f[c[0]][i];	
	return res;
}

int main () {
	freopen ("c.in", "r", stdin);
	freopen ("c.out", "w", stdout);	
	scanf ("%s%s%d\n", s, p, &k);
	
	for (int i=1; s[i]; i++)
		while (s[i-1]=='*' && s[i]=='*')
			for (int j=i; s[j]; j++)
				s[j]=s[j+1];
	
	n=strlen(p), m=strlen(s);
	
	if (m==1 && s[0]=='*') {
		for (int x=0; x<k; x++) {
			char c; int i;
			get(c, i);
			if (c=='-') n--;
			else n++;
			put((long long)n*(n-1)/2);
		}
		return 0;
	}
	
	for (int i=0; s[i]; )
		if (s[i]=='*') i++;
		else {
			c[++c[0]]=i;
			while(s[i] && s[i]!='*') i++;
			l[c[0]]=i-c[c[0]];
		}
	
	for (int x=0; x<k; x++) {
		char c; int i;
		get(c, i);
		if (c=='-') {
			for (int j=i-1; j<n; j++)
				p[j]=p[j+1];
			n--;
		}
		else {
			for (int j=n; j>=i; j--)
				p[j+1]=p[j];
			n++, p[i]=c;
		}
		put(fn());
	}
	return 0;
} 
