{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
  { you can add units after this };
type
  point=record
    x,y:longint;
  end;
var
  i,j,n:longint;
  a:array[0..2001]of point;
  p,q:Point;
  max_s:extended;
Function Square(a,b:point):extended;
Begin
  result:=abs(a.x*b.y-a.y*b.x);
End;
Function Vec(var a,b:point):point;
Begin
  result.x:=b.x-a.x;
  result.y:=b.y-a.y;
End;
Function Search(l,r:longint):extended;
var
  med1,med2:longint;
  s1,s2:extended;
  i:longint;
Begin
  if (r-l<3) then begin
    result:=0;
    for i:=l to r do
      result:=max(result,Square(Vec(a[i],p),Vec(a[i],q)));
    exit;
  end;
  med1:=(2*l+r) div 3;
  med2:=(l+2*r) div 3;
  s1:=Square(Vec(a[med1],p),Vec(a[med1],q));
  s2:=Square(Vec(a[med2],p),Vec(a[med2],q));
  if s1<s2 then result:=Search(med1,r) else result:=Search(l,med2);
End;
Begin
  //assign(input,'a.in');reset(input);assign(output,'a.out');rewrite(output);
  read(n);
  max_s:=0;
  for i:=1 to n do read(a[i].x,a[i].y);
  for i:=1 to n do begin
    p:=a[i];
    for j:=i+1 to n do begin
      q:=a[j];
      max_s:=max(max_s,Search(i,j));
      max_s:=max(max_s,Search(1,i));
      max_s:=max(max_s,Search(j,n));
    end;
  end;
  writeln(max_s/2:0:5);
  close(input);close(output);
End.