program z1;
uses Math;
type integer=longint;
     TPoint=record
       x,y: integer;
     end;

var a: array[1..4000] of TPoint;
    n,i,j: integer;
    rez: Extended;

function dist(const a,b: TPoint): Extended;
begin
  dist:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
end;

function s(const v1,v2,v3: TPoint): Extended;
var a,b,c,pp: Extended;
begin
  a:=dist(v1,v2);
  b:=dist(v2,v3);
  c:=dist(v3,v1);
  pp:=(a+b+c)/2;
  s:=sqrt(pp*(pp-a)*(pp-b)*(pp-c));
end;

procedure search(const i,j: integer);
var l,r,m1,m2,m: integer;
begin
  l:=i+1;
  r:=j-1;
  m:=l+(r-l) div 2;
  while (r-l>2) do begin
    m1:=l+(r-l) div 4;
    m2:=m+(r-l) div 4;
    if s(a[i],a[j],a[m1])>s(a[i],a[j],a[m]) then begin
      r:=m; m:=m1;
    end else if s(a[i],a[j],a[m2])>s(a[i],a[j],a[m]) then begin
      l:=m; m:=m2;
    end else begin
      l:=m1; r:=m2;
    end;
  end;
  rez:=max(rez,s(a[i],a[j],a[l]));
  rez:=max(rez,s(a[i],a[j],a[l+1]));
  rez:=max(rez,s(a[i],a[j],a[r]));
end;

begin
  ReadLn(n);
  for i:=1 to n do begin
    Read(a[i].x,a[i].y);
    a[i+n]:=a[i];
  end;
  rez:=0;
  for i:=1 to n do
    for j:=i+1 to n do
    begin
      if j-i>1 then search(i,j);
      if (i+n)-j>1 then search(j,i+n);
    end;
  WriteLn(rez:0:5);
end.
