#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;

int const N=10002;

struct point {
	long long x, y;
	inline point(long long x=0, long long y=0) :x(x), y(y) {}
} a[N+N];

istream &operator>>(istream &cin, point &a) {
	return cin >> a.x >> a.y;
}

inline point operator-(const point &a, const point &b) {
	return point(a.x-b.x, a.y-b.y);
}

inline long long operator*(const point &a, const point &b) {
	return a.x*b.y-a.y*b.x;
}

int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);
	int n; cin >> n;
	
	for (int i=0; i<n; i++)
		cin >> a[i];
	if ((a[1]-a[0])*(a[2]-a[0])<0)
		for (int i=0, j=n-1; i<j; i++, j--)
			swap(a[i], a[j]);
	for (int i=0; i<n; i++)
		a[n+i]=a[i];
	
	long long res=0;
	for (int i=0; i<n-1; i++) {
		int p=i+1, q=i+1, j=i+1;
		do {
			while((a[p+1]-a[p])*(a[j]-a[i])>0) p++;		
			while((a[j]-a[i])*(a[q+1]-a[q])>0) q++;
			res=max(res, (a[p]-a[i])*(a[j]-a[i]));
			res=max(res, (a[j]-a[i])*(a[q]-a[i]));
		}
		while(++j<n);
	}
	
	cout << (res/2);
	if (res%2) cout << ".5\n";
	else cout << ".0\n";
	
	return 0;
} 
