{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
  { you can add units after this };
type
  point=record
    x,y:longint;
  end;
  tpoint=record
    x,y:extended;
  end;
var
  i,j,n:longint;
  a:array[0..2001]of point;
  p,q:Point;
  max_s:extended;
  start:extended;
  med:longint;
Function Square(a,b:tpoint):extended;
Begin
  result:=abs(a.x*b.y-a.y*b.x);
End;
Function Vec(var a,b:point):tpoint;
Begin
  result.x:=b.x-a.x;
  result.y:=b.y-a.y;
End;
Function Search(l,r,med:longint;med_s:extended):extended;
var
  med1,med2:longint;
  s1,s2:extended;
  i:longint;
Begin
  if (r-l<5) then begin
    result:=0;
    for i:=l to r do
      result:=max(result,Square(Vec(a[i],p),Vec(a[i],q)));
    exit;
  end;
  med1:=(l+med) shr 1;
  med2:=(med+r) shr 1;
  s1:=Square(Vec(a[med1],p),Vec(a[med1],q));
  s2:=Square(Vec(a[med2],p),Vec(a[med2],q));
  if (med_s>=s1)and(med_s>=s2) then result:=Search(med1,med2,med,med_s) else
  if (s1>=med_s)and(s1>=s2) then result:=Search(l,med,med1,s1) else
  if (s2>=med_s)and(s2>=s1) then result:=Search(med,r,med2,s2);
End;
Begin
  start:=now;
  //assign(input,'a.in');reset(input);assign(output,'a.out');rewrite(output);
  read(n);
  max_s:=0;
  for i:=1 to n do read(a[i].x,a[i].y);
  for i:=1 to n do begin
    p:=a[i];
    for j:=i+1 to n do begin
      q:=a[j];
      med:=(i+j) shr 1;
      max_s:=max(max_s,Search(i,j,med,Square(Vec(a[med],p),Vec(a[med],q))));
      med:=(1+i) shr 1;
      max_s:=max(max_s,Search(1,i,med,Square(Vec(a[med],a[1]),Vec(a[med],p))));
      med:=(j+n) shr 1;
      max_s:=max(max_s,Search(j,n,med,Square(Vec(a[med],q),Vec(a[med],a[n]))));
    end;
    if (now-start)*24*60*60>1.91 then break;
  end;
  writeln(max_s/2:0:5);
  close(input);close(output);
End.