#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

int x[5000], y[5000];
int n;

int main () {
	scanf ("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf ("%d%d", &x[i], &y[i]);
		x[i + n] = x[i];
		y[i + n] = y[i];
	}
	double ans = 0;
	for (int i = 0; i < n; i++) {
		long long a, b, c;
		int j = i + 1;
		a = y[j] - y[i];
		b = x[i] - x[j];
		c = -(a * x[i] + b * y[i]);
		double dn = sqrt (a * a + b * b) * 2;
		int la = i, lb = i;
		long long fa = 0, fb = 0;
		for (int j = 0; j < n; j++) {
			long long fc = a * x[j] + b * y[j] + c;
			if (fc < fa) {
				fa = fc;
				la = j;
			}
			if (fc > fb) {
				fb = fc;
				lb = j;
			}
		}
		for (int j = i + 1; j < n;) {
// 			printf ("%d %d %d %d %lld %lld\n", i, j, la % n, lb % n, fa, fb);
			double d = sqrt ((x[j] - x[i] + 0.0) * (x[j] - x[i]) + (y[j] - y[i] + 0.0) * (y[j] - y[i]));
			double da = fa / dn;
			if (da < 0) da = -da;
			if (d * da > ans) ans = d * da;
			double db = fb / dn;
			if (db < 0) db = -db;
			if (d * db > ans) ans = d * db;
			j++;
			if (j == n) break;
			a = y[j] - y[i];
			b = x[i] - x[j];
			c = -(a * x[i] + b * y[i]);
			dn = sqrt (a * a + b * b) * 2;
			fa = a * x[la] + b * y[la] + c;
			fb = a * x[lb] + b * y[lb] + c;
			while (1) {
				long long fc = a * x[la + 1] + b * y[la + 1] + c;
				if (fc < fa) {
					fa = fc;
					la++;
				} else break;
			}
			while (1) {
				long long fc = a * x[lb + 1] + b * y[lb + 1] + c;
				if (fc > fb) {
					fb = fc;
					lb++;
				} else break;
			}
		}
	}
	printf ("%.4f\n", ans);
}