#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <utility>
#define point pair<long long,long long>
#define mvector pair<long long,long long>
#define x first
#define y second
#define mp make_pair
using namespace std;

vector< pair<long long,long long> > ps;

long long vecpr (mvector v1,mvector v2)
{
	return v1.x*v2.y-v2.x*v1.y;
}

point operator- (point a,point b)
{
	return mp(a.x-b.x,a.y-b.y);
}

long long s (point p1,point p2,point p3)
{
	return abs((vecpr(p2-p1,p3-p1)));
}

long long linedest (point p, long long a,long long b, long long c)
{
	return abs(a*p.x+b*p.y+c);
}

pair<long long,long long> trinserch (long long l,long long r,long long a,long long b,long long c)
{
	for (;r-l>=3;)
	{
		long long X1=l+(r-l)/3;
		long long X2=X1+(r-l)/3;
		long long d1=linedest(ps[X1],a,b,c);
		long long d2=linedest(ps[X2],a,b,c);
		if (d1<d2)
			l=X1;
		else
			r=X2;
	};
	long long res=0;
	long long resnum =0;
	for (long long i=l;i<=r;i++)
		if (res<linedest(ps[i],a,b,c))
		{
			res=linedest(ps[i],a,b,c);
			resnum=i;
		};
	return mp(res,resnum);
}

void getlineur (point p1,point p2,long long &a,long long &b,long long &c)
{
	a=p1.y-p2.y;
	b=p2.x-p1.x;
	c=-a*p1.x-b*p1.y;
}

int main()
{
	//cout<<"start"<<endl;
	//freopen("a.in","rt",stdin);
	//freopen("a.out","wt",stdout);
	int n;
	scanf("%d",&n);
	ps.resize(n);
	for (int i=0;i<n;i++)
		scanf("%d %d",&ps[i].x,&ps[i].y);
	long long res=0;
	//cout<<"GET"<<endl;
	for (long long i=0;i<n-2;i++)
		for (long long j=i+1;j<n;j++)
			{
				long long a,b,c;
				getlineur(ps[i],ps[j],a,b,c);
				pair<long long,long long> t1=trinserch(i,j,a,b,c);
				pair<long long,long long> t2=trinserch(0,i,a,b,c);
				pair<long long,long long> t3=trinserch(j,n-1,a,b,c);
				if (t1<t2)
					t1=t2;
				if (t1<t3)
					t1=t3;
				res=max(res,s(ps[t1.second],ps[i],ps[j]));
				//cout<<"END "<<i<<" "<<j<<" "<<res<<endl;
			}
	printf("%.1f\n",(float)res/2);
	return 0;
}