#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

int64 f[51];

bool calc (int n, int64 x)
{
	if (n <= 1)
	{
		if (x == 1)
			return 0;
		else
			return 1;	
	}
	if (f[n-1] >= x)
		return calc (n-1, x);
	else
		return calc (n-2, x-f[n-1]);	
}

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.ans", "w", stdout);
	f[0] = 1;
	f[1] = 2;
	for (int i = 2; i <= 50; i ++)
		f[i] = f[i-1] + f[i-2];
	int n;	
	scanf ("%d", &n);
	forn (i, n)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		y = x + y - 1;
		bool ok = 1;
		while (x < y)
		{
			if (calc (50, x) != calc (50, y))
			{
				ok = 0;
				break;
			}	
			x ++;
			y --;
		}
		if (ok)
			printf ("TAK\n");
		else
			printf ("NIE\n");
	}
	return 0;
}
