#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

int x[5000], y[5000];
int n;

long long vect (long long x1, long long y1, long long x2, long long y2) {
	long long tmp = x1 * y2 - x2 * y1;
	if (tmp < 0) tmp = -tmp;
	return tmp;
}

int main () {
	scanf ("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf ("%d%d", &x[i], &y[i]);
		x[i + n] = x[i];
		y[i + n] = y[i];
	}
	long long ans = 0;
	long long a, b, c, fa, fb, fc, tmp;
	for (int i = 0; i < n; i++) {
		int j = i + 1, la = i, lb = i;
		a = y[j] - y[i];
		b = x[i] - x[j];
		c = -(a * x[i] + b * y[i]);
		fa = fb = 0;
		for (int j = 0; j < n; j++) {
			fc = a * x[j] + b * y[j] + c;
			if (fc < fa) {
				fa = fc;
				la = j;
			}
			if (fc > fb) {
				fb = fc;
				lb = j;
			}
		}
		for (int j = i + 1; j < n;) {
			tmp = vect (x[j] - x[i], y[j] - y[i], x[la] - x[i], y[la] - y[i]);
			if (tmp > ans) ans = tmp;
			tmp = vect (x[j] - x[i], y[j] - y[i], x[lb] - x[i], y[lb] - y[i]);
			if (tmp > ans) ans = tmp;
			j++;
			if (j == n) break;
			a = y[j] - y[i];
			b = x[i] - x[j];
			c = -(a * x[i] + b * y[i]);
			fa = a * x[la] + b * y[la] + c;
			fb = a * x[lb] + b * y[lb] + c;
			while (1) {
				fc = a * x[la + 1] + b * y[la + 1] + c;
				if (fc < fa) {
					fa = fc;
					la++;
				} else break;
			}
			while (1) {
				fc = a * x[lb + 1] + b * y[lb + 1] + c;
				if (fc > fb) {
					fb = fc;
					lb++;
				} else break;
			}
		}
	}
	printf ("%.3f\n", ans / 2.0);
}