#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;
int const FB=47, Fb=19, N=4200, TL=1.95*CLOCKS_PER_SEC;

short rs[N][N];
int fib[47], nv[2];
pair<int,int> v[2][N+N];
char s[N];

int makestr() {
	int i=2, j=3;
	s[0]='!', s[1]='0', s[2]='1';
	while(j<N) {
		for (int x=1; x<=j-i; x++)
			s[i+x]=s[x];
		swap(i+=j, j);
	}
	return i;
}

int stupid(int i, int j) {
	for (int r=0; ; r++)
		if (s[i+r]!=s[j-r]) 
			return r;
}

int main () {
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);	
	
	fib[1]=fib[2]=1;
	for (int i=3; i<FB; i++)
		fib[i]=fib[i-1]+fib[i-2];	
		
	int n=makestr();
	for (int i=1; i<=n; i++)
		for (int j=1; j<=n; j++)
			rs[i][j]=stupid(i, j);
	
	int k; scanf ("%d", &k);
	for (int t=0; t<k; t++) {
		int l, len, u=nv[0]=nv[1]=0;
		scanf ("%d%d", &l, &len);	
		if (clock()>TL) {
			printf ("NIE\n");
			continue;
		}
		v[0][nv[0]++]=make_pair(l, l+len-1);
		for (int x=FB-1; x>=Fb; x--) {
			if (nv[u]>N) {
// 				cerr << "oops" << endl;
				break;
			}
			nv[u^1]=0;
			for (int i=0; i<nv[u]; i++)
				if (v[u][i].second>fib[x])
					if (v[u][i].first>fib[x])
						v[u^1][nv[u^1]++]=make_pair(v[u][i].first-fib[x], v[u][i].second-fib[x]);
			else {
				v[u^1][nv[u^1]++]=make_pair(v[u][i].first, fib[x]);
				v[u^1][nv[u^1]++]=make_pair(1, v[u][i].second-fib[x]);
			}
			else
				v[u^1][nv[u^1]++]=v[u][i];
			u^=1;
		}
		int i, j, ni, nj;
		for (i=0, j=nv[u]-1, ni=0, nj=0; i<j; ) {
			int c=min(v[u][i].second-v[u][i].first-ni, v[u][j].second-v[u][j].first-nj)+1;
			if (rs[v[u][i].first+ni][v[u][j].second-nj] < c)
				break;
			if (v[u][i].first + (ni+=c) > v[u][i].second)
				i++, ni=0;
			if (v[u][j].first + (nj+=c) > v[u][j].second)
				j--, nj=0;
		}
		if (i==j) {
			int c=v[u][i].second-v[u][i].first-ni-nj+1;
			if (rs[v[u][i].first+ni][v[u][j].second-nj] < c)
				puts("NIE");
			else
				puts("TAK");
		}
		else if (i<j) puts("NIE");
		else puts("TAK");
	}	 
// 	cerr << clock() << endl;
// 	int k; cin >> k;
// 	for (int i=0; i<k; i++) {
// 		int l, len; cin >> l >> len;
// 		put(rs[l][l+len-1]>=len);
// 	}	
	return 0;
} 
