{$MODE DELPHI}

uses
  Math,SysUtils;

type
  real=extended;

var
  n,i,j,l,r,m1,m2:integer;
  x,y:array[1..4000] of real;
  res:real;
  m1s,m2s,ls,rs,st:real;
  d:array[1..2000,1..2000] of real;

function dist(i,j:integer):real;
begin
  i:=(i-1)mod n+1;
  j:=(j-1)mod n+1;
  dist:=d[i,j]//sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]));
end;

function s(i,j,k:integer):real;
var p,a,b,c:real;
begin
  a:=dist(i,j);
  b:=dist(j,k);
  c:=dist(i,k);
  p:=(a+b+c)/2;
  s:=sqrt(p*(p-a)*(p-b)*(p-c));
end;

procedure toolong;
begin
  writeln(res:0:10);
  halt;
end;

begin
  {assign(output,'a.in');
  rewrite(output);
  n:=2000;
  writeln(n);
  for i:=1 to n do writeln(i,' 0');
  close(output);}
  st:=now;
  {assign(input,'a.in');
  assign(output,'a.out');
  reset(input);
  rewrite(output);}

  readln(n);
  res:=0;
  for i:=1 to n do
  begin
    readln(x[i],y[i]);
    x[i+n]:=x[i];
    y[i+n]:=y[i];
  end;
  for i:=1 to n do
    for j:=1 to n do
      d[i,j]:=sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]));
  for i:=1 to n do
    for j:=1 to n do
    begin
      if (now-st)*24*60*60*1000>1970 then toolong;
      l:=i;
      r:=j;
      if r<l then r:=r+n;
      ls:=s(i,j,l);
      rs:=s(i,j,r);
      while l<r do
      begin
        if l+1=r then
        begin
          if rs>ls then ls:=rs;
          break;
        end else
        if l+2=r then
        begin
          m1:=(l+r) div 2;
          m1s:=s(i,j,m1);
          if (ls>m1s) and (ls>rs) then rs:=ls else
          if (rs>m1s) and (rs>ls) then ls:=rs else
            ls:=m1s;
          break;
        end;
        m1:=l+(r-l+1) div 3;
        m2:=m1+(r-l+1) div 3;
        m1s:=s(i,j,m1);
        m2s:=s(i,j,m2);
        if (m1s>=ls) and (m1s<=m2s) then
        begin
          l:=m1;
          ls:=m1s;
        end else
        begin
          r:=m2;
          rs:=m2s;
        end;
      end;
      res:=max(res,ls);
    end;
  toolong;
end.


