{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O-,D-,I-,R-,S-,Q-,H+}

uses
{$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
{$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
{ you can add units after this };
type
  point=record
    x,y:longint;
  end;
var
  coz:longint;
  cards:array[0..4,0..9]of longint;
  kol,r_kol:array[0..4]of longint;
  deck:longint;
  pl,p:longint;
  v:point;
  x,y,i,j:longint;
  s:string;
  u:array[0..4,0..9]of boolean;
  k,k_min,k_max:array[0..9]of longint;
  can_add:array[1..9]of boolean;
  looser:longint;
  game:boolean;
  last:point;
  sm,sd:string;
  kol_in_game:longint;
  kol_coz:longint;
Function ReturnXY(s:string):point;
Begin
  result.x:=0;
  result.y:=0;
  case s[1] of
    '6':result.y:=1;
    '7':result.y:=2;
    '8':result.y:=3;
    '9':result.y:=4;
    'T':result.y:=5;
    'J':result.y:=6;
    'Q':result.y:=7;
    'K':result.y:=8;
    'A':result.y:=9;
  end;
  case s[2] of
    'H':result.x:=1;
    'S':result.x:=2;
    'C':result.x:=3;
    'D':result.x:=4;
  end;
End;
Function ReturnS(x,y:longint):string;
Begin
  result:=sd[y]+sm[x];
End;
Begin
  //assign(input,'input.txt');reset(input);assign(output,'output.txt');rewrite(output);
  sm:='HSCD';
  sd:='6789TJQKA';
  coz:=0;
  fillchar(kol,sizeof(kol),0);
  fillchar(r_kol,sizeof(r_kol),0);
  fillchar(u,sizeof(u),0);
  fillchar(cards,sizeof(cards),0);
  readln(s);
  deck:=36;
  game:=false;
  while s<>'out 1' do begin
    if (copy(s,1,5)='trump') then begin
      case s[7] of
        'H':coz:=1;
        'S':coz:=2;
        'C':coz:=3;
        'D':coz:=4;
      end;
    end else
    if (copy(s,1,4)='give') then begin
      delete(s,1,5);
      pl:=ord(s[1])-ord('0');
      delete(s,1,2);
      inc(kol[pl]);
      dec(deck);
      if (s='??') then inc(r_kol[pl]) else begin
        v:=ReturnXY(s);
        cards[v.x][v.y]:=1;
      end;
    end else
    if (copy(s,1,4)='move') then begin
      kol_in_game:=0;
      kol_coz:=0;
      inc(kol_in_game);
      if game then begin
        game:=false;
        for i:=1 to 4 do
          for j:=1 to 9 do
            if u[i][j] then cards[i][j]:=5;
      end;
      fillchar(u,sizeof(u),0);
      fillchar(can_add,sizeof(can_add),0);
      delete(s,1,5);
      x:=ord(s[1])-ord('0');
      y:=ord(s[3])-ord('0');
      looser:=y;
      game:=true;
      delete(s,1,4);
      v:=ReturnXY(s);
      if v.x=coz then inc(kol_coz);
      last:=v;
      dec(kol[x]);
      if (cards[v.x][v.y]=0) then dec(r_kol[x]) else cards[v.x][v.y]:=0;
      u[v.x][v.y]:=true;
      can_add[v.y]:=true;
    end else
    if (copy(s,1,3)='add') then begin
      inc(kol_in_game);
      delete(s,1,4);
      x:=ord(s[1])-ord('0');
      y:=ord(s[3])-ord('0');
      delete(s,1,4);
      v:=ReturnXY(s);
      if v.x=coz then inc(kol_coz);
      last:=v;
      dec(kol[x]);
      if (cards[v.x][v.y]=0) then dec(r_kol[x]) else cards[v.x][v.y]:=0;
      if game then u[v.x][v.y]:=true else begin
        inc(kol[y]);
        cards[v.x][v.y]:=y;
      end;
    end else
    if (copy(s,1,4)='beat') then begin
      delete(s,1,5);
      x:=ord(s[1])-ord('0');
      delete(s,1,2);
      v:=ReturnXY(s);
      if v.x=coz then inc(kol_coz);
      dec(kol[x]);
      if (cards[v.x][v.y]=0) then dec(r_kol[x]) else cards[v.x][v.y]:=0;
      u[v.x][v.y]:=true;
      can_add[v.y]:=true;
    end else
    if (copy(s,1,4)='take') then begin
      game:=false;
      delete(s,1,5);
      x:=ord(s[1])-ord('0');
      for i:=1 to 4 do
        for j:=1 to 9 do if (u[i][j]) then begin
          inc(kol[x]);
          cards[i][j]:=x;
        end;
      fillchar(u,sizeof(u),0);
    end else
    if (copy(s,1,4)='MOVE') then begin
      s:='';
      fillchar(k,sizeof(k),0);
      for j:=1 to 9 do
        for i:=1 to 4 do if ((i<>coz)or((deck=0)and(j<3)))and((cards[i][j]=1)or(cards[i][j]=3)) then inc(k[j]);
      for p:=4 downto 1 do
        for j:=1 to 9 do if (s='') then
          for i:=1 to 4 do if ((i<>coz)or((deck=0)and(j<3)))and(cards[i][j]=1)and(k[j]=p) then begin
            s:=ReturnS(i,j);
            break;
          end;
      for j:=1 to 9 do write(cards[2][j],' ');
      writeln('');
      if (s='') then
        for j:=1 to 9 do if (s='') then
          for i:=1 to 4 do if (cards[i][j]=1) then begin
            s:=ReturnS(i,j);
            break;
          end;
        writeln(s);
    end else
    if (copy(s,1,3)='ADD') then begin
      s:='';
      for j:=1 to 9 do if (can_add[j])and(s='') then
        for i:=1 to 4 do if (i<>coz)and(cards[i][j]=1) then begin
          s:=ReturnS(i,j);
          break;
        end;
      if (s='')and(kol[1]=1) then
      for j:=1 to 2 do if (can_add[j])and(s='') then
        for i:=1 to 4 do if (cards[i][j]=1) then begin
          s:=ReturnS(i,j);
          break;
        end;
      if (s='')and(deck=0) then
      for j:=1 to 5 do if (can_add[j])and(s='') then
        for i:=1 to 4 do if (cards[i][j]=1) then begin
          s:=ReturnS(i,j);
          break;
        end;
      if (s='')and(deck=0)and(kol[j]<=2) then
      for j:=6 to 9 do if (can_add[j])and(s='') then
        for i:=1 to 4 do if (cards[i][j]=1) then begin
          s:=ReturnS(i,j);
          break;
        end;
      if (s='') then writeln('NO') else writeln(s);
    end else
    if (copy(s,1,4)='BEAT') then begin
      fillchar(k_min,sizeof(k_min),0);
      for j:=1 to 9 do
        for i:=1 to 4 do if (cards[i][j]=2)or(cards[i][j]=4) then inc(k_min[j]);
      fillchar(k_max,sizeof(k_max),0);
      for j:=1 to 9 do
        for i:=1 to 4 do if (cards[i][j]=1)or(cards[i][j]=3) then inc(k_max[j]);
      for j:=1 to 9 do k_max[j]:=4-k_max[j];
      fillchar(k,sizeof(k),0);
      for j:=1 to 9 do k[j]:=(k_min[j]+k_max[j]) div 2;
      s:='';
      for p:=0 to 4 do if (s='') then
        for j:=last.y to 9 do if (cards[last.x][j]=1)and(k[j]=p) then begin
          s:=ReturnS(i,j);
          break;
        end;
      if (s='')and(last.x<>coz)and((deck<6)or(kol_in_game>=5)) then
      for j:=1 to 5 do if (cards[coz][j]=1) then begin
        s:=ReturnS(i,j);
        break;
      end;
      if (s='')and(last.x<>coz)and(deck=0)and(kol[1]<3) then
      for j:=6 to 9 do if (cards[coz][j]=1) then begin
        s:=ReturnS(i,j);
        break;
      end;
      if (deck>6)and(2*kol_coz>=kol_in_game) then s:='';
      if (s='') then writeln('NO') else writeln(s);
    end;
    readln(s);
  end;
  close(input);close(output);
End.