#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;

char x[9]={'6', '7', '8', '9', 'T', 'J', 'Q', 'K', 'A'}, y[4]={'H', 'S', 'C', 'D'};
int c[9][4], nc[5], zc[5], g[9][4], cc, pk, vz, kol=36;

int ztoi(char c) {
	int f=0; while(x[f]!=c) f++;
	return f;
}

int mtoi(char c) {
	int s=0; while(y[s]!=c) s++;
	return s;
}

int ctoi(string s) {
	return ztoi(s[0])*4+mtoi(s[1]);
}

int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	string s;	
	for (;;)
		if (!(cin >> s))
			return 0;
		else if (s=="trump") {
			cin >> s;
			swap(y[0], y[mtoi(s[0])]);
		}
		else if (s=="give") {
			int k;
			cin >> k >> s;
			if (k==1) {
				int z=ctoi(s);
				c[z/4][z%4]=1;
			}
			nc[k]++, kol--;
		}
		else if (s=="move") {
			for (int i=0; i<9; i++)
				for (int j=0; j<4; j++)
					if (g[i][j]) g[i][j]=0;
			int x, y, z;
			cin >> x >> y >> s;
			if (!nc[x]) x^=2;
			if (!nc[y]) y^=2;
			cc=z=ctoi(s);
			g[z/4][z%4]=1; 
			c[z/4][z%4]=-1;
			pk=y, vz=0, nc[x]--;
		}
		else if (s=="add") {
			int x, y, z;
			cin >> x >> y >> s;
			if (!nc[x]) x^=2;
			if (!nc[y]) y^=2;
			cc=z=ctoi(s);
			nc[x]--;
			g[z/4][z%4]=1;
			c[z/4][z%4]=-1;
			if (vz) {
				c[z/4][z%4]=pk;
				nc[pk]++;
			}
		}
		else if (s=="beat") {
			int x, z;
			cin >> x >> s;
			if (!nc[x]) x^=2;
			z=ctoi(s);
			g[z/4][z%4]=1;
			c[z/4][z%4]=-1;
			nc[x]--;
		}
		else if (s=="take") {
			int x; cin >> x; vz=1;
			if (!nc[x]) x^=2;
			for (int i=0; i<9; i++)
				for (int j=0; j<4; j++)
					if (g[i][j])
						c[i][j]=x, nc[x]++;
		}
		else if (s=="out") {
			int x; cin >> x; nc[x]=0;
			if ((!nc[1] && !nc[3]) || (!nc[2] && !nc[4]))
				return 0;
		}	
		else if (s=="MOVE") {
			int pr=0, f, s, u[4]={0, 0, 0, 0};
			for (int i=8; i>=0; i--)
				for (int j=1; j<4; j++)
					if (c[i][j]==1)
						if (pr <= ++u[j])
							pr=u[j], f=i, s=j;	
			if (!pr)
				for (int i=8; i>=0; i--)
					if (c[i][0]==1) 
						f=i, s=0;	
			printf ("%c%c\n", x[f], y[s]);
			fflush(stdout);
		}
		else if (s=="BEAT") {
			int xx=cc/4, yy=cc%4;
			int f=-1, s;
			for (int i=8; i>xx; i--)
				if (c[i][yy]==1)
					f=i, s=yy;
			if (yy && f<0)
				for (int i=8; i>=0; i--)
					if (c[i][0]==1)
						f=i, s=0;
			if (f<0) printf ("NO\n");
			else printf ("%c%c\n", x[f], y[s]);
			fflush(stdout);
		}
		else if (s=="ADD") {
			int h[9]={0, 0, 0, 0, 0, 0, 0, 0, 0};
			for (int i=0; i<9; i++)
				for (int j=0; j<4; j++)
					if (g[i][j]) h[i]=1;
			int pr=0, f, s, u[4]={0, 0, 0, 0};
			for (int i=8; i>=0; i--)
				for (int j=1; j<4; j++)
					if (c[i][j]==1 && pr <= ++u[j] && h[i])
						pr=u[j], f=i, s=j;	
			if (pr>1) printf ("%c%c\n", x[f], y[s]);
			else {
				for (int i=8; i>=0; i--)
					if (c[i][0]==1) ++u[0];
				if (pr==1 && (!kol && u[0]>=1 || u[0]>1))
					printf ("%c%c\n", x[f], y[s]);
				else {
					pr=u[0]=0;
					for (int i=8; i>=0; i--)
						if (c[i][0]==1 && pr <= ++u[0] && h[i])
							pr=u[0], f=i, s=0;	
					if (!kol && pr>=2 || pr>=3)
						printf ("%c%c\n", x[f], y[s]);
					else printf ("NO\n");
				}
			}	
			fflush(stdout);
		}
} 
