type
  koloda = array [1..4,1..9] of longint;
  player = record
             kol : longint;
             c : koloda;
           end;

var
  gfl : boolean;
  fl : array [1..4] of longint;
  s : string;
  trump,i,j,kolt,ltr,lp,k1,lasth,kolost,neighb : longint;
  a : array [1..4] of player;
  table : koloda;
  c,c1,c2 : char;
  d,num : array [1..9] of longint;

procedure get_number(var tr,p : longint; c2,c1 : char);
begin
  if c1='H' then tr:=1; 
  if c1='S' then tr:=2; 
  if c1='C' then tr:=3; 
  if c1='D' then tr:=4;
  case c2 of
    '6' : p:=1;
    '7' : p:=2;
    '8' : p:=3;
    '9' : p:=4;
    'T' : p:=5;
    'J' : p:=6;
    'Q' : p:=7;
    'K' : p:=8;
    'A' : p:=9;
  end;  
end;

procedure give(i : longint; c1,c2 : char);
var
  tr,p : longint;
begin
  dec(kolost);
  if c1='?' then
  begin
    inc(a[i].kol);
  end
            else
  begin
    inc(a[i].kol);
    get_number(tr,p,c1,c2);
    a[i].c[tr,p]:=1;  
  end;          
end;

procedure move(i,j : longint; c1,c2 : char);
var
  tr,p : longint;
begin
  lasth:=i;

  dec(a[i].kol);
  get_number(tr,p,c1,c2);
  a[i].c[tr,p]:=0;
  inc(kolt);
  table[tr,p]:=1;
  
  if (j=1) or (j=3) and (fl[3]=1) then
  begin
    ltr:=tr; lp:=p;
  end;
  if i=1 then 
  begin
    neighb:=j;
  end;
  
end;

procedure beat(i : longint; c1,c2 : char);
var
  tr,p : longint;
begin
  if fl[i]=1 then
  begin
    if i=1 then i:=3;
    if i=3 then i:=1;
    if i=2 then i:=4;
    if i=4 then i:=2;
  end;
  
  dec(a[i].kol);
  get_number(tr,p,c1,c2);
  a[i].c[tr,p]:=0;
  inc(kolt);
  table[tr,p]:=1;
end;

procedure add(i,j : longint; c1,c2 : char);
var
  tr,p : longint;
begin
  dec(a[i].kol);
  get_number(tr,p,c1,c2);
  a[i].c[tr,p]:=0;
  inc(kolt);
  table[tr,p]:=1;
  
  if (j=1) or (j=3) and (fl[3]=1) then
  begin
    ltr:=tr; lp:=p;
  end;
end;

procedure take(k : longint);
var
  i,j : longint;
begin
  for i:=1 to 4 do
    for j:=1 to 9 do
      if table[i,j]=1 then a[k].c[i,j]:=1;
  a[k].kol:=a[k].kol+kolt;    
end;

procedure out(i : longint);
begin
  fl[i]:=1;
  
  if  (fl[1]=1) and (fl[2]=1) and (fl[3]=1) and (fl[4]=1) then gfl:=true;
 
  if i=3 then
  begin
    if lasth=3 then k1:=1
               else k1:=0;
  end;
 
end;

procedure print_ans(tr,p : longint);
begin
  case p of
    1 : write('6'); 
    2 : write('7'); 
    3 : write('8'); 
    4 : write('9'); 
    5 : write('T'); 
    6 : write('J'); 
    7 : write('Q'); 
    8 : write('K'); 
    9 : write('A'); 
  end;
  if tr=1 then writeln('H');
  if tr=2 then writeln('S');
  if tr=3 then writeln('C');
  if tr=4 then writeln('D');
end;

procedure add_mine;
var
  i,j,i1,tr,p : longint;
begin
  tr:=-1;
  p:=10;

  for i:=1 to 4 do
    for j:=9 downto 1 do
      if table[i,j]=1 then
      begin
        for i1:=1 to 4 do
          if (trump<>i1) and (a[1].c[i1,j]=1) and (j<p) then
          begin
            tr:=i1; p:=j;    
          end;      
      end;
      
  if (a[1].kol=1) then
  begin
    if tr=-1 then
    begin
      for i:=1 to 4 do
        for j:=9 downto 1 do
          if table[i,j]=1 then
          begin
            if a[1].c[trump,j]=1 then
            begin
              tr:=trump; p:=j;    
            end;      
          end;
    end;    
  end;    
  if tr=-1 then writeln('NO')
           else print_ans(tr,p);
end;

procedure swap(var a,b : longint);
var
  c : longint;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure move_mine;
var
  i,j,tr,p : longint;
begin
  if fl[3]=0 then neighb:=2
             else
  begin
    if k1=0 then 
    begin
      k1:=1;
      if fl[4]=0 then neighb:=4
                 else neighb:=2;
    end
            else
    begin
      k1:=0;
      if fl[2]=0 then neighb:=2
                 else neighb:=4;
    end;                 
  end;           

  
  for i:=1 to 9 do
  begin
    d[i]:=a[1].c[1,i]+a[1].c[2,i]+a[1].c[3,i]+a[1].c[4,i];    
    d[i]:=d[i]+a[3].c[1,i]+a[3].c[2,i]+a[3].c[3,i]+a[3].c[4,i];    
    num[i]:=i;
  end;
 
  for i:=1 to 8 do
    for j:=1 to 9-i do
      if (d[j]>d[j+1]) or (d[j]=d[j+1]) and (num[j]<num[j+1]) then 
      begin
        swap(d[j],d[j+1]);
        swap(num[j],num[j+1]);
      end;  
  
  
  tr:=-1;
  for j:=9 downto 1 do
  begin
    if tr<>-1 then break;
    for i:=1 to 4 do
      if i<>trump then    
      begin
        if a[1].c[i,num[j]]=1 then 
        begin
          tr:=i; p:=num[j]; 
          break; 
        end;
      end;
    if tr=-1 then   
      if a[1].c[trump,num[j]]=1 then 
      begin
        tr:=trump; p:=num[j]; 
        break; 
      end;
  end;
  
  print_ans(tr,p);
end;

function bigger(i1,j1,i2,j2 : longint) : boolean;
begin
  if i1=i2 then 
  begin
    if j1>j2 then bigger:=true
             else bigger:=false;    
  end
           else
  begin
    if i1=trump then bigger:=true
                else bigger:=false;  
  end;          
end; 

procedure beat_mine;
var
  i,j,tr,p : longint;
begin
  tr:=-1; p:=10;
  for i:=1 to 4 do
    if i<>trump then
      for j:=9 downto 1 do
        if (a[1].c[i,j]=1) and (bigger(i,j,ltr,lp)) then begin tr:=i; p:=j; end;
  
  if (kolost<5) or (a[1].kol>8) then
  begin
    if tr=-1 then
    begin
      for j:=9 downto 1 do
        if (a[1].c[trump,j]=1) and (bigger(trump,j,ltr,lp)) then begin tr:=trump; p:=j; end;
    end; 
  end;
  
  if tr=-1 then writeln('NO')
           else print_ans(tr,p);
end;


begin
{  assign(input,'a.in');
  assign(output,'a.out');
  reset(input);
  rewrite(output);
}  

  readln(s);
  
  trump:=0;
  
  if s[7]='H' then trump:=1;
  if s[7]='S' then trump:=2;
  if s[7]='C' then trump:=3;
  if s[7]='D' then trump:=4;
  
  fillchar(a,sizeof(a),0);  
  fillchar(fl,sizeof(fl),0);  
  kolt:=0;
  fillchar(table,sizeof(table),0);  
  
  gfl:=false;
  kolost:=36;
  
  while (not gfl) and (not eof) do
  begin
    read(c);
    if c='g' then
    begin
      kolt:=0;
      fillchar(table,sizeof(table),0);  
    
      read(c); read(c); read(c);
      read(i);
      read(c);
      read(c1); read(c2);
      give(i,c1,c2);
    end;
    if c='m' then
    begin
      read(c); read(c); read(c);
      read(i,j);
      read(c);
      read(c1); read(c2);
      move(i,j,c1,c2);    
    end;
    if c='b' then
    begin
      read(c); read(c); read(c);
      read(i);
      read(c);
      read(c1); read(c2);
      beat(i,c1,c2);
    end;
    if c='a' then
    begin
      read(c); read(c);
      read(i,j);
      read(c);
      read(c1); read(c2);
      add(i,j,c1,c2);
    end;
    if c='t' then
    begin
      read(c); read(c); read(c);
      read(i);
      take(i);
      
      kolt:=0;
      fillchar(table,sizeof(table),0);  
    end;
    if c='o' then
    begin
      read(c); read(c);
      read(i);
      out(i);
      
      kolt:=0;
      fillchar(table,sizeof(table),0);  
    end;
    
    if c='A' then
    begin
      read(c); read(c);
      add_mine;
      flush(output);
    end;
    if c='M' then
    begin
      read(c); read(c); read(c);
      move_mine;
      flush(output);
    end;
    if c='B' then
    begin
      read(c); read(c); read(c);
      beat_mine;
      flush(output);
    end;
    
    readln;
  end;

end.