var
	s:string;
	Desk,YourCards:array[1..50]of integer;
	DeskCardsCnt,YourCardsCnt,lastcard,PlayersCnt:integer;
	tr:integer;
	CardCnt:array[1..4]of integer;
function GetCard(d,m:char):integer;
var a:integer;
begin
	a:=0;
	case d of
		'6':a:=0;
		'7':a:=1;
		'8':a:=2;
		'9':a:=3;
		'T':a:=4;
		'J':a:=5;
		'Q':a:=6;
		'K':a:=7;
		'A':a:=8;
	end;
	case m of
		'H':a:=a+0;
		'S':a:=a+9;
		'C':a:=a+18;
		'D':a:=a+27;
	end;
	GetCard:=a;
end;
function CardToString(card:integer):string;
var s:string;
begin
	case card mod 9 of
		0:s:='6';
		1:s:='7';
		2:s:='8';
		3:s:='9';
		4:s:='T';
		5:s:='J';
		6:s:='Q';
		7:s:='K';
		8:s:='A';
	end;
	case card div 9 of
		0:s:=s+'H';
		1:s:=s+'S';
		2:s:=s+'C';
		3:s:=s+'D';
	end;
	CardToString:=s;
end;
function GetM(card:integer):integer;
begin
	GetM:=(card div 9)+1;
end;
function GetD(card:integer):integer;
begin
	GetD:=card mod 9;
end;
procedure push(card:integer);
begin
	inc(YourCardsCnt);
	YourCards[YourCardsCnt]:=card;
end;
procedure AddToDesk(card:integer);
begin
	inc(DeskCardsCnt);
	Desk[DeskCardsCnt]:=card;
end;
procedure ClearDesk;
var i:integer;
begin
	for i:=1 to DeskCardsCnt do
		Desk[i]:=0;
	DeskCardsCnt:=0;
end;
function Price(card:integer):integer;
begin
	if GetM(card)=tr then
		Price:=GetD(card)+1000
	else
		price:=GetD(card){+random(4)};
end;
procedure DeleteYourCard(a:integer);
var i:integer;
begin
	For i:=a+1 to YourCardsCnt do
		YourCards[i-1]:=YourCards[i];
	Dec(YourCardsCnt);
end;
function CanBeat(a,b:integer):boolean;
begin
	if (GetM(a)=tr)and(GetM(b)<>tr)then begin
		CanBeat:=true;
		exit;
	end;
	if (GetM(a)=GetM(b))and(a>b)then begin
		CanBeat:=true;
		exit;
	end;
	CanBeat:=false;
end;
procedure TakeCards;
var i:integer;
begin
	for i:=1 to DeskCardsCnt do
		push(Desk[i]);
	ClearDesk;
end;
procedure trump(s:string);
begin
	case s[7] of
		'H':tr:=1;
		'S':tr:=2;
		'C':tr:=3;
		'D':tr:=4;
	end;
end;
procedure give(s:string);
begin
	if s[6]='1' then begin
		push(GetCard(s[8],s[9]));
		inc(CardCnt[1]);
	end;
	if s[6]='2' then
		inc(CardCnt[2]);
	if s[6]='3' then
		inc(CardCnt[3]);
	if s[6]='4' then
		inc(CardCnt[4]);	
end;
procedure move(s:string);
begin
	ClearDesk;
	lastcard:=GetCard(s[10],s[11]);
	AddToDesk(lastcard);
	Dec(CardCnt[ord(s[6])-ord('0')]);
end;
procedure add(s:string);
begin
	lastcard:=GetCard(s[9],s[10]);
	AddToDesk(lastcard);
	Dec(CardCnt[ord(s[5])-ord('0')]);
end;
procedure beat(s:string);
begin
	AddToDesk(GetCard(s[8],s[9]));
	Dec(CardCnt[ord(s[6])-ord('0')]);
end;
procedure take(s:string);
begin
	Inc(
		CardCnt[ord(s[6])-ord('0')],
		DeskCardsCnt
	);
	if s[6]='1' then TakeCards;
	ClearDesk;
end;
procedure out(s:string);
begin
	dec(PlayersCnt);
end;
procedure YourMove;
var i,min,p:integer;
begin
	{writeln(tr,trump);
	flush(output);}
	min:=10000;
	for i:=1 to YourCardsCnt do
		if price(YourCards[i])<min then begin
			min:=Price(YourCards[i]);
			p:=i;
		end;
	WriteLn(CardToString(YourCards[p]));
	flush(output);
	DeleteYourCard(p);
end;
procedure YourBeat;
var i,min,p:integer;
begin
	min:=10000;
	for i:=1 to YourCardsCnt do
		if (Price(YourCards[i])<min)and(CanBeat(YourCards[i],LastCard)) then begin
			min:=Price(YourCards[i]);
			p:=i;
		end;
	if min=10000 then begin
		Writeln('NO');
		flush(output)
	end else begin
		Writeln(CardToString(YourCards[p]));
		flush(output);
		DeleteYourCard(p);
	end;
end;
procedure YourAdd;
var i,j,min,p:integer;
begin
	min:=10000;
	for i:=1 to YourCardsCnt do
		For j:=1 to DeskCardsCnt do
			if (GetD(YourCards[i])=GetD(Desk[j]))and((GetM(YourCards[i])<>tr)or(PlayersCnt<4))and(price(YourCards[i])<min)then begin
				min:=price(YourCards[i]);
				p:=i;
			end;
	if min<>10000 then begin
		Writeln(CardToString(YourCards[p]));
		DeleteYourCard(p);
	end else
		writeln('NO');
	flush(output);
end;
begin
	//randomize;
	PlayersCnt:=4;
	while true do begin
		readln(s);
		case s[2] of
			'r':trump(s);
			'i':give(s);
			'o':move(s);
			'd':add(s);
			'e':beat(s);
			'a':take(s);
			'u':out(s);
			'O':YourMove;
			'E':YourBeat;
			'D':YourAdd;
		end;
	end;
end.
