Type TAct = (_give, _move, _add, _beat, _take, _out, _myMove, _myBeat, _myAdd);
		 TCard = record
		 	val,spd:Integer;
		 end;

Const CardSymbol:Array[1..9]of Char = ('6','7','8','9','T','J','Q','K','A');
			MastSymbol:Array[1..4]of Char = ('H','S','C','D');
			power:Array[1..9,1..2]of Integer=((1,1),(1,1),(1,1),(2,1),(2,1),(3,1),(7,2),(4,1),(5,1));

var ingame:array[1..4]of boolean;
		thisRound:Array[1..9,1..4]of Boolean;
		CardInfo:Array[1..9,1..4]of Integer;
		numCardsThisRound,deckLeft:Integer;
		curAttacked,curAttacker,trump:Integer;
		roundStarted:Boolean;
		nCards:Array[1..4]of Integer;
		lastCard:TCard;
		p1,p2:Integer;
		card:TCard;
		action:TAct;
		r_output:Text;

Procedure OutCard(i,j:Integer);
Begin
	WriteLn(cardSymbol[i],mastSymbol[j]);
End;

Function mast(ch:char):Integer;
Begin
	case ch of
		'H':mast:=1;
		'S':mast:=2;
		'C':mast:=3;
		'D':mast:=4;
	end;
End;

Function valC(ch:char):Integer;
Begin
	case ch of
		'6':valC:=1;
		'7':valC:=2;
		'8':valC:=3;
		'9':valC:=4;
		'T':valC:=5;
		'J':valC:=6;
		'Q':valC:=7;
		'K':valC:=8;
		'A':valC:=9;
	end;
End;


Function plNum(ch:Char):Integer;
Var k:Integer;
Begin
	k:=ord(ch)-ord('0');
	if not ingame[k] then  begin
		if odd(k) then k:=4-k;
		if not odd(k) then k:=6-k;
	end;
	plNum:=k;
End;

Function getCard(c1,c2:Char):TCard;
Begin
	if c1='?' then getCard.val:=1 else getCard.val:=valC(c1);
	getCard.spd:=mast(c2);
End;

Procedure EndPreviousRoundNoTake;
var i,j:Integer;
Begin
	for i:=1 to 9 do
		for j:=1 to 4 do
			if thisRound[i,j] then CardInfo[i,j]:=5;
	numCardsThisRound:=0;
	roundStarted:=false;
	fillchar(thisRound,sizeof(thisRound),false);
End;

Procedure Give(p1:Integer;card:TCard);
Begin
	if RoundStarted then EndPreviousRoundNoTake;
	if p1 = 1 then begin
		Inc(nCards[p1]);
		CardInfo[card.val,card.spd]:=p1;
	end else
		Inc(nCards[p1]);
	Dec(deckLeft);
End;

Procedure move(p1,p2:Integer;card:TCard);
Begin
	if RoundStarted then EndPreviousRoundNoTake;
	roundStarted:=true;numCardsThisRound:=1;
	lastCard:=card;
	Dec(nCards[p1]);thisRound[card.val,card.spd]:=true;
	CardInfo[card.val,card.spd]:=0;
	curAttacked:=p2;curAttacker:=p1;
End;

Procedure add(p1,p2:Integer;card:TCard);
Begin
	
	lastCard:=card;
	
	if not roundStarted then begin
		Inc(nCards[p2]);Dec(nCards[p1]);
		cardInfo[card.val,card.spd]:=p2;
	end else begin 
		Dec(nCards[p1]);
		Inc(numCardsThisRound);
		thisRound[card.val,card.spd]:=true;
		CardInfo[card.val,card.spd]:=0;
	end;
	
End;

Procedure Beat(p1:Integer;card:TCard);
Begin
	Dec(nCards[p1]);
	thisRound[card.val,card.spd]:=true;
	CardInfo[card.val,card.spd]:=0;
End;

Procedure Take(p1:Integer);
var i,j:Integer;
Begin
	nCards[p1]:=nCards[p1]+2*numCardsThisRound-1;
	for i:=1 to 9 do
		for j:=1 to 4 do
			if thisRound[i,j] then CardInfo[i,j]:=p1;
	numCardsThisRound:=0;
	roundStarted:=false;
	fillchar(thisRound,sizeof(thisRound),false);
End;

Procedure Out(p1:Integer);
Begin
	InGame[p1]:=false;
End;

Procedure Init;
var i:Integer;
Begin
	for i:=1 to 4 do InGame[i]:=true;
	deckLeft:=36;
End;

Procedure whoAttacked(var k:Integer);
Begin
	
	if (inGame[2] and (not inGame[4])) then k:=2;
	if ((not inGame[2]) and inGame[4]) then k:=4;
	
	if (inGame[2] and inGame[4]) then
		if (inGame[3]) then k:=2 else
			if (curAttacked = 2) or (curAttacker = 2) then k:=4 else k:=2;
End;

Procedure doMove;
Var cur,k,i,j,bestVal:Integer;
 		pot,rlyMy:Integer;
 		max,bestCard:Integer;
 		list:Array[1..4,1..9]of Integer;
 		numSuit:Array[1..4]of Integer;
Begin
	
	whoAttacked(k);
	
	for i:=1 to 4 do numSuit[i]:=0;
	
	for i:=1 to 4 do
		for j:=1 to 9 do
			if (cardInfo[j,i]=1) then begin
				Inc(numSuit[i]);
				list[i,numSuit[i]]:=j;
			end;

	if (nCards[1] <= 3) or (nCards[k] <= 3) then begin
		
		if numSuit[trump] <> 0 then begin
			OutCard(list[trump,numSuit[trump]],trump);
			flush(output);exit;
		end;
		
		for i:=9 downto 1 do 
			for j:=1 to 4 do
				if CardInfo[i,j] = 1 then begin
					OutCard(i,j);
					flush(output);
					exit;
				end;
				
	end;
	
	if (nCards[1] + deckLeft) <= 7 then begin
		max:=0;
		for i:=1 to 9 do begin
			pot:=0;rlyMy:=0;
			if cardInfo[i,trump] = 1 then pot:=pot+3;
			if cardInfo[i,trump] = 3 then pot:=pot+1;
			for j:=1 to 4 do begin
				if (cardInfo[i,j] = 1) or (cardInfo[i,j] = 3) then pot:=pot+1;
				if (cardInfo[i,j] = 1) then Inc(rlyMy);
			end;
			pot:=(pot*power[i,1]) div power[i,2];
			if rlyMy = 0 then pot:=0;
			if pot>max then begin
				max:=pot;bestVal:=i;
			end;
		end;
		Write(cardSymbol[bestVal]);
		if cardInfo[bestVal,trump] = 1 then begin
			WriteLn(mastSymbol[trump]);
			flush(output);exit;
		end;
		if cardInfo[bestVal,trump] <> 1 then
			for j:=1 to 4 do if cardInfo[bestVal,trump] = 1 then begin
				WriteLn(mastSymbol[j]);flush(output);exit;
			end;
	end;
	
	if nCards[1] = numSuit[trump] then begin
		OutCard(list[trump,1],trump);
		flush(output);
		exit;
	end;

	max:=0;
	for i:=1 to 9 do begin
		cur:=0;
		for j:=1 to 4 do if (j<>trump) and (cardInfo[i,j] = 1) then Inc(cur);
		if cur>max then begin
			max:=cur;BestCard:=i;
		end;
	end;
	
	for j:=1 to 4 do if (j<>trump) and (cardInfo[BestCard,j] = 1) then begin
		OutCard(BestCard,j);flush(output);exit;
	end;
	
End;

Function MinimalBeat:TCard;
Var k,i,j:Integer;
 		pot,rlyMy:Integer;
 		max,bestCard:Integer;
 		list:Array[1..4,1..9]of Integer;
 		numSuit:Array[1..4]of Integer;
Begin
	
	for i:=1 to 4 do numSuit[i]:=0;
	
	for i:=1 to 4 do
		for j:=1 to 9 do
			if (cardInfo[j,i]=1) then begin
				Inc(numSuit[i]);
				list[i,numSuit[i]]:=j;
			end;
	
	if lastCard.spd = trump then begin
		for i:=1 to numSuit[trump] do
			if list[trump,i]>lastCard.val then begin
				MinimalBeat.val:=list[trump,i];
				MinimalBeat.spd:=trump;
				exit;
			end;
		MinimalBeat.val:=-1;exit;
	end;
	
	if lastCard.spd <> trump then begin
		
		if numSuit[trump] <> 0 then begin
			MinimalBeat.val:=list[trump,1];
			MinimalBeat.spd:=trump;
			exit;
		end;
		
		if numSuit[trump] = 0 then begin
			
			for i:=1 to numSuit[lastCard.spd] do
				if list[lastCard.spd,i]>lastCard.val then begin
					MinimalBeat.val:=list[lastCard.spd,i];
					MinimalBeat.spd:=lastCard.spd;
					exit;
				end;
				MinimalBeat.val:=-1;exit;
		end;
	end;
	
End;

Procedure NormalBeat;

Var k,i,j,maxVal:Integer;
 		pot,rlyMy:Integer;
 		max,bestCard:Integer;
 		list:Array[1..4,1..9]of Integer;
 		numSuit:Array[1..4]of Integer;
 		minCard:TCard;
Begin
	for i:=1 to 4 do numSuit[i]:=0;
	
	for i:=1 to 4 do
		for j:=1 to 9 do
			if (cardInfo[j,i]=1) then begin
				Inc(numSuit[i]);
				list[i,numSuit[i]]:=j;
			end;
	
	minCard:=MinimalBeat;
	if minCard.val = -1 then begin
		WriteLn('NO');
		flush(output);
		exit;
	end;
	
	if nCards[1] + deckLeft <= 6 then begin OutCard(minCard.val,minCard.spd);flush(output);exit;end;
	
	maxVal:=0;
	for i:=9 downto 1 do begin
		for j:=1 to 4 do if (j<>trump) and (cardInfo[i,j] = 1) then begin
			maxVal:=i;break;
		end;
		if maxVal<>0 then break;
	end;
	
	if (((minCard.spd=trump) and (minCard.val<=5)) or (minCard.spd<>trump)) and ((numSuit[trump] >= 2) or (maxVal>=6)) then begin
		OutCard(minCard.val,minCard.spd);
		flush(output);
		exit;
	end;
	
	WriteLn('NO');
	flush(output);
	
End;


Procedure doAdd;
Var cur,k,i,j,bestVal:Integer;
 		pot,rlyMy:Integer;
 		max,bestCard:Integer;
 		list:Array[1..4,1..9]of Integer;
 		numSuit:Array[1..4]of Integer;
 		canAdd:Array[1..9]of Boolean;
 		hasCards:Boolean;
Begin
	
	fillchar(canAdd,sizeof(canAdd),false);
	
	for i:=1 to 9 do
		for j:=1 to 4 do
			if thisRound[i,j] then canAdd[i]:=true;
	
	whoAttacked(k);
	
	for i:=1 to 4 do numSuit[i]:=0;
	
	for i:=1 to 4 do
		for j:=1 to 9 do if canAdd[j] then
			if (cardInfo[j,i]=1) then begin
				Inc(numSuit[i]);
				list[i,numSuit[i]]:=j;
			end;
			
	hasCards:=false;
	for i:=1 to 4 do if numSuit[i] <>0 then hasCards:=true;
	if not hasCards then begin
		WriteLn('NO');flush(output);
		exit;
	end;

	if (nCards[1] <= 3) or (nCards[k] <= 3) then begin
		
		if numSuit[trump] <> 0 then begin
			OutCard(list[trump,numSuit[trump]],trump);
			flush(output);exit;
		end;
		
		for i:=9 downto 1 do if canAdd[i] then
			for j:=1 to 4 do
				if CardInfo[i,j] = 1 then begin
					OutCard(i,j);
					flush(output);
					exit;
				end;
				
	end;
	
	if (nCards[1] + deckLeft) <= 7 then begin
		max:=0;
		for i:=1 to 9 do if canAdd[i] then begin
			pot:=0;rlyMy:=0;
			for j:=1 to 4 do begin
				if (cardInfo[i,j] = 1) or (cardInfo[i,j] = 3) then pot:=pot+1;
				if (cardInfo[i,j] = 1) then Inc(rlyMy);
			end;
			pot:=(pot*power[i,1]) div power[i,2];
			if rlyMy = 0 then pot:=0;
			if pot>max then begin
				max:=pot;bestVal:=i;
			end;
		end;
		Write(cardSymbol[bestVal]);
		if cardInfo[bestVal,trump] = 1 then begin
			WriteLn(mastSymbol[trump]);
			flush(output);exit;
		end;
		if cardInfo[bestVal,trump] <> 1 then
			for j:=1 to 4 do if cardInfo[bestVal,trump] = 1 then begin
				WriteLn(mastSymbol[j]);flush(output);exit;
			end;
	end;
	
	if (nCards[1] = numSuit[trump]) and (list[trump,1]<=3) then begin
		OutCard(list[trump,1],trump);
		flush(output);
		exit;
	end;
	
	if (nCards[1] = numSuit[trump]) and (list[trump,1]>3) then begin
		WriteLn('NO');
		flush(output);
		exit;
	end;

	max:=0;
	for i:=1 to 9 do if canAdd[i] then begin
		cur:=0;
		for j:=1 to 4 do if (j<>trump) and (cardInfo[i,j] = 1) then Inc(cur);
		if cur>max then begin
			max:=cur;BestCard:=i;
		end;
	end;
	
	for j:=1 to 4 do if (j<>trump) and (cardInfo[BestCard,j] = 1) then begin
		OutCard(BestCard,j);flush(output);exit;
	end;
	
	WriteLn('NO');
	flush(output);
	
	
End;

Procedure getInfo;
var s:String;
Begin
	
	Init;
	
	ReadLn(s);
	case s[1] of
		't':if s[2] = 'r' then trump:=mast(s[7]) else begin
					p1:=plNum(s[6]);action:=_take;
				end;
		'g':begin p1:=plNum(s[6]);card:=getCard(s[8],s[9]);action:=_give;end;
		'm':begin p1:=plNum(s[6]);p2:=plNum(s[8]);card:=getCard(s[10],s[11]);action:=_move;end;
		'a':begin p1:=plNum(s[5]);p2:=plNum(s[7]);card:=getCard(s[9],s[10]);action:=_add;end;
		'b':begin p1:=plNum(s[6]);card:=getCard(s[8],s[9]);action:=_beat;end;
		'o':begin p1:=plNum(s[5]);action:=_out;end;
		'M':action:=_myMove;
		'B':action:=_myBeat;
 		'A':action:=_myAdd;
	end;
End;

Begin
{	Assign(input,'in.txt');
	Reset(input);
	Assign(output,'out.txt');
	ReWrite(output);}
	roundStarted:=false;
	while true do begin
		getInfo;
		case action of
			_give:Give(p1,card);
			_move:move(p1,p2,card);
			_add:add(p1,p2,card);
			_beat:beat(p1,card);
			_take:take(p1);
			_out:out(p1);
			_myMove:doMove;
			_myBeat:NormalBeat;
			_myAdd:doAdd;
		end;
	end;
End. 