#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

int res[1 << 20][20][3];
short prev[1 << 20][20][3];
int a[20][3], b[20][3], c[20][3];

int out (int i, int j, int k, int s, int *sa, int *sb) {
	if (i == 0) {
		printf ("%d\n", s);
		return 0;
	}
	int pj = prev[i][j][k] / 3;
	int pk = prev[i][j][k] % 3;
	int aa, bb;
	out (i - (1 << j), pj, pk, s + 1, &aa, &bb);
	if (i - (1 << j) == 0) {
		*sa = a[j][k];
		*sb = b[j][k];
	} else {
		if (aa >= a[j][k] && bb >= b[j][k]) {
			*sa = a[j][k];
			*sb = b[j][k];
		} else {
			*sa = b[j][k];
			*sb = a[j][k];
		}
	}
	printf ("%d %d %d %d\n", j + 1, *sa, *sb, c[j][k]);
}

int main () {
	int n;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf ("%d%d%d", &a[i][0], &b[i][0], &c[i][0]);
		a[i][1] = b[i][0]; b[i][1] = c[i][0]; c[i][1] = a[i][0];
		a[i][2] = c[i][0]; b[i][2] = a[i][0]; c[i][2] = b[i][0];
	}
	memset (res, 0, sizeof (res));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < 3; j++)
			res[1 << i][i][j] = c[i][j];
	int nn = (1 << n);
	for (int i = 1; i < nn; i++)
		for (int j = 0; j < n; j++)
			if (i & (1 << j))
				for (int k = 0; k < 3; k++)
					if (res[i][j][k]) 
						for (int l = 0; l < n; l++)
							if (!(i & (1 << l))) {
								int ni = i + (1 << l);
								for (int q = 0; q < 3; q++)
									if (res[ni][l][q] < res[i][j][k] + c[l][q])
										if (a[j][k] >= a[l][q] && b[j][k] >= b[l][q] || a[j][k] >= b[l][q] && b[j][k] >= a[l][q]) {
											res[ni][l][q] = res[i][j][k] + c[l][q];
											prev[ni][l][q] = j * 3 + k;
										}
					}
	int ni = 0, nj = 0, nk = 0;
	for (int i = 0; i < nn; i++)
		for (int j = 0; j < n; j++)
			for (int k = 0; k < 3; k++)
				if (res[i][j][k] > res[ni][nj][nk]) {
				ni = i;
				nj = j;
				nk = k;
			}
	printf ("%d\n", res[ni][nj][nk]);
	int aa, bb;
	out (ni, nj, nk, 0, &aa, &bb);
}