#include <iostream>

using namespace std;

const int maxn=185;
const int rotkol=6;

struct node
{
	int height;
	int ld1,ld2; // down
	int lu1,lu2; // up
	int downid, upid;
	int mask;
	node *downcomp, *upcomp;

	node()
	{
 		this->height=-1;
// 		this->ld1=this->ld2=this->lu1=this->lu2=this->mask=0;
// 		this->downcomp=this->upcomp=0;
// 		this->downid=this->upid=0;
	}
	node (int height,int ld1,int ld2,int lu1,int lu2,int downid,int upid, int mask,node *downcomp,node *upcomp)
	{
		this->height=height;
		this->ld1=ld1;
		this->ld2=ld2;
		this->lu1=lu1;
		this->lu2=lu2;
		this->downid=downid;
		this->upid=upid;
		this->mask=mask;
		this->downcomp=downcomp;
		this->upcomp=upcomp;
	}
};

node mas[maxn][maxn][maxn];
int sum[maxn];

int n;


void WriteBoxes(node* x)
{
	if (!x->downcomp && !x->upcomp)
	{
		cout << x->upid+1 << ' '<<  x->lu1 << ' ' << x->lu2 << ' ' << sum[x->upid]-x->lu1-x->lu2 << endl;
		return;
	}
	WriteBoxes(x->downcomp);
	WriteBoxes(x->upcomp);
}

bool CanStand(int x1,int y1, int x2,int y2)
{
	return (x2>=x1 && y2>=y1);
}

int main()
{
	cin >> n;
	int k=0;
	for (int i=0; i<n; i++)
	{
		int a,b,c;
		cin >> a >> b >> c;
		sum[i]=a+b+c;
		mas[1][k][k] = node(c,a,b,a,b,i,i,1<<i,0,0);
		k++;
		mas[1][k][k] = node(c,b,a,b,a,i,i,1<<i,0,0);
		k++;
		mas[1][k][k] = node(a,b,c,b,c,i,i,1<<i,0,0);
		k++;
		mas[1][k][k] = node(a,c,b,c,b,i,i,1<<i,0,0);
		k++;
		mas[1][k][k] = node(b,a,c,a,c,i,i,1<<i,0,0);
		k++;
		mas[1][k][k] = node(b,c,a,c,a,i,i,1<<i,0,0);
		k++;
	}
	
	for (int h=2; h<n; h++)
		for (int down1=0; down1<k; down1++)
			for (int up1=0; up1<k; up1++)
				for (int height1=1; height1<=h/2+1; height1++)
					if (mas[height1][down1][up1].height!=-1)
						for (int down2=0; down2<k; down2++)
							for (int up2=0; up2<k; up2++)
							{
								int height2=h-height1;
								node* node1=&mas[height1][down1][up1];
								node* node2=&mas[height2][down2][up2];
								if (node2->height!=-1)
									if (CanStand(node1->ld1,node1->ld2,node2->lu1,node2->lu2))
										if ((node2->height+node1->height>mas[h][down2][up1].height) &&	((node2->mask&node1->mask)==0))
											mas[h][down2][up1]=node(node2->height+node1->height,node2->ld1,node2->ld2,node1->lu1,
											node1->lu2,node2->downid,node1->upid,node1->mask|node2->mask,node2,node1);
											
							}
	int maxheight=-1;
	int maxkol=-1;
	node* max=0;
	for (int h=1; h<n; h++)
		for (int down1=0; down1<k; down1++)
			for (int up1=0; up1<k; up1++)
				if (mas[h][down1][up1].height>maxheight)
				{
					maxheight=mas[h][down1][up1].height;
					max=&mas[h][down1][up1];
					maxkol=h;
				}
	cout << maxheight << endl;
	cout << maxkol << endl;
	WriteBoxes(max);
}