#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10;

struct cub{
	int a,b,c,n;
};

bool ls(cub a, cub b){
	if (a.a != b.a)
		return a.a < b.a;
	if (a.b != b.b)
		return a.b < b.b;
	if (a.c != b.c)
		return a.c < b.c;
	return a.n < b.n;
}	

int n,m,lmax;
cub a[nmax];
vector<cub> ans;
vector<int> have;
int64 t[3*nmax+2][3*nmax+2][1 << nmax];
pair<pii, pair<int,cub> > p[3*nmax+2][3*nmax+2][1 << nmax];
int64 res;

void norm(cub &a){
	vector<int> q;
	q.pb(a.a);
	q.pb(a.b);
	q.pb(a.c);
	sort(all(q));
	a.a = q[0];
	a.b = q[1];
	a.c = q[2];
}
	
void go(pair<pii,pair<int,cub> > q){
	pair<pii, pair<int,cub> > w = p[q.fs.fs][q.fs.sc][q.sc.fs];
	ans.pb(q.sc.sc);
	if (q.sc.fs == 0)return;
	go(w);
}
	
int nom(int x){
	forn(i,have.size())
		if (have[i] == x)
			return i;
	return nmax;
}
	
void solve(){
	forn(i,n)
		norm(a[i]);
	forn(i,n){
		have.pb(a[i].a);
		have.pb(a[i].b);
		have.pb(a[i].c);
	}
	have.pb(0);
	sort(all(have));
	have.erase(unique(all(have)),have.end());
	lmax = have.size();
	forn(i,n){
		a[i].a = nom(a[i].a);
		a[i].b = nom(a[i].b);
		a[i].c = nom(a[i].c);
	}
		
	
	forn(i,nmax)
		forn(j,1 << nmax)
			forn(k,nmax){
				t[i][k][j] = -1;
			}
	t[0][0][0] = 0;
	forn(i,1 << n)
		forn(l,lmax)
			forn(r,lmax)
				if (t[l][r][i] >= 0){
		forn(j,n)
		if (!(i & (1 << j))){
			cub q = a[j];
			if (q.a < l){
				swap(q.a,q.b);
				if (q.a < l){
					swap(q.a,q.c);
					swap(q.b,q.c);
				}
			}
			if (q.b < r)swap(q.b,q.c);
		if (q.a >= l && q.b >= r &&  t[q.a][q.b][i | (1 << j)] < t[l][r][i] + q.c){
				t[q.a][q.b][i | (1 << j)] = t[l][r][i] + q.c;
				p[q.a][q.b][i | (1 << j)] = mp(mp(l,r),mp(i,q));
			}
				}
				}
	res = 0;
	pair<pii,int> now;
	forn(i,lmax)
		forn(j,lmax)
			forn(k,1 << n)
				if (t[i][j][k] > res){
		res =t[i][j][k];
		ans.clear();
// 		cerr << i << " " << j << " " << res << endl;
		now = mp(mp(i,j),k);
				}
	go(p[now.fs.fs][now.fs.sc][now.sc]);
}

void read(){
	scanf("%d",&n);
	forn(i,n){
		scanf("%d %d %d",&a[i].a,&a[i].b,&a[i].c);
		a[i].n = i+1;
	}
}

void write(){
	cout << res << endl;
	cout << ans.size() << endl;
	forn(i,ans.size())
		printf("%d %d %d %d\n",ans[i].n,have[ans[i].a],have[ans[i].b],have[ans[i].c]);
}

int main(){
// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
