#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=100;
int a[N][3], g[N][N], h[N][N], p[3][3]= {{0, 1, 2}, {0, 2, 1}, {1, 2, 0}};
int nr, res[N][4];

inline int vm(int x, int y, int i, int j) {
	return ((x>=i && y>=j) ? ((x>i || y>j) ? 1 : 0) : -1);
}

void way(int x, int y) {
	if (h[x][y]) {
		way(x, h[x][y]);
		way(h[x][y], y);
	}
	else {
		res[nr][0]=x/3+1;
		for (int i=1; i<=3; i++)
			res[nr][i]=a[x/3][p[x%3][i-1]];
		nr++;
	}
}

int main () {
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
	int n; 
// 	cin >> n;
	n=30;
	for (int x=0; x<n; x++) {
// 		cin >> a[x][0] >> a[x][1] >> a[x][2];
		for (int i=0; i<3; i++)
			a[x][i]=rand()%1000000+1;
		sort(a[x], a[x]+3);
	}
	for (int i=0; i<n; i++)
		for (int j=0; j<n; j++)
			if (i!=j)
				for (int x=0; x<3; x++)
					for (int y=0; y<3; y++) {
						int c=vm(a[i][p[x][0]], a[i][p[x][1]], a[j][p[y][0]], a[j][p[y][1]]);
						if (c == 1 || c == 0 && i < j)
							g[i*3+x][j*3+y]=a[i][p[x][2]];
					}
	
	for (int i=0; i<n; i++)
		for (int x=0; x<3; x++)
			g[i*3+x][n*3]=a[i][p[x][2]];
	
	n*=3;
	
	for (int k=0; k<=n; k++)
		for (int i=0; i<=n; i++)
			for (int j=0; j<=n; j++)
				if (g[i][k] && g[k][j] && g[i][j]<g[i][k]+g[k][j])
					g[i][j]=g[i][k]+g[k][j], h[i][j]=k;
	
	int x=0;
	for (int i=1; i<n; i++)
		if (g[x][n]<g[i][n]) 
			x=i;
	
	way(x, n);
	
	cout << g[x][n] << endl << nr << endl;
	
	for(int i=0; i<nr; i++, cout << endl) 
		for (int j=0; j<4; j++, cout << ' ')
			cout << res[i][j];
		
	
	return 0;
} 
