#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>
using namespace std;
int const N=10000, M=1000000, NB=24;
int nn, be[M], en[M], v[N][N/NB], t[N/NB], cn[1<<NB];

int f(int x, int y) {
	int res=0;
	for (int i=0; i<nn; i++)
		res+=cn[v[x][i]&v[y][i]];
	return res;
}

int main () {
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);	
	
	for (int i=1; i<(1<<NB); i++)
		cn[i]=cn[i>>1]+(i&1);
	
	int n, m; 
	scanf ("%d%d", &n, &m);
	nn=(n-1)/NB+1;
	
	for (int i=0; i<m; i++) {
		scanf ("%d%d", be+i, en+i);
		be[i]--, en[i]--;
		v[be[i]][en[i]/NB] |= 1 << en[i]%NB;
		v[en[i]][be[i]/NB] |= 1 << be[i]%NB;
	}
	
	long long res=0;	
	for (int i=0; i<m; i++)
		res+=f(be[i], en[i]);
	
	cout << setprecision(15) << res/12. << endl;
	return 0;
} 
