{$MODE DELPHI}
//{$O-,D+,I+,R+,S+,Q+,H+}
{$O+,D-,I-,R-,S-,Q-,H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, Math
  { you can add units after this };

const
  MaxA=22;
  MaxN=1 shl (MaxA+1);
type
  data=array[0..42]of boolean;
var
  i,n,x,maxer:longint;
  a:array[0..42]of longint;
  e:longint;
  u:array[0..MaxN]of boolean;
  pr,d:array[0..MaxN]of longint;
  list:array[0..MaxN]of longint;
  used,must:data;
  kol:longint;
  rn:longint;
  s:array[0..100]of string;
  r_kol:array[0..42,0..42]of longint;
Procedure Modify(var p:longint;i:longint);
Begin
  p:=p or (1 shl (i-1));
End;
Function Bit(p,i:longint):boolean;
Begin
  if (p and (1 shl (i-1)))>0 then result:=true else result:=false;
End;
Procedure WriteAns(v,kol:longint);
var
  i,p,t,k:longint;
Begin
  if (v=0) then exit;
  if (v=1) then begin
    writeln(kol);
    exit;
  end;
  WriteAns(pr[v],kol+1);
  i:=d[v];
  p:=pr[v];
  k:=1;
        while i shl k<=MaxA do begin
          t:=p;Modify(t,i shl k);
          if t=v then begin
            writeln(i,'<<',k);
            exit;
          end;
          inc(k);
        end;
        for k:=i+1 to MaxA do
          if (Bit(p,k))and(i+k<=MaxA) then begin
            t:=p;Modify(t,i+k);
            if t=v then begin
              writeln(i,'+',k);
              exit;
            end;
          end;
        for k:=1 to i-1 do
          if Bit(p,k) then begin
            t:=p;Modify(t,i-k);
            if t=v then begin
              writeln(i,'-',k);
              exit;
            end;
          end;
End;
Procedure BFS(v:longint);
var
  l,r,p,i,t,k:longint;
Begin
  l:=1;r:=1;
  list[1]:=v;
  u[v]:=true;
  while (l<=r) do begin
    p:=list[l];
    if (p and e)=e then break;
    for i:=1 to MaxA do
      if Bit(p,i) then begin
        k:=i shl 1;
        while k<=MaxA do begin
          t:=p;Modify(t,k);
          if not(u[t]) then begin
            inc(r);
            list[r]:=t;
            u[t]:=true;
            pr[t]:=list[l];
            d[t]:=i;
          end;
          k:=k shl 1;
        end;
        for k:=i to MaxA do
          if (Bit(p,k))and(i+k<=MaxA) then begin
            t:=p;Modify(t,i+k);
            if not(u[t]) then begin
              inc(r);
              list[r]:=t;
              u[t]:=true;
              pr[t]:=list[l];
              d[t]:=i;
            end;
          end;
        for k:=1 to i-1 do
          if Bit(p,k) then begin
            t:=p;Modify(t,i-k);
            if not(u[t]) then begin
              inc(r);
              list[r]:=t;
              u[t]:=true;
              pr[t]:=list[l];
              d[t]:=i;
            end;
          end;
      end;
    inc(l);
  end;
  WriteAns(p,0);
End;
Procedure Add(v:longint;t:string);
Begin
  inc(kol);
  if (must[v]) then dec(rn);
  used[v]:=true;
  must[v]:=false;
  s[kol]:=t;
End;
Function Can(v:longint):string;
var
  i,j,k:longint;
Begin
  result:='';
  for i:=1 to 42 do if (used[i]) then
    for j:=i to 42 do if (used[j]) then begin
      if (j+i=v) then begin
        result:=inttostr(i)+'+'+inttostr(j);
        exit;
      end;
      if (j-i=v) then begin
        result:=inttostr(j)+'-'+inttostr(i);
        exit;
      end;
    end;
  for i:=1 to v do if (used[i]) then begin
      k:=1;
      while (i shl k)<=v do begin
        if (i shl k)=v then begin
          result:=inttostr(i)+'<<'+inttostr(k);
          exit;
        end;
        inc(k);
      end;
  end;
End;
Procedure Perebor;
var
  i,j,k:longint;
  ok:boolean;
  kol:array[0..42]of longint;
  t:string;
  max_k,max_v,max_j:longint;
Begin
  if (rn=0) then exit;
  ok:=false;
  for i:=1 to 42 do if (not used[i])and(must[i])and(Can(i)<>'') then begin
    Add(i,Can(i));
    ok:=true;
  end;
  if ok then begin
    Perebor();
    exit;
  end;
  fillchar(kol,sizeof(kol),0);
  for i:=1 to 42 do if (not used[i])then begin
    t:=Can(i);
    if t='' then continue;
    used[i]:=true;
    for k:=1 to 42 do if (not used[k])and(must[k])and(Can(k)<>'') then inc(kol[i]);
    used[i]:=false;
  end;
  max_k:=0;max_v:=0;
  for i:=1 to 42 do if (kol[i]>max_k)then begin
    max_k:=kol[i];
    max_v:=i;
  end;
  if max_k<>0 then begin
    ok:=true;
    Add(max_v,Can(max_v));
  end;
  if ok then begin
    Perebor();
    exit;
  end;
  fillchar(r_kol,sizeof(r_kol),0);
  for i:=1 to 42 do if (not used[i]) then
    for j:=i+1 to 42 do if (not used[j]) then begin
      t:=Can(i);
      if (t='') then break;
      t:=Can(j);
      if (t='') then continue;
      used[i]:=true;used[j]:=true;
      for k:=1 to 42 do if (not used[k])and(must[k])and(Can(k)<>'') then inc(r_kol[i][j]);
      used[i]:=false;used[j]:=false;
    end;
  max_k:=0;max_v:=0;max_j:=0;
  for i:=1 to 42 do
    for j:=i+1 to 42 do if (r_kol[i][j]>max_k) then begin
      max_k:=r_kol[i][j];
      max_v:=i;
      max_j:=j;
    end;
  if max_k<>0 then begin
    ok:=true;
    Add(max_v,Can(max_v));
    Add(max_j,Can(max_j));
  end;
  if ok then begin
    Perebor();
    exit;
  end;
  for i:=1 to 5 do
  if (not used[1 shl i]) then begin
    Add(1 shl i,Can(1 shl i));
    Perebor();
    exit;
  end;
End;
Begin
  //assign(input,'b.in');reset(input);assign(output,'b.out');rewrite(output);
  read(n);
  maxer:=0;
  fillchar(a,sizeof(a),0);
  for i:=1 to n do begin
    read(a[i]);
    maxer:=max(maxer,a[i]);
  end;
  if maxer<=MaxA then begin
    for i:=1 to n do begin
      x:=a[i];
      Modify(e,x); 
    end;
    fillchar(u,sizeof(u),0);
    BFS(1);
  end else begin
    kol:=0;
    fillchar(used,sizeof(used),0);
    fillchar(must,sizeof(must),0);
    for i:=1 to n do
      must[a[i]]:=true;
    used[1]:=true;
    rn:=n;
    for i:=1 to n do begin
      if must[2] then Add(2,'1<<1');
      if must[4] then Add(4,'1<<2');
      if must[8] then Add(8,'1<<3');
      if must[16] then Add(16,'1<<4');
      if must[32] then Add(32,'1<<5');
    end;
    Perebor();
    writeln(kol);
    for i:=1 to kol do writeln(s[i]);
  end;
  close(input);close(output);
End.