#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;

const int inf = (1 << 30) - 1;

bool win[101000], win1[101000], win2[101000], u[101000];
int d[101000], moves1[101000], moves2[101000], deg[101000];
int n, m;
vector < vector <int> > a;

void go (int v)
{
	if (u[v])
		return;
	u[v] = 1;
	if (deg[v] == 0)
	{
		win[v] = 0;
		d[v] = 0;
		return;
	}	
	win[v] = 0;
	forn (i, a[v].size())
	{
		go (a[v][i]);
		win[v] |= !win[a[v][i]];
	}
	if (win[v])
	{
		d[v] = inf;
		forn (i, a[v].size())
			if (!win[a[v][i]])
				d[v] = min (d[v], d[a[v][i]] + 1);
	}
	else
	{
		d[v] = -inf;
		forn (i, a[v].size())
			d[v] = max (d[v], d[a[v][i]] + 1);
	}
}

void calc()
{
	scanf ("%d%d", &n, &m);
	a.resize (n);
	seta (deg, 0);
	forn (i, n)
		a[i].clear ();
	forn (i, m)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		x --;
		y --;
		a[x].pb (y);
		deg[x] ++;
	}	
	seta (u, 0);
	forn (i, n)
		go (i);
}

int main ()
{	
//  	freopen ("c.in", "r", stdin);
//  	freopen ("c.out", "w", stdout);
	calc ();
	memcpy (win1, win, sizeof (win));
	memcpy (moves1, d, sizeof (d));
	calc ();
	memcpy (win2, win, sizeof (win));
	memcpy (moves2, d, sizeof (d));
	int k;
	scanf ("%d", &k);
	forn (i, k)
	{
		int x, y;
		scanf ("%d%d", &x, &y);
		x --;
		y --;
		if (win1[x] && win2[y])
			printf ("first\n");
		else
		if (!win1[x] && !win2[y])
			printf ("second\n");
		else
		{
			int d1, d2;
			d1 = moves1[x];
			d2 = moves2[y];
			if (!win1[x])
				swap (d1, d2);
			if (d1 < d2)
				printf ("first\n");
			else
				printf ("second\n");		
		}		
	}
	return 0;
}
