#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

vector<int> v[2][200000];
int res[2][200000];
int dist[2][200000];
int n, m;

int calc (int it, int a) {
	if (res[it][a]) return 0;
	int mind = 1000000, maxd = 0;
	res[it][a] = 1;
	for (int i = 0; i < v[it][a].size (); i++) {
		int j = v[it][a][i];
		if (!res[it][j]) calc (it, j);
		if (res[it][j] == 1 && dist[it][j] + 1 < mind) mind = dist[it][j] + 1;
		if (dist[it][j] + 1 > maxd) maxd = dist[it][j] + 1;
		if (res[it][j] == 1) res[it][a] = 2;
	}
	if (res[it][a] == 1) dist[it][a] = maxd; else dist[it][a] = mind;
	return 0;
}

int main () {
	for (int it = 0; it < 2; it++) {
		scanf ("%d%d", &n, &m);
		for (int i = 0; i < m; i++) {
			int a, b;
			scanf ("%d %d", &a, &b); a--; b--;
			v[it][a].push_back (b);
		}
		for (int i = 0; i < n; i++) 
			if (!res[it][i]) calc (it, i);
	}
	int t;
	scanf ("%d", &t);
	for (int i = 0; i < t; i++) {
		int a, b;
		scanf ("%d %d", &a, &b); a--; b--;
		int ra = res[0][a], rb = res[1][b], da = dist[0][a], db = dist[1][b];
		if (ra == rb) {
			if (ra == 1) printf ("second\n"); else printf ("first\n");
		} else {
			if (ra == 2) swap (da, db);
			if (da < db) printf ("second\n"); else printf ("first\n");
		}
	}
}