Type Integer=LongInt;
		 TXSeg = record
		  x,y1,y2:Extended;
		 end;
		 TYSeg = record
		  y,x1,x2:Extended;
		 end;
		 
Const inf : Extended = 1000000000000;		 

Var x,y:Array[1..4002]of Integer;
		xE,yE:Array[1..4002]of Extended;
		xSeg:Array[1..2000]of TXSeg;
		ySeg:Array[1..2000]of TYSeg;
		d:Array[1..4002]of Extended;
		fr:Array[1..4002]of Integer;
		nm,n,i,nSeg,cur:Integer;
		x1,y1,x2,y2:Integer;
		use:Array[1..4002]of Boolean;
		min:Extended;
		ans:Array[0..4002]of Integer;
		
		
Procedure Swap(var x,y:Integer);
Var z:Integer;
Begin
	z:=x;
	x:=y;
	y:=z;
End;		
		
Function dist(v1,v2:Integer):Extended;
Begin
	dist:=sqrt((xE[v2]-xE[v1])*(xE[v2]-xE[v1])+(yE[v2]-yE[v1])*(yE[v2]-yE[v1]));
End;

Function signVectMul(x1,y1,x2,y2:Extended):Integer;
Var p:Extended;
Begin
	p:=x1*y2-x2*y1;
	if abs(p) < 0.001 then signVectMul:=0 else
		if p > 0 then signVectMul:=1 else
			signVectMul:=-1;
End;

function can(v1,v2:Integer):Boolean;
var i,p1,p2,cur:Integer;
Begin
     can:=true;
     for i:=1 to nSeg do begin

         cur:=0;
         p1:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],xSeg[2*i-1].x-xE[v1],xSeg[2*i-1].y1-yE[v1]);
         p2:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],xSeg[2*i-1].x-xE[v1],xSeg[2*i-1].y2-yE[v1]);
         if p1*p2<0 then begin can:=false;exit;end;
         if p1*p2=0 then Inc(cur);
         if p1*p2>0 then continue;
         
         p1:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],xSeg[2*i].x-xE[v1],xSeg[2*i].y1-yE[v1]);
         p2:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],xSeg[2*i].x-xE[v1],xSeg[2*i].y2-yE[v1]);

         if p1*p2<0 then begin can:=false;exit;end;
         if p1*p2=0 then Inc(cur);
         if p1*p2>0 then continue;
         
         p1:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],ySeg[2*i-1].x1-xE[v1],ySeg[2*i-1].y-yE[v1]);
         p2:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],ySeg[2*i-1].x2-xE[v1],ySeg[2*i-1].y-yE[v1]);

         if p1*p2<0 then begin can:=false;exit;end;
         if p1*p2=0 then Inc(cur);
         if p1*p2>0 then continue;
         
         p1:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],ySeg[2*i].x1-xE[v1],ySeg[2*i].y-yE[v1]);
         p2:=signVectMul(xE[v2]-xE[v1],yE[v2]-yE[v1],ySeg[2*i].x2-xE[v1],ySeg[2*i].y-yE[v1]);

         if p1*p2<0 then begin can:=false;exit;end;
         if p1*p2=0 then Inc(cur);
         if p1*p2>0 then continue;

         if cur = 4 then begin
            if ((x[v1]<xSeg[2*i-1].x) and (x[v2]>xSeg[2*i].x)) or ((x[v2]<xSeg[2*i-1].x) and (x[v1]>xSeg[2*i].x)) then
               if ((y[v1]<ySeg[2*i-1].y) and (y[v2]>ySeg[2*i].y)) or ((y[v2]<ySeg[2*i-1].y) and (y[v1]>ySeg[2*i].y)) then
            can:=false;exit;
         end;
         
         
     end;
End;

Begin
	
{	Assign(input,'in.txt');Assign(output,'out.txt');
	Reset(input);ReWrite(output);}
	
	Read(x[1],y[1],x[2],y[2]);xE[1]:=x[1];yE[1]:=y[1];xE[2]:=x[2];yE[2]:=y[2];
	Read(n);
	for i:=1 to n do begin
		Read(x1,y1,x2,y2);
		if x1>x2 then Swap(x1,x2);
		if y1>y2 then Swap(y2,y1);
		x[4*i-1]:=x1;y[4*i-1]:=y1;xE[4*i-1]:=x[4*i-1];yE[4*i-1]:=y[4*i-1];
		x[4*i]:=x1;y[4*i]:=y2;xE[4*i]:=x[4*i];yE[4*i]:=y[4*i];
		x[4*i+1]:=x2;y[4*i+1]:=y1;xE[4*i+1]:=x[4*i+1];yE[4*i+1]:=y[4*i+1];
		x[4*i+2]:=x2;y[4*i+2]:=y2;xE[4*i+2]:=x[4*i+2];yE[4*i+2]:=y[4*i+2];
		
		
		
		xSeg[2*i-1].x:=x1;
		xSeg[2*i-1].y1:=y1;
		xSeg[2*i-1].y2:=y2;
		
		xSeg[2*i].x:=x2;
		xSeg[2*i].y1:=y1;
		xSeg[2*i].y2:=y2;
		
		ySeg[2*i-1].y:=y1;
		ySeg[2*i-1].x1:=x1;
		ySeg[2*i-1].x2:=x2;
		
		ySeg[2*i].y:=y2;
		ySeg[2*i].x1:=x1;
		ySeg[2*i].x2:=x2;
		
	end;
	d[1]:=0;nSeg:=n;
	n:=4*n+2;
	for i:=2 to n do d[i]:=inf;fr[1]:=0;
	fillchar(use,sizeof(use),false);
	while true do begin
		min:=inf;nm:=-1;
		for i:=1 to n do
			if (not use[i]) and (d[i]<min) then begin
				min:=d[i];
				nm:=i;
			end;
		if nm=-1 then break;
		
		for i:=1 to n do if i<>nm then 
			if (not use[i]) and (can(nm,i)) and (d[i]>d[nm]+dist(nm,i)) then begin
				d[i]:=d[nm]+dist(nm,i);
				fr[i]:=nm;
			end;
		
		use[nm]:=true;if nm = 2 then break;
		
	end;
	
	WriteLn(d[2]:10:10);
	ans[0]:=0;
	cur:=2;
	while (cur<>0) do begin
		Inc(ans[0]);
		ans[ans[0]]:=cur;
		cur:=fr[cur];
	end;
	
	WriteLn(ans[0]);
	for i:=ans[0] downto 1 do WriteLn(x[ans[i]],' ',y[ans[i]]);

End. 
