#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

const int base = (1 << 16) - 1;

char g[10001][10001];
int gb[10001][400];
int ea[200000], eb[200000];
int cnt[base + 1];

int put (int a, int b) {
	int bp = b / 31;
	int bq = b % 31;
	gb[a][bp] += (1 << bq);
	return 0;
}

int calc (int x) {
	return cnt[x >> 16] + cnt[x & base];
}

int main () {
	for (int i = 0; i <= base; i++)
		cnt[i] = cnt[i >> 1] + (i & 1);
	int n, m;
	scanf ("%d %d", &n, &m);
	for (int i = 0; i < m; i++) {
		int a, b;
		scanf ("%d%d", &a, &b); a--; b--;
		if (a > b) swap (a, b);
		g[a][b] = g[b][a] = 1;
		put (a, b);
		put (b, a);
		ea[i] = a;
		eb[i] = b;
	}
	int nk = (n + 30) / 31;
	int ans = 0;
	for (int i = 0; i < m; i++) {
		int a = ea[i], b = eb[i];
		int k = (b + 31) / 31;
		int bk = k * 31;
		for (int j = b + 1; j < bk; j++)
			ans += g[a][j] & g[b][j];
		for (int j = k; j < nk; j++)
			ans += calc (gb[a][j] & gb[b][j]);
	}
	printf ("%.15f\n", ans / 4.0);
}