Uses Math;
const
  eps = 1e-9;
type
  point = record
            x,y : extended;
          end;
  kvadrat = record
              x1,y1,x2,y2 : extended;
            end;
var
  ans : array [1..4000] of point;
  kans : longint;
  xst,yst,xfin,yfin,x1,y1,x2,y2,m : extended;
  i,j,n,n1,ind,t : longint;
  a : array [1..4002] of point;
  kv : array [1..1000] of kvadrat;
  c : array [1..4002,1..4002] of extended;
  d : array [1..4002] of extended;
  last,fl : array [1..4002] of longint; 

procedure add(x,y : extended);
begin
  inc(n1);
  a[n1].x:=x;
  a[n1].y:=y;
end;

procedure koef(x1,y1,x2,y2 : extended; var a,b,c : extended);
begin
  a:=y2-y1;
  b:=x1-x2;
  c:=y1*(x2-x1)-x1*(y2-y1);
end;

function det(a,b,c,d : extended) : extended;
begin
  det:=a*d-b*c;
end;

function per(x1,y1,x2,y2,x3,y3,x4,y4 : extended) : boolean;
var
  d,d1,d2,xt,yt : extended;
  a1,b1,c1,a2,b2,c2 : extended;
begin
  koef(x1,y1,x2,y2,a1,b1,c1);
  koef(x3,y3,x4,y4,a2,b2,c2);
  
  
  d:=det(a1,b1,a2,b2);
  d1:=det(-c1,b1,-c2,b2);
  d2:=det(a1,-c1,a2,-c2);
  
  if abs(a2*x1+b2*y1+c2)<eps then begin per:=false; exit; end;
  if abs(a2*x2+b2*y2+c2)<eps then begin per:=false; exit; end;
  
  if abs(a1*x3+b1*y3+c1)<eps then begin per:=false; exit; end;
  if abs(a1*x4+b1*y4+c1)<eps then begin per:=false; exit; end;
  
  if abs(d)>eps then
  begin
    xt:=d1/d;
    yt:=d2/d;
    per:=false;
  if    (min(x1,x2)<=xt) and (max(x1,x2)>=xt)
    and (min(y1,y2)<=yt) and (max(y1,y2)>=yt) then 
    if    (min(x3,x4)<=xt) and (max(x3,x4)>=xt)
      and (min(y3,y4)<=yt) and (max(y3,y4)>=yt) then begin per:=true; exit; end;
       
    exit;   
  end;
  per:=false;
end;

function prov(k1,k2 : point) : boolean;
var
  i : longint; 
begin
  prov:=true;
  for i:=1 to n1 do
  begin
    if per(k1.x,k1.y,k2.x,k2.y,kv[i].x1,kv[i].y1,kv[i].x2,kv[i].y1) then begin prov:=false; exit; end;
    if per(k1.x,k1.y,k2.x,k2.y,kv[i].x1,kv[i].y1,kv[i].x1,kv[i].y2) then begin prov:=false; exit; end;
    if per(k1.x,k1.y,k2.x,k2.y,kv[i].x2,kv[i].y2,kv[i].x2,kv[i].y1) then begin prov:=false; exit; end;
    if per(k1.x,k1.y,k2.x,k2.y,kv[i].x2,kv[i].y2,kv[i].x1,kv[i].y2) then begin prov:=false; exit; end;
  end;  
end;

begin
{  assign(input,'d.in');
  assign(output,'d.out');
  reset(input);
  rewrite(output);
}  
  read(xst,yst);
  read(xfin,yfin);
  n1:=0;
  add(xst,yst);
  add(xfin,yfin);
  
  read(n);
  for i:=1 to n do
  begin
    read(x1,y1,x2,y2);
    add(x1,y1);
    add(x1,y2);
    add(x2,y1);
    add(x2,y2);
    kv[i].x1:=x1;
    kv[i].y1:=y1;
    kv[i].x2:=x2;
    kv[i].y2:=y2;
  end;  
  
  for i:=1 to n1 do  
    for j:=1 to n1 do
      c[i,j]:=-1;
  
  for i:=1 to n1 do
    for j:=i+1 to n1 do
      if prov(a[i],a[j]) then 
      begin
        c[i,j]:=sqrt(sqr(a[i].x-a[j].x)+sqr(a[i].y-a[j].y));
        c[j,i]:=c[i,j];
      end;
      
  for i:=1 to n1 do
  begin
    for j:=1 to n1 do
      write(c[i,j]:0:3,' ');
    writeln;    
  end;    
      
  for i:=1 to n1 do 
  begin
    d[i]:=1000000000000000000;    
    fl[i]:=0;
  end;  
  d[1]:=0;    
  for i:=1 to n1 do
  begin
    m:=1000000000000000000;
    for j:=1 to n1 do
      if (d[j]<m) and (fl[j]=0) then begin ind:=j; m:=d[j]; end;  
      
    fl[ind]:=1;  
      
    if ind=2 then break;  
      
    for j:=1 to n1 do  
      if c[ind,j]<>-1 then
      begin
        if d[j]>d[ind]+c[ind,j] then 
        begin
          d[j]:=d[ind]+c[ind,j];
          last[j]:=ind;
        end;  
      end;  
  end;    
      
  kans:=0;
  t:=2;
  while t<>1 do
  begin
    inc(kans);
    ans[kans]:=a[t];
    t:=last[t];
  end;
  
  writeln(d[2]:0:6);
  writeln(kans+1);
  writeln(xst:0:0,' ',yst:0:0);
  for i:=kans downto 1 do
    writeln(ans[i].x:0:0,' ',ans[i].y:0:0);
  
  
end.