#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

double prob[100][100][100];

int main () {
	int n;
	double p;
	scanf ("%d%lf", &n, &p);
	p /= 100;
	memset (prob, 0, sizeof (prob));
	prob[0][1][0] = 1;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j <= n; j++) 
			for (int k = 0; k <= i; k++) {
// 				printf ("%d %d %d %.10f\n", i, j, k, prob[i][j][k]);
				if (i + 1 == n) {
					prob[n][n][k] += prob[i][j][k];
					continue;
				}
				if (i + 1 == j) {
					double cp = prob[i][j][k];
					for (int l = 1; j + l <= n; l++) {
						prob[i + 1][j + l][k + int (l > 1)] += cp * (1 - p * int (j + l < n));
						cp *= p;
					}
				} else {
					double cp = prob[i][j][k];
					for (int l = 0; j + l <= n; l++) {
						prob[i + 1][j + l][k + int (l > 1)] += cp * (1 - p * int (j + l < n));
						cp *= p;
					}
				}
			}
	double ans = 0;
	for (int k = 0; k < n; k++)
		ans += k * prob[n][n][k];
	printf ("%.15f\n", ans);
}