program z3;
uses Math;
type integer=longint;
     TArr=array[1..1000] of integer;
var a,sum: TArr;
    n,i,r1,r2,rez: integer;

procedure swap(var a,b: integer);
var t: integer;
begin
  t:=a; a:=b; b:=t;
end;

procedure qsort(l,r: integer);
var i,j,x: integer;
begin
  i:=l; j:=r; x:=a[l+random(r-l+1)];
  repeat
    while a[i]<x do inc(i);
    while a[j]>x do dec(j);
    if i<=j then begin
      swap(a[i],a[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;

procedure solve(k,r1,r2: integer);
begin
  if k>n then begin
    if max(r1,r2)<rez then rez:=max(r1,r2);
    if abs(r1-r2)<=1 then begin
      WriteLn(max(r1,r2));
      halt(0);
    end;
    exit;
  end;
  if r1+a[k]<rez then solve(k+1,r1+a[k],r2);
  if r2+a[k]<rez then solve(k+1,r1,r2+a[k]);
  if (max(r1,r2)+(a[k] div 2)<rez) and (a[k] and 1=0) then solve(k+1,r1+a[k] div 2,r2+a[k] div 2);
end;

begin
//  assign(input,'input.txt');
//  reset(input);
  ReadLn(n);
  for i:=1 to n do
  begin
    Read(a[i]);
  end;
  qsort(1,n);
  r1:=0; r2:=0;
  sum[1]:=a[1];
  for i:=2 to n do
    sum[i]:=sum[i-1]+a[i];
  rez:=sum[n];
  solve(1,0,0);
  WriteLn(rez);
end.

