#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define x first
#define y second
#define seta(a,x) memset (a, x, sizeof (a));
#define I (int)

typedef long long int64;
typedef long double ldb;
typedef pair <int64, int64> point;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int l, n, next[1000][26];
char s[20000];
int it;
int f[4000][1000];
int t[1000][40];

int go (int &v)
{
	it ++;
	int m = it;
	forn (i, n)
		f[m][i] = i;
	while (1)
	{
		if (v >= l)
			break;
		if (s[v] == ')')
			break;	
		if ('a' <= s[v] && s[v] <= 'z')
		{
			int c = s[v] - 'a';
			v ++;
			forn (i, n)
				f[m][i] = next[f[m][i]][c];
		}	
		else
		if (s[v] == '(')
		{
			v ++;
			int k = go (v);
			v ++;
			int deg = 0;
			while (isdigit (s[v]))
			{
				deg = deg * 10 + s[v] - '0';
				v ++;
			}
			int list = 0;
			while ((1 << list) < deg)
				list ++;
			forn (i, n)
				t[i][0] = f[k][i];
			for (int j = 1; j <= list; j ++)
				forn (i, n)
					t[i][j] = t[t[i][j-1]][j-1];
			forn (i, n)
				for (int j = 0; j <= list; j ++)
					if (deg & (1 << j))
						f[m][i] = t[f[m][i]][j];
		}
	}
	return m;
}

int main ()
{	
// 	freopen ("a.in", "r", stdin);
//  	freopen ("a.out", "w", stdout);
	seta (s, 0);
	seta (next, 0);
	scanf ("%s", s);
	l = strlen (s);
	s[l] = 0;
	scanf ("%d", &n);
	forn (i, n)
		forn (j, 26)
		{
			int x;
			scanf ("%d", &x);
			x --;
			next[i][j] = x;
		}
	it = -1;
	int v = 0;
	int fin = go (v);	
	forn (i, n)
		printf ("%d ", f[fin][i] + 1);
	printf ("\n");	
	return 0;
}
