#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 1100;
const int mmax = 3000;

int g[nmax][26];
int res[nmax];
string s;
int n;


string repack(string s){
	string res = "";
	forn(i,s.size()){
		if (s[i] == '('){
			int l,r;
			l = r = i + 1;
			
			int dep = 1;
			
			while (dep != 0){
				if (s[r] == ')')dep--;
				if (s[r] == '(')dep++;
				r++;
			}
			string now = repack(s.substr(l,r-l-1));
			int p = r;
			int kol = 0;
			while(p < (int)s.size() && isdigit(s[p])){
				kol = kol * 10 + s[p] - '0';
				p++;
			}
			forn(q,kol)
				res += now;
			i = r;
			continue;
		}
		res += s[i];
	}
	return res;
}


void solve(){
	s = repack(s);
	forn(i,n){
		int now = i;
		forn(j,s.size())
			now = g[now][s[j]-'a'];
		res[i] = now+1;
	}
}


void read(){
	getline(cin,s);
	scanf("%d",&n);
	forn(i,n)
		forn(j,26){
			scanf("%d",&g[i][j]);
			g[i][j] --;
		}
}

void write(){
	forn(i,n)
		printf("%d ",res[i]);
	cout << endl;
}

int main(){
// 	freopen("a.in","rt",stdin);
// 	freopen("a.out","wt",stdout);
	
	
	read();
	solve();
	write();
	
	return 0;
}
