#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

char w[20000];
int aut[1000][26];
int d[10000][1000];
int next[20000], rg[20000], num[20000], st[20000], q[20000];
int n, m, o; 

int go (int l, int r) {
	int c = o;
	o++;
	for (int i = 0; i < n; i++) d[c][i] = i;
	while (l < r) {
		if (w[l] >= 'a' && w[l] <= 'z') {
			for (int i = 0; i < n; i++)
				d[c][i] = aut[d[c][i]][w[l] - 'a'];
			l++;
		} else {
			int k = go (l + 1, rg[l]);
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) q[j] = -1;
				int tmp = num[l];
				int x = d[c][i];
				int ok = 1;
				for (int j = 0; j < tmp; j++) {
					if (ok && q[x] != -1) {
						int p = j - q[x];
						int pp = q[x];
						tmp = (tmp - pp) % p + pp + p;
						ok = 0;
						if (j >= tmp) break;
						x = d[k][x];
					} else {
						q[x] = j;
						x = d[k][x];
 					}
				}
				d[c][i] = x;
			}
			l = next[l];
		}
	}
	return c;
}

int main () {
	scanf ("%s", w);
	while (w[m]) m++;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < 26; j++) {
			scanf ("%d", &aut[i][j]);
			aut[i][j]--;
		}
	int r = 0;
	for (int i = 0; i < m; i++) 
		if (w[i] == '(') {
			st[r++] = i;
		} else
		if (w[i] == ')') {
			r--;
			rg[st[r]] = i;
			int x = 0;
			int j = i + 1;
			while (j < m && w[j] >= '0' && w[j] <= '9') {
				x = x * 10 + w[j] - '0';
				j++;
			}
			next[st[r]] = j;
			num[st[r]] = x;
		}
	o = 0;
	int k = go (0, m);
	for (int i = 0; i < n; i++)
		printf ("%d ", d[k][i] + 1);
}