#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> point;

const double inf = 1e100;
const double eps = 1e-2;

map < vector <int>, double > t;
vector <int> st;
int n;

void calc ()
{
	vector <int> a;
	a.resize (n);
	forn (i, n)
		a[i] = i;
	t[a] = 0;
	int fc = 1;
	forn (i, n)
		fc *= (i+1);
	forn (i, fc-1)
	{
		next_permutation (all (a));
		t[a] = fc + fc / n / 2;
	}		
}

int main ()
{	
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	t.clear ();
	scanf ("%d", &n);
	calc ();
	st.clear ();
	forn (i, n)
	{
		int x;
		scanf ("%d", &x);
		x --;
		st.pb (x);
	}
	map < vector <int>, double > :: iterator it;
	forn (i, 500)
	{	
		for (it = t.begin(); it != t.end(); it ++)
		if (it != t.begin())
		{
			double res = 0;
			vector <int> a = (*it).fs;
			double pr = 1.0 / (double)((n * (n-1)) / 2);
			forn (i, n)
				forn (j, i)
				{
					swap (a[i], a[j]);
					res += pr * (t[a] + 1.0);
					swap (a[i], a[j]);
				}
			t[a] = res;	
		}
	}
// 	for (it = t.begin(); it != t.end(); it ++)
// 		printf ("%d\n", (int)((*it).sc+eps));
	printf ("%d\n", (int)(t[st]+eps));
	return 0;
}
