#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <set>
#include <math.h>
#include <string>
#include <cstdlib>
#include <map>
#include <ctime>
#include <iostream>

using namespace std;

char w[20000];
int aut[1000][26];
int d[10000][1000];
int next[20000], rg[20000], num[20000], st[20000], q[20000], pc[2000], ppc[2000], was[2000], dc[2000][15], prev[2000], dl[2000];
int n, m, o, ct; 

int dfs (int k, int x, int l) {
	if (was[x] == ct) {
		if (pc[x] != -1) return 0;
		int p = l - dl[x];
		int j = prev[x];
		pc[x] = p;
		ppc[x] = 0;
		while (j != x) {
			pc[j] = p;
			ppc[j] = 0;
			j = prev[j];
		}
		return 0;
	}
	was[x] = ct;
	dl[x] = l;
	prev[d[k][x]] = x;
	dfs (k, d[k][x], l + 1);
	if (pc[x] == -1) {
		pc[x] = pc[d[k][x]];
		ppc[x] = ppc[d[k][x]] + 1;
	}
	return 0;
}

int go (int l, int r) {
	int c = o;
	o++;
	for (int i = 0; i < n; i++) d[c][i] = i;
	while (l < r) {
		if (w[l] >= 'a' && w[l] <= 'z') {
			for (int i = 0; i < n; i++)
				d[c][i] = aut[d[c][i]][w[l] - 'a'];
			l++;
		} else {
			int k = go (l + 1, rg[l]);
			ct++;
			for (int i = 0; i < n; i++) pc[i] = -1;
			for (int i = 0; i < n; i++)
				if (was[i] != ct)
					dfs (k, i, 0); 
			for (int i = 0; i < n; i++) dc[i][0] = d[k][i];
			int mq = 0;
			for (int q = 1; (1 << q) < n; q++) {
				for (int i = 0; i < n; i++)
					dc[i][q] = dc[dc[i][q - 1]][q - 1];
				mq = q;
			}
			for (int t = 0; t < n; t++) {
				int i = d[c][t];
				int tmp;
				if (num[l] <= ppc[i]) tmp = num[l]; else tmp = (num[l] - ppc[i]) % pc[i] + ppc[i];
				int j = i;
				int q = mq;
				while (tmp > 0)
					if (tmp >= (1 << q)) {
						j = dc[j][q];
						tmp -= (1 << q);
					} else q--;
				d[c][t] = j;
			}
			l = next[l];
		}
	}
	return c;
}

int main () {
	scanf ("%s", w);
	while (w[m]) m++;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < 26; j++) {
			scanf ("%d", &aut[i][j]);
			aut[i][j]--;
		}
	int r = 0;
	for (int i = 0; i < m; i++) 
		if (w[i] == '(') {
			st[r++] = i;
		} else
		if (w[i] == ')') {
			r--;
			rg[st[r]] = i;
			int x = 0;
			int j = i + 1;
			while (j < m && w[j] >= '0' && w[j] <= '9') {
				x = x * 10 + w[j] - '0';
				j++;
			}
			next[st[r]] = j;
			num[st[r]] = x;
		}
	o = 0;
	ct = 0;
	int k = go (0, m);
	for (int i = 0; i < n; i++)
		printf ("%d ", d[k][i] + 1);
	printf ("\n");
}