Type Integer=Longint;
		 tList = Array[0..15]of Integer;

Var d:TList;
		list:Array[1..200]of TList;
		k,q,i,n,tot:Integer;
		m:Array[1..200,1..200]of Extended;
		x,b:Array[1..200]of Extended;
		p:TList;
  ans:Extended;
				
		e2father:Array[1..200]of Integer;
		use:Array[1..200] of  Boolean;
		

Procedure Swap(var a,b:Integer);
Var c:Integer;
Begin
	c:=a;a:=b;b:=c;
End;

Procedure AddCycle;
var i:Integer;
Begin
	Inc(tot);
	list[tot,0]:=d[0];
	for i:=1 to d[0] do list[tot,i]:=d[i];
End;

Procedure Gen(n,k,max:Integer);
Begin
	if (n=0) and (k=0) then AddCycle;
	if (n<=0) or (k<=0) or (max<=0) then exit;
	Inc(d[0]);
	d[d[0]]:=max;
	Gen(n-max,k-1,max);
	Dec(d[0]);
	Gen(n,k,max-1);
End;


Procedure GenAllCycles;
var i:Integer;
Begin
	for i:=1 to n do Gen(n,i,n);
End;

Function Find(var d:TList):Integer;
var i,j:Integer;
		our:Boolean;
Begin
	for i:=1 to d[0]-1 do
		for j:=1 to d[0]-i do
			if d[j]<d[j+1] then Swap(d[j],d[j+1]);
	for i:=1 to tot do if list[i,0]=d[0] then begin
		our:=true;
		for j:=1 to d[0] do
			if d[j]<>list[i,j] then begin
				our:=false;
				break;
			end;
		if our then begin
			find:=i;exit;
		end;	
	end;
End;

Procedure FindInfo;
var i,j,k,r,p:Integer;
		tmp:TList;
Begin
	for i:=1 to tot do
		for j:=1 to list[i,0] do begin
			{Connecting cycles j and k}
			for k:=j+1 to list[i,0] do begin
				tmp:=list[i];
				r:=tmp[j]+tmp[k];
				Swap(tmp[k],tmp[tmp[0]]);
				tmp[j]:=r;
				Dec(tmp[0]);
				p:=Find(tmp);
				m[i,p]:=m[i,p]+list[i,j]*list[i,k];
			end;
			{Disconnecting cycle j}
			for k:=list[i,j]-1 downto 1 do begin
				tmp:=list[i];
				Inc(tmp[0]);
				tmp[j]:=k;
				tmp[tmp[0]]:=list[i,j]-k;
				p:=Find(tmp);
				m[i,p]:=m[i,p]+k;
			end;
		end;
	
	for i:=1 to tot do begin m[i,tot]:=0;m[tot,i]:=0;end;
	for i:=1 to tot do m[i,i]:=-((n*(n-1))div 2);
	for i:=1 to tot do b[i]:=(n*(n-1))div 2;
	Dec(tot);
	
End;


Procedure DFS2(v:Integer;var k:Integer);
Begin
	use[v]:=true;
	Inc(k);
	if not use[p[v]] then DFS2(p[v],k);
End;

Procedure SolveGauss;
var use:Array[1..200]of Boolean;
		i,j,k,nm:Integer;
		koef:Extended;
Begin
	fillchar(use,sizeof(use),false);
	for i:=1 to tot do begin
		nm:=-1;
		for j:=1 to tot do if (not use[j]) and (abs(m[j,i])>0.001) then begin
			nm:=j;use[j]:=true;break;
		end;
		if nm<>-1 then begin
			for j:=1 to tot do if (j<>nm) and (abs(m[j,i])>0.001) then begin
				koef:=m[j,i]/m[nm,i];
				for k:=1 to tot do m[j,k]:=m[j,k]-m[nm,k]*koef;
				b[j]:=b[j]-b[nm]*koef;
			end;
		end;
	end;
        for i:=1 to tot do
            for j:=1 to tot do if m[i,j]<>0 then begin
                x[j]:=-b[i]/m[i,j];
            end;
End;

Begin
{        Assign(input,'in.txt');Assign(output,'out.txt');
        Reset(input);ReWrite(output);}


	Read(n);

	
	GenAllCycles;
	FindInfo;

{	WriteLn(nCycles);
	for i:=1 to nCycles do begin
		Write(list[i,0],' ');
		for j:=1 to list[i,0] do Write(list[i,j],' ');
		WriteLn;
	end;}
	
	SolveGauss;
	
{	for i:=1 to tot do begin
		for j:=1 to tot do Write(m[i,j],' ');WriteLn;
	end;}

	for i:=1 to n do Read(p[i]);
	d[0]:=0;
	fillchar(use,sizeof(use),false);
	for i:=1 to n do if not use[i] then begin
		k:=0;
		DFS2(i,k);
		Inc(d[0]);
		d[d[0]]:=k;
	end;
	
	q:=find(d);

        if q = tot+1 then Write(0) else begin
          ans:=x[q];
          if abs(round(ans)-ans)<0.001 then ans:=round(ans);
          Write(trunc(ans));
        end;

End.