#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;

int n, k;
int64 p, q;
int s[17000010];
int64 ans;
int64 res[30];

void calc (int L, int R, int n)
{
	int l, r, pos = 1;
	l = n;
	r = n+1;
	int64 sum = 0;
	for (pos = 1; pos <= n; pos ++)
	{
		while (l && pos-1 + l-1 >= L)
		{	
			sum += (int64)s[l];
			l --;
		}
		while (r && pos-1 + r-2 > R)
		{
			r --;
			sum -= (int64)s[r];
		}
		ans += (int64)s[pos] * sum;
	}		
}

int main ()
{	
// 	freopen ("b.in", "r", stdin);
// 	freopen ("b.out", "w", stdout);
 	scanf ("%d%d%lld%lld", &n, &k, &p, &q);
	int x = 1;
	memset (s, 0, sizeof (s));
	if (n > 0)
		s[x+1] ++;
	forn (i, n-1)
	{
		x = ((int64)x * p + q) & (int64)((1 << k) - 1);
		s[x+1] ++;
	}
	ford (i, k+1)
	{
		int it = 1 << i;
		ans = 0;
		int N;
		if (i == k)
			N = it;
		else
			N = it * 2;	
		calc (it, it*2-1, N);
		calc (it + it*2, it*2-1 + it*2, N);	
		res[i] = ans;
		if (i < k)
		{
			int n1 = N/2;
			forn (j, n1)
			{
				s[j+1] += s[j+n1+1];
				s[j+n1+1] = 0;	
			}
		}		
	}
	forn (i, k+1)
		cout << res[i] << " ";
	cout << endl;
	return 0;
}
