#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <cmath>

using namespace std;

int const N=100010, M=1000010, MOD=1000000007;
int kp=N, be[N], en[M], z[N], d[N], q[N];
long long p[N];
char w[N];

void bfs(int k) {
	int b=0;
	w[k]=1, p[k]=1, d[k]=0, q[q[0]=1]=k;
	while(b<q[0]) {
		int c=q[++b];
		if (d[c]>kp)
			return;
		p[c]%=MOD;
		if (d[c]==kp)
			continue;
		for (int j=be[c]; j<be[c+1]; j++)
			if (!w[en[j]])
				w[en[j]]=1, p[en[j]]=p[c], d[en[j]]=d[c]+1, q[++q[0]]=en[j];
			else if (d[en[j]]==d[c]+1) 
				p[en[j]]+=p[c];
	}
}

vector< pair<int,int> > aa;

int main () {
// 	freopen ("d.in", "r", stdin);
// 	freopen ("d.out", "w", stdout);
	int n, m, t, k=0;
	scanf ("%d%d%d", &n, &m, &t);
	for (int i=0; i<t; i++) {
		int p; scanf ("%d", &p);
		z[++z[0]]=p;
	}
	sort(z+1, z+z[0]+1);	
	for (int i=0; i<m; i++) {
		int p, q;
		scanf ("%d%d", &p, &q);
		aa.push_back(make_pair(p, q));
		aa.push_back(make_pair(q, p));
	}
	sort(aa.begin(), aa.end());
	int c=0;
	for (int i=1; i<=n; i++) {
		for (; c<aa.size() && aa[c].first<i; c++);
		be[i]=c;
	}
	be[n+1]=aa.size();
	for (int i=0; i<aa.size(); i++)
		en[i]=aa[i].second;
	long long nw=0; 
	for (int i=1; i<=z[0]; i++) {
		memset(w+1, 0, n*sizeof(w[0]));
		bfs(z[i]);
		for (int j=i+1; j<=z[0]; j++) 
			if (w[j] && j!=i) {
				if (kp>d[z[j]]) kp=d[z[j]], nw=0;
				if (kp==d[z[j]]) nw+=p[z[j]];
			}
		nw%=MOD;
	}
	printf ("%d %d\n", kp, nw);
	return 0;
} 
