#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define day first
#define s second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii1;

const int inf = (1 << 30) - 1;
const int64 inf64 = ((int64)1 << 62) - 1;
const ldb eps = 1e-9;
const int64 P = 1000000009;

int k, m, a[30];
int64 s[30], t[30][101], c[3000][151];

int64 go (int m, int k)
{
	if (m == 1)
	{
		if (k == 0)
			return 1;
		else
			return 0;	
	}
	if (t[m][k] != -1)
		return t[m][k];
	int64 res = 0;
	for (int i = 0; i <= k; i ++)
	{
		int y = i + 1;
		int x = s[m-1] - i;
		int d = k - i;
		if (y < 0 || x < 0 || a[m]-d < 0 || a[m]+y-1 < 0)
			continue;
		int64 tmp = (c[x][d] * c[a[m]+y-1][a[m]-d]) % P;
		tmp = (tmp * go (m-1, i)) % P;
		res = (res + tmp) % P;
	}
	return t[m][k] = res;	
}

int main ()
{	
// 	freopen ("a.in", "r", stdin);
// 	freopen ("a.out", "w", stdout);
	scanf ("%d%d", &k, &m);
	seta (a, 0);
	forn (i, m)
		scanf ("%d", &a[i+1]);
	seta (s, 0);
	forn (i, m)
		s[i+1] = s[i] + a[i+1];
	seta (t, 255);
	seta (c, 0);
	forn (i, 3000)
		c[i][0] = 1;
	for (int i = 1; i < 3000; i ++)
		for (int j = 1; j <= min (i,150); j ++)
			c[i][j] = (c[i-1][j] + c[i-1][j-1]) % P;	
	printf ("%lld\n", go (m, k));
	return 0;
}
