#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <math.h>
#include <set>
#include <map>

using namespace std;

int w[1 << 24], g[1 << 24];
long long cans[26];
int n;

int calc (int l, int r, int base) {
	int vl = n, vr = n;
	if (l < base) {
		vl = 0;
		if (l - 1 >= 0) vl = g[l - 1];
	}
	if (r < base) {
		vr = 0;
		if (r >= 0) vr = g[r];
	}
	return vr - vl;
}

int main () {
	int k, p, q;
	scanf ("%d%d%d%d", &n, &k, &p, &q);
	if (n == 0) {
		for (int i = 0; i <= k; i++) printf ("0 ");
		printf ("\n");
		return 0;
	}
	int base = 1 << k;
	long long cur = 1;
	w[1]++;
	for (int i = 1; i < n; i++) { cur = (cur * p + q) & (base - 1); w[cur]++; }
	base = 1;
	int b2 = 1;
	long long sum = 0;
	for (int i = k; i >= 0; i--) {
		base = 1 << (i + 1);
		if (i == k) base >>= 1;
		b2 = 1 << i;
		g[0] = w[0];
		for (int j = 1; j < base; j++) g[j] = g[j - 1] + w[j];
		long long ans = 0;
		int l1 = 1 << i, r1 = (l1 << 1) - 1, l2 = 3 * l1, r2 = (l1 << 2) - 1;
		for (int j = 0; j < base; j++) 
			if (w[j] != 0) {
				ans += (long long)w[j] * calc (l1 - j, r1 - j, base);
				ans += (long long)w[j] * calc (l2 - j, r2 - j, base);
			}
		cans[i] = ans;
		sum += ans;
		for (int j = 0; j + b2 < base; j++) { w[j] += w[j + b2]; w[j + b2] = 0; }
	}
	for (int i = 0; i <= k; i++) printf ("%lld ", cans[i]);
	printf ("\n");
}