#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i,n) for (int i = 0; i < (int)n; i ++)
#define ford(i,n) for (int i = (int)n - 1; i >= 0; i --)
#define pb push_back
#define mp make_pair
#define last(a) (int)a.size() - 1
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define seta(a,x) memset (a, x, sizeof (a));

typedef long long int64;
typedef long double ldb;
typedef pair <int, int> pii;

int n;
int64 a[10100], sum, b[10100], aold[10100];
set < pair <int, int64> > s;
set < pair <int64, int> > l;
vector < pair <int64, int> > ans, sr;

void error ()
{
	printf ("Bad luck\n");
	exit (0);
}

int main ()
{	
//	freopen ("b.in", "r", stdin);
//	freopen ("b.out", "w", stdout);
	scanf ("%d", &n);
	seta (a, 0);
	forn (i, n)
		scanf ("%lld", &a[i+1]);
	memcpy (b, a, sizeof (a));
	memcpy (aold, a, sizeof (a));
	sum = 0;
	forn (i, n)
		sum += a[i+1];
	s.clear ();
	forn (i, n)
		s.insert (mp (i+1, a[i+1]));
	l.clear ();	
	forn (i, n)
		l.insert (mp (-a[i+1] * (int64)2, i+1));
	ans.clear ();
	set < pair <int, int64> > :: iterator sit;
	set < pair <int64, int> > :: iterator lit;	
	pii q;
	for (int i = 1; i <= n; i ++)
	{
		while (a[i] > 0)
		{
			int64 t = a[i];
			int num = -1;
			if ((int)l.size())
			{
				lit = l.begin();
				if ((*lit).sc <= i)
				{
					l.erase (lit);
					continue;
				}
				if ((*lit).fs + sum < 0)
					error ();
				else
					t = min (t, (*lit).fs + sum);	
				if (t == 0)
				{
					num = (*lit).sc;
					t = min (a[i], b[num]);
				}	
			}
			sit = s.begin();
			if ((*sit).fs == i)
			{
				sit ++;
				if (sit == s.end())
					error ();
			}
			if (num == -1)
			{
				num = (*sit).fs;
				t = min (t, b[num]);
			}
			sit = s.find (mp (num, b[num]));
			if (sit != s.end())
				s.erase (sit);
			lit = l.find (mp (-aold[num]-b[num], num));
			if (lit != l.end())
				l.erase (lit);
			a[i] -= t;
			sum -= t;
			b[num] -= t;
			if (t > 0)
				ans.pb (mp (t, num));
			if (b[num] > 0)
			{
				s.insert (mp (num, b[num]));
				l.insert (mp (-aold[num]-b[num], num));
			}
		}
	}	
	sr = ans;
	forn (i, ans.size()-1)
		sr[i+1].fs += sr[i].fs;
	printf ("Ok\n");
	int k;
	scanf ("%d", &k);
	forn (i, k)
	{
		int64 l, r;
		scanf ("%lld%lld", &l, &r);
		vector < pair <int64, int> > :: iterator it;
		it = lower_bound (all (sr), mp (l, 0));	
		int pos = it - sr.begin();
		while (l <= r)
		{
			printf ("%d ", sr[pos].sc);
			l ++;
			if (sr[pos].fs < l)
				pos ++;
		}	
		printf ("\n");
	}
	return 0;
}
