#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <cassert>
using namespace std;

typedef long long int64;
typedef pair<int,int> pii;
typedef long double real;


#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10000;
const int base = 16;
const int mmax = 1 << base;

int n,m;
int g[nmax][nmax/base + 10];
int cnt[mmax];
int64 res;

int solve(){
	cnt[0] = 0;
	forn(i,mmax){
		if (i*2 < mmax)cnt[i*2] = cnt[i];
		if (i*2+1 < mmax)cnt[i*2+1] = cnt[i]+1;
	}
	res = 0;
	forn(i,n)
		for (int j = i+1; j < n; j++)
			if (g[i][j/base] & (1 << (j % base)))
			forn(k,n/base + 2){
				res += (int64)cnt[g[i][k] & g[j][k]];
			}
	res /= 3ll;
}
	


void read(){
	scanf("%d %d",&n,&m);
	forn(i,m){
		int v,u;
		scanf("%d %d",&v,&u);
		v--, u--;
 		g[v][u/base] += 1 << (u % base);
		g[u][v/base] += 1 << (v % base);
	}
}

void write(){
	double ans = res / 4.0;
	printf("%0.9lf",ans);
}

int main(){
// 	freopen("a.in","rt",stdin);
// 	freopen("a.out","wt",stdout);
	
	
	read();
	solve();
	write();
	
	return 0;
}
