#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <queue>

using namespace std;

typedef long long int64;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10010;

vector<int> g[nmax];
vector<int> g1[nmax];
bool used[nmax];
int n,m,res;

void go(int v){
	forn(i,n)
		used[i] = 0;
	queue<int> q;
	queue<int> w;
	q.push(v);
	used[v] = true;
	while(!q.empty()){
		int h = q.front();
		q.pop();
		w.push(h);
		forn(i,g1[h].size())
			if (!used[g1[h][i]]){
			used[g1[h][i]] = true;
			q.push(g1[h][i]);
			}
	}
	
	while(!w.empty()){
		int h = w.front();
		w.pop();
		res++;
		forn(i,g[h].size())
			if (!used[g[h][i]]){
			used[g[h][i]] = true;
			w.push(g[h][i]);
			}
	}
}


void solve(){
	res = 0;
	forn(i,n)
		go(i);
}

void read(){
	scanf("%d %d",&n,&m);
	forn(i,m){
		int u,v;
		scanf("%d %d",&u,&v);
		u--, v--;
		g[u].pb(v);
		g1[v].pb(u);
	}
}

void write(){
	cout << res << endl;
}

int main(){

// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
 	
	read();
	solve();
	write();
	
	return 0;
}
