#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <queue>

using namespace std;

typedef long long int64;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10010;

vector<int> g[nmax];
vector<int> g1[nmax];
bool used[nmax];
int n,m,res;

int q[nmax];
int w[nmax];
int hq,hw;
int eq,ew;

void go(int v){
	forn(i,n)
		used[i] = 0;
	hw = 0;	ew = 0;
	hq = 0;	eq = 1;	
	q[0] = v;
	used[v] = true;
	while(hq < eq){
		int h = q[hq++];
		w[ew++] = h;
		forn(i,g1[h].size())
			if (!used[g1[h][i]]){
			used[g1[h][i]] = true;
			q[eq++]=g1[h][i];
			}
	}
	
	while(hw < ew){
		int h = w[hw++];
		res++;
		forn(i,g[h].size())
			if (!used[g[h][i]]){
			used[g[h][i]] = true;
			w[ew++] = g[h][i];
			}
	}
}


void solve(){
	res = 0;
	forn(i,n)
		go(i);
}

void read(){
	scanf("%d %d",&n,&m);
	forn(i,m){
		int u,v;
		scanf("%d %d",&u,&v);
		u--, v--;
		g[u].pb(v);
		g1[v].pb(u);
	}
}

void write(){
	cout << res << endl;
}

int main(){

// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
 	
	read();
	solve();
	write();
	
	return 0;
}
