#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <queue>

using namespace std;

typedef long long int64;

#define forn(i,n) for (int i = 0; i < (int)(n); i++)
#define ford(i,n) for (int i = (int)(n)-1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define fs first
#define sc second
#define pb push_back
#define mp make_pair

const int nmax = 10010;

vector<int> g[nmax];
vector<int> g1[nmax];
int used[nmax];
int n,m,res;
int shag = 1;

int next[nmax],ee[nmax],first[nmax];
int nexto[nmax],eeo[nmax],firsto[nmax];
int o,oo;


int q[nmax];
int hq,eq;

void go(int v){
	shag ++;
	hq = 0;	eq = 1;	
	q[0] = v;
	used[v] = shag;
	while(hq < eq){
		int h = q[hq++];
		for (int j = firsto[h]; j != 0; j = nexto[j])
			if (used[eeo[j]] < shag){
			used[eeo[j]] = shag;
			q[eq++]=eeo[j];
			}
	}
	
	hq = 0;
	
	while(hq < eq){
		int h = q[hq++];
		res++;
			
		for (int j = first[h]; j != 0; j = next[j])
			if (used[ee[j]] < shag){
			used[ee[j]] = shag;
			q[eq++]=ee[j];
			}
	}

}


void solve(){
	res = 0;
	forn(i,n)
		go(i);
}

void read(){
	o = oo = 0;
	scanf("%d %d",&n,&m);
	forn(i,m){
		int u,v;
		scanf("%d %d",&u,&v);
		u--, v--;
		
		o++;
		ee[o] = v;
		next[o] = first[u];
		first[u] = o;
		
		oo++;
		eeo[oo] = u;
		nexto[oo] = firsto[v];
		firsto[v] = oo;
		
		
	}
}

void write(){
	cout << res << endl;
}

int main(){
// 
// 	freopen("input.txt","rt",stdin);
// 	freopen("output.txt","wt",stdout);
 	
	read();
	solve();
	write();
	
	return 0;
}
