#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

int N, M, best=-1, bestm[4];
vector< vector<int> > kam, kolko;

int main() {
  // nacitame vstup
  cin >> N >> M;
  kam.resize(N); kolko.resize(N);
  for (int m=0; m<M; m++) { 
    int x,y,h; cin >> x >> y >> h; x--; y--;
    kam[x].push_back(y); kolko[x].push_back(h);
    kam[y].push_back(x); kolko[y].push_back(h);
  }

  for (int u=0; u<N; u++) {
    vector<int> kadial1(N), kolko1(N,-1), kadial2(N), kolko2(N,-1);

    // spracujeme vsetky cesty dlzky 2 z mesta u
    for (int i=0; i<int(kam[u].size()); i++) {
      int v = kam[u][i];
      if (v<=u) continue;
      for (int j=0; j<int(kam[v].size()); j++) {
        int w = kam[v][j], cena = kolko[u][i] + kolko[v][j];
        if (w<=u) continue;
        if (cena > kolko2[w]) { kolko2[w]=cena; kadial2[w]=v; }
        if (kolko2[w] > kolko1[w]) { swap(kadial1[w],kadial2[w]); swap(kolko1[w],kolko2[w]); }
      }
    }
    
    // prezrieme vsetkych kandidatov pre mesto w
    for (int w=0; w<N; w++) if (kolko2[w]!=-1) if (kolko1[w]+kolko2[w] > best) {
      best=kolko1[w]+kolko2[w];
      bestm[0]=u; bestm[1]=kadial1[w]; bestm[2]=w; bestm[3]=kadial2[w];
    }
  }

  // vypiseme riesenie
  if (best==-1) cout << "NEEXISTUJE" << endl; else {
    cout << best << endl;
    cout << bestm[3]+1; for (int i=0; i<4; i++) cout << " " << bestm[i]+1;
    cout << endl;
  }
}
