#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 51
#define TMAX 1001

int d[NMAX], p[NMAX], tinf[NMAX], tsup[NMAX];

vector<pair<double, int> > v;
int tsched[2][TMAX], req[NMAX][2];
int i, j, k, X, N, t, tt, T, pmax, feasible;

int main()
{
	freopen("core2.in", "r", stdin);
	freopen("core2.out", "w", stdout);

	scanf("%d %d %d", &N, &X, &T);

	v.clear();

	for (i = 1; i < N; i++)
	{
		scanf("%d %d", &d[i], &p[i]);
		tinf[i] = 0;
		tsup[i] = T;
		v.push_back(make_pair((double) p[i] / (double) d[i], i));
	}

	scanf("%d %d %d %d", &d[N], &p[N], &tinf[N], &tsup[N]);
	v.push_back(make_pair((double) p[N] / (double) d[N], i));

	sort(v.begin(), v.end());

	memset(req, 0, sizeof(req));
	for (i = 1; i <= X; i++)
		req[i][0] = 1;

	for (i = X + 1; i < N; i++)
		req[i][1] = 1;

	req[N][0] = req[N][1] = 1;

	memset(tsched, 0, sizeof(tsched));

	for (pmax = 0, k = N - 1; k >= 0; k--)
	{
		i = v[k].second;

		for (t = tinf[i]; t <= tsup[i] - d[i]; t++)
		{
			// test feasibility
			feasible = 1;

			for (j = 0; j < 2 && feasible; j++)
				if (req[i][j])
				{
					for (tt = t; tt < t + d[i]; tt++)
						if (tsched[j][tt] > 0)
						{
							feasible = 0;
							break;
						}
				}

			if (feasible)
			{
				pmax += p[i];

				for (j = 0; j < 2 && feasible; j++)
					if (req[i][j])
						for (tt = t; tt < t + d[i]; tt++)
							tsched[j][tt] = 1;

				break;
			}
		}
	}

	fprintf(stderr, "%d\n", pmax);
	printf("%d\n", pmax);

	return 0;
}
