// O(N^5) per test

#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 3000

vector<int> xs, ys;
vector<pair<int, int> > p;
int amax, xleft, xright, ylow, yhigh, xleok, xriok, ylook, yhiok, empty;
int i, j, k, N, XMAX, YMAX, x, y;

int main()
{
  int T;

  freopen("dr.in", "r", stdin);
  freopen("dr.out", "w", stdout);

  scanf("%d", &T);

  while (T--)
  {
    scanf("%d %d %d", &N, &XMAX, &YMAX);

    p.clear();
    xs.clear();
    ys.clear();

    for (i = 0; i < N; i++)
    {
      scanf("%d %d", &x, &y);
      p.push_back(make_pair(x, y));
      xs.push_back(x);
      ys.push_back(y);
    }

    xs.push_back(0);
    xs.push_back(XMAX);

    ys.push_back(0);
    ys.push_back(YMAX);

    sort(xs.begin(), xs.end());
    sort(ys.begin(), ys.end());

    amax = 0;

    for (xright = xs.size() - 1; xright > 0; xright--)
      for (xleft = xright - 1; xleft >= 0; xleft--)
        for (yhigh = ys.size() - 1; yhigh > 0; yhigh--)
          for (ylow = yhigh - 1; ylow >= 0; ylow--)
            if ((xs[xright] - xs[xleft]) * (ys[yhigh] - ys[ylow]) > amax)
            {
              // check if the rectangle is empty

              empty = 1;

              for (i = 0; i < N; i++)
                if (p[i].first > xs[xleft] && p[i].first < xs[xright] && p[i].second > ys[ylow] && p[i].second < ys[yhigh])
                {
                  empty = 0;
                  break;
                }

              if (empty)
              {
                amax = (xs[xright] - xs[xleft]) * (ys[yhigh] - ys[ylow]);
                xleok = xleft;
                xriok = xright;
                ylook = ylow;
                yhiok = yhigh;
              }
            }

    fprintf(stderr, "N=%d -> amax=%d (xleft=%d, xright=%d, ylow=%d, yhigh=%d), numx=%d, numy=%d\n", N, amax, xleok, xriok, ylook, yhiok, xs.size(), ys.size());
    printf("%d\n", amax);
  }

  return 0;
}
