#include <stdio.h>
#include <stdlib.h>

#define NMAX 1001

int grundy[NMAX], used[10 * NMAX];
int i, j, k, N, g;

int main()
{
	int T;

	// precompute

	grundy[0] = 0;

	for (i = 1; i < NMAX; i++)
	{
		// compute grundy[i]

		// move 1: remove one petal
		used[grundy[i - 1]] = i;

		// move 2: split the daisy into 2 non-empty daisies
		for (j = 1; j < i; j++)
			used[grundy[j] ^ grundy[i - j]] = i;

		// move 3: remove a petal and then split the daisy into 2 non-empty daisies
		for (j = 1; j < i - 1; j++)
			used[grundy[j] ^ grundy[i - 1 - j]] = i;

		for (j = 0; used[j] == i; j++);

		grundy[i] = j;

		//printf("%d: %d, %d, %d\n", i, i % 2, 2 - (i % 2), grundy[i]);
	}

	freopen("g.in", "r", stdin);
	freopen("g.out", "w", stdout);

	scanf("%d", &T);

	while (T--)
	{
		scanf("%d", &N);

		g = 0;
		for (i = 0; i < N; i++)
		{
			scanf("%d", &k);

			if (k >= NMAX)
				k = 1 + (rand() % (NMAX - 1));

			g ^= grundy[k];
		}

		if (g > 0)
			printf("1\n");
		else
			printf("2\n");
	}

	return 0;
}
