#include <stdio.h>

#define NMAX 100100
#define INF 1000000001

#define min(a, b) ((a) < (b) ? (a) : (b)) 

int x[NMAX], smin[2][NMAX], vmax[NMAX], minsmin[NMAX], minsum[NMAX];
int i, j, k, N, K, c, a, cnt, vmin;

int main()
{
	freopen("ksecv.in", "r", stdin);
	scanf("%d %d", &N, &K);

	for (i = 1; i <= N; i++)
		scanf("%d", &x[i]);

	// initialize for k=0
	smin[a = c = 0][0] = 0;
	for (i = 1; i <= N; i++)
		smin[0][i] = INF;

	for (k = 1; k <= K; k++)
	{
		c = 1 - a;

		smin[c][k] = smin[a][k - 1] + x[k];

		cnt = 1;
		vmax[1] = x[k];
		minsmin[1] = smin[a][k - 1];
		minsum[1] = vmax[1] + minsmin[1];
		minsum[0] = INF;

		for (i = k + 1; i <= N; i++)
		{
			// add x[i] to the stack
			vmin = smin[a][i - 1];

			while (cnt > 0 && vmax[cnt] <= x[i])
			{
				vmin = min(vmin, minsmin[cnt]);
				cnt--;
			}

			cnt++;
			vmax[cnt] = x[i];
			minsmin[cnt] = vmin;
			minsum[cnt] = min(minsum[cnt - 1], vmax[cnt] + minsmin[cnt]);
			smin[c][i] = minsum[cnt];
		}

		a = c;
	}

	freopen("ksecv.out", "w", stdout);
	printf("%d\n", smin[c][N]);

	return 0;
}
