#include <stdio.h>

#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100100
#define INF 2100000000
#define LIMIT 5

#define id(i) (v[i].second)

vector<pair<int, int> > v;
int lup[NMAX], ldown[NMAX], cleft[NMAX], cright[NMAX], C[NMAX];
int i, j, k, q, N, L, P, cmin, cij;

int main()
{
	freopen("mm.in", "r", stdin);
	scanf("%d %d %d", &N, &L, &P);

	for (i = 1; i <= P; i++)
	{
		scanf("%d %d %d %d %d", &lup[i], &cleft[i], &ldown[i], &cright[i], &C[i]);
		v.push_back(make_pair(-C[i], i));
	}

	sort(v.begin(), v.end());

	cmin = INF;
	for (i = 1; i <= N - L + 1; i++)
		if (i <= LIMIT || N - L + 1 - i <= LIMIT)
		{
			for (j = 1; j <= N - L + 1; j++)
			{
				cij = 0;

				for (k = 0; k < P; k++)
				{
					q = id(k);
	
					if (lup[q] > i + L - 1 || ldown[q] < i || cleft[q] > j + L - 1 || cright[q] < j)
						continue;

					cij = C[q];
					break;
				}

				if (cij < cmin)
				{
					cmin = cij;
					fprintf(stderr, "(%d,%d) => %d\n", i, j, cij);
				}
			}
		}
		else
		{
			for (j = 1; j <= N - L + 1 && j <= LIMIT; j++)
			{
				cij = 0;

				for (k = 0; k < P; k++)
				{
					q = id(k);
	
					if (lup[q] > i + L - 1 || ldown[q] < i || cleft[q] > j + L - 1 || cright[q] < j)
						continue;

					cij = C[q];
					break;
				}

				if (cij < cmin)
				{
					cmin = cij;
					fprintf(stderr, "(%d,%d) => %d\n", i, j, cij);
				}
			}

			for (j = N - L + 1; j > LIMIT && j >= N - L + 1 - LIMIT; j--)
			{
				cij = 0;

				for (k = 0; k < P; k++)
				{
					q = id(k);
	
					if (lup[q] > i + L - 1 || ldown[q] < i || cleft[q] > j + L - 1 || cright[q] < j)
						continue;

					cij = C[q];
					break;
				}

				if (cij < cmin)
				{
					cmin = cij;
					fprintf(stderr, "(%d,%d) => %d\n", i, j, cij);
				}
			}
		}

	freopen("mm.out", "w", stdout);
	printf("%d\n", cmin);

	return 0;
}
