#include <stdio.h>
#include <string.h>

#define PMOD 41143
#define NMAX 1001001
#define MMAX 10100
#define KMAX 101

char used[NMAX];
int np[MMAX][KMAX];
int i, j, p, N, K, cnt, ninv;

void bkt(int niv)
{
	int x, lninv;

	if (niv > N)
	{
		if (ninv == K)
			cnt = (cnt + 1) % PMOD;
	}
	else
	{
		lninv = 0;
		
		for (x = N; x >= 1; x--)
			if (!used[x])
			{
				used[x] = 1;
				ninv += lninv;

				if (ninv <= K)
					bkt(niv + 1);

				used[x] = 0;
				ninv -= lninv;
			}
			else
			{
				lninv++;
			}
	}
}

int main()
{
	freopen("pkinv.in", "r", stdin);
	scanf("%d %d", &N, &K);

	cnt = 0;
	ninv = 0;

	memset(used, 0, sizeof(used));

	if (N < MMAX)
	{
		memset(np, 0, sizeof(np));
		np[0][0] = 1 % PMOD;

		for (i = 1; i <= N; i++)
			for (j = 0; j <= K; j++)
				for (p = j; p >= 0 && p >= j - i + 1; p--)
					np[i][j] = (np[i][j] + np[i - 1][p]) % PMOD;

		cnt = np[N][K];
	}
	else
		bkt(1);

	freopen("pkinv.out", "w", stdout);
	printf("%d\n", cnt);

	return 0;
}