#include <stdio.h>

#include <map>
#include <vector>
#include <algorithm>
using namespace std;

map<int, int> vmap;
vector<int> vnum;
vector<char> win;
int i, j, K;
int N, x, y;

int main()
{
	freopen("pp.in", "r", stdin);
	scanf("%d %d", &N, &K);

	// compute the important states
	vnum.push_back(N);
	win.push_back(0);
	vmap[N] = 1;

	for (i = 0; i < vnum.size(); i++)
	{
		x = vnum[i];
		for (j = 2; j <= K; j++)
		{
			y = x / j;
			if (!vmap[y])
			{
				vnum.push_back(y);
				win.push_back(0);
				vmap[y] = vnum.size();
			}
		}
	}

	sort(vnum.begin(), vnum.end());

	for (i = 0; i < vnum.size(); i++)
		vmap[vnum[i]] = i + 1;

	// compute the winning values
	for (i = 0; i < vnum.size(); i++)
	{
		x = vnum[i];

		for (j = 2; j <= K; j++)
		{
			y = x / j;

			if (y < x && !win[vmap[y] - 1])
			{
				win[i] = 1;
				break;
			}
		}

		fprintf(stderr, "x=%d => %d\n", vnum[i], win[i]);
	}

	//fprintf(stderr, "nstates=%d\n", vnum.size());

	freopen("pp.out", "w", stdout);
	printf("%d\n", win[vnum.size() - 1]);

	return 0;
}
